﻿
var wxjsdsk = (function () {
    var funList = [];//用于存储分享后要执行的方法


    var rtnObj = {
        shareJson: null,
        init: function () {
            //自动启动微信注册(只有微信下才会自动执行）
            try {
                wxConfig();//不显示菜单
            }
            catch (e) {
                alert(e.message);
            }
        },
        reshare: function (title, desc, url, img) {
            this.shareJson = {
                title: title, // 分享标题
                link: url, // 分享链接
                imgUrl: img, // 分享图标
                desc: desc,
                success: function () {
                   // alert("分享成功");
                },
                cancel: function () {
                  //  alert("分享失败");
                }
            };

            //先显示分享菜单
            regShareMenu();
        },
        showShare: function (title, desc, url, img) {
            this.shareJson = {
                title: title, // 分享标题
                link: url, // 分享链接
                imgUrl: img, // 分享图标
                desc: desc,
                success: function () {
                   // alert("分享成功");
                },
                cancel: function () {
                   // alert("分享失败");
                }
            };


            //先显示分享菜单
            showShareMenu();

            regShareMenu();
        }
    };


    function isWeiXin() {
        var ua = window.navigator.userAgent.toLowerCase();
        if (ua.match(/MicroMessenger/i) == 'micromessenger') {
            return true;
        } else {
            return false;
        }
    }

    //注册分享内容
    function regShareMenu() {
        var fun = function () {
            var myjson = rtnObj.shareJson;
            try{
                // 获取“分享到朋友圈”按钮点击状态及自定义分享内容接口
                wx.onMenuShareTimeline({
                    title: myjson.title, // 分享标题
                    link: myjson.link, // 分享链接
                    imgUrl: myjson.imgUrl, // 分享图标
                    success: myjson.success,
                    cancel: myjson.cancel
                });

                //获取“分享给朋友”按钮点击状态及自定义分享内容接口
                wx.onMenuShareAppMessage({
                    title: myjson.title, // 分享标题
                    desc: myjson.desc, // 分享描述
                    link: myjson.link, // 分享链接
                    imgUrl: myjson.imgUrl, // 分享图标
                    success: myjson.success,
                    cancel: myjson.cancel
                });
            }
            catch (e) { }


            try {

                //自定义“分享给朋友”及“分享到QQ”按钮的分享内容（1.4.0）
                wx.updateAppMessageShareData({
                    title: myjson.title, // 分享标题
                    desc: myjson.desc, // 分享描述
                    link: myjson.link, // 分享链接，该链接域名或路径必须与当前页面对应的公众号JS安全域名一致
                    imgUrl: myjson.imgUrl, // 分享图标
                    success: myjson.success,
                    cancel: myjson.cancel
                });
                //自定义“分享到朋友圈”及“分享到QQ空间”按钮的分享内容（1.4.0）
                wx.updateTimelineShareData({
                    title: myjson.title, // 分享标题
                    desc: myjson.desc, // 分享描述
                    link: myjson.link, // 分享链接，该链接域名或路径必须与当前页面对应的公众号JS安全域名一致
                    imgUrl: myjson.imgUrl, // 分享图标
                    success: myjson.success,
                    cancel: myjson.cancel
                });

                wx.error(function (res) {
                    // config信息验证失败会执行error函数，如签名过期导致验证失败，具体错误信息可以打开config的debug模式查看，也可以在返回的res参数中查看，对于SPA可以在这里更新签名。
                    alert("注册分享错误:" + JSON.stringify(res));
                });
            }
            catch (e) {
                alert("注册分享时出错了：" + e.message);
            }
        }
        execwxfun(fun);
    }

    //显示分享主菜单
    function showShareMenu() {
        if (isWeiXin()) {
            var fun = function () {
                try {
                    wx.hideOptionMenu();//先隐藏所有菜单
                    wx.showMenuItems({
                        menuList: [
                          "menuItem:share:appMessage",//发送给朋友: 
                          "menuItem:share:timeline",//,//分享到朋友圈: 
                        ]
                    });
                }
                catch (e) { alert(e.message); }
            };
            execwxfun(fun);
        }
    }
    //隐藏分享主菜单
    function hideShareMenu() {
        if (isWeiXin()) {
            var fun = function () {
                wx.hideOptionMenu();//先隐藏所有菜单
            };
            execwxfun(fun);
        }
    }


    ///关闭当前窗口
    function closeWX() {
        if (isWeiXin())
            wx.closeWindow();
        else
            window.close();
    }

    function checkJsApi() {
        wx.ready(function () {
            wx.checkJsApi({
                jsApiList: [
                  'checkJsApi',
                          'updateAppMessageShareData',
                            'updateTimelineShareData',
                            'onMenuShareTimeline',
                            'onMenuShareAppMessage',
                            'startRecord',
                            'stopRecord',
                            'onVoiceRecordEnd',
                            'playVoice',
                            'pauseVoice',
                            'stopVoice',
                            'onVoicePlayEnd',
                            'uploadVoice',
                            'downloadVoice',
                            'chooseImage',
                            'previewImage',
                            'uploadImage',
                            'downloadImage',
                            'translateVoice',
                            'getNetworkType',
                            'openLocation',
                            'getLocation',
                            'hideOptionMenu',
                            'showOptionMenu',
                            'hideMenuItems',
                            'showMenuItems',
                            'hideAllNonBaseMenuItem',
                            'showAllNonBaseMenuItem',
                            'closeWindow',
                            'scanQRCode',
                            'chooseWXPay',
                            'openProductSpecificView',
                            'addCard',
                            'chooseCard',
                            'openCard'
                ],
                success: function (res) {

                }, fail: function (r) {

                }
            });
        });
    };

    //进行微信JsSDK注册，以便当前页可进行微信JS调用
    function wxConfig() {
        try {
            if (isWeiXin()) {
                try {
                    var url = window.location.href;
                    if (url.indexOf("#") >= 0)
                        url = url.substring(0, url.indexOf("#"));
                }
                catch (e)
                { }
                var successFun = function (rtn) {
                    wx.config({
                        debug: false,
                        appId: rtn.appId,
                        timestamp: rtn.timestamp,
                        nonceStr: rtn.nonceStr,
                        signature: rtn.signature,
                        jsApiList: [
                         'updateAppMessageShareData',
                            'updateTimelineShareData',
                            'onMenuShareTimeline',
                            'onMenuShareAppMessage',
                            'startRecord',
                            'stopRecord',
                            'onVoiceRecordEnd',
                            'playVoice',
                            'pauseVoice',
                            'stopVoice',
                            'onVoicePlayEnd',
                            'uploadVoice',
                            'downloadVoice',
                            'chooseImage',
                            'previewImage',
                            'uploadImage',
                            'downloadImage',
                            'translateVoice',
                            'getNetworkType',
                            'openLocation',
                            'getLocation',
                            'hideOptionMenu',
                            'showOptionMenu',
                            'hideMenuItems',
                            'showMenuItems',
                            'hideAllNonBaseMenuItem',
                            'showAllNonBaseMenuItem',
                            'closeWindow',
                            'scanQRCode',
                            'chooseWXPay',
                            'openProductSpecificView',
                            'addCard',
                            'chooseCard',
                            'openCard'
                        ]
                    });
                };
                var errFun = function (errMsg) {
                    showNotice(errMsg);
                };
                apollo.api("WeixinApi", "GetJsSDKConfig", { Url: url }, successFun, errFun);
            }
        }
        catch (e) {
        }
    }

    var readyFuns = [];//页面要执行的微信相关


    //用于判断是否微信打开
    var iswxloaded = false;

    hideShareMenu();//默认执行不显示所有分享菜单
    wx.ready(function () {
        iswxloaded = true;
        for (var i = 0; i < funList.length; i++) {
            var fun = funList[i];
            if (fun != null) fun.call();
        }
    });

    function execwxfun(fun) {
        if (iswxloaded == true) //微信JSK已注册加载完毕
        {
            if (fun != null) fun.call();
        }
        else {
            funList.push(fun);
        }
    }


    return rtnObj;
})();

$(function () {
    wxjsdsk.init();
});
