﻿(function ($) {
    apollo.Page({
        data: {
            IsHome: true,//是否为首页，首页栏目是有具体商品
            SearchKey: "",//检索关键字
            Products: [],
            ProdCTitems: [],//所有商品分类
            NavItems: [],//导航分类
            ClassProducts: [],//主要专区产品列表（只列前8个）
            PTProducts: [],//四大分类产品列表
            PlaceNav: [ //四馆固定导航
                { NodeType: 1, NodeName: "至尊生活馆", NodeCode: "01", url: apollo.pageInfo.rootvpath + "Content/Images/branch-01.jpg" },
                { NodeType: 1, NodeName: "现代养生馆", NodeCode: "02", url: apollo.pageInfo.rootvpath + "Content/Images/branch-02.jpg" },
                { NodeType: 1, NodeName: "轻奢福利馆", NodeCode: "03", url: apollo.pageInfo.rootvpath + "Content/Images/branch-03.jpg" },
                { NodeType: 1, NodeName: "营销工具馆", NodeCode: "09", url: apollo.pageInfo.rootvpath + "Content/Images/branch-09.jpg" }
            ],
            Banners: [ //Banner区
                { title: "促销公告", url: "", banner: "../Content/Images/i-banner02.jpg", src: apollo.pageInfo.rootvpath + "Content/Images/alpha.png" },
                { title: "私董优选", url: "", banner: "../Content/Images/i-banner01.jpg", src: apollo.pageInfo.rootvpath + "Content/Images/alpha.png" }
            ]
        },
        onload: function (app) {
            apollo.app.setdata({ isIndex: true });
            apollo.api("CKProductApi", "GetAllProdTypes", function (pt) {
                //根据取到的分类及UI，设置呈现数据
                var ct = [];
                ct.push({ Title: "产品馆", NodeList: pt.ProductPlaces });
                ct.push({ Title: "产品专区", NodeList: pt.ClassItems });
                ct.push({ Title: "产品汇总", NodeList: pt.ProductTypes });               

                //导航区
                var nav = [];
                var ctlist = [];
                var ptlist = [];
                $(pt.ProductTypes).each(function (i, c) {
                    var exp = "";
                    if (c.NodeCode == "YangZZ")
                        exp = "全方位呵护：做更安全更有效的保健品";
                    else if (c.NodeCode == "JiuZZ")
                        exp = "灸法治病，灸法养生：构建绿色医疗体系";
                    else if (c.NodeCode == "JinZZ")
                        exp = "构建符合中国健康时尚的生活方式";
                    else if (c.NodeCode == "YanZZ")
                        exp = "激发自身美丽潜能，让美丽自信绽放";
                    else
                        return;

                    ptlist.push({
                        NodeCode: c.NodeCode,
                        NodeType: c.NodeType,
                        NodeName: c.NodeName,
                        Products: [],
                        Explain: exp
                    });
                });


                $(pt.ProductPlaces).each(function (i, c) {
                    nav.push({
                        NodeName: c.NodeName,
                        NodeCode: c.NodeCode,
                        NodeType: c.NodeType
                    });
                });

                $(pt.ClassItems).each(function (i, c) {
                    nav.push({
                        NodeName: c.NodeName,
                        NodeCode: c.NodeCode,
                        NodeType: c.NodeType
                    });

                    ctlist.push({
                        NodeCode: c.NodeCode,
                        NodeType: c.NodeType,
                        NodeName: c.NodeName,
                        Products: []
                    });
                });

                //呈现数据
                app.setdata({
                    ProdCTitems: ct,
                    NavItems: nav,
                    ClassProducts: ctlist,
                    PTProducts: ptlist
                });

                //再启动加载产品信息
                loadAllProd();
            });
        },
        oninputkey: function (e) {//检索框输入
            e.updatavalue();
        },
        onnodeclick: function (e) //分类导航点击事件
        {
            var node = e.source;
            location.href = "ProdList?NodeCode=" + node.NodeCode + "&NodeType=" + node.NodeType + "&NodeName=" + node.NodeName;
        },
        onprodclick: function (e)//产品点击
        {
            location.href = "ProdView?Code=" + e.source.ProductCode;
        },
         onsearch: function (e) {
            location.href = "ProdList?key=" + apollo.app.getdata().SearchKey;
        }

    });
    //加载产品信息，并进行分类
    function loadAllProd() {
        apollo.api("CKProductApi", "GetAllProductLists", function (ps) {

            var data = apollo.app.getdata();
            data.Products = ps;//将获取到的产品设置到页面属性中，这里是不需要呈现的
            //设置所有分类各类对应商品,并自动移除无产品的分类
            var ProdCTitems = [];
            $(data.ProdCTitems).each(function (i, ct) {
                var arr = [];
                $(ct.NodeList).each(function (j, node) {
                    node.Products = getproductsForType(ps, node.NodeCode, node.NodeType, 30);
                    if (node.Products.length > 0) arr.push(node);
                });
                if (arr.length > 0) ProdCTitems.push(ct);
            });


            //设置首页各区分类所属商品，以便呈现
            var ClassProducts = [];
            $(data.ClassProducts).each(function (j, node) {
                node.Products = getproductsForType(ps, node.NodeCode, node.NodeType, 8);
                if (node.Products.length > 0) ClassProducts.push(node);
            });

            var PTProducts = [];
            $(data.PTProducts).each(function (j, node) {
                node.Products = getproductsForType(ps, node.NodeCode, node.NodeType, 8);
                if (node.Products.length > 0) PTProducts.push(node);
            });

            //更新首页呈现
            apollo.app.setdata({
                ProdCTitems: ProdCTitems,
                ClassProducts: ClassProducts,
                PTProducts: PTProducts
            });
        });
    }

    ///获取指定分类下所属产品
    function getproductsForType(prods, nodecode, nodetype, num) {
        var arr = [];
        $(prods).each(function (i, p) {
            if (num > 0 && arr.length >= num) return; //取到的数量已达到指定数
            var type = "";
            if (nodetype == 0) {
                type = p.SerialCode;
            }
            else if (nodetype == 1) {
                type = p.ProductPlaceID;
            }
            else if (nodetype == 2)//注意，这类下还有一些特殊的，需要处理
            {
                type = p.ClassTypeID;
            }
            if (apollo.Lib.isEquals(type, nodecode)) {
                arr.push(p);
            }
        });
        return arr;
    }

})(jQuery);