﻿(function ($) {
    apollo.Page({
        data: {
            Node: { NodeCode: "", NodeName: "产品列表", NodeType: 1 },
            ProdCount:0,
            PagerInfo:{ //分页信息
                CurPage:1,//当前页
                PageCount:1,//总页数
                IsFirst:true,//是否为首页
                IsEnd:false, //是否为尾页
                TotalNum:0
            },
            ProdCTitems: [],//所有商品分类
            NavItems: [],//导航分类
            SearchKey:"", //检索关键字
        },
        onload: function (app) {
            apollo.api("CKProductApi", "GetAllProdTypes", function (pt) {
                //根据取到的分类及UI，设置呈现数据
                var ct = [];
                ct.push({ Title: "产品馆", NodeList: pt.ProductPlaces });
                ct.push({ Title: "产品专区", NodeList: pt.ClassItems });
                ct.push({ Title: "产品汇总", NodeList: pt.ProductTypes });

                //导航区
                var nav = [];

                $(pt.ProductPlaces).each(function (i, c) {
                    nav.push({
                        NodeName: c.NodeName,
                        NodeCode: c.NodeCode,
                        NodeType: c.NodeType
                    });
                });

                $(pt.ClassItems).each(function (i, c) {
                    nav.push({
                        cls:"",
                        NodeName: c.NodeName,
                        NodeCode: c.NodeCode,
                        NodeType: c.NodeType
                    });
                });

                //呈现数据
                app.setdata({
                    ProdCTitems: ct,
                    NavItems: nav
                });
            });
        },
        listOptions: {
            createPager:function(pager)
            {
                var page={
                    IsFirst:pager.pageIndex <= 0,
                    IsEnd:pager.pageIndex >= pager.totalPage - 1,
                    PageCount:pager.totalPage,
                    CurPage:pager.pageIndex+1,
                    TotalNum:pager.totalRecord
                };
                apollo.app.setdata({
                    PagerInfo:page,
                    ProdCount:pager.totalRecord
                });
            },
            pageSize: 30,//每页数量
            getDataFun: function (pageIndex, pageSize, succFun) {
                var data=apollo.app.getdata();
                var node=data.Node;
                var key=data.SearchKey;
                var param = {
                    NodeCode:node.NodeCode,
                    NodeType:node.NodeType,
                    Key:key,
                    PageIndex: pageIndex,
                    PageSize: pageSize
                };
                apollo.api("CKProductApi", "GetProductLists", param, succFun);
            }

        },
        oninputkey: function (e)//检索框输入
        {
            e.updatavalue();
        },
        onnodeclick: function (e) //分类导航点击事件
        {
            apollo.app.setdata({
                Node:e.source,
                SearchKey:"",
                TxtKey:""
            });
            var pager=apollo.app.getpager("listOptions");
            pager.load();
        },
        onprodclick: function (e)//产品点击
        {
            location.href="ProdView?Code="+e.source.ProductCode;
        },
        onprev:function(e)//上一页
        {
            var pager=apollo.app.getpager("listOptions");
            pager.prev();
        },
        onnext:function(e){//下一页
            var pager=apollo.app.getpager("listOptions");
            pager.next();
        },
        onsearch:function(e)
        {
            apollo.app.setdata({
                Node: { NodeCode: "", NodeName: "检索结果", NodeType: 1 },
            });
            //更新检索关键字
            var pager=apollo.app.getpager("listOptions");
            pager.load();
        }
    });
})(jQuery);