﻿(function ($) {
    var BasketBox;
    apollo.Page({
        data: {
            Node:{NodeCode:"",NodeName:"产品列表",NodeType:1},
            Count:1,
            Product: null,
            ProdCTitems: [],//所有商品分类
            NavItems: [],//导航分类
            SearchKey:"", //检索关键字,
            CXInfo:[] //当前产品促销相关信息{}
        },
        onload: function (app) {
            apollo.api("CKProductApi", "GetAllProdTypes", function (pt) {
                //根据取到的分类及UI，设置呈现数据
                var ct = [];
                ct.push({ Title: "产品馆", NodeList: pt.ProductPlaces });
                ct.push({ Title: "产品专区", NodeList: pt.ClassItems });
                ct.push({ Title: "产品汇总", NodeList: pt.ProductTypes });

                //导航区
                var nav = [];

                $(pt.ProductPlaces).each(function (i, c) {
                    nav.push({
                        NodeName: c.NodeName,
                        NodeCode: c.NodeCode,
                        NodeType: c.NodeType
                    });
                });

                $(pt.ClassItems).each(function (i, c) {
                    nav.push({
                        cls:"",
                        NodeName: c.NodeName,
                        NodeCode: c.NodeCode,
                        NodeType: c.NodeType
                    });
                });

                //呈现数据
                app.setdata({
                    ProdCTitems: ct,
                    NavItems: nav
                });
            });
        },
        oninitspinner: function (e) {
            var isInBasket = true;//默认是购物车中数量输入框
            var prod=e.source;


            var numtimes = prod.OrderNumTimes;
            var mincount = prod.OrderNumMin;
            if (mincount <= 0) {
                mincount = 1;
            }
            var num = mincount;

            if (numtimes > 1) {//如果设置了订购倍数，则最小起订量要符合这个倍数
                if (numtimes >= mincount) //订购倍数大于或等于最小订购量
                    num = numtimes;
                else if ((mincount % numtimes) > 0) { //最小订购数并不是订购倍数
                    num = Math.ceil(mincount / numtimes) * numtimes;
                }
                else
                    num = numtimes;
            }
            else
                numtimes = 1;

            if (num <= 0) num = 1;


            e.target.Spinner({ min: num, value: prod.ProductCount, numTimes: numtimes }).change = function (box) {
                prod.ProductCount = newnum;
                prod.SaleMoney = prod.ProductCount * prod.ProductPrice;
            };
        },
        oninputkey: function (e)//检索框输入
        {
            e.updatavalue();
        },
        onnodeclick: function (e) //分类导航点击事件
        {
            var node = e.source;
            location.href = "ProdList?NodeCode=" + node.NodeCode + "&NodeType=" + node.NodeType + "&NodeName=" + node.NodeName;

        },
        onnumchange:function(e)
        {
            var num=e.getValue();
            var data = apollo.app.getdata();
            data.Product.ProductCount = num
            apollo.app.setdata({
                Count: num,
            });
        },
        onsearch: function (e) {
            var key=apollo.app.getdata().SearchKey;
            var node = apollo.app.getdata().Node;
            location.href = "ProdList?NodeCode=" + node.NodeCode + "&NodeType=" + node.NodeType + "&NodeName=" + node.NodeName+"&key="+key;
        }
    });


    ///将产品加入到订货购物车中
    function addTobasket(prod, count, animationFun) {
        if (prod.BuyAuthCode != null && prod.BuyAuthCode != "") //需要授权码
        {
            alert("对不起，该产品购买需要授权，不能加入购物车!");
            return;
        }

        //addToShopCart(prod.ProductCode, count);
        if (animationFun != null) {
            try {
                animationFun();
            }
            catch (e) { }
        }
    }
})(jQuery);