﻿/*分享商城购物车*/
(function ($) {
    //扩展apollo.app增加购物车相关方法
    //首先取本地缓存
    var carts;
    try {
        var str = apollo.catchutil.setLocVal("apollo.ck.cartproducts");//更新本地缓存
        if (apollo.Lib.isEmpty(str))
            carts = [];
        else
            carts = JSON.parse(str);
    }
    catch (e) { }
  
    if (!jQuery.isArray(carts)) carts = [];

    apollo.Partial({
        data: {
            cartproducts: carts,
            cartprodcount:carts.length
        },
        url: apollo.getapi("CKCartApi", "GetCartProducts"),
        postdata: { IsWXShare: 1 },
        success:function(){
            apollo.app.setdata("footerNav");
        },
        onaddmycart: function (e) //将产品加到我的购物车中
        {
            var code = e.source.ProductCode;

            var numtimes = e.source.OrderNumTimes;
            var mincount = e.source.OrderNumMin;
            if (mincount <= 0) {
                mincount = 1;
            }
            var num = mincount;
            if (numtimes > 1) {//如果设置了订购倍数，则最小起订量要符合这个倍数
                if (numtimes >= mincount) //订购倍数大于或等于最小订购量
                    num = numtimes;
                else if ((mincount % numtimes) > 0) { //最小订购数并不是订购倍数
                    num = Math.ceil(mincount / numtimes) * numtimes;
                }
                else
                    num = numtimes;
            }

            if (num <= 0) num = 1;

            var successFun = function (rtn) {
                if (rtn.IsSuccess) {
                    var cartproducts = apollo.app.getdata().cartproducts;
                    var prod = apollo.array.find(cartproducts,function (p) {
                        return p.ProductCode = code;
                    });
                    if (prod == null)
                        cartproducts.push({ ProductCode: code, ProductCount: num });
                    else
                        prod.ProductCount += num;
                    apollo.app.setdata({
                        cartprodcount: cartproducts.length
                    })
                    apollo.app.setdata("cartproducts", "footerNav", "");

                    //更新本地缓存
                    apollo.catchutil.setLocVal("apollo.ck.cartproducts", JSON.stringify(cartproducts));

                    showNotice("成功添加到购物车中", 1);
                }
                else
                    showNotice(rtn.Message);
            };

            var param = { ProductCode: code, ProductCount: num, IsWXShare: 1 };
            apollo.api("CKCartApi", "AddToCart", param, successFun);
        },
        ontomycart: function (e) {
            openWin("BuyReport", "Mobile/BuyReport/ShareIndex");
        }
    });

})(jQuery);