﻿//报单页面全局对象
var ReportPage = {};
var stepUtil;
var basket;

var initstep = null;

//报单定义对象
var ReportDefine = (function (apollo, $) {
    //页面框架全局对象（各方法内的app实体与这个变量都是指定同一对象，即apollo.app;
    var app = apollo.app;
    //以下为报单通用字符枚举对象(页面全局对象)，用于各方法调用，以便防止误输入
    var CKReportEnum = {
        /**报单错误显示值*/
        OpTypeForReportError: "Error",
        /**正确报单显示值*/
        OpTypeForReport: "Report",
        /**选购产品显示值*/
        OpTypeForSelProduct: "SelProduct"
    };

    /**定义报单相关通用方法*/
    function ReportUtil(myoptions) {
        var ismobile = !apollo.isPCComputer();
        var isbuying = false;//当前是否正处于报单状态

        var that = {//注意，这里用 that代替this,以防委托方法时，this指向其它对象，保证that一定是指向当前定义对象
            regType: myoptions.Param.RegType,            
            stepUtil: null,//用于控制各步骤
            setStepInfo: function (ReportSteps) //重新设置步骤信息
            {
                if (initstep == null) initstep = stepUtil;
                var reportStep = CreateReportStepInfo(ReportSteps);//选创建步骤对象
                //刷新页面
                var step = new ReportStepUtil(reportStep, function (index) {
                    apollo.app.setvalue("StepInfo.CurrStepIndex", index);
                });
                apollo.app.setdata({
                    StepInfo: reportStep //创建报单步骤对象，用于控制各步骤
                });

                that.stepUtil = step;
                stepUtil = step;

            },
            topaystep: function () {
                this.stepUtil.goto(myoptions.options.PayStepName);//进入最后一步
            },
            saleoptions: myoptions.options,
            options: null,//页面全局配置对象相当于apollo.app.getoption()
            report: null,//当前报单对象 相当于apollo.app.getdata().Report;
            basket: null, //当前购物车对象 相当于apollo.app.getdata().Basket;
            uiparam: null,//报单输入参数
            createparam: function (p)//创建当前报单参数 以便提交后台，如果hasproduct==true，则还要加购物车产品信息参数,本方法必须要在成功开启报单后才能调用
            {
                var customparam, hasproduct;
                if (arguments.length == 0) {
                    customparam = {};
                    hasproduct = false;
                }
                else if (arguments.length == 1) {
                    if (jQuery.isPlainObject(arguments[0])) {
                        customparam = arguments[0];
                        hasproduct = false;
                    }
                    else {
                        customparam = {};
                        hasproduct = arguments[0] == true;
                    }
                }
                else if (jQuery.isPlainObject(arguments[0])) {
                    customparam = arguments[0];
                    hasproduct = arguments[1] == true;
                }
                else {
                    customparam = arguments[0];
                    hasproduct = arguments[1] == true;
                }


                var param = {
                    ReportType: that.report.ReportType,
                    EntityJson: JSON.stringify(that.report)
                };
                if (hasproduct == true) {
                    //取到购物产品集
                    var arr = [];
                    $(that.basket.ProductItems).each(function (i, item) {
                        arr.push(item.Product);
                    });
                    param.ProductsJson = JSON.stringify(arr);
                }

                //将两个参数进行合并到自定参数中，并返回自定义参数
                if (customparam == null) customparam = {};
                return $.extend(customparam, param);
            },
            reloadreport: function (report, products) {//重置产品信息
                that.report = report;
                that.basket = new BasketProductUtil(products);
                basket = that.basket;

                app.setdata({
                    Report: that.report,
                    Basket: that.basket
                });
            },
            selproduct: ShowSelProduct,
            tobasket: ShowReport,
            selpopup: ShowPopupProducts, //弹出选择指定产品
            /*正常退出购物报单*/
            existSale: function () {
                $(window).off('beforeunload');
                isbuying = false;
            },
            /*进入报单状态*/
            beginSale: function (e) {
                $(window).on('beforeunload', function () { return '您当前购物未提交，只有提交成功后购物才自动生效，是否真要退出？'; });
                isbuying = true;
            },
            getAreaForShopName: getAreaForShopName,
            getAreaForSH: getAreaForSH,
            getAreaForBankName: getAreaForBankName,
            getZzmmName: getZzmmName,
            getDegreeName: getDegreeName,
            getRegUserRoleName: getRegUserRoleName,
            getUpgradeUserRoleName: getUpgradeUserRoleName,
            getReBusinessName: getReBusinessName,
            getSaleChannel: getSaleChannel,
            getPrice: function (p, hasunit) {
                var unit = (hasunit == true ? "/" + p.ProductUnit : "");
                if (p.Retail > p.ProductPrice) {

                    return "&yen;" + apollo.Lib.BASEformatNumber(p.ProductPrice) + unit + "<span class=\"mar-l1 c-light-gra font-n\">/&yen;" + apollo.Lib.BASEformatNumber(p.Retail) + unit + "</span>";
                }
                else {
                    return "&yen;" + apollo.Lib.BASEformatNumber(p.ProductPrice) + unit;
                }
            }
        };
        var ReportPanel = null;
        var defaults = {
            IsStepOptions:false,//是否为普通流程操作
            Steps: null,//报单步骤信息(初始设置)
            StepPanelHtml: "",
            ReportPanel: "",//报单步骤所在区域DOM
            SelProductPanel: "",//选购产品报在区域
            ApiController: "",//开始报单的API控制器
            SelProductDefine: null,//选购产品定义
            ApiMethod: "",//开始报单的API方法
            Param: "",//API方法参数
            BeforeSaleBuy: null,
            BeginToStepFun: null //加载完毕后执行进入指定步骤的方法
        };

        var op = $.extend(defaults, myoptions);


        var OnLoadFun = function (app) {
            if (op.IsStepOptions == true) {
                NormalFlowLoad(app, op.ApiController, op.ApiMethod, op.Param, op.BeginToStepFun, op.BeforeSaleBuy);
            }
            else {
                ReportLoad(app, op.ApiController, op.ApiMethod, op.Param, op.BeginToStepFun, op.BeforeSaleBuy);
            }
        };

        //注册报单页全局配置对象
        var page = CreateReportPageOption(op.Steps, OnLoadFun);
        that.stepUtil = page.stepUtil;
        stepUtil = that.stepUtil;

        apollo.Partial(page.options);
        app = apollo.app;

        that.options = app.getoption();

        //报单步骤控制器
        function ReportStepUtil(reportStep, _cngPageIndexFun) {
            var stepInfo = getStepInfo(reportStep);//取到当前注册步骤信息
            var cngPageIndexFun = _cngPageIndexFun;

            var currRegingStep = null;//当前要注册的步骤，用于各分步骤页自注册

            var currStep = null;//当前步骤

            //对步骤信息进行再包装，以便控制加载，显示
            function getStepInfo(reportStep) {
                var info = reportStep;
                if (info == null) {
                    return {
                        ReportSteps: []
                    };
                }
                var arr = [];
                var prev = null;//上一步骤
                $(info.ReportSteps).each(function (i, step) {
                    var nstep;
                    if (ismobile == true)
                        nstep = new StepEntityMobile(step, prev, i);
                    else
                        nstep = new StepEntity(step, prev, i);

                    //设置当前步骤为前一步骤的下一步骤
                    if (prev != null) prev.next = nstep;

                    arr.push(nstep);
                    prev = nstep;
                });
                return {
                    ReportSteps: arr
                };
            }

            function StepEntity(_step, _prev, _index) {
                var index = _index;
                var step = _step;
                var prev = _prev;

                this.name = step.name;
                this.stepInfo = step;
                this.index = index,//当前步骤序号
                    this.el = null;
                this.url = apollo.getvpath(step.url);
                this.isloaded = function () {
                    return step.partial != null;
                };
                this.reg = function (partpage) {
                    if (arguments.length == 0 || partpage == null)//无参数
                        partpage = { partial: null, reflash: function () { }, valid: function () { return true; }, load: function () { } };

                    this.stepInfo.partial = partpage;
                    if (partpage.partial == null)
                        apollo.app.append(this.el);
                    else
                        apollo.app.append(this.el, partpage.partial);
                };
                this.focus = function () {
                    // if (currStep!=null) currStep.blur();
                    if (step.partial != null && jQuery.isFunction(step.partial.load)) {
                        step.partial.load();
                    }
                    if (step.partial != null && jQuery.isFunction(step.partial.reflash)) {
                        step.partial.reflash();
                    }
                    if (this.el != null) $(this.el).show();

                    var isFirstStep = false, isLastStep = false;
                    if (this.prev == null)
                        isFirstStep = true;

                    if (this.next == null)
                        isLastStep = true;

                    apollo.app.setdata({
                        isFirstStep: isFirstStep,//当前步骤是否为第一步
                        isLastStep: isLastStep, //当前步骤是否为最后一步
                        currStepName: this.title
                    });
                    //对数据进行一次自动刷新
                    if (cngPageIndexFun != null && jQuery.isFunction(cngPageIndexFun)) cngPageIndexFun(index);
                };
                this.blur = function () {
                    // currStep=null;
                    if (this.el != null) $(this.el).hide();
                };
                this.empty = function () {
                    if (this.el != null) $(this.el).empty();
                };
                this.valid = function (toNext) {
                    if (step.partial != null && jQuery.isFunction(step.partial.valid)) {
                        return step.partial.valid(toNext);
                    }
                    else
                        return true;
                };
                this.prev = prev,//上一步骤,这是直接进入上一步
                    this.next = null //下一步骤，这是直接进入下一步，后续赠加一个委托，点击后不直接进入下一步，而是经过处理后再进入
            }

            function StepEntityMobile(_step, _prev, _index) {
                var index = _index;
                var step = _step;
                var prev = _prev;

                this.name = step.name;
                this.stepInfo = step;
                this.index = index,//当前步骤序号
                    this.el = null;
                this.url = apollo.getvpath(step.url);
                this.isloaded = function () {
                    return step.partial != null;
                };
                this.reg = function (partpage) {
                    if (arguments.length == 0 || partpage == null)//无参数
                        partpage = { name: this.name, partial: null, reflash: function () { }, valid: function () { return true; }, load: function () { } };
                    else
                        partpage.name = this.name;


                    if (apollo.SPA != null) {
                        apollo.SPA.reg(partpage);
                    }
                    else {
                        $(function () { apollo.SPA.reg(partpage); });
                    }

                    this.stepInfo.partial = partpage;
                };
                this.focus = function () {
                    if (step.partial != null && jQuery.isFunction(step.partial.load)) {
                        step.partial.load();
                    }
                    if (step.partial != null && jQuery.isFunction(step.partial.reflash)) {
                        step.partial.reflash();
                    }


                    if (this.el != null) $(this.el).show();

                    var isFirstStep = false, isLastStep = false;
                    if (this.prev == null)
                        isFirstStep = true;

                    if (this.next == null)
                        isLastStep = true;

                    apollo.app.setdata({
                        isFirstStep: isFirstStep,//当前步骤是否为第一步
                        isLastStep: isLastStep //当前步骤是否为最后一步
                    });
                    //对数据进行一次自动刷新
                    if (cngPageIndexFun != null && jQuery.isFunction(cngPageIndexFun)) cngPageIndexFun(index);
                };
                this.blur = function () {
                    // currStep=null;
                    if (this.el != null) $(this.el).hide();
                };
                this.empty = function () {
                    if (this.el != null) $(this.el).empty();
                };
                this.valid = function (toNext) {
                    if (step.partial != null && jQuery.isFunction(step.partial.valid)) {
                        return step.partial.valid(toNext);
                    }
                    else
                        return true;
                };
                this.prev = prev,//上一步骤,这是直接进入上一步
                    this.next = null //下一步骤，这是直接进入下一步，后续赠加一个委托，点击后不直接进入下一步，而是经过处理后再进入
            }

            //进入下一步
            function toNext() {
                //在进行下一步之前，先要对当前步骤进行检测及相关步骤操作
                var fun = function () {
                    var step = currStep.next;
                    if (step == null) return; //则取第一步
                    toStep(step, false);
                }
                if (currStep != null && currStep.valid(fun) == true) { //如果需要马上进入下一步进行操作，否则，根据调用方自行控制进入下一步
                    fun();
                }
            }
            //返回上一步
            function toPrev() {
                var step = null;
                if (currStep != null) step = currStep.prev;
                if (step == null) return; //则取第一步

                toStep(step, true);
            }
            //滚动到顶部
            function toTop() {
                try {
                    if (ismobile == true) {
                        var p = $('.pt-page-current>article');
                        p.animate({ scrollTop: 0 }, 'slow');
                    }
                    else {
                        $('html,body').animate({ scrollTop: 0 }, 'slow');
                    }
                }
                catch (e) {}
            }


            function getStep(name) {
                var steps = stepInfo.ReportSteps;
                var curstep = null;
                for (var i = 0; i < steps.length; i++) {
                    var step = steps[i];
                    if (apollo.Lib.isEquals(step.name, name)) {
                        curstep = step;
                        break;
                    }
                }
                return curstep;
            }
            //转入指定name的步骤
            function gotoStep(p, isback) {
                var step;
                if (jQuery.isNumeric(p)) {
                    var steps = stepInfo.ReportSteps;
                    if (p >= 0 && p < steps.length)
                        step = steps[p];
                }
                else
                    step = getStep(p);

                toStep(step, isback);
            }

            function toStepForMobile(step, isback) {
                if (step == null) return;//步骤不存在，则不处理
                currRegingStep = step;

                if (step.isloaded()) {//该步骤已加载
                    var prevName = "";
                    if (step.prev != null) prevName = step.prev.name;

                    apollo.SPA.open(step.name, step.url, prevName, function () {
                        if (currStep != null) currStep.blur();
                        step.focus();
                        currStep = step;
                        toTop();
                    }, isback);
                }
                else if (!step.isloaded() || isback != true) //该步骤之前未加载或者不是返回
                {
                    var prevName = "";
                    if (step.prev != null) prevName = step.prev.name;

                    apollo.SPA.open(step.name, step.url, prevName, function () {
                        if (currStep != null) currStep.blur();
                        step.focus();
                        currStep = step;
                        toTop();
                    }, isback);
                }
                else {
                    apollo.SPA.toback();
                    if (currStep != null) currStep.blur();
                    step.focus();
                    currStep = step;
                    toTop();
                }
            }

            function toStep(step, isback) {
                if (step == null) return;//步骤不存在，则不处理
                if (ismobile) {
                    toStepForMobile(step, isback);
                    return;
                }


                currRegingStep = step;

                if (!step.isloaded()) //该步骤未加载，则自动启动加载，加载完后步骤页必须要自行注册
                {
                    step.empty();
                    //这里要注意一下，如果是移动端，这里加载时是采用动画效果
                    if (step.el == null) {

                        if (ReportPanel == null) ReportPanel = $(op.ReportPanel);

                        step.el = $(op.StepPanelHtml);   //TODO:后续将改为参数模板控制
                        step.el.hide();
                        ReportPanel.append(step.el);
                    }

                    apollo.load(step.url, step.el, function () {
                        if (currStep != null) currStep.blur();
                        step.focus();//获取焦点
                        currStep = step;

                        toTop();
                    });
                }
                else //如之前已加载，则直接显示
                {
                    if (currStep != null) currStep.blur();
                    step.focus();

                    currStep = step;

                    toTop();
                }
            }


            //定义对象属性
            this.toNext = toNext;
            this.toPrev = toPrev;
            this.goto = gotoStep;//进入指定步骤，参数可以是索引，或步骤名称
            this.reg = function (partpage) {
                if (currRegingStep != null) currRegingStep.reg(partpage);
            }
        }

        //购物车产品控制器（用于处理购物车中商品、赠品等信息)
        function BasketProductUtil(Products) {
            var boxidno = 0;//定义一个全局id序号值，以便保证每个boxno一致
            var boxnameno = 0;//定义一个全局id序号值，以便保证每个boxno一致


            //初始购物车产品集对象
            var prods = [];
            $(Products).each(function (i, p) {
                prods.push(createItem(p));
            });

            //初始购物车赠品集对象
            var giveinfo = {
                flexgives: [],
                selectitems: [],
                valid: function () {
                    //先验证各产品赠品选项是否有选择
                    for (var i = 0; i < prods.length; i++) {
                        if (!prods[i].valid()) //有未选择项
                        {
                            return false;//这里不需要提示，在具体产品中有相应提示
                        }
                    }
                    //再验证自身
                    for (var i = 0; i < giveinfo.selectitems.length; i++) {
                        if (apollo.Guid.isEmpty(giveinfo.selectitems[i].SelectedID)) {
                            // showNotice("您未选择本报单具体促销赠品，请选择！");
                            basket.checkresult(false, "您未选择本报单具体促销赠品，请选择！", true);
                            return false;
                        }
                    }
                    return true;
                }
            }
            var isbasketprodvalid = false;//是否为购物车产品不合业务规则
            basketprodnovalid = "";//购物车产品不合规则提示信息

            var basket = {
                giveinfo: giveinfo,
                updateproducts: function () {
                    var param = that.createparam(true);

                    apollo.api("CKRegReportApi", "UpdateBasketProducts", param, function (arr) {
                        apollo.array.clear(prods);
                        $(arr).each(function (i, p) {
                            prods.push(createItem(p));
                        });
                        basket.reflash();
                        apollo.app.setdata("Basket", "Basket.checkInfo","Basket.ProductItems");
                    });
                },
                updatelist: function (arr) {
                    apollo.array.clear(prods);
                    $(arr).each(function (i, p) {
                        prods.push(createItem(p));
                    });
                    basket.reflash();
                    apollo.app.setdata("Basket", "Basket.checkInfo", "Basket.ProductItems");
                },
                //购物车产品信息项
                ProductItems: prods,
                //购物车中加价购商品信息
                //查找指定编号的产品，并获取该产品
                find: function (code) {
                    return apollo.array.find(prods, function (p) { return apollo.Lib.isEquals(p.Product.ProductCode, code); });
                },
                //向购物车增加产品(不指定数量),注意，这里不进行控制重复产品，由前端进行控制
                add: function (op) {                    
                    var prod = basket.find(op.ProductCode);
                    if (prod == null) {
                        prods.push(createItem(op));//只有实际存在，才会添加
                        basket.reflash();
                    }
                },
                changenum: function (prod, num)//更改购物车指定商品数量
                {
                    //注意，这里要保证数量是符合订购倍数
                    prod.ProductCount = num;
                    prod.SaleMoney = prod.ProductPrice * num;
                    prod.SaleDiscountMoney = prod.DiscountMoney * num;
                    basket.reflash();
                },
                reflashcx: function (p) {
                    var cxentity, productcode = "";
                    if (arguments.length == 1) //为设置报单对象
                    {
                        cxentity = arguments[0];
                    }
                    else if (arguments.length == 2) {
                        cxentity = arguments[0];
                        productcode = arguments[1];
                    }
                    else
                        return;//视为无效方法


                    if (cxentity == null) cxentity = { FixedGives: [], SelectedItem: [], MarkupGives: [], IsFixedGive: true };//为空对象
                    var info = null;
                    if (productcode != "") {
                        info = basket.find(productcode);
                    }
                    else
                        info = giveinfo;

                    if (info == null) return;

                    var arr = [];

                    $(cxentity.FixedGives).each(function (i, give) {
                        arr.push(give.Explain);
                    });

                    info.fixedgives = arr.join("+");


                    createSelectItemsfor(info, cxentity.SelectedItem);

                    //移除不属于相产品项的
                    if (productcode != "") {
                        apollo.array.removeAll(cxentity.SelectedItem, function (item) {
                            return item.IsForProduct != true;
                        });
                    }
                    info.selectitems = cxentity.SelectedItem;//注意，这里更新之前要保留之前的选项                 

                },
                addmarkupgive: function (prod)//将产品加入到加价购赠品中
                {
                    var checkfun = function (mg) { return apollo.Lib.isEquals(mg.CxDetailID == prod.CxDetailID); };
                    //检测要添加的商品是否属于多选一
                    var mginfo = apollo.array.find(app.getdata().MarkupGiveInfos, checkfun);
                    if (mginfo != null && mginfo.IsMoreSaleOne == true) //属于多选一
                    {
                        //则检查加价购中已选产品
                        if (apollo.array.exists(that.report.MarkupGives, checkfun)) {
                            alert("对不起，加价购商品只能选择一个，不能选择多个！");
                            return false;
                        }
                    }
                    var mgprod = apollo.array.find(that.report.MarkupGives, function (p) {
                        return apollo.Lib.isEquals(p.CxDetailID, prod.CxDetailID) && apollo.Lib.isEquals(p.Product.ProductCode, prod.Product.ProductCode);
                    });
                    if (mgprod != null) {
                        mgprod.LimitSaleNum = prod.LimitSaleNum;//注意这项，一定是以促销规则的为准
                        showNotice("该加价购商品已在购物车中");
                        return false;
                    }
                    else //将该产品转成订货产品
                    {
                        var p = $.extend(true, {}, prod); //创建一个复本
                        //设置具体数量（必须是最小订购倍数）
                        var count = 1 * prod.Product.OrderNumTimes;
                        if (count <= 0) count = 1;

                        p.Product.ProductCount = count;
                        that.report.MarkupGives.push(p);
                        showNotice("成功加入到促销优惠加价购商品中！")
                        basket.reflash();
                        return true;
                    }
                },
                IsRegUpgradeReport: that.report.IsRegUpgradeReport,//当前报单是否为注册升级
                //报单金额及费用相关，主要用于呈现，在改变报单情况下刷新
                //注意，这一部分与相关业务规则有点关系
                totalsalemoney:0,//报单所有金额
                totalmoney: 0,//报单所有金额（减扣赠券后的金额）
                logfee: 0,//运费
                totalprodmoney: 0,//报单产品总金额，不含9号馆，也不包括工具包
                totalothermoney: 0,
                totaldiscountmoney:0,//赠券合计
                
                reflash: function () {
                    basket.totalsalemoney = 0;
                    basket.totalmoney = 0;//总金额
                    basket.totalprodmoney = 0;//产品金额
                    basket.totalothermoney = 0;//其它金额
                    basket.totaldiscountmoney = 0;
                    basket.logfee = 0;
                    $(prods).each(function (i, p) {
                        if (p.Product.ProductPlaceID == "09" || p.Product.ProductPlaceID == "03")
                            basket.totalothermoney += p.Product.SalePrice * p.Product.ProductCount;
                        else
                            basket.totalprodmoney += p.Product.SalePrice * p.Product.ProductCount;                        

                        //总的赠用券
                        basket.totaldiscountmoney += p.Product.DiscountMoney * p.Product.ProductCount;

                        basket.totalsalemoney += p.Product.SalePrice * p.Product.ProductCount;
                        basket.totalmoney += p.Product.ProductPrice * p.Product.ProductCount;
                    });
                    $(that.report.MarkupGives).each(function (i, mg) {
                        basket.totalothermoney += mg.Product.SaleMoney;
                        basket.totalmoney += mg.Product.SaleMoney;
                        basket.totalsalemoney += mg.Product.SaleMoney;
                    });
                    apollo.app.setdata("Basket");
                },
                checkInfo: {
                    isvalid: false,
                    novalidInfo: ""//购物车不合法时提示信息                    
                },
                checkresult: function (isvalid, info, isgive) {
                    basket.checkInfo.isvalid = isvalid;
                    basket.checkInfo.novalidInfo = "温馨提示：" + info;
                    apollo.app.setdata("Basket.checkInfo");
                    if (isgive != true) {
                        isbasketprodvalid = isvalid;
                        basketprodnovalid = info;
                    }
                },
                valid: giveinfo.valid
            };

            ///封装购物产品
            function createItem(prod) {
                var p = prod;
                var info = {
                    Product: p,//实际产品
                    saleProductCode: p.ProductCode,
                    fixedgives: "",//该产品购物固定赠品信息
                    selectitems: [],//相关赠品选择项,等同于后台PersonGiveSelect对象数组
                    valid: function () { //验证是否合法,这里是验证前端赠品选择是否合法
                        for (var i = 0; i < info.selectitems.length; i++) {
                            if (apollo.Guid.isEmpty(info.selectitems[i].SelectedID)) {
                                //  showNotice("您未选择购买[" + p.AliasName + "]的具体促销赠品，请选择！");
                                basket.checkresult(false, "您未选择购买[" + p.AliasName + "]的具体促销赠品，请选择！", true);
                                return false;
                            }
                        }
                        return true;
                    }
                };
                return info;
            }

            ///对赠品选择项再次进行封装，以便UI选择时知道是对应哪个促销赠品,并产生选择赠品联动，所以这里一定要记录是和后端PersonSaleGive对象一致
            function createSelectItemsfor(prod, selectitems) {
                $(selectitems).each(function (index, item) {
                    boxnameno++;//单选项name序号增加1，使得当前组序号不会和其它组重合
                    var arr = [];
                    $(item.SelectedItem).each(function (i, option) {
                        //在原来的每个选项中增加一些方法，以便可以控制前端UI显示
                        boxidno++;//每个选项id值序号加1，保证唯一性
                        var thatOp = option;
                        option.saleProductCode = prod.saleProductCode;
                        option.parent = item;
                        //在原来的选择项增加属性
                        option.rdboxname = "rdGiveSelectBox" + boxnameno;
                        option.rdboxid = option.rdboxname + "_" + boxidno;
                        //创建一个方法,当选中本项时，产生联动，以便报单保存选择信息(必须按现有报单对象设计规则处理）
                        option.selected = function () {//选中了当前项
                            var report = apollo.app.getdata().Report;
                            var info = apollo.array.find(report.GiveSelectInfos, function (o) {
                                return o.CxDetailID == thatOp.parent.CxDetailID && o.SaleProductCode == thatOp.saleProductCode
                            });
                            if (info != null) //有这项,则标记该项选中值为当前项ID
                            {
                                info.SelectedID = thatOp.Value;//Value为option选项本身属性值，即选择项ID
                            }
                            else //如果不存在，则将当前选中值追加到报单中
                            {
                                report.GiveSelectInfos.push({
                                    CxDetailID: thatOp.parent.CxDetailID,
                                    SaleProductCode: thatOp.saleProductCode,
                                    SelectedID: thatOp.Value
                                });
                            }

                            //为了使前端能进行验证，这里对该选项所属促销项也要标记当前选中的ID
                            $(thatOp.parent.SelectedItem).each(function (i, ci) { ci.IsSelected = false; });

                            thatOp.parent.SelectedID = thatOp.Value;
                            thatOp.IsSelected = true;


                            //到这一步，赠品选择项就已完成了。
                            if (basket.valid()) basket.checkresult(isbasketprodvalid, basketprodnovalid, false);
                        };

                        arr.push(option);
                    });

                    //到这一步，前端就可以设置SelectedItem作为赠品选择项用于呈现了
                });
            }


            if (Products != null && Products.length > 0)
                basket.reflash();

            return basket;
        }


        /**
        * 创建报单注册步骤对象
        * @param {Array} ReportSteps 注册步骤
        */
        function CreateReportStepInfo(ReportSteps) {
            return {
                ReportSteps: ReportSteps,
                CurrStepIndex: 0// 当前步骤索引
            };
        }

        /**创建报单页通用配置对象*/
        function CreateReportPageOption(ReportSteps, OnLoadFun) {
            var reportStep = CreateReportStepInfo(ReportSteps);//选创建步骤对象
            //刷新页面
            stepUtil = new ReportStepUtil(reportStep, function (index) {
                apollo.app.setvalue("StepInfo.CurrStepIndex", index);
            });


            var options = {
                data: {
                    showcurshareainfo:false,
                    OpType: "Report",//当前报单操作类型：Report-正常报单各步骤,SelProduct-选购购物产品,-ReportError:报单异常,如结算不能报单或报单不存在提示等
                    Report: null,//购物报单对象
                    Basket: null,//购物蓝对象 
                    isFirstStep: false,
                    isLastStep: false,
                    currStepName: "",
                    StepInfo: reportStep, //创建报单步骤对象，用于控制各步骤
                },
                onload: OnLoadFun,
                //以下为各页需处理的共用事件方法
                onnext: function (e) {//进入下一步
                    stepUtil.toNext();
                },
                onprev: function (e) {//进入上一步
                    stepUtil.toPrev();
                },
                onautoupdate: function (e) //针对输入项自动进行更新(因为有可能多页都有输入框，为防止多页重复设置同一名称方法，这里固定一个通用的
                {
                    e.updatevalue();
                },
                ontohome: function (e)//返回到首页
                {
                    if (that.report.ReportType > 1) //非注册报单
                    {
                        var fun = function () {
                            that.existSale();
                            if (ismobile == true && that.report.IsShareRetail == true && apollo.Lib.isEmpty(that.report.ID)) {//分享报单 
                                openWin("ShareHome", "Mobile/WXShare/Index");
                            }
                            else if (ismobile == true && that.report.IsShareRetail == true) {
                                openWin("ShareHome", "Mobile/WXShare/MyIndex");
                            }
                            else
                                apollo.app.getoption().ontomycenter();
                        };
                        if (isbuying == true) {
                            apollo.dialog.confirm("您当前正在进行购物操作，是否真要退出！", function () {
                                fun();
                            });
                        }
                        else {
                            fun();
                        }
                    }
                    else {
                        var fun = function () {
                            that.existSale();
                            if (ismobile == true) {
                                if (that.regType == 1 || that.report.ReportUserRole==5) //天使注册,进入分享首页
                                {
                                    openWin("ShareHome", "Mobile/WXShare/Index");
                                }
                                else {
                                    openWin("Home", "Mobile/CKHome/Index");
                                }
                            }
                            else
                                location.href = apollo.getvpath("CKHome/Index");
                        };
                        if (isbuying == true) {
                            apollo.dialog.confirm("您当前正在进行购物报单操作，是否真要退出报单！", function () {
                                fun();
                            });
                        }
                        else {
                            fun();
                        }
                    }
                },
                ontomycenter: function (e)//返回到个人中心
                {
                    var fun = function () {
                        that.existSale();
                        if (that.report.ReportType == 1) //注册报单
                        {
                            if (ismobile == true) {
                                if (that.report.ReportUserRole == 5) {
                                    openWin("ShareHome", "Mobile/WXShare/Index");
                                }
                                else {
                                    openWin("Home", "Mobile/MyCenter/Index");
                                }
                            }
                            else
                                location.href = apollo.getvpath("CKHome/Main");
                        }
                        else {
                            if (ismobile == true) {
                                if (that.report.ReportType == 71)
                                    openWin("ShareHome", "Mobile/WXShare/MyIndex");
                                else
                                    openWin("Home", "Mobile/MyCenter/Index");
                            }
                            else
                                location.href = apollo.getvpath("CKHome/Main");
                        }
                    };

                    if (isbuying == true) {
                        apollo.dialog.confirm("您当前正在进行购物操作，是否真要退出！", function () {
                            fun();
                        });
                    }
                    else {
                        fun();
                    }
                }
            };

            return { stepUtil: stepUtil, options: options };
        }

        /**报单页初步加载方法*/
        function ReportLoad(app, ApiController, ApiMethod, Param, GotoStepFun, BeforeSaleBuy) {
            var isshare = Param.IsShareReport;
            var reporttype = "0";
            if (Param.ReportType != null)
                reporttype = Param.ReportType;

            app.setdata({ ReportType: reporttype });
            var successFun = function (rtn) {
                if (rtn.IsSuccess) //可以正常进行报单
                {
                    var item = rtn.ReturnValue;//实际值格式为：{Bill:{Report:{},Products:[]},UIParams}

                    //初始化报单步骤
                    that.report = item.Bill.Report;
                    that.basket = new BasketProductUtil(item.Bill.Products);
                    that.uiparam = item.UIParams;
                    basket = that.basket;

                    if (that.report.ReportType != null)
                        reporttype = that.report.ReportType;


                    app.setdata({
                        Report: that.report,
                        Basket: that.basket,
                        ReportType: reporttype,
                        OpType: CKReportEnum.OpTypeForReport,
                        ReportError: ""
                    });

                    if (BeforeSaleBuy != null && jQuery.isFunction(BeforeSaleBuy)) {
                        BeforeSaleBuy({
                            options: that.saleoptions,
                            util: that,
                            report: that.report
                        });
                    }

                    if (GotoStepFun != null && jQuery.isFunction(GotoStepFun))
                        GotoStepFun(that.stepUtil, that.report);
                    that.beginSale();
                }
                else //有异常，不能正常报单，则统一提示错误
                {
                    //显示错误信息
                    if (isshare == true)
                        ShowShareReportError(app, rtn.Message);
                    else
                        ShowReportError(app, rtn.Message);
                }
            };
            var errorFun = function (err) {
                //显示错误信息
                if (isshare)
                    ShowShareReportError(app, "报单时出现了故障，请联系管理员！");
                else
                    ShowReportError(app, "报单时出现了故障，请联系管理员！");


                showNotice(err);

            };

            apollo.api(ApiController, ApiMethod, Param, successFun, errorFun);
        }

        function NormalFlowLoad(app, ApiController, ApiMethod, Param, GotoStepFun, BeforeOption) {
            var isshare = false;
            var successFun = function (rtn) {
                if (rtn.IsSuccess) //可以正常进行报单
                {
                    var item = rtn.ReturnValue;//实际值格式为：{Bill:{Report:{},Products:[]},UIParams}

                    //初始化报单步骤
                    that.report = item;
                    app.setdata({
                        Report: that.report
                    });

                    if (BeforeOption != null && jQuery.isFunction(BeforeOption)) {
                        BeforeOption({
                            options: that.saleoptions,
                            util: that,
                            report: that.report
                        });
                    }

                    if (GotoStepFun != null && jQuery.isFunction(GotoStepFun))
                        GotoStepFun(that.stepUtil, that.report);
                }
                else //有异常，不能正常报单，则统一提示错误
                {
                    //显示错误信息
                    ShowReportError(app, rtn.Message);
                }
            };
            var errorFun = function (err) {
                //显示错误信息
                if (isshare)
                    ShowShareReportError(app, "报单时出现了故障，请联系管理员！");
                else
                    ShowReportError(app, "报单时出现了故障，请联系管理员！");


                showNotice(err);

            };

            apollo.api(ApiController, ApiMethod, Param, successFun, errorFun);
        }




        //显示分享报单错误
        function ShowShareReportError(app, ReportError) {
            app.setdata({
                OpType: CKReportEnum.OpTypeForReportError,
                ReportError: ReportError
            });
            apollo.SPA.open("SaleError", "ReportTemplate/Mobile/ShareSaleError.html", "");
        }


        /**显示报单错误异常
         * @param {string} ReportError  错误提示信息
        */
        function ShowReportError(app, ReportError) {
            app.setdata({
                OpType: CKReportEnum.OpTypeForReportError,
                ReportError: ReportError
            });
            if (ismobile == true) {
                apollo.SPA.open("SaleError", "ReportTemplate/Mobile/SaleError.html", "");
            }
        }
        /**显示正常报单，并进入指定步骤
         * @param {string} Step  要进入的步骤，如果为空，则默认进入之前那一步或第一步
        */
        function ShowReport() {
            if (ismobile == true) {
                apollo.SPA.toBackPage("ShopingCart");
            }
            else {
                app.setdata({
                    OpType: CKReportEnum.OpTypeForReport,
                    ReportError: ""
                });
            }
        }

        /**显示选购产品*/
        function ShowSelProduct() {
            if (ismobile == true) {
                apollo.SPA.open("ProdList", op.SelProductDefine.url, apollo.SPA.name);
            }
            else {
                //加载选购产品模板，并进入选购产品页,因在购物车中可能会有已加入了产品信息，
                if (op.SelProductDefine.isloaded == true) //之前已加载过选购商品区，则自动显示产品列表
                {
                    app.setdata({
                        OpType: CKReportEnum.OpTypeForSelProduct,
                        ShowProdList: true
                    });
                }
                else {//则进行加载
                    var url = apollo.getvpath(op.SelProductDefine.url);
                    apollo.load(url, $(op.SelProductPanel), function () {
                        op.SelProductDefine.isloaded = true;//标记为已加载
                        app.setdata({
                            OpType: CKReportEnum.OpTypeForSelProduct,
                            ShowProdList: true
                        });
                        //进行渲染该区域
                        apollo.app.append($(op.SelProductPanel));
                    });
                }
            }
        }

        var arrPopup = {};
        //显示弹出销售选择产品
        function ShowPopupProducts(typeName, title, url) {
            url = apollo.getvpath(url);
            var util = apollo.Lib.getAttr(arrPopup, typeName);
            if (util == null) {
                var popupdiv = $("<div></div>");
                $("body").append(popupdiv);
                apollo.load(url, popupdiv, function (rtn) {
                    //从底部弹出                    
                    util = popupdiv.popupLayout({ title: title });
                    apollo.app.append(popupdiv);

                    arrPopup[typeName] = util;
                    util.show();
                });
            }
            else
                util.show();
        }

        function getProductPlaceName(el) {
            var param = {
                tb: "TB_ProductPlace", vf: "ProductPlaceID", nf: "ProductPlaceName", v: product.ProductPlaceID
            };
            apollo.api("CKHomeApi", "GetEnumName", param, function (v) {
                $(el).html(v);
            });
            return "";
        }

        function getSaleChannel() {
            var zz = apollo.array.find(that.uiparam.SaleChannels, function (el) {
                return el.SaleChannelID == that.report.SaleChannel;
            });
            if (zz != null)
                return zz.SaleChannelName;
            else
                return "";
        }
        function getAreaForShopName(el) {
            var report = that.report;
            var pid = report.ShopNameForProvinceID;
            var cid = report.ShopNameForCityID;
            var cuid = report.ShopNameForCountyID;

            return getFullAddress(pid, cid, cuid, el);
        }

        function getAreaForSH(el) {
            var report = that.report;
            var pid = report.ProvinceIDOfSH;
            var cid = report.CityIDOfSH;
            var cuid = report.CountyIDOfSH;

            return getFullAddress(pid, cid, cuid, el);
        }

        function getFullAddress(pid, cid, cuid, el) {
            var param = { ProvinceID: pid, CityID: cid, CountyID: cuid };
            apollo.api("CKAreaApi", "GetFullAddress", param, function (v) {
                $(el).val(v);
            });
            return "";
        }

        function getAreaForBankName() {
            return that.report.ProvinceOfBankName + that.report.CityOfBankName;
        }
        function getZzmmName() {
            var zz = apollo.array.find(that.uiparam.ZzmmItems, function (el) {
                return el.Value == that.report.ZzmmID;
            });
            if (zz != null)
                return zz.Name;
            else
                return "";
        }
        function getDegreeName() {
            var zz = apollo.array.find(that.uiparam.DegreeItems, function (el) {
                return el.Value == that.report.DegreeID;
            });
            if (zz != null)
                return zz.Name;
            else
                return "";
        }
        function getRegUserRoleName() {
            var zz = apollo.array.find(that.uiparam.UserRoleItems, function (el) {
                return el.Value == that.report.RegUseRole;
            });
            if (zz != null)
                return zz.Name;
            else
                return "";
        }
        function getUpgradeUserRoleName() {
            var zz = apollo.array.find(that.uiparam.UserRoleItems, function (el) {
                return el.Value == that.report.UpgradeUserRole;
            });
            if (zz != null)
                return zz.Name;
            else
                return "";
        }

        function getReBusinessName() {
            if (apollo.Lib.isEmpty(that.report.ReBusinessCode))
                return "指定推荐码";
            else
                return that.report.ReBusinessName;
        }

        return that;
    }

    //普通业务流程，只进行步骤处理，不进行业务控制
    function NormalFlow(myoptions) {
        //注册步骤信息,因这里有固定步骤模板URL，所以这个变量改为参数
        var defaults = {
            Steps: null,
            SelProductUrl: null,
            StepDivHtml: null,
            ReportPanel: null,
            SelProductPanel: null,
            FirstStepName: "",
            PayStepName: "",
            BeforeSaleBuy: null,
            ApiController: "",
            ApiMethod: "",
            Param:null
        }

        var op = $.extend(defaults, myoptions);

        var SelProductDefine = {
            isloaded: false,//是已加载过模板（主要是防止重复加载)
            url: op.SelProductUrl //选购产品模板
        };
        var initop = {
            IsStepOptions: true,
            Steps: op.Steps,//报单步骤信息
            SelProductDefine: SelProductDefine,//产品选购对应模板
            StepPanelHtml: op.StepDivHtml,//存放各报单内容的div元素HTML（因为PC和移动端可能会有差异，所以这里采用参数模板方式，由前端调用获取，不再由库自行控制，以确保脚本与UI分离
            ReportPanel: op.ReportPanel,//报单步骤所在区域DOM
            SelProductPanel: op.SelProductPanel,//选购产品报在区域
            ApiController: op.ApiController,//开始报单的API控制器
            ApiMethod: op.ApiMethod,//开始报单的API方法
            Param: op.Param,
            options: op,
            BeforeSaleBuy: op.BeforeSaleBuy,
            BeginToStepFun: function (stepUtil, report) { //加载完毕后执行进入指定步骤的方法
                stepUtil.goto(op.FirstStepName);//进入第一步
            }
        }

        return new ReportUtil(initop);
    }


    /**
     * 定义视频认证通用方法
     * @param {any} myoptions
     */
    function VideoAuth(vaOp) {
        //注册步骤信息,因这里有固定步骤模板URL，所以这个变量改为参数
        var defaults = {
            Steps: null,
            SelProductUrl: null,
            StepDivHtml: null,
            ReportPanel: null,
            SelProductPanel: null,
            FirstStepName: "",
            PayStepName: "",
            BeforeSaleBuy: null
        }

        var op = $.extend(defaults, vaOp);

        var SelProductDefine = {
            isloaded: false,//是已加载过模板（主要是防止重复加载)
            url: op.SelProductUrl //选购产品模板
        };
        var initop = {
            IsStepOptions: true,
            Steps: op.Steps,//报单步骤信息
            SelProductDefine: SelProductDefine,//产品选购对应模板
            StepPanelHtml: op.StepDivHtml,//存放各报单内容的div元素HTML（因为PC和移动端可能会有差异，所以这里采用参数模板方式，由前端调用获取，不再由库自行控制，以确保脚本与UI分离
            ReportPanel: op.ReportPanel,//报单步骤所在区域DOM
            SelProductPanel: op.SelProductPanel,//选购产品报在区域
            ApiController: "CKUserApi",//开始报单的API控制器
            ApiMethod: "GetCurUserVideoAuth",//开始报单的API方法
            Param: {//API方法参数
                
            },
            options: op,
            BeforeSaleBuy: op.BeforeSaleBuy,
            BeginToStepFun: function (stepUtil, report) { //加载完毕后执行进入指定步骤的方法
                if (report.IsVideoAuthed!=true) //新报单
                    stepUtil.goto(op.FirstStepName);//进入第一步
                else
                    stepUtil.goto(op.PayStepName);//进入最后一步
            }
        }

        return new ReportUtil(initop);
    }
    /**
     * 创建并获取注册报单对象，返回apollo.app对象值
     * @param {string} BusinessCode  注册编辑时，业务编号，如是新注册，则为空值
     * @param {string} BusiLicenceNo 注册珍珠店时已上传的实体营业编号，非珍珠店或编辑时为空值
     * @param {string} Sign  //注册珍珠店实体验签或编辑注册时编号验签码，非珍珠店新注册或其它珍珠店新注册时为空值
     * @param {JQuery Element} ReportPanel  //页面模板中存放各步骤的DOM元素ID，注意，这里是jquery对象，必须实现可通过$()取到具体对象(报单页采用单页模式)
     * @param {JQuery Element} SelProductPanel ////页面模板中存放选购产品的DOM元素ID，注意，这里是jquery对象，必须实现可通过$()取到具体对象(报单页采用单页模式)
     */
    function RegReport(regOp) {
        //注册步骤信息,因这里有固定步骤模板URL，所以这个变量改为参数
        var defaults = {
            BusinessCode: null,
            MainBusinessCode:null,
            BusiLicenceNo: null,
            RecommandCode: "",
            FromShopCode: null,
            isYSIndex: false,//是否来源于云商天使注册（注意，这个专指天使分享注册）
            IsPay:null,
            Sign: null,
            RegType: null,
            Steps: null,
            SelProductUrl: null,
            StepDivHtml: null,
            ReportPanel: null,
            SelProductPanel: null,
            FirstStepName: "",
            PayStepName: "",
            BeforeSaleBuy: null
        }

        var op = $.extend(defaults, regOp);

        var SelProductDefine = {
            isloaded: false,//是已加载过模板（主要是防止重复加载)
            url: op.SelProductUrl //选购产品模板
        };
        var initop = {
            Steps: op.Steps,//报单步骤信息
            SelProductDefine: SelProductDefine,//产品选购对应模板
            StepPanelHtml: op.StepDivHtml,//存放各报单内容的div元素HTML（因为PC和移动端可能会有差异，所以这里采用参数模板方式，由前端调用获取，不再由库自行控制，以确保脚本与UI分离
            ReportPanel: op.ReportPanel,//报单步骤所在区域DOM
            SelProductPanel: op.SelProductPanel,//选购产品报在区域
            ApiController: "CKRegReportApi",//开始报单的API控制器
            ApiMethod: "GetOrCreateRegReport",//开始报单的API方法
            Param: {//API方法参数
                BusinessCode: op.BusinessCode,
                MainBusinessCode: op.MainBusinessCode,
                BusiLicenceNo: op.BusiLicenceNo,
                ReCommandCode: op.RecommandCode,
                FromShopCode: op.FromShopCode,
                IsPay: op.IsPay,
                Sign: op.Sign,
                RegType: op.RegType,
                IsShareReport: op.isYSIndex
            },
            options: op,
            BeforeSaleBuy: op.BeforeSaleBuy,
            BeginToStepFun: function (stepUtil, report) { //加载完毕后执行进入指定步骤的方法
                if (apollo.Lib.isEmpty(report.BusinessCode)) //新报单
                    stepUtil.goto(op.FirstStepName);//进入第一步
                else if (op.IsPay == "1" || (op.isYSIndex != true && report.RegUseRole==5) || report.PayingMoney > 0)//还没有付清，则直接跳到支付页以进行支付或天使注册，直接进入最后一步
                    stepUtil.goto(op.PayStepName);//进入最后一步
                else {
                    stepUtil.goto(op.FirstStepName);//进入第一步
                }   
            }
        };

        return new ReportUtil(initop);
    }
    /**
     * 创建并获取购物报单对象，返回apollo.app对象值(对于升级和普通报单，步骤可能会有点点差异)
     * @param {string} BusinessCode  注册编辑时，业务编号，如是新注册，则为空值
     * @param {string} BusiLicenceNo 注册珍珠店时已上传的实体营业编号，非珍珠店或编辑时为空值
     * @param {string} Sign  //注册珍珠店实体验签或编辑注册时编号验签码，非珍珠店新注册或其它珍珠店新注册时为空值
     * @param {JQuery Element} ReportPanel  //页面模板中存放各步骤的DOM元素ID，注意，这里是jquery对象，必须实现可通过$()取到具体对象(报单页采用单页模式)
     * @param {JQuery Element} SelProductPanel ////页面模板中存放选购产品的DOM元素ID，注意，这里是jquery对象，必须实现可通过$()取到具体对象(报单页采用单页模式)
     */

    function BuyReport(buyOp) {
        //注册步骤信息,因这里有固定步骤模板URL，所以这个变量改为参数
        var defaults = {
            CashCode: null,
            ReportType: null,
            BusiLicenceNo: null,
            IsPay: 0,
            IsToCart: "0",
            UpgradeID:25,//针对跨类型店升级，默认是升级到大店
            ProductCode: "",
            Sign: null,
            IsShareReport: false,
            Steps: null,
            SelProductUrl: null,
            StepDivHtml: null,
            ReportPanel: null,
            SelProductPanel: null,
            FirstStepName: "",
            PayStepName: "",
            SettlementName: "",//结算确认步（当报单不能修改时的步骤)
            YXBillCode:"",//亲选订单
            BeforeSaleBuy: null
        }

        var op = $.extend(defaults, buyOp);

        var SelProductDefine = {
            isloaded: false,//是已加载过模板（主要是防止重复加载)
            url: op.SelProductUrl //选购产品模板
        };

        var apimethod = "";
        if (op.ReportType == 71) {//非业务报单
            apimethod = "GetOrCreateNoBusiReport";
        }
        else if(op.IsShareReport == true) //私董优选微信分享报单
        {
            apimethod = "GetOrCreateShareReport";
        }
        else { //正常业务报单
            apimethod = "GetOrCreateBuyReport";
        }


        var apiMethod = "";
        var initop = {
            Steps: op.Steps,//报单步骤信息
            SelProductDefine: SelProductDefine,//产品选购对应模板
            StepPanelHtml: op.StepDivHtml,//存放各报单内容的div元素HTML（因为PC和移动端可能会有差异，所以这里采用参数模板方式，由前端调用获取，不再由库自行控制，以确保脚本与UI分离
            ReportPanel: op.ReportPanel,//报单步骤所在区域DOM
            SelProductPanel: op.SelProductPanel,//选购产品报在区域
            ApiController: "CKBuyReportApi",//开始报单的API控制器
            ApiMethod: apimethod,//开始报单的API方法
            Param: {//API方法参数
                CashCode: op.CashCode,
                ReportType: op.ReportType,
                BusiLicenceNo: op.BusiLicenceNo,
                IsToCart: op.IsToCart,
                IsPay: op.IsPay,
                ProductCode: op.ProductCode,
                UpgradeID: op.UpgradeID,
                YXBillCode: op.YXBillCode,
                Sign: op.Sign,
                IsShareReport: op.IsShareReport
            },
            options: op,
            BeforeSaleBuy: op.BeforeSaleBuy,
            BeginToStepFun: function (stepUtil, report) { //加载完毕后执行进入指定步骤的方法
                if (report.FormTypeID == "2" && apollo.Lib.isEmpty(report.CashCode) && report.ReportType != 51 && report.ReportType != 1 && apollo.Lib.isNotEmpty(op.SettlementName))
                    stepUtil.goto(op.SettlementName);//亲选购物新报单直接进入结算确认
                else if (apollo.Lib.isEmpty(report.CashCode)) //新报单
                    stepUtil.goto(op.FirstStepName);//进入第一步
                else if (report.FormTypeID == "2" && apollo.Lib.isNotEmpty(report.CashCode) && report.ReportType != 51 && report.ReportType != 1)
                    stepUtil.goto(op.PayStepName);//亲选购物报单修改进入最后一步
                else if (op.IsPay != "1" && report.ReportType == 51)//考核报单修改状态下进行第一页
                    stepUtil.goto(op.FirstStepName);//进入第一步
                else if (op.IsPay == "1" || report.ReportType == 51 || report.PayedMoney > 0 || report.IsShareRetail == true)
                    stepUtil.goto(op.PayStepName);//进入最后一步
                else
                    stepUtil.goto(op.FirstStepName);//进入第一步
            }
        };

        return new ReportUtil(initop);
    }

    return {
        NormalFlow: NormalFlow,
        VideoAuth: VideoAuth,
        RegReport: RegReport,//注册报单
        BuyReport: BuyReport //购物报单（含升级、分享零售、自零售、积分、考核等)
    };
})(apollo, jQuery);


function MobileCheckUtil(MobileInfo, dataName) {
    var rtn = {
        status: 0,//未启动获取
        getVCode: function () {
            if (rtn.status == 1) return;
            getVCode();
        },
        stopJS: function (type) {
            stopJS();

        }
    };
    var mi = null;// MobileInfo;

    function isMobile(value) {
        var length = value.length;
        var mobile = /[0-9]{11}/;
        return length == 11 && mobile.test(value);
    }
    //获取开店短信验证码
    function getVCode() {
        var mobile = ReportPage.report.Mobile;
        if (!isMobile(mobile)) {
            alert("请输入正确的手机号");
            return;
        }
        var successFun = function (rtn) {
            if (rtn.IsSuccess) {
                if (apollo.Lib.isNotEmpty(rtn.Message)) {
                    showNotice(rtn.Message);
                }
                beginJS();
            }
            else
                alert(rtn.Message);
        };

        apollo.api("CKRegReportApi", "CreateVCode", { Mobile: mobile }, successFun);
    }

    var timerJS = null;
    var times = 0;
    function jsForVCode() {
        if (mi == null) {
            mi = apollo.app.getdata().MobileInfo;
        }
        mi.btnText = times + "s";
        rtn.status = 1;

        if (times <= 0) {
            clearInterval(timerJS);
            rtn.status = 0;
            mi.btnText = "重新获取";
        }
        else {
            times--;
        }
        apollo.app.setdata(dataName);
    }

    function beginJS() {
        if (mi == null) {
            mi = apollo.app.getdata().MobileInfo;
        }
        times = 60;
        mi.btnText = times + "s";
        rtn.status = 1;
        timerJS = setInterval(jsForVCode, 1000);

        apollo.app.setdata(dataName);
    }
    /*停止计时*/
    function stopJS() {
        if (mi == null) {
            mi = apollo.app.getdata().MobileInfo;
        }
        clearInterval(timerJS);
        rtn.status = 0;
        mi.btnText = "获取验证码";
        apollo.app.setdata(dataName);
    }
    return rtn;
}

/*购物车方法*/
(function ($) {
    $.fn.extend({
        /*产品选购时购物车相关方法*/
        popupLayout: function (options) {
            var panel = $(this);
            var panelH = panel.height();
            var defaults = {
                title: "",
                showClose: true,
                position: "bottom",//起始位置
                ismax: false//是否全屏显示，如果是全屏，则不定位
            };

            var op = $.extend(defaults, options);

            var layout = {
                maskDiv: null,
                mainDiv: null,
                init: function () {
                    var h = panelH;
                    panel.remove();
                    layout.maskDiv = $("<div style=\"position: fixed;top:0;left:0;width:100%;height:100%;background-color:#000000;z-index:120;\"></div>");
                    layout.maskDiv.css("opacity", 0);

                    layout.maskDiv.click(function () {
                        layout.hide();
                    });

                    layout.maskDiv.hide();
                    $("body").append(layout.maskDiv);

                    layout.mainDiv = $("<div style=\"position:fixed;z-index:121; right:0px;left:0px;bottom:-30px;background-color:#fff;padding:10px; color:#da251c;\"></div>");
                    //先加标题行
                    var tdiv = $("<div style='height:2.5em; line-height:1em;overflow:hidden;'></div>");
                    var tspan = $("<div style='width:80%;float:left;text-overflow:ellipsis;font-size:16px;font-weight:bold;'>" + op.title + "</div>");
                    tdiv.append(tspan);
                    layout.mainDiv.append(tdiv);

                    var rspan = $("<div style='float:right;width:20%;line-height:2em;text-align:right;'></div>");
                    tdiv.append(rspan);
                    var imgclose = $("<img src='" + apollo.pageInfo.rootvpath + "Content/Images/imgClose.png' style='cursor:pointer; width:32px; display:inline-block;' />");
                    rspan.append(imgclose);
                    imgclose.click(function () { rtnObj.hide(); });

                    layout.mainDiv.append(panel);
                    layout.mainDiv.hide();
                    h += 10;
                    layout.mainDiv.css("bottom", (0 - h) + "px");
                    $("body").append(layout.mainDiv);
                },
                show: function () {
                    this.maskDiv.show();
                    this.maskDiv.animate({ opacity: 0.7 });

                    this.mainDiv.show();
                    this.mainDiv.animate({ bottom: "0px" });
                },
                hide: function () {
                    this.maskDiv.animate({ opacity: 0 }, "fast", function () { layout.maskDiv.hide() });
                    var h = layout.mainDiv.height();
                    this.mainDiv.animate({ bottom: (0 - h) + "px" }, "fast", function () { layout.mainDiv.hide(); })
                }
            };

            layout.init();


            var rtnObj = {
                show: function () { layout.show(); },
                hide: function () { layout.hide(); }
            };

            return rtnObj;
        }
    });
})(jQuery);


