﻿(function ($) {
    var report = ReportPage.report;
    var partial = apollo.Partial({
        data: {
            IsShowReportTip: false, //是否显示报单提示
            CurPayingMoney: report.PayingMoney,//当前正在支付的金额,即输入框中的金额
            CurSXFee: report.SXFee  //当前支付金额下的手续费
        },
        onload: function (app) {
            apollo.app.setdata("Report");//加载本页时刷新
            //到本页后，报单已完成
            ReportPage.existSale();
            setTimeout(function () {
                apollo.app.getoption().onautosubmit();
            }, 100);
        },
        onsetinfo: function (e) {//返回到注册编辑步骤进行信息编辑
            //返回前，需要
            ReportPage.beginSale();
        },
        onreflash: function (e) {//刷新报单支付情况
            reflashPayedmoney(e.source);
        },
        onlinemobilepay: function (e) {//移动端在线支付
            var fun = function () {
                var PayMode = 1;//微信支付
                var m = parseFloat(apollo.app.getdata().CurPayingMoney);
                if (isNaN(m)) m = 0;
                if (m <= 0) alert("您必须要输入要支付的金额！");
                var successFun = function (rtn) {
                    if (rtn.IsSuccess) {
                        var info = rtn.ReturnValue;
                        var param = info.Data;
 
                        var callbackUrl =apollo.getvpath(info.CallBackUrl);

                        beginBuyAppPay(PayMode, null, callbackUrl, param.PlatForm, param.RequestID, param.YHGKCode, param.MyCode, param.m);
                    }
                    else
                        showNotice(rtn.Message);
                };
                var param = {
                    ReportCode: report.ReportCode,
                    ReportType: report.ReportType,
                    UserRole: report.RegUseRole,
                    BusinessCode: report.BusinessCode,
                    ShopCode: report.ShopCode,
                    PayingMoney: m,
                    RegType:ReportPage.regType
                };
                apollo.api("CKReportApi", "GetMobilePayParam", param, successFun);
            }

            if (!apollo.dialog.confirm("确定立即支付吗？", fun));
        },
        onlinepay: function (e) { //进行在线支付
            if (!confirm("确定立即支付吗？")) return;

            var m = parseFloat(apollo.app.getdata().CurPayingMoney);
            if (isNaN(m)) m = 0;
            if (m <= 0) alert("您必须要输入要支付的金额！");
            var successFun = function (rtn) {
                if (rtn.IsSuccess) {
                    var param = rtn.ReturnValue;
                    param.pageInfo = apollo.pageInfo;
                    var waitpayurl = param.waitpayurl;
                    apollo.openWin(waitpayurl, 800, 600, function (isneedref) {
                        if (isneedref == true) reflashPayedmoney(report);
                    }, param);
                }
                else
                    showNotice(rtn.Message);
            };
            var param = {
                ReportCode: report.ReportCode,
                ReportType: report.ReportType,
                UserRole: report.RegUseRole,
                BusinessCode: report.BusinessCode,
                ShopCode: report.ShopCode,
                PayingMoney: m
            };
            apollo.api("CKReportApi", "GetPaymentUrl", param, successFun);
        },
        onautosubmit: function () {//自动提交
            if (report.ReportType!=1 &&  report.PayingMoney==0 && apollo.Lib.isEmpty(report.ToOrderCode))//已支付完成，没有提交，则启动自动提交
            {
                apollo.app.getoption().onsubmitreport({ source: report });
            }
        },
        oncngpayingmoney: function (e) {
            //自动更新正要支付金额
            e.update();
            var m = parseFloat(e.value);
            if (isNaN(m)) m = 0;
            //实时计算手续费
            var param = {
                PayingMoney: m
            };
            apollo.api("CKReportApi", "CalSXFee", param, function (sxfee) {
                apollo.app.setdata({ CurSXFee: sxfee });
            });
        },
        onsubmitreport: function (e) {
            var param = {
                CashCode: e.source.CashCode
            };
            apollo.api("CKReportApi", "OnSubmitBuyReport", param, function (rtn) {
                if (rtn.IsSuccess) {
                    $.extend(report, rtn.ReturnValue);
                    apollo.app.setdata("Report");
                    showNotice("提交成功！");
                }
                else {
                    showNotice(rtn.Message);
                }
            });
        }
    });

    stepUtil.reg({
        partial: partial,
        reflash: function () {//每次进入时都会执行的方法,不管是上一步还是下一步
            apollo.app.setdata({
                IsShowReportTip: false, //是否显示报单提示
                CurPayingMoney: report.PayingMoney,
                SXFee: report.SXFee
            });
        },
        valid: function (tonxt) {
            return true;
        }
    });

    //刷新已报单金额
    function reflashPayedmoney(report) {
        var param = ReportPage.createparam();
        apollo.api("CKReportApi", "RflashReportPayedmoney", param, function (info) {
            //更新当前报单已付款情况，以便进行去付
            $.extend(true, report, info);
            
            apollo.app.setdata({
                CurPayingMoney: report.PayingMoney,
                SXFee: report.SXFee
            });
            apollo.app.setdata("Report");
            showNotice("您的在线充值金额为：" + apollo.Lib.BASEformatNumber(info.PayedMoney) + "元。");

            setTimeout(function () {
                apollo.app.getoption().onautosubmit();
            }, 100);
        });

    }

})(jQuery)