﻿/*下面这个方法仅为云购支付使用*/
function beginBuyAppPay(PayMode, getPayBillcallBack, callBackUrl, PlatForm, RequestID, YHGKCode, myCode, m) {
    var PostPayData = { PlatForm: PlatForm, RequestID: RequestID, YHGKCode: YHGKCode, myCode: myCode, m: m };
    beginToOnlinePay(PayMode, getPayBillcallBack, PostPayData, callBackUrl);
}
/*上面这个方法仅为云购支付使用*/

/*Apollo内部测试用*/
function beginBuyAppPayForApolloTest(PayMode, getPayBillcallBack, callBackUrl, PlatForm, RequestID, YHGKCode, myCode, m, TestZH) {
    var PostPayData = { PlatForm: PlatForm, RequestID: RequestID, YHGKCode: YHGKCode, myCode: myCode, m: m, IsApolloTest: "ApolloTest", TestZH: TestZH };
    beginToOnlinePay(PayMode, getPayBillcallBack, PostPayData, callBackUrl);
}

/**
 *支付统一调用方法
 * @param int PayMode 支付方式:0或2-在线支付;1-纯微信支付,3-盛付通
 * @param function getPayBillcallBack 获取支付交易订单数据后回调方法(注意：不是指支付完毕）
 * @param String succCallBackUrl    支付完毕后回调的URL 主要用于微信支付
 * @param String failCallBackUrl    支付取消/失败后返回的URL 主要用于微信支付

 * @param object param  需要传递的参数,参数如下等       
       PlatForm  支付的业务类型,如：yhgk,jxreg,shop,business等
       RequestID  相关业务编号，如会员注册则为businesscode，会员报单则为cashcode，店充值也为cashcode或ordercode
       YHGKCode   会员编号
       myCode   即店编号，只对于shop类型有效
       m  本次实际支付金额,进入本方法后，该金额不能变动
 */
function beginToOnlinePay(PayMode, getPayBillcallBack, PostPayData, payedCallBack) {
    var successFun = function (rtn) {
        if (rtn.IsSuccess) {
            var paybill = rtn.ReturnValue;//这里取到交易数据，则调用app支付插件，进行实际支付操作

            if ( paybill.payChannel == 11) //通联
            {
                gotoTLAppPay(paybill.payData);
                return;
            }

            try {
                if (getPayBillcallBack != null){
                    if (getPayBillcallBack(paybill) == true) return;//如果回调方法是表示中止，则停止支付
                }
            }
            catch (e) {
                //如有错误，则中止执行

                return;
            }
            //进入支付
            gotoPay(paybill, payedCallBack);
        }
        else
            showNotice(rtn.Message);
    };

    /*payMode的值
    0-通联在线支付,1-微信移动支付,2-盛付通一键支付
    */
   
    var AppPayType = ""; //默认为快捷支付
    if (PayMode == 1 || PayMode == 999) //微信支付
        AppPayType = "apolloAppWeixin";
    else if (PayMode == 3)//盛付通支付
        AppPayType = "SFTPay";
    else if (PayMode == 7)//通联
        AppPayType = "apolloSybAppPay";

    var defaults = {
        AppPayType: AppPayType, //支付方式，主要是区分在线支付，微信支付，通联微信支付
        AppTLVersion:'2.0' //通联插件版本2.0
    };

    var op = $.extend(defaults, PostPayData);
    
    apollo.Common.GetPayBill(op, successFun);
}

function toast(mes, t) {
    uexWindow.toast(t ? '0' : '1', '5', mes, t ? t : 0);
}

//网关支付相关
//通联支付的方法
function uexAllinpay_menth(bill) {
    var data = bill.payData;
    
    var type = bill.mode;
    uexAllinpay.gotoPay(JSON.stringify(data), type);
}

//环迅支付的方法
function uexIPSPay_menth(bill) {
    var data = bill.payData;

    var jsonStr = {
        "merCode": data.merCode,                                  //商户号
        "accCode": data.accCode,                                  //IPS交易账户号
        "merBillNo": data.merBillNo,                 //商户订单号
        "ccyCode": data.ccyCode,                                               //币种，默认为人民币（156）
        "prdCode": data.prdCode,                                             //产品类型，默认为移动无卡支付（2301）
        "tranAmt": data.tranAmt,                                            //订单金额
        "requestTime": data.requestTime,                     //请求时间
        "ordPerVal": data.ordPerVal,                                                //订单有效期 必须是整数，以小时为单位
        "merNoticeUrl": data.merNoticeUrl,                 //商户系统通知地址URL
        "orderDesc": data.orderDesc,                                //订单描述
        "bankcard": data.bankcard,                                                   //银行卡号14-19位 可为空
        "md5Cert": data.md5Cert,                                                    //MD5密钥
        "ivl": data.ivl,                                               //3DES加密向量
        "secretKeyl": data.secretKeyl     //3DES加密密钥
    }
    uexIPSPay.payment(JSON.stringify(jsonStr));
}

//盛付通支付
function uexSFTPay_menth(bill) {
    var json = bill.payData;
    
    uexSDPMerchantPay.startPayWithOrderInfo(json, function (code) {
        if (code == -1 || code == "-1")
            alert("支付成功");
    });
}


//微信支付的方式
//微信支付的方式
function uexWeiXin_menth(bill, callback) {
    var fun = callback;
    var payData = bill.payData;
    var appid = payData.appid;
    uexWeiXin.cbRegisterApp = function (opCode, dataType, data) {
        if (data == 0) {

            uexWeiXin.cbIsWXAppInstalled = function (opCode, dataType, data) {
                if (data == 0 || data == '0') {

                    var params = {
                        windowName: "confirmPay"
                    };
                    uexWeiXin.setCallbackWindowName(JSON.stringify(params));
                    
                    ispay(payData, fun);
                } else {
                    toast('请先安装微信', 3000);
                }
            }
            uexWeiXin.isWXAppInstalled();
        }
    }
    uexWeiXin.registerApp(payData.appid);
}

function ispay(payData, callback) {
    var fun = callback;
    uexWeiXin.cbIsSupportPay = function (opCode, dataType, data) {
        if (data == 0 || data == '0') {
            //启动微信支付
            weixinpay(payData, fun);
        } else {
            toast('暂不支持微信支付功能', 3000);
        }
    }
    //检测是否可以进行微信支付
    uexWeiXin.isSupportPay()

}

function weixinpay(payData, callback) {
    var fun = callback;
    var json = payData.appwxdata;
    uexWeiXin.cbGetPrepayId = function (data) {
        var ydd = JSON.parse(data);
        if (ydd.return_code == "SUCCESS") //生成预订单成功
        {
            var objJson = JSON.stringify(data);
            var param = {
                appid: ydd.appid,
                ipscert: payData.ipsCert,
                data: data
            };
            var successFun = function (bill) {
                wxpayTo(bill, fun);
            };
            var error = function (errmsg) {
                toast('支付时出现异常:'+errmsg, 3000);
            }
            try {
                apollo.Weixin.GetAppWeixinPayData(param, successFun, error);
            }
            catch (e) { alert(e.message); }
        }
        else
            toast("进行支付失败：" + ydd.return_msg, 5000);
    }
    var data1 = JSON.stringify(json);
    uexWeiXin.getPrepayId(data1);
}
function wxpayTo(json, callback) {
    var callbackurl = callback;
    uexWeiXin.cbStartPay = function (data) {
        var rut = JSON.parse(data);
        
        if (rut.errCode == "0"||rut.errCode==0) //生成预订单成功
        {
            //则刷新列表
            alert("微信支付成功！");

            if (callbackurl != null) {
                if (jQuery.isFunction(callbackurl))
                    callbackurl();
                else
                    openUrl(callbackurl);
            }
        }
        else if (rut.errCode=="-1"||rut.errCode==-1) //支付失败
        {
            var msg = rut.errStr;
            if (msg != "" && msg != null)
            {
                toast("进行支付失败：" + msg, 5000);
            }
            else 
                toast("微信支付时失败", 5000);
        }
    }
    var data1 = JSON.stringify(json);
    uexWeiXin.startPay(data1);
}



function gotoPay(payBill,callback) {
    if (payBill.payChannel == 0) {
        //通联支付的方法
        uexAllinpay_menth(payBill);
    } else if (payBill.payChannel == 1) {
        //银联支付的方法
        alert("暂未开通银联支付");
        // uexUnionpay_menth(JSON.stringify(payBill));
    } else if (payBill.payChannel == 2) {
        //贝付支付的方法
        // uexBFPay_menth(JSON.stringify(payBill));
        alert("暂未开通贝付支付");
    } else if (payBill.payChannel == 3) {
        //易生支付的方法
        // uexEasyPay_menth(JSON.stringify(payBill));
        alert("暂未开通易生支付");
    } else if (payBill.payChannel == 4) {
        //环迅支付的方法
        uexIPSPay_menth(payBill);
    } else if (payBill.payChannel == 5) {
        //盛付通支付的方法
        uexSFTPay_menth(payBill);
    } else if (payBill.payChannel == 6) {
        //微信支付的方法
        uexWeiXin_menth(payBill, callback);
    }
    else {
        alert("未知支付方式");
    }
}

//可能的原因：签名错误、未注册APPID、项目设置APPID不正确、注册的APPID与设置的不匹配、其他异常等。


//跳转到微信支付（必须是open窗口才可发起微信支付）
function gotoWXAppPay(payData,url) {
    var data = JSON.stringify({ data: payData, url: url });
    var key = "ReportWXPay";
    apollo.catchutil.clearLocVal(key);
    apollo.catchutil.setLocVal(key, data);

    //打开微信支付页
    var param = {
        name: "confirmPay",
        data: apollo.getvpath("Mobile/CKHome/WxPayOK.html"),
        animID: 2,
        flag:4
    }
   uexWindow.open(param);
}

function payend() {
    alert("您确认写了吗");
}
/*
  通联收银宝
*/
function gotoTLAppPay(payData) {
    //跳转到支付页面前对象保存到缓存

    jQuery.each(payData, function (i, val) {

        console.log('key:' + i + " " + 'value:' + val);
        apollo.catchutil.setLocVal(i, val);       
    });
    openWin('TLPay_AddBank', 'mb2016/TLPayManager/PayOK');
}