﻿
/*下面这个方法仅为云购支付使用*/
function beginBuyAppPay(PayMode, getPayBillcallBack, callBackUrl,PlatForm, RequestID, YHGKCode, myCode, m)
{
    var PostPayData = { PlatForm: PlatForm, RequestID: RequestID, YHGKCode: YHGKCode, myCode: myCode, m: m };
    beginToOnlinePay(PayMode, getPayBillcallBack, callBackUrl, PostPayData);
}

/*Apollo内部测试用*/
function beginBuyAppPayForApolloTest(PayMode, getPayBillcallBack, callBackUrl,PlatForm, RequestID, YHGKCode, myCode, m,TestZH)
{
    var PostPayData = { PlatForm: PlatForm, RequestID: RequestID, YHGKCode: YHGKCode, myCode: myCode, m: m,IsApolloTest:"ApolloTest",TestZH:TestZH };
    beginToOnlinePay(PayMode, getPayBillcallBack, callBackUrl, PostPayData);
}


/*上面这个方法仅为云购支付使用*/

/**
 *支付统一调用方法
 * @param int PayMode 支付方式:0-在线支付;1-纯微信支付
 * @param function getPayBillcallBack 获取支付交易订单数据后回调方法(注意：不是指支付完毕）
 * @param String succCallBackUrl    支付完毕后回调的URL 主要用于微信支付
 * @param String failCallBackUrl    支付取消/失败后返回的URL 主要用于微信支付

 * @param object param  需要传递的参数,参数如下等       
       PlatForm  支付的业务类型,如：yhgk,jxreg,shop,business等
       RequestID  相关业务编号，如会员注册则为businesscode，会员报单则为cashcode，店充值也为cashcode或ordercode
       YHGKCode   会员编号
       myCode   即店编号，只对于shop类型有效
       m  本次实际支付金额,进入本方法后，该金额不能变动
 */
function beginToOnlinePay(PayMode, getPayBillcallBack, succCallBackUrl, PostPayData, failCallBackUrl) {
    var successFun = function (rtn) {
        if (rtn.IsSuccess) {
            var paybill = rtn.ReturnValue;//这里取到交易数据，则调用app支付插件，进行实际支付操作
            
            if (PayMode == 1 && paybill.payChannel == 6) //微信支付，则启动微信支付通道
            {
                gotoWXPay(paybill.payData, succCallBackUrl, failCallBackUrl);
                return;
            }
            else if (PayMode == 2&&paybill.payChannel==7) //通联收银宝微信
            {
                gotoSybWXPay(paybill.payData, succCallBackUrl);
                return;
            }
            else if ((PayMode == 1 || PayMode == 5) && paybill.payChannel == 9) //银盛公众号
            {
                gotoYinShengWXPay(paybill.payData, succCallBackUrl);
                return;
            }
            else if ((PayMode == 1 || PayMode == 6) && paybill.payChannel == 10) //易生公众号
            {
                gotoYiShengWXPay(paybill.payData, succCallBackUrl);
                return;
            }
            else if (PayMode == 999)//测试环境下测试支付
            {
                showNotice("开启模拟测试支付...");
                gotoTestPay(paybill.payData, succCallBackUrl);
            }
            //以下这些代码在微信端实际上是无任何作用
            //alert(PayMode);
            //alert(paybill.payChannel);
            try {
                if (getPayBillcallBack != null)
                    if (getPayBillcallBack(paybill) == true) return;//如果是中止执行，则退出
            }
            catch (e) {
                return;//如果之前检测有异常，则退出支付
            }
            //进入支付
            //gotoPay(paybill);
        }
        else
            showNotice(rtn.Message);
    };
    
    var AppPayType = ""
    if (PayMode == 1) //微信支付
        AppPayType = "apolloWeixin";
    else if (PayMode == 2) //通联微信支付
        AppPayType = "TLWeixin"
    else if (PayMode == 4) //扫码支付
        AppPayType = "TLWeixin"
    else if (PayMode == 5) //银盛微信公众号支付
        AppPayType = "YinshengWXpay"
    else if (PayMode == 6) //易生微信公众号支付
        AppPayType = "YishengWXpay"
    var defaults = {
        AppPayType: AppPayType //支付方式，主要是区分在线支付，微信支付，通联微信支付
    };

    var op = $.extend(defaults, PostPayData);
    //alert(PayMode + "," + AppPayType);
    apollo.Common.GetPayBill(op, successFun);
}


///测试环 境下测试支付
function gotoTestPay(bill,callback)
{
    var paybillno = bill.orderid;
    var url = callback;
    var noticepayed=function () {
        showNotice("开启模拟支付异步到账...");
        var param = { orderNo: paybillno };
        apollo.api("CKReportApi", "NoticePaySuccessed", param, function (rtn) {
            if (rtn.IsSuccess) {
                showNotice("模拟在线支付成功，并已到账。2秒后自动刷新！");
                window.setTimeout(function () {
                    openUrl(url);
                }, 2000);
            }
            else {
                showNotice("模拟支付到账失败：" + rtn.Message);
            }
        }, function (err) {
            showNotice("异步到账通知出现异常：" + err);
        });
    }
    
    showNotice("已成功生成预支付订单，开始模拟支付中...，预计5秒后到账！");
    setTimeout(noticepayed, 5000);

    return true;//这里不再继续进行支付，直接改为模拟到账
}

//通知支付已到账







//网关支付相关
//通联支付的方法
function uexAllinpay_menth(bill) {
    var data = bill.payData;
    var json = {
        "orderAmount": data.orderAmount,
        "orderDatetime": data.orderDatetime,
        "version": data.version,
        "merchantId": data.merchantId,
        "productName": data.productName,
        "inputCharset": data.inputCharset,
        "orderNo": data.orderNo,
        "payType": data.payType,
        "receiveUrl": data.receiveUrl,
        "signType": data.signType,
        "orderCurrency": data.orderCurrency,
        "signMsg": data.signMsg
    };

    var type = bill.mode;
    uexAllinpay.gotoPay(JSON.stringify(json), type);
}

//环迅支付的方法
function uexIPSPay_menth(bill) {
    var data = bill.payData;

    var jsonStr = {
        "merCode": data.merCode,                                         //商户号
        "accCode": data.accCode,                                  //IPS交易账户号
        "merBillNo": data.merBillNo,                 //商户订单号
        "ccyCode": data.ccyCode,                                               //币种，默认为人民币（156）
        "prdCode": data.prdCode,                                             //产品类型，默认为移动无卡支付（2301）
        "tranAmt": data.tranAmt,                                            //订单金额
        "requestTime": data.requestTime,                     //请求时间
        "ordPerVal": data.ordPerVal,                                                //订单有效期 必须是整数，以小时为单位
        "merNoticeUrl": data.merNoticeUrl,                 //商户系统通知地址URL
        "orderDesc": data.orderDesc,                                //订单描述
        "bankcard": data.bankcard,                                                   //银行卡号14-19位 可为空
        "md5Cert": data.md5Cert,                                                    //MD5密钥
        "ivl": data.ivl,                                               //3DES加密向量
        "secretKeyl": data.secretKeyl     //3DES加密密钥
    }
    uexIPSPay.payment(JSON.stringify(jsonStr));
}


function gotoPay(payBill) {
    if (payBill.payChannel == 0) {
        //通联支付的方法
        uexAllinpay_menth(payBill);
    } else if (payBill.payChannel == 1) {
        //银联支付的方法
        alert("暂未开通银联支付");
        // uexUnionpay_menth(JSON.stringify(data));
    } else if (payBill.payChannel == 2) {
        //贝付支付的方法
        // uexBFPay_menth(JSON.stringify(data));
        alert("暂未开通贝付支付");
    } else if (payBill.payChannel == 3) {
        //易生支付的方法
        // uexEasyPay_menth(JSON.stringify(data));
        alert("暂未开通易生支付");
    } else if (payBill.payChannel == 4) {
        //环迅支付的方法
        uexIPSPay_menth(JSON.stringify(payBill));
    } else if (payBill.payChannel == 5) {
        //盛付通支付的方法
        alert("暂未开通盛付通支付");
    } else {
        //微信支付的方法
        // uexWeiXin_menth(JSON.stringify(data));
        alert("暂未开通微信支付");
    }
}


/*
  微信支付通用函数
 * @parampayData:订单交易数据
 * @param String succCallBackUrl    支付完毕后回调的URL 主要用于微信支付
 * @param String failCallBackUrl    支付取消/失败后返回的URL 主要用于微信支付
*/
//转入微信支付
function gotoWXPay(payData, succCallBackUrl, failCallBackUrl) {
    //第一步，因页面要进行跳转，所以先进行参数保存
    var params = {
        Key: "apolloMBWXPay",
        PayMode: 1,//纯微信支付
        AppID: payData.appid,
        PayData: JSON.stringify(payData),
        FailCallBackUrl: failCallBackUrl,
        CallBackUrl: succCallBackUrl
    };
    var successFun = function (rtn) {
        //跳转到微信oauth授权页进行授权
        var wxurl = rtn.wxurl;
        var wxappid = rtn.appid;
        window.onbeforeunload = null;
        top.location.href = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + wxappid + "&redirect_uri=" + wxurl + "&response_type=code&scope=snsapi_base&state=1qaz0okm";
    };
    apollo.Weixin.GetWXOAuth2UrlInfo(params, successFun);
}

/*
  通联收银宝微信支付通用函数
@@payData:订单交易数据
@@callBackurl:支付完毕后跳转的URL
*/
function gotoSybWXPay(payData,callBackurl)
{
    //第一步，因页面要进行跳转，所以先进行参数保存
    var params = {
        Key: "apolloMBSybWXPay",
        PayMode:2,//通联收银宝支付
        AppID:"",
        PayData: JSON.stringify(payData),
        CallBackUrl: callBackurl
    };
    var successFun = function (rtn) {
        //跳转到微信oauth授权页进行授权
        var wxurl = rtn.wxurl;
        var wxappid = rtn.appid;
        window.onbeforeunload = null;
        top.location.href = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + wxappid + "&redirect_uri=" + wxurl + "&response_type=code&scope=snsapi_base&state=1qaz0okm";
    };
    apollo.Weixin.GetWXOAuth2UrlInfo(params, successFun);
}

/*银盛公众号支付*/
function gotoYinShengWXPay(payData,callBackurl)
{
    //第一步，因页面要进行跳转，所以先进行参数保存
    var params = {
        Key: "apolloMBYinShengWXPay",
        PayMode: 5,//银盛微信公众号支付
        AppID: payData.appid,
        PayData: JSON.stringify(payData),
        CallBackUrl: callBackurl
    };
    var successFun = function (rtn) {
        //跳转到微信oauth授权页进行授权
        var wxurl = rtn.wxurl;
        var wxappid = rtn.appid;
        window.onbeforeunload = null;
        top.location.href = "https://open.weixin.qq.com/connect/oauth2/authorize?appid=" + wxappid + "&redirect_uri=" + wxurl + "&response_type=code&scope=snsapi_base&state=1qaz0okm";
    };
    apollo.Weixin.GetWXOAuth2UrlInfo(params, successFun);
}

/*易生公众号支付*/
function gotoYiShengWXPay(payData, callBackurl) {
    //第一步，因页面要进行跳转，所以先进行参数保存
    var params = {
        Key: "apolloMBYiShengWXPay",
        PayMode: 6,//银盛微信公众号支付
        AppID: payData.appid,
        PayData: JSON.stringify(payData),
        CallBackUrl: callBackurl
    };
    var successFun = function (rtn) {
       
     
        var wxurl = rtn.wxurl;

        var url = decodeURIComponent(wxurl);
        //alert("decodeURIComponent:" + url);


        //var wxappid = rtn.appid;
        window.onbeforeunload = null;
        top.location.href = url;
    };
    apollo.Weixin.GetWXOAuth2UrlInfo(params, successFun);
}