﻿(function ($) {
    window.shopingcart = {
        init: function () {
            var successFun = function (arr) {
                shopingcart.cartproducts = arr;
                shopingcart.refcart();
            };
            apollo.api("CartApi", "GetCartProducts", successFun);
        },
        addtocart: function (p, num) //将产品加到购物车中
        {
            var successFun = function (rtn) {
                if (rtn.IsSuccess) {
                    var isAdded = false;
                    for (var i = 0; i < shopingcart.cartproducts.length; i++) {
                        var cp = shopingcart.cartproducts[i];
                        if (apollo.Lib.isEquals(cp.ProductCode, p.ProductCode)) {
                            cp.ProductCount += num;
                            isAdded = true;
                            break;
                        }
                    }
                    if (isAdded != true)
                        shopingcart.cartproducts.push($.extend({}, p));

                    shopingcart.refcart();
                    showNotice("成功添加到购物车中", 1);
                }
                else
                    showNotice(rtn.Message);
            };
            var param = { ProductCode: p.ProductCode, ProductCount: num };
            apollo.api("CartApi", "AddToCart", param, successFun);
        },
        beginBuy: function (p, num) //产刻购买(直接进入购物车)
        {
            location.href = apollo.pageInfo.rootvpath + "Buy/Index";
        },
        remove: function (p, callback, cbParam) {
            var funparam = cbParam;
            var successFun = function (rtn) {
                if (rtn.IsSuccess) {
                    if (shopingcart.cartproducts != null && shopingcart.cartproducts.length > 0) {
                        var arr = [];
                        $(shopingcart.cartproducts).each(function (i, cp) {
                            if (!apollo.Lib.isEquals(cp.ProductCode, p.ProductCode))
                                arr.push(cp);
                        });
                        shopingcart.cartproducts = arr;
                    }
                    shopingcart.refcart();
                    if (callback != null)
                        callback(funparam);
                }
            }
            var param = { Products: JSON.stringify([p.ProductCode]) };
            apollo.api("CartApi", "RemoveCartProduct", param, successFun);
        },
        changenum: function (p, num) //改变产品购物数量
        {
            var param={ProductCode:p.ProductCode,ProductCount:num};
            apollo.api("CartApi", "UpdateCartNum", param, function () { }, function () { });
        },
        tocart: function () //进入到购物车中
        {
            toCart();
        },
        refcart: function ()//刷新购物车数量
        {
            var num = 0;
            if (shopingcart.cartproducts != null && shopingcart.cartproducts.length > 0)
                num = shopingcart.cartproducts.length;
            $(".cart-num").text(num);
            if (num > 0)
                $(".cart-num").show();
            else
                $(".cart-num").hide();
        },
        gettotalmoney: function () {
            var tm = 0;
            $(this.cartproducts).each(function (i, p) {
                tm += p.ProductPrice * p.ProductCount;
            });
            return tm;
        },
        isempty: function () {
            if (this.cartproducts.length == 0)
                return true;
            else
                return false;
        },
        getcount: function () {
            return this.cartproducts.length;
        },
        cartproducts: [] //当前购物车产品
    }

    window.footerutil = {
        curpage: 0,//0-首页,1-购物车,2-个人中心,3-商城管理,4-开店/升级,5-商城规定
        init: function () {
            apollo.api("HomeApi", "ReflashFooterNav", function (obj) {
                var ul = $("footer").find("ul");
                if (apollo.Lib.isEquals(obj.OSOpType, "Upgrade")) //为店升级
                {
                    ul.find(".tab-shop").removeClass("ub").hide();
                    ul.find(".tab-upgrade").addClass("ub").show();
                }
                else {
                    ul.find(".tab-shop").addClass("ub").show();
                    ul.find(".tab-upgrade").removeClass("ub").hide();
                }
            });
        },
        wxsharenav: null,
        shoprule: function () {
            if (this.curpage != 5)
                openWin("Home", "Home/ShopRule");
        },
        //进入分享
        wxshare: function () {
            //if (this.wxsharenav == null)
            //{
            //    this.wxsharenav = $("<div class=\"wxsharenav\"></div>");
            //    this.wxsharenav.click(function () {
            //        $(this).hide();
            //    });
            //    this.wxsharenav.append("<img src=\"" + apollo.pageInfo.rootvpath + "Content/Images/tishi.png\">");
            //    $("body").append(this.wxsharenav);
            //}
            //this.wxsharenav.show();
        },
        //进入首页
        home: function () {
            if (this.curpage != 0)
                openWin("Home", "Home/Index");
        },
        //进入开新店
        openShop: function () {
            if (this.curpage != 4) {
                var url = "openShop/Index";
                openWin("openShop", url);
            }
        },
        shopUpgrade:function(){
            if (this.curpage != 4) {
                var url = "ShopUpgrade/Index";
                openWin("ShopUpgrade", url);
            }
        },
        //进入购物车
        toCart: function () {
            if (this.curpage != 1) {
                var url = "Buy/Index";
                openWin("Buy", url);
            }
        },
        //我的个人中心
        toMyCenter: function () {
            if (this.curpage != 2) {
                var url = "MyCenter/Index";
                openWin("MyCenter", url);
            }
        },
        toMyShop: function () {
            if (this.curpage != 3) {
                var url = "MyShop/Index";
                openWin("MyShop", url);
            }
        },
        setfocus: function (pageindex) {
            var ul = $("footer").find("ul");
            ul.find("li").removeClass("active");
            if (pageindex == 0) {
                this.curpage = 0;
                ul.find(".home").addClass("active");
            }
            else if (pageindex == 1) {
                this.curpage = 1;
                ul.find(".cart").addClass("active");
            }
            else if (pageindex == 2) {
                this.curpage = 2;
                ul.find(".mycenter").addClass("active");
            }
            else if (pageindex == 3) {
                this.curpage = 3;
                ul.find(".myshop").addClass("active");
            }
            else if (pageindex == 4) {
                this.curpage = 4;
                ul.find(".tab-shop").addClass("active");
            }
            else if (pageindex == 5) {
                this.curpage = 5;
                ul.find(".shoprule").addClass("active");
            }
        }
    };

    window.footerutil.init();

    shopingcart.init();
})(jQuery);

