﻿var apolloCKCashe = {
    getAreaItem:function(successFun)
    {
        var plJson = apollo.catchutil.getLocVal("CKCityInfoItem");//缓存的内容
        var plTime = apollo.catchutil.getLocVal("CKCityInfoItemTime");//缓存的时间

        if (apollo.Lib.isEmpty(plJson) || apollo.Lib.isEmpty(plTime)) //没有缓存,则从服务器中获取
        {
            this.reloadAreaItem(successFun)
        }
        else {
            //有缓存，则检测时间是否过时
            var tp = this.timeSpan(plTime, this.getTimeExp());
            if (tp.days > 2 || tp.days < 0) //缓存过时，则重新从服务器中获取
            {
                this.reloadAreaItem(successFun);
            }
            else {//从缓存中获取
                successFun(JSON.parse(plJson));
            }
        }
    },
    reloadAreaItem:function(callBack)
    {
        var curJsObj = this;
        var successFun = function (data) {
            
            var rows = data;//因没有采用分页，所以这里是获取所有产品
            apollo.catchutil.setLocVal("CKCityInfoItem", JSON.stringify(rows));//加入到缓存中
            apollo.catchutil.setLocVal("CKCityInfoItemTime", curJsObj.getTimeExp());//加入到缓存中
            callBack(rows);
        };
        apollo.api("CKAreaApi", "GetAreaInfos",successFun)
    },

    getTimeExp: function () {
        var nowday = new Date();
        var nowyear = nowday.getFullYear();
        var nowmonth = parseInt(nowday.getMonth() + 1) < 10 ? '0' + parseInt(nowday.getMonth() + 1) + '' : '' + parseInt(nowday.getMonth() + 1) + '';
        var nowdata = nowday.getDate() < 10 ? '0' + nowday.getDate() + '' : '' + nowday.getDate() + '';
        var nowhour = nowday.getHours() < 10 ? '0' + nowday.getHours() + '' : '' + nowday.getHours() + '';
        var nowm = nowday.getMinutes() < 10 ? '0' + nowday.getMinutes() + '' : '' + nowday.getMinutes() + '';
        var nowtime = nowyear + ';' + nowmonth + ';' + nowdata + ';' + nowhour + ';' + nowm;
        return nowtime;
    },
    timeSpan: function (starTime, endTime) {
        var arr1 = starTime.split(";");
        var arr2 = endTime.split(";");
        if (arr1.length < 5 || arr2.length < 5) {
            //不属于缓存规定的，则视为无效，则返回一个超时
            return { years: -1, months: -1, days: -1, hours: -1, minutes: -1 };
        }
        else {

            var date1 = new Date(arr1[0], arr1[1], arr1[2], arr1[3], arr1[4]); //开始时间
            var date2 = new Date(arr2[0], arr2[1], arr2[2], arr2[3], arr2[4]); //结束时间
            var date3 = date2.getTime() - date1.getTime(); //时间差的毫秒数
            //计算相差的年数
            var years = Math.floor(date3 / (12 * 30 * 24 * 3600 * 1000));
            //计算相差的月数
            var leave = date3 % (12 * 30 * 24 * 3600 * 1000);
            var months = Math.floor(leave / (30 * 24 * 3600 * 1000));
            //计算出相差天数
            var leave0 = leave % (30 * 24 * 3600 * 1000);
            var days = Math.floor(leave0 / (24 * 3600 * 1000));
            //计算出小时数
            var leave1 = leave0 % (24 * 3600 * 1000); //计算天数后剩余的毫秒数
            var hours = Math.floor(leave1 / (3600 * 1000));
            //计算相差分钟数
            var leave2 = leave1 % (3600 * 1000); //计算小时数后剩余的毫秒数
            var minutes = Math.floor(leave2 / (60 * 1000));
            //计算相差秒数
            var leave3 = leave2 % (60 * 1000); //计算分钟数后剩余的毫秒数
            var seconds = Math.round(leave3 / 1000);

            return { years: years, months: months, days: days, hours: hours, minutes: minutes };
        }
    }
};
