﻿/*图片上传插件*/
(function ($) {
    $.fn.photoBox = function (options) {
        var defaults = {
            onlyRead: false,
            imgUrl: "",
            postUrl: apollo.getwebpath("Mobile/Content/Scripts/photoBox/PhotoBoxHandler.ashx"),
            pathName: "CKPhoto/UserPhoto",//上传文件后存放的目录名,
            maxImageWH: 0//最大宽度，如为0，则表示原图大小            
        }
        var form;//用于实现图片上传，只有实际用处理

        var divPhoto = $(this);
        var op = $.extend(defaults, options);


        var imgBox, fileBox, lblInfo, boxPanel,libtn;

        var rtnObj = {
            getValue: function () {
                return op.imgUrl;
            },
            setValue: function (url) {
                op.imgUrl = url;
                if (imgBox == null) return;
                imgBox.css("width", "100%");
                imgBox.css("height", "auto");
                imgBox.attr("src", url);
                setTimeout(function () {
                    var w = imgBox.width();
                    var h = imgBox.height();
                    if (w > h) {
                        imgBox.css("width", "100%");
                    }
                    else {
                        imgBox.css("height", "100%");
                    }
                }, 1000);
            }
        }

        function setEnabled(isE) {
            op.onlyRead = !isE;
            if (!isE) {
                if (fileBox != null) fileBox.hide();
                if (lblInfo != null) lblInfo.hide();
            }
            else {
                if (fileBox != null) fileBox.show();
                if (lblInfo != null) lblInfo.show();
            }
        }
        function createBox() {
            var h = divPhoto.height();
            var boxdiv = $("<div style='width:100%;height:15em;background-color:#f3f1f1'></div>");
            imgBox = $("<img class=\"w100 h100 uc-a1\" />");
            if (op.imgUrl != "")
                imgBox.attr("src", op.imgUrl);
            
            boxdiv.append(imgBox);
            divPhoto.append(boxdiv);

            boxPanel = $("<div class='pad-t1 ubt bor-light-gray'></div>");
            divPhoto.append(boxPanel);

            libtn = $("<div class='txt-orange tx-c' style='padding:11px;'>点击更新图片</div>");
            boxPanel.append(libtn);
            libox = $("<div class='mui-content-padded'></div>");
            divPhoto.append(libox);
            libox.hide();

            lblInfo = $("<span>正在更新中...</span>");
            divPhoto.append(lblInfo);
            lblInfo.hide();
            var i = 0;
            if (op.onlyRead == false) {
                libtn.off("click");
                libtn.on("click", function (e) {
                    if (isAppcan()) {
                        UexImage();
                    }
                    else {
                        fileBox.get(0).click();
                    }
                });
                if (!isAppcan()) {
                    fileBox = $("<input type=\"file\" name=\"ApolloPhotoBox\" class=\"\" style=\"position:absolute; top:0; z-index:-1;\" />");
                    libox.append(fileBox);
                    fileBox.change(function () {
                        uploadImage();
                    });
                }
            }
            else {
                libtn.attr("disabled", "disabled");
            }
        }

        function createForm() {
            form = $("<form action=\"SaveOneShop\" method=\"post\" enctype=\"multipart/form-data\"></form");
            var databox = $("<input type='hidden' name=\"ApolloPhotoData\" id=\"ApolloPhotoData\" />");
            databox.val(JSON.stringify({ ImageMaxWH: op.ImageMaxWH, PathName: op.pathName }));
            form.append(databox);

            var upbox = fileBox

            form.append(upbox);

            $("body").append(form);
        }

        function removeForm() {
            boxPanel.append(fileBox);
            if (form != null)
                form.remove();
        }

        function uploadImage() {
            var imgUrl = fileBox.val();
            if (imgUrl == "") return;

            lblInfo.show();
            //先创建
            createForm();

            form.ajaxSubmit({
                url: op.postUrl,
                success: function (data) {
                    lblInfo.hide();
                    var rtn = JSON.parse(data);
                    if (rtn != null && rtn.IsSuccess) {
                        rtnObj.setValue(rtn.ReturnValue);
                    }
                    else {
                        showNotice("保存时出现错误：" + rtn.Message);
                    }
                    removeForm();
                    lblInfo.hide();
                },
                error: function (e) {
                    lblInfo.hide();
                    showNotice("保存时出现异常！");
                    removeForm();
                    lblInfo.hide();
                }
            });
        }

        function isAppcan() {
            try {
                if (uexWindow == null)
                    return false;
                else
                    return true;
            }
            catch (e) {
                return false;
            }
        }




        //拍照进行上传图片  
        function UexImage() {
            if (op.onlyRead == true) return;
            uexWindow.actionSheet({
                title: "选择图片",
                cancel: "取消",
                buttons: "本地照片,相机拍照"
            }, function (index) {
                if (index == 0) {
                    addressPHone();
                } else if (index == 1) {
                    camer();
                }
            });
        }
        //拍照
        function camer() {
            try {
                uexCamera.cbOpen = function (opCode, dataType, data) {
                    upload(data);
                }
                uexCamera.open();
            }
            catch (e) { }
        }

        //本地照片
        function addressPHone() {
            var data = {
                min: 1,
                max: 1,
                quality: 0.8,
                detailedInfo: true
            }
            uexImage.onPickerClosed = function (info) {
                info = JSON.parse(info);
                upload(info.data[0]);
            }

            var json = JSON.stringify(data);
            uexImage.openPicker(json)
        }


        //上传图片到服务器
        //随机字符串
        var chars = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'];
        function generateMixed(n) {
            var res = "";
            for (var i = 0; i < n; i++) {
                var id = Math.ceil(Math.random() * 5);
                res += chars[id];
            }
            return res;
        }
        function uploadFile(dirPath, cb, name) {
           
            var uploadHttp = apollo.getwebpath("CKHome/SaveAppUploadPhoto?ImageMaxWH=" + op.maxImageWH + "&PathName=");
            var num = generateMixed(5);
            uexUploaderMgr.onStatus = function (opCode, fileSize, percent, rtn, status) {
                switch (status) {
                    case 0:
                        $toast('文件上传中' + percent + '%', 3000)
                        break;
                    case 1:
                        $toast('文件上传成功', 3000)
                        uexUploaderMgr.closeUploader(num);
                        cb(JSON.parse(rtn));
                        uexImage.clearOutputImages();
                        break;
                    case 2:
                        $toast('文件上传失败', 3000)
                        uexUploaderMgr.closeUploader(num);
                        break;
                }
            }
            uexUploaderMgr.cbCreateUploader = function (opCode, dataType, data) {
                if (data == 0) {
                    uexUploaderMgr.uploadFile(num, dirPath, "ApolloPhotoBox", 1);
                } else {
                    alert("创建失败");
                }
            }

            uexUploaderMgr.createUploader(num, uploadHttp);
        }
        function upload(url) {
            var name = url.substring(url.lastIndexOf('/') + 1).toLowerCase();
            uploadFile(url, function (rtn) {
                if (rtn.IsSuccess) {//上传成功
                    rtnObj.setValue(rtn.ReturnValue);
                } else {
                    $toast(rtn.Message, 3000);
                }
            }, name);
        }

        
        createBox();
        return rtnObj;
    }

})(jQuery);