﻿(function ($, app) {
    var report = ReportPage.report;
    var uiparam = ReportPage.uiparam;
    var myPanel = $("#panelAddressInfo");
    var myForm = $("#formAddressInfo");
    var partial= apollo.Partial({
        data: {
            IsAddressOK: apollo.Lib.isNotEmpty(report.ID),
            IsShowReportTip: false, //是否显示报单提示,
            MyAddress:[] //我的收货地址
        },
        onload: function () {
            ReportPage.options.loadAddr();
        },
        loadAddr: function () {
            var param;
            if (report.IsShareRetail == true||report.ReportType=='71') {
                param = { AppID: report.AppID, OpenID: report.OpenID };
            }
            else {
                param = { BusinessCode: report.BusinessCode };
            }            
            apollo.api("CKSHAddressApi", "GetMySHAddress", param, function (arr) {
                var curaddr = report.ProvinceIDOfSH + report.CityIDOfSH + report.CountyIDOfSH + report.Street + report.ReceiverName + report.ReceiverTel + report.ReceiverName2 + report.ReceiverTel2;
                var defaddr = null;
                var hasselect = false;
                $(arr).each(function (i, addr) {
                    var addrstr = addr.ProvinceIDOfSH + addr.CityIDOfSH + addr.CountyIDOfSH + addr.Street + addr.ReceiverName + addr.ReceiverTel + addr.ReceiverName2 + addr.ReceiverTel2;
                    if (curaddr == addrstr) {
                        addr.IsSelected = true;
                        hasselect = true;
                    }
                    else
                        addr.IsSelected = false;

                    if (addr.IsDefault == true) defaddr=addr;
                });
                
                if (hasselect != true)
                {
                    var addr=null;
                    if (defaddr != null)
                        addr = defaddr;
                    if (addr==null && arr.length>0) addr=arr[0];
                    if (addr!=null)
                    {
                        report.SendAreaName = addr.SendAreaName;
                        report.SendProvince = addr.SendProvince;
                        report.ProvinceIDOfSH = addr.ProvinceIDOfSH;
                        report.CityIDOfSH = addr.CityIDOfSH;
                        report.CountyIDOfSH = addr.CountyIDOfSH;
                        report.Street = addr.Street;
                        report.ReceiverName = addr.ReceiverName;
                        report.ReceiverTel = addr.ReceiverTel;
                        report.ReceiverName2 = addr.ReceiverName2;
                        report.ReceiverTel2 = addr.ReceiverTel2;
                        report.FullAddress = addr.FullAddress;

                        addr.IsSelected = true;
                    }
                }
                    
                //刷新地址列表
                apollo.app.setdata({
                    MyAddress: arr                    
                });
                apollo.app.setdata("Report");
            });
        },
        onupdate: function (e) {
            e.update();
        },
        oncngshtypeid: function (e) {
            e.update();
            apollo.app.setdata("Report","Report.SHTypeID");
        },
        onupdateandreflash: function (e) {
            e.update();
            app.setdata("Report");
        },
        onsetdefaultaddr: function (e) {
            apollo.dialog.confirm("您确认要将这个地址设为您的默认收货地址？", function () {
                var param = {
                    BusinessCode: e.source.BusinessCode,
                    AppID: e.source.AppID,
                    OpenID: e.source.OpenID,
                    ID:e.source.ID
                };
                apollo.api("CKSHAddressApi", "SetDefaultSHAddr", param, function (rtn) {
                    ReportPage.options.loadAddr();
                });
            });
        },
        ondeleteaddr: function (e) {
            apollo.dialog.ask("您是否真要删除这条收货地址信息？", function () {
                var param = {
                    ID: e.source.ID
                };
                apollo.api("CKSHAddressApi", "DeleteSHAddress", param, function (rtn) {
                    if (rtn.IsSuccess){
                        //清空当前报单地址设置 
                        //report.ProvinceIDOfSH = "";
                        //report.CityIDOfSH = "";
                        report.CountyIDOfSH = "";
                        report.Street = "";
                        report.ReceiverName = "";
                        report.ReceiverTel = "";
                        report.ReceiverName2 = "";
                        report.ReceiverTel2 = "";
                        report.FullAddress = "";

                        ReportPage.options.loadAddr();

                        if (apollo.SPA.name == "EditSHAddress") {
                            apollo.SPA.toback();
                        }
                    }                        
                    else
                        showNotice(rtn.Message);
                });
            });
        }
    });



    //初始加载后要注册当前步骤
    stepUtil.reg({
        partial: partial,
        reflash: function () {//每次进入时都会执行的方法,不管是上一步还是下一步
            apollo.app.setdata({
                IsShowReportTip: false //是否显示报单提示
            });
        },
        //这是进入下一步前的检测方法，如果无参数，则直接返回true或false，有参数，则不需要直接返回值 ，参数为一个进入下一步的委托方法，根据自行处理后达到条件，调用该方法就可直接进入下一步了
        valid: function (toNextFun) {
            if (report.ProvinceIDOfSH == "") {
                alert("您未选择收货地址，请选择！");
                return false;//不马上进入下一步
            }
            else if (apollo.app.getdata().IsAddressOK != true) {
                alert("请先选中已确认收货地址信息后才能进入下一步！");
                return false;
            }
            var param = ReportPage.createparam(true);
            apollo.api("CKBuyReportApi", "CheckSHAddrIsValid", param, function (rtn) {
                if (rtn.IsSuccess) {
                    var bill = rtn.ReturnValue;
                    $.extend(true, report,bill.Report);
                    apollo.app.setdata("Report");//先刷新一下报单 情况

                    //购物车产品要更新
                    basket.updatelist(bill.Products);
                    
                    toNextFun();//进入下一步
                }
                else
                    showNotice(rtn.Message);
            })
            return false;//这里不直接进入下一步
        }
    });

})(jQuery, apollo.app);