﻿(function ($, app) {
    var report = ReportPage.report;
    var uiparam = ReportPage.uiparam;
    var myForm = $("#formBaseInfo");
    var myPanel = $("#RegBaseInfo");

    var partail = apollo.Partial({
        data: {
            IsCanSelPosLeft: true, //是否可选择A
            IsCanSelPosRight: true, //是否可选择B
            IsShowReportTip: false //是否显示报单提示
        },
        onupdate: function (e) {
            e.update();
        },
        onupdateandreflash: function (e) {
            e.update();
            app.setdata("Report");
        },
        onselposleft: function (e) {
            report.PosLeft = false;
            report.PosRight = false;
            e.update("Report.PosLeft", e.checked);
        },
        onselposright: function (e) {
            report.PosLeft = false;
            report.PosRight = false;
            e.update("Report.PosRight", e.checked);
        },
        onsetentrusttype: function (e) {
            e.update("Report.EntrustType", e.value);
            app.setdata("Report");
        },
        onparentChange: function (e) {
            e.update();
            var v = e.value;
            var report = e.source.Report;
            if (v == "") {
                report.ParentCode = "";
                report.ParentName = "*";
                report.PosLeft = false;
                report.PosRight = false;
                e.source.IsCanSelPosLeft = false;
                e.source.IsCanSelPosRight = false;
            }
            else {
                if (v.length != 12 && v.length != 8) {
                    report.ParentName = "*";
                    report.PosLeft = false;
                    report.PosRight = false;
                    e.source.IsCanSelPosLeft = false;
                    e.source.IsCanSelPosRight = false;
                    apollo.app.setdata("Report")//刷新列表
                    return;
                }
                var DownCode = "";
                if (apollo.Lib.isNotEmpty(report.OldParentCode)) {
                    DownCode = report.BusinessCode;
                }

                var successFun = function (rtn) {
                    if (rtn.IsSuccess) {
                        e.update();//成功取到值，说明输入的有效，所以这里启动自动更新
                        var arr = rtn.ReturnValue.split("$$$");
                        report.ParentName = arr[0];

                        var strPos = arr[1];
                        if (strPos.substr(0, 1) == "0") {
                            report.PosLeft = false;//设为未选中
                            e.source.IsCanSelPosLeft = true;//可用
                        }
                        else if (strPos.substr(0, 1) == "1") {
                            report.PosLeft = false;//设为未选中
                            e.source.IsCanSelPosLeft = false;//不可用
                        }
                        else if (strPos.substr(0, 1) == "2") {
                            report.PosLeft = true;
                            e.source.IsCanSelPosLeft = true;
                            report.PosRight = false;
                        }
                        if (strPos.substr(1, 1) == "0") {
                            report.PosRight = false; //设为未选中
                            e.source.IsCanSelPosRight = true;//可用
                        }
                        else if (strPos.substr(1, 1) == "1") {
                            report.PosRight = false;; //设为未选中
                            e.source.IsCanSelPosRight = false;//不可用
                        }
                        else if (strPos.substr(1, 1) == "2") {
                            report.PosRight = true; //设为选中
                            e.source.IsCanSelPosRight = true;//可用

                            report.PosLeft = false; //设为未选中
                        }
                    }
                    else {
                        if (v.length == 12) {
                            showNotice(rtn.Message);
                            report.ParentCode = "";
                            report.ParentName = "*";
                            e.source.IsCanSelPosLeft = false;
                            e.source.IsCanSelPosRight = false;
                            report.PosLeft = false;
                            report.PosRight = false;
                        }
                    }
                    apollo.app.setdata("Report")//刷新列表
                };
                var errorFun = function (errMsg) {
                    showNotice(errMsg);
                    report.ParentCode = "";
                    report.ParentName = "*";
                    e.source.IsCanSelPosLeft = false;
                    e.source.IsCanSelPosRight = false;
                    report.PosLeft = false;
                    report.PosRight = false;
                    apollo.app.setdata("Report")//刷新列表
                };
                var param = { ParentCode: v, DownCode: DownCode };

                apollo.api("CheckApi", "CheckGetInfoForParentCode", param, successFun, errorFun);
            }
        },
        codeChange: function (e) {
            var v = e.value;
            var report = e.source.Report;
            if (v == "") {
                report.ReBusinessName = "*";
                report.ReBusinessCode = v;
                report.InitReBusinessCode = "";
                apollo.app.setdata("Report")//刷新列表
            }
            else if (v.length != 12 && v.length != 8) {
                report.ReBusinessName = "*";
                report.ReBusinessCode = v;
                report.InitReBusinessCode = "";
                apollo.app.setdata("Report")//刷新列表
            }
            else {
                var successFun = function (rtn) {
                    if (rtn.IsSuccess) {
                        var arr = rtn.ReturnValue.split("$$$");
                        report.ReBusinessName = arr[0];
                        report.ReBusinessCode = v;
                        report.InitReBusinessCode = arr[1];
                    }
                    else {
                        showNotice(rtn.Message);
                        report.ReBusinessName = "*";
                        report.ReBusinessCode = v;
                        report.InitReBusinessCode = "";
                    }
                    apollo.app.setdata("Report");
                };
                var errorFun = function (errMsg) {
                    showNotice(errMsg);
                    report.ReBusinessName = "*";
                    report.ReBusinessCode = v;
                    report.InitReBusinessCode = "";
                    apollo.app.setdata("Report");
                };
                var param = { FromBusinessCode: v };
                apollo.api("CheckApi", "CheckGetInfoForFromBusinessCode", param, successFun, errorFun);
            }
        }
    });

    //初始加载后要注册当前步骤
    stepUtil.reg({
        partial: partail,
        reflash: function () {//每次进入时都会执行的方法,不管是上一步还是下一步
            apollo.app.setdata({
                IsShowReportTip: false //是否显示报单提示
            });
        },
        //这是进入下一步前的检测方法，如果无参数，则直接返回true或false，有参数，则不需要直接返回值 ，参数为一个进入下一步的委托方法，根据自行处理后达到条件，调用该方法就可直接进入下一步了
        valid: function (toNextFun) {
            var isValid = myForm.valid();//进行输入项基本检测
            if (!isValid) {
                alert("检测发现您输入的信息不符合要求，请核查您的信息！");
                return false;//不马上进入下一步
            }

            //再信息再次提交后台，由后台进行验证
            var param = ReportPage.createparam(true);
            apollo.api("CKRegReportApi", "CheckIsValid", param, function (rtn) {
                if (rtn.IsSuccess) //检测通过
                {
                    //注意，这里要重新更新报单对象信息,为不改变原报单对象，这里采用复制方式
                    $.extend(report, rtn.ReturnValue);

                    basket.updateproducts();
                    //再次刷新一下
                    apollo.app.setdata("Report", "Report.RegUseRole","MobileCheck");

                    //调用参数委托方法进入下一步
                    toNextFun();
                }
                else
                    alert(rtn.Message);
            });
            //注意，这里不马上进入下一步，所以直接返回false
            return false;
        }
    });

})(jQuery, apollo.app);