﻿(function ($, app) {
    var report = ReportPage.report;
    var data = app.getdata();
    
    var partial = apollo.Partial({
        data: {
            CXPlanExplain: "",
            BasketTipInfo: "",//购物车提示信息
            CheckBasketTipInfo: "",
            CheckBasketTipInfoBg: "",
            BasketIsValid: false, //报单产品是否符合要求
            MarkupGiveInfos: [],//促销加价购赠品信息
            PopupProducts: [],//需要弹出让用户选购的产品

            IsShowReportTip: true,//当前步骤是否显示报单提示 

            SearchKey: "",//检索关键字,用于选购产品时检索
            Products: [],//当前所有产品，用于呈现
            ProdCTitems: [],//所有商品分类
            NavItems: [],//导航分类
        },
        oninitmarkupspinner: function (e) //加价购商品数量输入框初始化（这里要处理限购问题
        {
            var item = e.source;

            var numtimes = item.Product.OrderNumTimes;
            var mincount = item.Product.OrderNumMin;
            if (mincount <= 0) {
                mincount = 1;
            }
            var num = mincount;


            var maxcount = item.Product.OrderNumMax;
            if (maxcount == null || maxcount <= 0)
                maxcount = 999999;//不限

            if (numtimes > 1) {//如果设置了订购倍数，则最小起订量要符合这个倍数
                if (numtimes >= mincount) //订购倍数大于或等于最小订购量
                    num = numtimes;
                else if ((mincount % numtimes) > 0) { //最小订购数并不是订购倍数
                    num = Math.ceil(mincount / numtimes) * numtimes;
                }
                else
                    num = numtimes;
            }
            else
                numtimes = 1;

            if (num <= 0) num = 1;


            var option;
            if (e.source.LimitSaleNum > 0) {
                option = { min: num, value: item.Product.ProductCount, numTimes: numtimes, max: e.source.LimitSaleNum };
            }
            else {
                option = { min: num, max: maxcount, value: item.Product.ProductCount, numTimes: num };
            }
            e.target.Spinner(option).change = function (box) {
                var newnum = box.getValue();
                if (newnum <= 0) //视为移除
                {
                    e.removeRow();
                }
                else {
                    basket.changenum(item.Product, newnum);
                    e.reflash();
                }
                apollo.app.setdata("Basket");//刷新数量，注意，这里不需要刷新赠品，因为加价购不会产生额外赠品信息
                report.IsCngedBaskets = true;//进入到购物车就视为已进行了购物车编辑
            };
        },
        oninitspinner: function (e) //商品数量输入框初始化
        {
            var isInBasket = true;//默认是购物车中数量输入框
            var prod;
            if (e.source != null && e.source.Product != null)
                prod = e.source.Product;
            else if (e.source == null || e.source.ProductCode == null)
                return;
            else {
                prod = e.source;
                isInBasket = false;
            }


            var numtimes = prod.OrderNumTimes;
            var mincount = prod.OrderNumMin;
            

            if (mincount <= 0) {
                mincount = 1;
            }

            var maxcount = prod.OrderNumMax;
            if (maxcount == null || maxcount <= 0)
                maxcount = 999999;//不限


            var num = mincount;
            
            if (numtimes > 1) {//如果设置了订购倍数，则最小起订量要符合这个倍数
                if (numtimes >= mincount) //订购倍数大于或等于最小订购量
                    num = numtimes;
                else if ((mincount % numtimes) > 0) { //最小订购数并不是订购倍数
                    num = Math.ceil(mincount / numtimes) * numtimes;
                }
                else
                    num = numtimes;
            }
            else
                numtimes = 1;

            if (num <= 0) num = 1;

            e.target.Spinner({ min: num, max: maxcount, value: prod.ProductCount, numTimes: numtimes }).change = function (box) {
                if (isInBasket == true) {
                    var newnum = box.getValue();
                    if (newnum <= 0) //视为移除
                    {
                        e.removeRow();

                        checkBasketIsValidAndRefCX("", function () {
                            apollo.app.setdata(["Basket.giveinfo", "Basket"]);
                        });
                    }
                    else {
                        basket.changenum(prod, newnum);
                        checkBasketIsValidAndRefCX(prod.ProductCode, function () {
                            e.reflash();
                            apollo.app.setdata(["Basket.giveinfo", "Basket"]);
                        });
                        //再刷新该行
                        e.reflash();
                    }
                    report.IsCngedBaskets = true;//进入到购物车就视为已进行了购物车编辑
                }
                else {
                    prod.ProductCount = newnum;
                    prod.SaleMoney = prod.ProductCount * prod.ProductPrice;
                }
            };
        },//初始化输入框
        onaddtocart: function (e) {//将指定商品加入到购物车
            if (report.OrderBusiAuditIsPass == true) {
                alert("您的注册购物订单已生效，不能编辑购物车！");
                return;
            }
            report.IsCngedBaskets = true;//进入到购物车就视为已进行了购物车编辑
            var prod = basket.find(e.source.ProductCode);
            if (prod == null) //不在购物车中
            {
                //则再次从后台取这个产品，并加入到购物车中
                var param = ReportPage.createparam({ ProductCode: e.source.ProductCode });
                apollo.api("CKProductApi", "GetOrderProduct", param, function (rtn) {
                    if (rtn.IsSuccess) {
                        var op = rtn.ReturnValue;
                        var fun = function (op) {
                            basket.add(op);//将该产吕添加到报单产品中。
                            
                            checkBasketIsValidAndRefCX(op.ProductCode, function () {
                                app.setdata(["Basket.ProductItems", "Basket", "Basket.giveinfo"]);
                            });
                            //刷新购物车
                            app.setdata("Basket.ProductItems","Product");
                            //同时启动促销商品检索，以便在当前报单数量情况下显示赠品相关信息
                            showNotice("成功加入到购物车中");


                            var code = op.ProductCode.toLowerCase();
                            if (code == "hz0029" || code == "hz0030" || code == "hz0031" || code == "hz0032" || code == "hz0033" || code == "hz0034" || code == "hz0035" || code == "hz0036") {
                                showTZProdlist();
                            }

                        };
                        if (apollo.Lib.isNotEmpty(op.BuyAuthCode)) {
                            apollo.dialog.prompt("购买本商品需要授权码，请输入授权码：", "", function (v) {
                                if (v == op.BuyAuthCode)
                                    fun(op);
                                else
                                    showNotice("授权码输入不对，不能加入购物车！");
                            });
                        }
                        else
                            fun(op);
                    }
                    else
                        showNotice("添加到购物车失败：" + rtn.Message);
                });
            }
            else {
                showNotice("该产品已在购物车中");
            }
        },
        onaddcustomtocart: function (p, custom) {//将私人定制信息加到购物车中
            if (report.OrderBusiAuditIsPass == true) {
                alert("您的注册购物订单已生效，不能编辑购物车！");
                return;
            }
            report.IsCngedBaskets = true;//进入到购物车就视为已进行了购物车编辑
            var prod = basket.find(p.ProductCode);
            if (prod == null) //不在购物车中
            {
                //则再次从后台取这个产品，并加入到购物车中
                var param = ReportPage.createparam({ ProductCode: p.ProductCode, CustomInfo: JSON.stringify(custom) });
                apollo.api("CKProductApi", "GetOrderProduct", param, function (rtn) {
                    if (rtn.IsSuccess) {
                        var op = rtn.ReturnValue;
                        op.ProductCount = p.ProductCount;
                        basket.add(op);//将该产吕添加到报单产品中。

                        checkBasketIsValidAndRefCX(op.productcode, function () {
                            app.setdata(["Basket.ProductItems", "Basket", "Basket.giveinfo"]);
                        });
                        //刷新购物车
                        app.setdata("Basket.ProductItems", "Product");
                        //同时启动促销商品检索，以便在当前报单数量情况下显示赠品相关信息
                        showNotice("成功加入到购物车中");


                        var code = op.ProductCode.toLowerCase();
                        if (code == "hz0029" || code == "hz0030" || code == "hz0031" || code == "hz0032" || code == "hz0033" || code == "hz0034" || code == "hz0035" || code == "hz0036") {
                            showTZProdlist();
                        }
                    }
                    else
                        showNotice("添加到购物车失败：" + rtn.Message);
                });
            }
            else {
                showNotice("该产品已在购物车中");
            }
        },
        oneditmobilecustom: function (e) { //修改私人定制参数(移动端)
            var that = e;
            var code = e.source.Product.ProductCode;
            customUtil.show(e.source.Product, true, function () {
                that.reflash();
                checkBasketIsValidAndRefCX(code, function () {
                    app.setdata(["Basket.ProductItems", "Basket", "Basket.giveinfo"]);
                });                
            });
        },
        oneditpccustom: function (e) {
            var that = e;
            var product = e.source.Product;
            var code = e.source.Product.ProductCode;
            customUtil.show(e.source.Product, true, function (customInfo) {
                //取到参数表达式
                apollo.api("CKOrderApi", "GetDefineParamExp", { jsonEntity: JSON.stringify(customInfo), ProductCode: product.ProductCode }, function (rtn) {
                    if (rtn.IsSuccess) {
                        product.CustomExp = rtn.ReturnValue.join(",");
                        product.CustomInfo = customInfo;

                        that.reflash();
                        checkBasketIsValidAndRefCX(code, function () {
                            app.setdata(["Basket.ProductItems", "Basket", "Basket.giveinfo"]);
                        }); 
                        
                    }
                    else {
                        showNotice(rtn.Message);
                    }
                });
            });
        },
        onremoveprod: function (e) {
            if (report.OrderBusiAuditIsPass == true) {
                alert("您的注册购物订单已生效，不能编辑购物车！");
                return;
            }


            apollo.dialog.ask("您是否真要从购物车中移除该产品？", function () {
                if (true) {
                    var prod = null;
                    if (e.source != null && e.source.Product != null)
                        prod = e.source.Product;
                    if (prod != null) {

                        var param = { Products: JSON.stringify([prod.ProductCode]), IsWXShare: report.IsShareRetail }
                        try {
                            apollo.api("CKCartApi", "RemoveCartProduct", param, function (rtn) { }, function (err) { });
                        }
                        catch (e) { }
                    }
                }

                e.removeRow();
                               
                checkBasketIsValidAndRefCX("", function () {
                    apollo.app.setdata(["Basket.giveinfo", "Basket"]);
                });
            });
        },
        ongiveselected: function (e) {//促销赠品选中时事件(用于多项选择)
            if (e.checked == true) e.source.selected();//标记当前项已选中,这里会自动产生联动更改，已封装好，无需再控制
        },
        onaddmarkupprod: function (e)//加价购添加事件
        {
            if (report.OrderBusiAuditIsPass == true) {
                alert("您的注册购物订单已生效，不能编辑购物车！");
                return;
            }

            report.IsCngedBaskets = true;//进入到购物车就视为已进行了购物车编辑
            if (basket.addmarkupgive(e.source) == true) {
                apollo.app.setdata(["Basket", "Report.MarkupGives"]);//刷新这两个区域（即根据最新的数据，重新渲染这两个区域）
            }
        },
        ontobasket: function (e) {
            ReportPage.tobasket();
        },
        onselproduct: function (e) {//选购产品按钮事件
            if (report.OrderBusiAuditIsPass == true) {
                alert("您的注册购物订单已生效，不能编辑购物车！");
                return;
            }

            ReportPage.selproduct();
        }
    });

    //初始加载后要注册当前步骤
    stepUtil.reg({
        partial: partial,
        reflash: function () {
            apollo.app.setdata({
                IsShowReportTip: true //是否显示报单提示
            });
        },
        load: function () {
            var report = app.getdata().Report;//后续用current代替
            checkBasketIsValidAndRefCX("", function () {
                apollo.app.setdata(["Basket.giveinfo", "Basket", "Basket.ProductItems"]);
            });
            var param = ReportPage.createparam();
            apollo.api("CKProductApi", "GetAllProdTypes", param, function (pt) {
                //根据取到的分类及UI，设置呈现数据
                //以下分类为PC选购商品导航分类，和首页及产品列表相类似
                var ct = [];//快捷检测导航区

                var cbg = [];
                for (var i = 0; i < pt.ProductPlaces.length; i++) {
                    cbg.push(pt.ProductPlaces[i]);
                    //if (pt.ProductPlaces[i].NodeCode != '09')
                    //    cbg.push(pt.ProductPlaces[i]);
                }

                //ct.push({ Title: "产品专区", NodeType: 2, NodeList: pt.ClassItems });
                ct.push({ Title: "产品馆", NodeType: 1, NodeList: cbg });
                ct.push({ Title: "产品汇总", NodeType: 0, NodeList: pt.ProductTypes });

                //导航区
                var nav = [];
                var classNav = [];
                //classNav.push({ Title: "产品分类", Nodes: pt.ProductTypes, Node: { NodeType: 0, NodeCode: "", NodeName: "全部产品", Products: [] } });

                $(pt.ProductPlaces).each(function (i, c) {
                    nav.push({
                        NodeName: c.NodeName,
                        NodeCode: c.NodeCode,
                        NodeType: c.NodeType
                    });
                    classNav.push({ Title: c.NodeName, Node: c, Nodes: [] });
                });

                $(pt.ClassItems).each(function (i, c) {
                    nav.push({
                        NodeName: c.NodeName,
                        NodeCode: c.NodeCode,
                        NodeType: c.NodeType
                    });
                    //classNav.push({ Title: c.NodeName, Node: c, Nodes: [] });
                });
                

                //更新分类
                app.setdata({
                    ProdCTitems: ct,
                    NavItems: nav,
                    CurrKJNavItems: ct[0].NodeList,
                    CurrKJNavType: ct[0].NodeType,
                    PCKJNavs: ct,
                    classNav: classNav
                });

                //再启动加载产品信息
                //默认加载第一个项目
                window.setTimeout(loadAllProd, 500);
            });
        },
        valid: function (tonextfun) {

            //当不选择加价购或无加价购时执行的检测方法
            var checkfun = function (callback) {

                //先检测购物车本身是否合业务规则
                if (!basket.valid()) return false;//如果本身不合规则，则不再进行后台检测（提示信息在valid方法中自行控制）
                var param = ReportPage.createparam({
                    IsReflashCX: false,//不需要刷新促销
                    ProductCode: ""
                }, true);
                apollo.nomask = true;
                apollo.api("CKReportApi", "CheckBasketIsValid", param, function (rtn) {
                    if (rtn.IsSuccess)//符合业务规则，进行回调
                    {
                        //这里要刷新一下报单对象及产品信息，因为后台会同时汇总报单可得赠品情况及计算相关费用信息
                        var bill = rtn.ReturnValue;
                        $.extend(true, report, bill.Report);
                        //再次刷新
                        apollo.app.setdata("Report", "Report.MarkupGives", "Basket.ProductItems", "Basket");

                        if (jQuery.isFunction(callback)) callback();//进入下一步回调
                    }
                    else {
                        basket.checkresult(false, rtn.Message);
                    }
                }, function (err) {
                    showNotice("调用出现故障，请稍后再试。信息：" + err);
                });

            }

            //检查是否有加价购
            if (data.MarkupGiveInfos != null && data.MarkupGiveInfos.length > 0) //当前有促销加价购赠品
            {
                if (report.MarkupGives == null || report.MarkupGives.length <= 0) //如果没有选择加价购
                {
                    apollo.dialog.ask("温馨提示：当前正在进行促销换购活动，您是否要参加换购活动？<br>点击【是】进行促销换购，需要选换购商品。<br>点击【否】不进行促销换购，直接进入下一步。", function () {
                        //显示加价购商品
                        ReportPage.options.showmarkuppopup();
                    }, function () {
                        checkfun(tonextfun);
                    });
                }
                else
                    checkfun(tonextfun);
            }
            else
                checkfun(tonextfun);
            //再次调用后端检测当前购物车数据是否合业务规则

            return false;//不直接进入下一步
        }
    });

    /**加载产品信息，并进行分类*/
    function loadAllProd() {
        var report = app.getdata().Report;//后续用current代替
        var param = ReportPage.createparam();


        apollo.api("CKProductApi", "GetAllProductLists", param, function (ps) {
            //设置所有分类各类对应商品,并自动移除无产品的分类
            $(data.PCKJNavs).each(function (i, ct) {
                $(ct.NodeList).each(function (j, node) {
                    node.Products = getproductsForType(ps, node.NodeCode, node.NodeType);
                });
                //移除无实际产品的类型
                apollo.array.removeAll(ct.NodeList, function (node) {
                    return node.Products == null || node.Products.length <= 0;
                });
            });

            //再移除没有实际元素的项
            apollo.array.removeAll(data.PCKJNavs, function (nav) {
                return nav.NodeList == null && nav.NodeList.length <= 0;
            });


            //移除无产品的项
            apollo.array.removeAll(data.classNav, function (c) {
                return c.Nodes.length<=0&&( c.Node.Products==null || c.Node.Products.length <= 0);
            });


            var defaultItems = [];//默认分类
            if (data.PCKJNavs.length > 0) defaultItems = data.PCKJNavs[0].NodeList;

            //更新首页呈现
            apollo.app.setdata({
                CurrKJNavItems: defaultItems,
                PCKJNavs: data.PCKJNavs
            });
        });
    }

    /**获取指定分类下所属产品*/
    function getproductsForType(prods, nodecode, nodetype) {
        var arr = [];
        $(prods).each(function (i, p) {
            var type = "";
            if (nodetype == 0) {
                type = p.SerialCode;
            }
            else if (nodetype == 1) {
                type = p.ProductPlaceID;
            }
            else if (nodetype == 2)//注意，这类下还有一些特殊的，需要处理
            {
                type = p.ClassTypeID;
            }
            if (apollo.Lib.isEquals(type, nodecode)) {
                if (nodecode != "CXProduct" && p.IsCXProduct == true) {
                    return;
                }
                else {
                    arr.push(p);
                }
            }
        });
        return arr;
    }


    //检测购物车是否合法并刷新促销信息
    function checkBasketIsValidAndRefCX(productcode, callback) {
        var param = ReportPage.createparam({
            IsReflashCX: true,
            ProductCode: productcode
        }, true);
        apollo.nomask = true;
        apollo.api("CKReportApi", "CheckBasketIsValid", param, function (rtn) {


            //同时更新促销
            var info = rtn.ReturnValue;
            //合并加价购
            var arr = [];
            if (info.billgive != null && info.billgive.MarkupGives.length > 0) {
                arr = info.billgive.MarkupGives;
            }
            apollo.app.setdata({
                MarkupGiveInfos: arr
            });

            basket.reflashcx(info.billgive);//更新指定产品的促销信息
            if (apollo.Lib.isNotEmpty(productcode)) {
                basket.reflashcx(info.prodgive, productcode);
            }

            if (rtn.IsSuccess) {

                var msg = "您当前符合购物规则，可以进入结算确认。";
                if (report.ReportType == "71") {
                    if (report.TagInfo != null && report.TagInfo.IsTuanLeader==1)
                        msg = "茅台白金酒扫码购，每人限购20箱.预售时间：2019.11.8--11.21，预计元旦前后统一发货。";
                    else if (report.TagInfo != null && report.TagInfo.IsTuanLeader == 2)
                        msg = "茅台白金酒扫码购，预售时间：2019.11.8--11.21，预计元旦前后统一发货。";
                    else
                        msg = "茅台白金酒扫码购，每人限购3箱.预售时间：2019.11.8--11.21，预计元旦前后统一发货。";
                }
                if (apollo.Lib.isNotEmpty(rtn.Message))
                    msg = rtn.Message;

                products = info.Products;

                basket.updatelist(products);
                //先设置检测结果
                basket.checkresult(true, msg);
                //再进行购物车本身检测
                basket.valid();
            }
            else {
                basket.checkresult(false, rtn.Message);
            }

            apollo.app.setdata(["Basket.giveinfo", "Basket.checkInfo"]);

            if (callback != null) callback();
        });

        basket.reflash();
        apollo.app.setdata("Basket");

    }



    function showTZProdlist() {
        var codes = [];
        var hasFX2032 = false, hasFX0074 = false;

        $(basket.ProductItems).each(function (i, p) {
            if (p.Product.ProductCode.toLowerCase() == "fx2032")
                hasFX2032 = true;

            if (p.Product.ProductCode.toLowerCase() == "fx0074")
                hasFX0074 = true;
        });

        if (hasFX2032 == false)
            codes.push("FX2032");

        if (hasFX0074 == false)
            codes.push("FX0074");

        if (codes.length == 0) {
            apollo.app.setdata({ PTProducts: [] });
            return; //没有配套产品，则不显示
        }

        var successFun = function (arr) {
            apollo.app.setdata({ PopupProducts: arr });
            if (arr.length > 0) {
                //弹出产品，让用户时行选购
                ReportPage.options.showPopupProd("是否需要订购雅丽化妆品手提袋、水润紧致系列产品折页？");
            }
        };
        //获取各购物相关参数信息
        var param = ReportPage.createparam({ Codes: JSON.stringify(codes) });
        apollo.api("CKProductApi", "GetProductListsForCode", param, successFun);
    }

})(jQuery, apollo.app);