﻿(function ($) {
    window.customUtil = (function () {
        var arrCustom = [];//存储所有定制对象

        function getname(code) {
            if (apollo.Lib.isIn(code, ["2FS0001", "2FS0001-A"]))
                return "2FS0001";
            else if (apollo.Lib.isIn(code, ["2FS0002", "2FS0002-A"]))
                return "2FS0002";
            else
                return code;
        }

        function provateOrder(options) {
            var defaults = {
                path:"",
                OrderNum: 1,
                Product: null,//私人订制产品基本信息
                CustomInfo: null, //当前私人定制产品定制对象,里面包含有初始输入参数信息
                CustomInfoUIParam: null//辅助输入信息
            };

            var op = $.extend(defaults, options);

            var key = getname( op.Product.ProductCode);
            var util = arrCustom[key];
            if (util == null) {//如果不存在，则进行注册
                var url = apollo.getvpath(op.path+"Index.html",true)
                $.get(url, {}, function (html, status) {
                    if (status == "success") {//加载成功
                        $("body").append(apollo.convertpath(html));
                    }
                    else {
                        showNotice(html);
                    }
                });
            }
            else
                util.load();
        }


        //设置私人定制信息
        function OnSetCustom(info,isupdate) {
            var code = info.ProductCode;
            var successFun = function (rtn) {
                if (rtn.IsSuccess) {                    
                    var param = {
                        path: "Mobile/Content/PrivateOrder/" + getname(code) + "/",
                        OrderNum: 1,
                        Product: info,//私人订制产品基本信息
                        CustomInfo: rtn.ReturnValue.CustomInfo, //当前私人定制产品定制对象,里面包含有初始输入参数信息
                        CustomInfoUIParam: rtn.ReturnValue.CustomInfoUIParam//辅助输入信息
                    };
                    var custom = info.CustomInfo;
                    if (isupdate == true && custom != null)
                        param.CustomInfo = custom;

                    customUtil.load(param);
                }
                else {
                    showNotice("获取定制参数时失败，请稍候再试！");
                }
            };
            apollo.api("CKOrderApi", "GetCustomInfo", { ProductCode: getname(code) }, successFun);
        }
        return {
            name:"",
            isUpdate:false,//是否为设置,如果是设置，则可以进行编辑，否则只可查看
            current: null,//当前定制参数对象
            param: null,
            uiparam: null,
            callback: null,            
            load: function (options) {
                this.current = options.CustomInfo;
                this.param = options;
                this.uiparam = options.CustomInfoUIParam;
                provateOrder(options)
            },
            reg: function (name, funload) {
                this.name = name;
                var item = {
                    load: funload
                };
                arrCustom[name] = item;
                funload();
            },
            show: function (prod, isupdate,callback) {//显示私人定制
                if (isupdate == true)
                    this.isUpdate = true;
                else
                    this.isUpdate = false;
                this.callback = callback;
                OnSetCustom(prod, isupdate);
            }
        }
    })();
})(jQuery);