﻿/*产品选购页相关控制脚本*/
var prodPageIndex = 0;//默认为第一页
var ProdNumbox = null;//产品详情中数量输入框对象
var IsNeedProd = false;//用于标识当前是否为必选购物产品
var BasketBox = { runFlyIn: function (obj, isA) { } };

var prodListUtil = null;//用于控制产品列表显示
var currProductType = "", currClassType = "", currSearchKey = "", currPTName = "全部产品";//当前选中的产品类型及分类
var currBasketCodes = ['FX095'];//当前报单已选中的产品

var prodTypeUtil = null;//用于控制产品分类显示

var isHomeIndex = true;//当前是否为首页

var cxProductCodes = [];//当前正在进行促销的产品

//初始化当前页面
function initPage() {
    if (!isHomeIndex) {//为产品列表页
        getCXProducts();
        currProductType = request("pt");
        currClassType = request("ct");
        currSearchKey = request("key");
        currPTName = urldecore(request("ptN"));
        var type = request("type");
        if (currPTName == "") {
            currPTName = currSearchKey == "" ? "产品列表" : "检索结果";
        }


        initProduct();
        BasketBox = $("body").saleBasket();
        initProductPager();
        showProductList(currSearchKey, currProductType, currClassType, currPTName);

        if (type=="showProduct") //首页点击产品详情
        {
            var code = request("code");
            if (code == null || code == undefined || code == "") return;
            showProductInfo(code);
        }
    }
    else
        initProduct();
}

function homeToProductInfo(code)
{
    openWin("Home/ProdView", "Home/ProdView?code=" + code);
}


function urldecore(str) {
    try {
        return decodeURIComponent(url);
    }
    catch (e) { return ""; }
}
function urlencode(str) {
    try {
        return encodeURIComponent(str);
    }
    catch (e) { return ""; }

}
function initLoadPT() {
    initProductTypeAndClass();
}

function initProduct() {
    prodTypeUtil = PushUrl({ url: apollo.pageInfo.rootvpath + "SalePartial/PTClsType.html", showAnimation: 2 });
}


//显示指定产品详细信息
function onShowProdDetail(ProductCode) {
    homeToProductInfo(ProductCode);
}

//设置当前购物提示信息
function refProductTip() {

}

///初始化产品分类及类型
function initProductTypeAndClass() {
    var successFun = function (rtn) {
        var arrPT = rtn.ProductTypes;
        var arrCT = rtn.ClassTypes;
        var iconclass = ["icon-yybj", "icon-hzp", "icon-bjyp", "icon-xxcj", "icon-bjqc", "icon-other", "icon-zlpd","icon-fx", "icon-sjpj", "icon-gbjpj"]
        //先设置产品类型集
        var ulpt = $("#divPT");
        ulpt.empty();
        var iconindex = 0;
        $(arrPT).each(function (i, pt) {
            var li = $("<div class=\"ub ulev0 mar-b-5\"></div>");
            var html = "<i class=\"push-icon " + iconclass[iconindex] + " umar-r ub-f1 ub-img umh3 umw2\"></i>";
            html += "<div class=\"ub-f2 t-wh\">" + pt.Name + "</div>";
            html += "<span class=\"glyphicon glyphicon-menu-right txt-pink-red ub-f1\"></span>"
            li.html(html);
            li.data("Code", pt.Code);
            li.data("Name", pt.Name);
            li.click(function (e) {
                hidePTNav();
                var code = $(this).data("Code");
                var name = $(this).data("Name");
                showProductList($("#txtKeyword").val(), code, "", name);
            });
            ulpt.append(li);

            if (iconindex >= iconclass.length-1)
                iconindex = 0;
            else
                iconindex++;
        });

        //设置产品分类
        var upct = $("#divClass");
        upct.empty();
        iconindex = 0;

        $(arrCT).each(function (i, ct) {

            var li = $("<div class=\"ub ulev0 mar-b-5 hand\"></div>");
            var html = "<i class=\"push-icon " + iconclass[iconindex] + " umar-r ub-f1 ub-img umh3 umw2\"></i>";
            html += "<div class=\"ub-f2 t-wh\">" + ct.Name + "</div>";
            html += "<span class=\"glyphicon glyphicon-menu-right txt-pink-red ub-f1\"></span>"
            li.html(html);
            li.data("Code", ct.Code);
            li.data("Name", ct.Name);
            li.click(function (e) {
                hidePTNav();
                var code = $(this).data("Code");
                var name = $(this).data("Name");
                showProductList($("#txtKeyword").val(),"", code, name);
            });
            upct.append(li);

            if (iconindex >= 4)
                iconindex = 0;
            else
                iconindex++;
        });
    };
    mbCashe.getProductTypeItem(successFun);

    //改用缓存方式
    //apollo.SelProduct.GetPtsAndCts(0, successFun);

    refBasketView();

    $("#btnSearch").click(function (e) {
        var key = $("#txtKeyword").val();
        showProductList(key, "", "", key == "" ? "全部产品" : "检索结果");
    })
}

function initProductPager() {
    var json = {
        isDefaultLoad: false,//一开始不加载
        pageSize: 30,
        getDataFun: function (pageIndex, pageSize, successFun) {

            mbCashe.getProductItems(currSearchKey, currProductType, currClassType, successFun);

            //改用缓存方式
            //apollo.SelProduct.GetSaleProductItems("",
            //    JSON.stringify(currBasketCodes),
            //    0,
            //    currSearchKey, currProductType, currClassType, false, pageIndex, pageSize, successFun);
        },
        listDataFun: viewProdList //用于呈现当前页的方法，分页插件只控制页面跳转，本身不处理页面数据
    };

    prodListUtil = $(window).ListPager(json);
}

//显示产品分类
function showPTNav() {
    //设置产品分类栏样式
    prodTypeUtil.show();
}
//隐藏产品分类
function hidePTNav() {
    prodTypeUtil.hide();
}
//显示产品列表
function showProductList(key, productType, classType, ptName) {
    if (isHomeIndex) //非产品列表页
    {
        var url = "Home/ProdList?pt=" + productType + "&ct=" + classType + "&key=" + key + "&ptN=" + urlencode(ptName);
        openWin("Home_ProdList", url);
    }
    else {
        $("#lblSalePTName").html(ptName);

        var codes = [];
        currBasketCodes = codes;
        currProductType = productType;
        currClassType = classType;
        currSearchKey = key;

        $("#divProdList").empty();
        prodListUtil.load();//当改分类及条件时再加载
    }
}

//显示产品详细信息
function showProductInfo(code) {
    $(".Spinner").empty();
    $("#pdCXInfo").hide();//促销政策不显示    

    var successFun = function (info) {
        viewProdDetail(info.ProductInfo, info.OrderProduct);
        var num = info.ProductInfo.OrderNumTimes;
        if (num <= 0) num = 1;
        ProdNumbox = $("#ProdNumSpinner").Spinner({ min: num, value: num, numTimes: num });
        ProdNumbox.change = prodNumBoxChange;
    };
    apollo.SelProduct.GetSaleProductInfo("",code, 0, "", "", successFun);
}
//继续选择产品
function reSelProdList() {
    $("#prodList").show();
    $("#prodDetail").hide();
}

//检测指定产品是否在促销
function checkIsCxForCode(code) {
    if (cxProductCodes == null) return false;

    for (var i = 0; i < cxProductCodes.length; i++) {
        if (code == cxProductCodes[i])
            return true;
    }
    return false;
}

//获取当前正在进行促销的产品
function getCXProducts() {
    var successFun = function (codes) {
        cxProductCodes = [];
        $(codes).each(function (i, c) {
            cxProductCodes.push(c);
        });
    };
    var errfun = function () { };

    apollo.SelProduct.GetCXProductCodes(successFun, errfun);
}
//设置产品详细情况显示
function viewProdList(arr) {
    var ul = $("#divProdList");
    $(arr).each(function (i, p) {
        var li = $("<div class=\"ubb bor-light-gray ub pad-b-2 pad-t-2 w100\" onclick=\"onShowProdDetail('" + p.ProductCode + "')\"></div>");

        var html = "<div class=\"pro-list-pic\"><img src=\"" + p.ProductUrl + "\" onerror=\"onLoadImgError(this)\" /></div>";
        if (checkIsCxForCode(p.ProductCode)) {
            html += "<div class=\"sales-icon uabs ub-img umw3 umh5\"> </div>";
        }
        html += "                <div class=\"ub-f2 pad-l-2 pad-t-9 w56\">";
        html += "                    <h4 class=\"ut-s\">[" + p.ProductCode + "] " + p.ProductName + "</h4>";
        html += "                    <div class=\"t-gra pad-b-5 font-9\">" + p.BoxSpec + "</div>";
        html += "                    <b class=\"txt-red ulev1\">" + (p.IsTwoProduct == true ? "" : "&yen;") + apollo.Lib.BASEformatNumber(p.BoxPrice) + "</b>";
        html += "                </div>";

        li.html(html);
        ul.append(li);
    });
}
///显示产品详细信息
function viewProdDetail(product, orderProduct) {
    var img = $("#imgProduct");
    img.error(function () {
        onLoadImgError(this);
    }
    );
    img.attr("src", product.ProductUrl);

    $("#pdProductUrl").empty().append(img);

    $("#pdTitle").html(product.ProductCode + "    " + product.AliasName);
    $("#pdTitle1").html(product.ProductCode + "    " + product.AliasName);
    if (product.IsTwoShopProduct) //2号店产品
    {
        //2号店改为只能用积分换购，不再支持现金价格
        $("#lblProductPrice").html("换购积分：");
        $("#pdPrice").html(apollo.Lib.BASEformatNumber(product.ProductScore) + "/" + product.ProductUnit);
        $("#divTwoPrice").hide();



        //2017年1月17日之前代码，可支持三种价格
        //if (product.FuliPrice != product.Retail) {
        //    var h = "<span style='text-decoration: line-through; color:#999999; font-weight:lighter; font-size:0.85em;'>¥ " + apollo.Lib.BASEformatNumber(product.Retail) + "</span>  &nbsp;&nbsp;&nbsp;";
        //    h += "¥ " + apollo.Lib.BASEformatNumber(product.FuliPrice);
        //    $("#pdPrice").html(h);
        //    $("#pdPrice1").html(h);
        //}
        //else {
        //    $("#pdPrice").html("¥ " + apollo.Lib.BASEformatNumber(product.FuliPrice));
        //    $("#pdPrice1").html("¥ " + apollo.Lib.BASEformatNumber(product.FuliPrice));
        //}


        //$("#lblProductPrice").html("现金福利价：");
        //$("#divTwoPrice").show();
        //$("#pdProductScore").html(apollo.Lib.BASEformatNumber(product.ProductScore));

        //$("#pdScorePrice").html(apollo.Lib.BASEformatNumber(product.ScorePart) + " + ¥" + apollo.Lib.BASEformatNumber(product.PricePart));
    }
    else {
        $("#pdPrice").html("¥ " + apollo.Lib.BASEformatNumber(product.BoxPrice) + "/" + product.ProductUnit);
        $("#pdPrice1").html("¥ " + apollo.Lib.BASEformatNumber(product.BoxPrice) + "/" + product.ProductUnit);



        $("#lblProductPrice").html("价格：");
        $("#divTwoPrice").hide();
    }
    if (product.ProductPV != product.PV) {
        var h = "<span style='text-decoration: line-through; color:#999999; font-weight:lighter; font-size:0.85em;'>" + apollo.Lib.BASEformatNumber(product.PV) + "</span>  &nbsp;&nbsp;&nbsp;";
        h += apollo.Lib.BASEformatNumber(product.ProductPV);
        $("#pdPV").html(h);
    }
    else {
        $("#pdPV").html(apollo.Lib.BASEformatNumber(product.ProductPV));
    }
    $("#pdChineseName").html(product.ProductName);

    $("#pdBoxSpec").html(product.BoxSpec);
    $("#pdBoxSpec1").html(product.BoxSpec);

    //产品简介
    $("#pdMemo").html(product.Memo);

    //如果是私人定制产品，还要显示提示信息
    if (product.IsPrivateOrder == true) {
        if (product.InventoryExplain != "" && product.InventoryExplain != null) {
            $("#divPrivateProductFHTip").html(product.InventoryExplain + "<br>" + product.ProductName + "需要私人订制，一般从下单后20天才能发货，请耐心等待。");
            $("#divPrivateProductFHTip").show();
        }
        else {
            $("#divPrivateProductFHTip").html(product.ProductName + "需要私人订制，一般从下单后20天才能发货，请耐心等待。");
            $("#divPrivateProductFHTip").show();
        }
    }
    else {
        if (product.InventoryExplain != "" && product.InventoryExplain != null) {
            $("#divPrivateProductFHTip").html(product.InventoryExplain);
            $("#divPrivateProductFHTip").show();
        }
        else {
            $("#divPrivateProductFHTip").html("");
            $("#divPrivateProductFHTip").hide();
        }
    }



    //详细图片信息
    var imgPanel = $("#pdMoreImages");
    imgPanel.empty();
    if (product.ProductAllImages.length > 0) {
        imgPanel.show();
        var ul = $("<ul class=\"c-wh ub ub-ver mar0\"></ul>");
        imgPanel.append(ul);
        ul.append("<h4 class=\"pad-lr1 pad-b-5 pad-t-5 mar0 ubb bor-light-gray\">图文详情</h4>");
        $(product.ProductAllImages).each(function (i, imgurl) {
            ul.append("<li><img src=\"" + imgurl + "\"></li>")
        });
    }
    else
        imgPanel.hide();


    if (product.ProductCode.toUpperCase() == "FX095")
        $("#divFX095Gife").show();
    else
        $("#divFX095Gife").hide();

    $("#divGiveView").hide();

    $("#FX095_1").removeAttr("checked");
    $("#FX095_2").removeAttr("checked");
    $("#FX095_3").removeAttr("checked");
    $("#FX095_4").removeAttr("checked");
    $("#FX095_5").removeAttr("checked");

    var hasFX095 = true;

    if (hasFX095 && product.ProductCode.toUpperCase() == "FX095") {
        $("#btnAdd").attr("disabled", "disabled");
        $("#btnAdd").addClass("btnDisabled");
    }
    else {
        $("#btnAdd").removeAttr("disabled");
        $("#btnAdd").removeClass("btnDisabled");
    }

    //将产品加入到购物车中
    $("#btnAdd").data("OrderProduct", orderProduct);

    //显示该产品相关的促销政策
    viewProdCxInfo(product.ProductCode);

    viewGiveInfo(orderProduct, 1);

    $("#btnCustom").hide();
    $("#btnAdd").show();
    $("#liProdNumSpinner").show();//显示数量选择
}

//获取指定产品的复本
function getProductColne(product) {
    return {
        CustomParamID: product.CustomParamID,
        DeductScore: product.DeductScore,
        ProductSaleType: product.ProductSaleType,
        ProductCode: product.ProductCode,
        ProductName: product.ProductName,
        FX095Gife: product.FX095Gife,
        ProductUnit: product.ProductUnit,
        ProductPrice: product.ProductPrice,
        ProductPV: product.ProductPV,
        Retail: product.Retail,
        BoxPrice:product.BoxPrice,
        PV: product.PV,
        ProductUrl: product.ProductUrl,
        OrderNumMin: product.OrderNumMin,
        OrderNumTimes: product.OrderNumTimes,
        ProductCount: product.ProductCount,
        StoreCode: product.StoreCode,
        FuliPrice: product.FuliPrice,
        ScorePart: product.ScorePart,
        PricePart: product.PricePart,
        ProductScore: product.ProductScore,
        BoxSpec: product.BoxSpec,
        IsPrivateOrder: product.IsPrivateOrder,
        CustomInfo: product.CustomInfo,
        IsReadOnly: product.IsReadOnly,
        IsOther: product.IsOther,
        SaleMoney: product.SaleMoney,
        SalePV: product.SalePV,
        SaleScore: product.SaleScore
    };
}

//设置私人定制信息
function OnSetCustom(btn) {
    var info = $(btn).data("OrderProduct");
    if (info == null) return;

    var successFun = function (rtn) {
        if (rtn.IsSuccess) {
            var param = {
                OrderNum: 0,
                Product: info,//私人订制产品基本信息
                CustomInfo: rtn.ReturnValue.CustomInfo, //当前私人定制产品定制对象,里面包含有初始输入参数信息
                CustomInfoUIParam: rtn.ReturnValue.CustomInfoUIParam//辅助输入信息
            };

            openModelDialog(apollo.pageInfo.rootvpath + "Content/PrivateOrder/" + info.ProductCode + "/Index.html", 20000, 20000, function (rtnParam) {
                if (rtnParam == null)
                    return;

                if (rtnParam.OrderNum > 0 && rtnParam.CustomInfo != null) //传入正常参数
                {
                    info.CustomInfo = rtnParam.CustomInfo;
                    //则加入到购物车中
                    addCustomTobasket(info, rtnParam.OrderNum);
                    BasketBox.runFlyIn($("#imgProduct"), false);
                }
            }, param);
        }
        else {
            showNotice("获取定制参数时失败，请稍候再试！");
        }
    };
    apollo.JXSBuy.GetCustomInfo(info.ProductCode, successFun);
}

//显示指定产品相关的促销政策信息
function viewProdCxInfo(productCode) {
    var cx = $("#pdCXInfo");
    var lbl = $("#pdCXInfoPanel");
    cx.hide();

    var successFun = function (items) {
        if (items != null && items.length > 0) {
            var arr = [];
            var index = 0;
            $(items).each(function (i, info) {
                if (info != "") {
                    index++;
                    arr.push(index + "、" + info);
                }
            });
            if (arr.length > 0) {
                var html = "<span class=\"bg-danger bor-red uba txt-red pad-l-5 pad-r-5 lh2 umw3 umar-r\">促销</span>";
                html += "<div class=\"t-gra ub-f2 ut-s umar-r\">" + arr.join(";") + "</div>";
                html += "<div class=\"umw1\"><span class=\"glyphicon glyphicon-option-horizontal\"></span></div>";
                lbl.html(html);
                cx.show();
            }
            else
                cx.hide();
        }
    };
    apollo.Common.GetCxInfos(productCode, successFun);
}

//显示当前产品当前购物数可获得的赠品
function viewGiveInfo(prod, num) {
    $("#divGiveView").hide();
    $("#pdGiveInfo").html("");

}

//当前产品详细页产品数改改变时激活的事件
function prodNumBoxChange(box) {
    var prod = $("#btnAdd").data("OrderProduct");
    if (prod == null) return;
    //取到数量
    viewGiveInfo(prod, box.getValue());
}

//将产品加入到购物车中
function OnAddToBasket(btn) {
    var op = $(btn).data("OrderProduct");
    if (op != null) {
        var num = ProdNumbox.getValue();
        if (num < 1) {
            alert("请输入订货数量！");
            return;
        }
        if (op.ProductCode.toUpperCase() == "FX095") {
            var type = "";
            if ($("#FX095_1").is(":checked"))
                type = "1";
            else if ($("#FX095_2").is(":checked"))
                type = "2";
            else if ($("#FX095_3").is(":checked"))
                type = "3";
            else if ($("#FX095_4").is(":checked"))
                type = "4";
            else if ($("#FX095_5").is(":checked"))
                type = "5";
            if (type == "") {
                alert("请选择赠品");
                return;
            }
            op.FX095Gife = type;
        }
        addTobasket(op, num);
    }
}
//将私人定制产品增加到购物车中
function addCustomTobasket(prod, count) {
    
}

///将产品加入到订货购物车中
function addTobasket(prod, count) {


    if (prod.BuyAuthCode != null && prod.BuyAuthCode != "") //需要授权码
    {
        alert("对不起，该产品购买需要授权，不能加入购物车!");
        return;
    }




    addToShopCart(prod.ProductCode, count);
}

//刷新购物车显示信息(主要用于产品选择上）
function refBasketView() {
    //底部显示区

}


//图片加载错误时激活的事件
function onLoadImgError(img) {
    try {
        img.onerror = null;
    }
    catch (e) { }
    $(img).attr("src", apollo.pageInfo.rootvpath + "Content/Images/NoPic.png");
}

function showProdDetail(showid, hideid) {
    $("#" + showid).show();
    $("#" + hideid).hide();
}



/*购物车方法*/
(function ($) {
    /*产品选购时购物车相关方法*/
    $.fn.saleBasket = function () {
        var basket = {
            runFlyIn: function (img, isNumChange)//执行飞入动作
            {
                this.flyFun(false, isNumChange);
            },
            runFlyOut: function (img, isNumChange) //执行飞出动作
            {
                this.flyFun(true, isNumChange);
            },
            flyFun: cartFly,//产品加入到购物车后启动的飞入动画
            getNum: function () {//获取当前购物车中产品数
                return 0;
            }
        };


        function cartFly(isOut, numChange) {
            var txt = "";
            if (isOut == null || isOut == undefined)
                txt = "已在购物车中！";
            else if (isOut == true) {
                txt = numChange ? "已从购物车中减数！" : "已成功从购物车中移除！";
            }
            else {
                txt = numChange ? "已向购物车中加数！" : "已成功加入账物车！"
            }
            showNotice(txt, 2);
        }

        return basket;
    }
})(jQuery);
