﻿//采用懒加载方式分页显示
(function ($) {
    $.fn.extend({
        ListPager: function (options) {
            var defaults = {
                pageMode: 0,//分页模式，0为标准版,1为简化版，多用于APP，
                pageSize: 20,//每页数量
                isDefaultLoad:true,//是否一初始化就加载
                data: null,
                getDataFun: null,//获取数据的方法,通过这个方法，获取到指定数据，需传递如下参数,pageIndex,pageSize,和成功取到数据后的委托方法
                listDataFun:null //用于呈现当前页的方法，分页插件只控制页面跳转，本身不处理页面数据
            }
            //分页区主要对象变量
            var allowPage = true;//是否需要分页

            var op = $.extend(defaults, options);

            allowPage = op.pageSize > 0 //表示要分页

            var totalPage = 0;//当前总页数
            var pageIndex = 0;//当前页的索引
            var totalRecord = 0

            var pager = $(this);//滚动分页显示区

            var isLoadFin = false;//是否已全部加载完
            var isLoading = false;//是否真在加载中
            

            //默认加载第一页            
            if (op.data != null) {
                allowPage = false;
                createBody(op.data);
            }
            else {
                initList();
                if (op.isDefaultLoad)
                    gotoPage(0);
            }
                

            //创建具体页面数据
            function createBody(rows) {
                if (op.listDataFun != null)
                    op.listDataFun(rows);
            }

            function isEmptyValue(v) {
                if (v == "0001-01-01 00:00:00")
                    return true;
                else if (v == null)
                    return true;
                else if (v == "null")
                    return true;
                else if (v == "00000000-0000-0000-0000-000000000000")
                    return true;
                else
                    return false;
            }
            
            
            //转到第几页并显示指定页数据
            function gotoPage(index) {
                if (isLoading == true) return;
                isLoading = true;
                var successFun = function (rtn) {
                    if (rtn == null) return;

                    var total = rtn.total;//总记录数
                    var rows = rtn.rows;

                    if (isNaN(total)) total = items.rows.length;
                    if (isNaN(total)) total = 0;
                    totalRecord = total;

                    totalPage = Math.ceil(totalRecord / op.pageSize);

                    if (pageIndex>=totalPage-1) //表示无记录可加载，已加载完
                    {
                        isLoadFin = true;
                    }
                    createBody(rows);
                    pageIndex = index;
                    isLoading = false;
                };

                pageIndex = index;//设置当前页索引为该页

                if (op.getDataFun != null)
                    op.getDataFun(pageIndex, op.pageSize, successFun);
            }

            function initList() {
                var range = 50;             //距下边界长度/单位px
                var elemt = 500;           //插入元素高度/单位px
                var maxnum = 20;            //设置加载最多次数
                var num = 1;
                var totalheight = 0;
                var main = $("#content");                     //主体元素
                pager.scroll(function () {
                    if (isLoadFin == true||isLoading==true) return;
                    var srollPos = pager.scrollTop();    //滚动条距顶部距离(页面超出窗口的高度)
                    totalheight = parseFloat(pager.height()) + parseFloat(srollPos);
                    if (($(document).height() - range) <= totalheight && !isLoading && isLoadFin != true) {
                        pageIndex++;
                        gotoPage(pageIndex);
                    }
                });
            }

            return {
                load: function () {
                    pageIndex = 0;//默认为第一页
                    isLoadFin = false;
                    gotoPage(0);
                }
            }
        }
    });
})($);