﻿/* jQuery.Spinner V1.0 CopyRight (c) 2014 by:Loyaoo Taobao:http://isseven.taobao.com */

(function ($) {

    $.fn.Spinner = function (opts) {

        var defaults = { value: 0, min: 0, len: 5, max: 99999, numTimes: 1 };
        var options = $.extend(defaults, opts);
        if (options.numTimes <= 0) options.numTimes = 1;
        var keyCodes = { up: 38, down: 40 };
        var boxNum = null, a = null, c = null;
        var isEnabled = true;
        var prevNum = options.value;
        var rtnBox = {
            add: null,
            onAdd: null,//增加后激活的事件
            onDecrease: null,//减少后激活的事件
            getValue: function () {
                var nv = boxNum.val();
                var v = parseInt(nv);
                if (isNaN(v))
                    return 0;
                else
                    return v;
            },
            setValue: function (v) {
                boxNum.val(v);
                prevNum = v;
            },
            setEnabled: function (isE) {
                isEnabled = isE;
                if (isEnabled) { f(a, 2, "DisDe", "Decrease"); } else { f(a, 2, "Decrease", "DisDe"); }
                if (isEnabled) { f(c, 2, "DisIn", "Increase"); } else { f(c, 2, "Increase", "DisIn"); }
                if (isE)
                    boxNum.removeAttr("disabled");
                else
                    boxNum.attr("disabled", "disabled");
            },
            setmax: function (m) {
                options.max = m;
            },
            change: null
        };


        this.each(function () {
            a = $('<a></a>');
            f(a, 0, "Decrease", "－");	//减

            c = $('<a></a>');
            f(c, 0, "Increase", "＋");	//加

            boxNum = $('<input/>');
            f(boxNum, 1, "Amount"); cv(0);	//值

            $(this).append(a).append(boxNum).append(c);
            a.click(function () {
                var nv = rtnBox.getValue();
                
                cv(-1, true);

                if (nv>options.min && rtnBox.onDecrease != null)
                    rtnBox.onDecrease(rtnBox.getValue());
            });
            boxNum.focus(function () {
                $(this).select();
            });
            boxNum.keyup(function () {  cv(0) });
            boxNum.change(function () {
                cv(0);
            });
            c.click(function () {
                var nv = rtnBox.getValue();
                cv(+1, true);
                if (nv < options.max && rtnBox.onAdd != null)
                    rtnBox.onAdd(rtnBox.getValue());
            });
            
            boxNum.bind('keyup paste change', function (e) {
                if (e.keyCode == keyCodes.up)
                    cv(+1, false);
                else if (e.keyCode == keyCodes.down)
                    cv(-1, false);
                else {
                    cv(0);
                }
            });

            function cv(n, isBtn) {
                if (!isEnabled) return;
                n = n * options.numTimes;
                boxNum.val(boxNum.val().replace(/[^\d]/g, ''));
                bv = parseInt(boxNum.val() || options.min) + n;
                if (bv >= options.min && bv <= options.max){
                    boxNum.val(bv);
                }
                if (bv <= options.min) { boxNum.val(options.min); f(a, 2, "DisDe", "Decrease"); } else { f(a, 2, "Decrease", "DisDe"); }
                if (bv >= options.max) { boxNum.val(options.max); f(c, 2, "DisIn", "Increase"); } else { f(c, 2, "Increase", "DisIn"); }

                if (prevNum != bv && rtnBox.change != null) rtnBox.change(rtnBox, isBtn == true, prevNum<bv);
                prevNum = bv;
            }
            rtnBox.add = function (n) {
                cv(n, true);
            }
        });

        function f(o, t, c, s) {
            t == 0 && o.addClass(c).attr("href", "javascript:void(0)").append(s);
            t == 1 && o.addClass(c).attr({ "value": options.value, "autocomplete": "off", "maxlength": options.len });
            t == 2 && o.addClass(c).removeClass(s);
        }
        return rtnBox;
    }

})(jQuery);