﻿/*图片上传插件*/
(function ($) {
    $.fn.photoBox = function (options) {
        var defaults = {
            onlyRead: false,
            imgUrl: "",
            postUrl: systemWebApiSiteUrl + "Content/Scripts/photoBox/PhotoBoxHandler.ashx",
            pathName: "MBPhoto/UserPhoto",//上传文件后存放的目录名,
            maxImageWH: 0//最大宽度，如为0，则表示原图大小            
        }
        var form;//用于实现图片上传，只有实际用处理

        var divPhoto = $(this);
        var op = $.extend(defaults, options);

        var imgBox, fileBox, lblInfo, boxPanel;

        var rtnObj = {
            getValue: function () {
                return op.imgUrl;
            },
            setValue: function (url) {
                op.imgUrl = url;
                if (imgBox == null) return;
                imgBox.css("width", "100%");
                imgBox.css("height", "auto");
                imgBox.attr("src", url);
                imgBox.css("border", "1px");
                setTimeout(function () {
                    var w = imgBox.width();
                    var h = imgBox.height();
                    if (w > h) {
                        imgBox.css("width", "100%");
                    }
                    else {
                        imgBox.css("height", "100%");
                    }
                }, 1000);
                setIsCanLoad();
            },
            setEnabled:setEnabled
        }

        function setEnabled(isE) {
            op.onlyRead = !isE;

            setIsCanLoad();
        }

        function setIsCanLoad() {
            if (lblInfo != null) {
                if (op.onlyRead != true) {
                    if (op.imgUrl == null || op.imgUrl == "")
                        lblInfo.show();
                    else
                        lblInfo.hide();
                }
                else
                    lblInfo.hide();
            }
        }



        function createBox() {

            boxPanel = $("<div style=\"border:1px solid #ccc;background-color:#e2e2e2;\" class=\"w100 h100\"></div>");
            divPhoto.append(boxPanel);

            imgBox = $("<img style=\"width:100%;height:100%;\" />");
            boxPanel.append(imgBox);
            if (op.imgUrl != "")
                imgBox.attr("src", op.imgUrl);

            boxPanel.click(UexImage);

            lblInfo = $("<span class=\"pos-abs cur-p l0 t0 w100\" style=\"text-align:center\">点击进行上传...</span>");

            boxPanel.append(lblInfo);

            var h = divPhoto.height();
            boxPanel.css("line-height", h + "px");
        }


        //拍照进行上传图片  
        function UexImage() {
            if (op.onlyRead == true) return;
            uexWindow.actionSheet({
                title: "选择图片",
                cancel: "取消",
                buttons: "本地照片,相机拍照"
            }, function (index) {
                if (index == 0) {
                    addressPHone();
                } else if (index == 1) {
                    camer();
                }
            });
        }
        //拍照
        function camer() {
            try {
                uexCamera.cbOpen = function (opCode, dataType, data) {
                    upload(data);
                }
                uexCamera.open();
            }
            catch (e) { }
        }

        //本地照片
        function addressPHone() {
            var data = {
                min: 1,
                max: 1,
                quality: 0.8,
                detailedInfo: true
            }
            uexImage.onPickerClosed = function (info) {
                info = JSON.parse(info);
                upload(info.data[0]);
            }

            var json = JSON.stringify(data);
            uexImage.openPicker(json)
        }


        //上传图片到服务器
        //随机字符串
        var chars = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'];
        function generateMixed(n) {
            var res = "";
            for (var i = 0; i < n ; i++) {
                var id = Math.ceil(Math.random() * 5);
                res += chars[id];
            }
            return res;
        }
        function uploadFile(dirPath, cb, name) {
            var uploadHttp = systemWebApiSiteUrl + 'SysSet/SaveRealShopPhoto?ImageMaxWH=' + op.ImageMaxWH + "&PathName=" + op.pathName;
            var num = generateMixed(5);
            uexUploaderMgr.onStatus = function (opCode, fileSize, percent, rtn, status) {
                switch (status) {
                    case 0:
                        $toast('文件上传中' + percent + '%', 3000)
                        break;
                    case 1:
                        $toast('文件上传成功', 3000)
                        uexUploaderMgr.closeUploader(num);
                        cb(JSON.parse(rtn));
                        uexImage.clearOutputImages();
                        break;
                    case 2:
                        $toast('文件上传失败', 3000)
                        uexUploaderMgr.closeUploader(num);
                        break;
                }
            }
            uexUploaderMgr.cbCreateUploader = function (opCode, dataType, data) {
                if (data == 0) {
                    uexUploaderMgr.uploadFile(num, dirPath, "ApolloPhotoBox", 1);
                } else {
                    alert("创建失败");
                }
            }

            uexUploaderMgr.createUploader(num, uploadHttp);
        }
        function upload(url) {
            var name = url.substring(url.lastIndexOf('/') + 1).toLowerCase();

            uploadFile(url, function (rtn) {
                if (rtn.IsSuccess) {//上传成功
                    rtnObj.setValue(rtn.ReturnValue);
                } else {
                    $toast(rtn.Message, 3000);
                }
            }, name);
        }


        createBox();
        return rtnObj;
    }

})(jQuery);