﻿//用于判断是否微信打开
function isWeiXin() {
    var ua = window.navigator.userAgent.toLowerCase();
    if (ua.match(/MicroMessenger/i) == 'micromessenger') {
        return true;
    } else {
        return false;
    }
}

//注册分享内容
function regShareMenu(title, desc, url, img) {
    var json = {
        title: title, // 分享标题
        link: url, // 分享链接
        imgUrl: img, // 分享图标
        desc: desc,
        success: function () {
            alert("分享成功");
        },
        cancel: function () {
            alert("分享失败");
        }
    }
    try {
        // 获取“分享到朋友圈”按钮点击状态及自定义分享内容接口
        wx.onMenuShareTimeline({
            title: json.title, // 分享标题
            link: json.link, // 分享链接
            imgUrl: json.imgUrl, // 分享图标
            success: json.success,
            cancel: json.cancel
        });

        //获取“分享给朋友”按钮点击状态及自定义分享内容接口
        wx.onMenuShareAppMessage({
            title: json.title, // 分享标题
            desc: json.desc, // 分享描述
            link: json.link, // 分享链接
            imgUrl: json.imgUrl, // 分享图标
            success: json.success,
            cancel: json.cancel
        });

        //获取“分享到QQ”按钮点击状态及自定义分享内容接口
        wx.onMenuShareQQ({
            title: json.title, // 分享标题
            desc: json.desc, // 分享描述
            link: json.link, // 分享链接
            imgUrl: json.imgUrl, // 分享图标
            success: json.success,
            cancel: json.cancel
        });

        // 获取“分享到腾讯微博”按钮点击状态及自定义分享内容接口
        wx.onMenuShareWeibo({
            title: json.title, // 分享标题
            desc: json.desc, // 分享描述
            link: json.link, // 分享链接
            imgUrl: json.imgUrl, // 分享图标
            success: json.success,
            cancel: json.cancel
        });

        //获取“分享到QQ空间”按钮点击状态及自定义分享内容接口
        wx.onMenuShareQZone({
            title: json.title, // 分享标题
            desc: json.desc, // 分享描述
            link: json.link, // 分享链接
            imgUrl: json.imgUrl, // 分享图标
            success: json.success,
            cancel: json.cancel
        });
    }
    catch (e) {
        alert("注册分享时出错了：" + e.message);
    }
}

//显示分享主菜单
function showShareMenu(title, desc, url, img) {
    if (isWeiXin()) {
        wx.ready(function () {            
            wx.hideOptionMenu();//先隐藏所有菜单
            // wx.hideAllNonBaseMenuItem();
            wx.showMenuItems({
                menuList: [
                  "menuItem:share:appMessage",//发送给朋友: 
                  "menuItem:share:timeline",//分享到朋友圈: 
                  "menuItem:share:qq",//分享到QQ:
                  "menuItem:share:weiboApp",//分享到Weibo:
                  "menuItem:favorite",//收藏: 
                  "menuItem:share:facebook",//分享到FB:
                  "menuItem:share:QZone", //分享到 QQ 空间/
                ]
            });
            regShareMenu(title, desc, url, img);
        });
    }
}
//隐藏分享主菜单
function hideShareMenu() {
    if (isWeiXin()) {
        wx.ready(function () {
            wx.hideOptionMenu();//先隐藏所有菜单
        });
    }
}


///关闭当前窗口
function closeWX() {
    if (isWeiXin())
        wx.closeWindow();
    else
        window.close();
}

function checkJsApi() {
    wx.ready(function () {
        wx.checkJsApi({
            jsApiList: [
              'checkJsApi',
                      'onMenuShareTimeline',
                      'onMenuShareAppMessage',
                      'onMenuShareQQ',
                      'onMenuShareWeibo',
                      'onMenuShareQZone',
                      'hideMenuItems',
                      'showMenuItems',
                      'hideAllNonBaseMenuItem',
                      'showAllNonBaseMenuItem',
                      'translateVoice',
                      'startRecord',
                      'stopRecord',
                      'onRecordEnd',
                      'playVoice',
                      'pauseVoice',
                      'stopVoice',
                      'uploadVoice',
                      'downloadVoice',
                      'chooseImage',
                      'previewImage',
                      'uploadImage',
                      'downloadImage',
                      'getNetworkType',
                      'openLocation',
                      'getLocation',
                      'hideOptionMenu',
                      'showOptionMenu',
                      'closeWindow',
                      'scanQRCode',
                      'chooseWXPay',
                      'openProductSpecificView',
                      'addCard',
                      'chooseCard',
                      'openCard'
            ],
            success: function (res) {
                alert(JSON.stringify(res));
            }, fail: function (r) {
                alert(r);
            }
        });
    });
};

//进行微信JsSDK注册，以便当前页可进行微信JS调用
function wxConfig(method) {
    try{
        if (isWeiXin()) {
            try {
                var url = window.location.href;
                if (url.indexOf("#") >= 0)
                    url = url.substring(0, url.indexOf("#"));
            }
            catch (e)
            { }

            var successFun = function (rtn) {
                wx.config({
                    debug: true,
                    appId: rtn.appId,
                    timestamp: rtn.timestamp,
                    nonceStr: rtn.nonceStr,
                    signature: rtn.signature,
                    jsApiList: [
                      'checkJsApi',
                      'onMenuShareTimeline',
                      'onMenuShareAppMessage',
                      'onMenuShareQQ',
                      'onMenuShareWeibo',
                      'onMenuShareQZone',
                      'hideMenuItems',
                      'showMenuItems',
                      'hideAllNonBaseMenuItem',
                      'showAllNonBaseMenuItem',
                      'translateVoice',
                      'startRecord',
                      'stopRecord',
                      'onRecordEnd',
                      'playVoice',
                      'pauseVoice',
                      'stopVoice',
                      'uploadVoice',
                      'downloadVoice',
                      'chooseImage',
                      'previewImage',
                      'uploadImage',
                      'downloadImage',
                      'getNetworkType',
                      'openLocation',
                      'getLocation',
                      'hideOptionMenu',
                      'showOptionMenu',
                      'closeWindow',
                      'scanQRCode',
                      'chooseWXPay',
                      'openProductSpecificView',
                      'addCard',
                      'chooseCard',
                      'openCard'
                    ]
                });

                wx.ready(function () {
                    checkJsApi();
                });
            };
            var errFun=function (errMsg) {
                showNotice(errMsg);
            };
            apollo.Weixin.GetJsSDKConfig(url, successFun, errFun);
        }
    }
    catch (e) {
        alert(e.message);
    }
}
