﻿/*
! apollo v2.0.1 | (c) 2017, 2020 RS Workroom, Inc.Li.jp /license 
*/

var apollo = (function () {
    var rtnObj = {
        init: function (sessionID, rootvpath, webapipath, ajaxDefaultParam) {
            this.userToken = sessionID;
            this.pageInfo.rootvpath = rootvpath;
            if (webapipath == null || webapipath == undefined || webapipath == "")
                apollo.pageInfo.webapipath = window.APOLLOUI_SYSTEM_GLOBAL_VOL == null ? "" : window.APOLLOUI_SYSTEM_GLOBAL_VOL.systemWebApiSiteUrl; //api接口访问目录,默认是本地，取本地配置文件，
            else
                apollo.pageInfo.webapipath = webapipath;
            apollo.defaultAjaxParams = ajaxDefaultParam;
        },
        userToken: "",
        app: null,
        aLink: null,
        nomask: false,//在进行远程执行时，不显示执行进度
        Page: function (options) { },
        ajaxProcess: {
            maskProcessDiv: null,
            maskDiv: null,
            init: function () {
                //以下为进度控制
                var body = $("body");
                if (body.length == 0) {
                    //页面还没初始完
                    return;
                }

                this.maskProcessDiv = $("<div id=\"apolloui_ajaxmask\" style=\"position:fixed;top:0px;bottom:0px;overflow:hidden;\"></div>");
                this.maskProcessDiv.css("width", "100%");
                this.maskProcessDiv.css("height", "100%");
                this.maskProcessDiv.css("z-index", 29000);

                this.maskDiv = $("<div></div>");
                this.maskDiv.css("position", "absolute");

                this.maskDiv.append($("<img src ='" + apollo.pageInfo.base + "images/Loading.gif'/>"));

                this.maskProcessDiv.append(this.maskDiv);
                body.append(this.maskProcessDiv);

                this.closeMask();
            },
            setCenter: function () {
                //居中显示
                try {
                    var h = this.maskProcessDiv.height();
                    var ch = this.maskDiv.height();
                    if (h > ch) {
                        var t = (h - ch) / 2;
                        this.maskDiv.css("top", t + "px");
                    }

                    var w = this.maskProcessDiv.width();
                    var cw = this.maskDiv.width();
                    if (w > cw) {
                        var l = (w - cw) / 2;
                        this.maskDiv.css("left", l + "px");
                    }
                }
                catch (e) { }
            },
            showMask: function () {
                if (this.maskProcessDiv == null) {
                    this.init();
                }
                else {
                    if ($("#apolloui_ajaxmask").length == 0) {
                        try {
                            $("body").append(this.maskProcessDiv);
                        }
                        catch (e) { }
                    }
                }
                if (this.maskProcessDiv != null) {
                    this.maskProcessDiv.show();
                    this.setCenter();
                }
            },
            closeMask: function () {
                if (this.maskProcessDiv == null) return;
                this.maskProcessDiv.hide();
            }
        },
        loadpost: function () {
            //参数只能为三个或四个
            var url = "", param = {}, panel = null, callback = null;
            if (arguments.length == 1) {
                url = arguments[0];
                panel = $("body");
                param = {};
                callback = null;
            }
            if (arguments.length == 2) {
                url = arguments[0];
                panel = arguments[1];
                param = {};
                callback = null;
            }
            else if (arguments.length == 3) {//如果为三个，则各变量向前移一位
                if (jQuery.isFunction(arguments[2]))
                    callback = arguments[2];

                url = arguments[0];
                panel = arguments[1];
                param = {};
            }
            else if (arguments.length >= 4) {
                url = arguments[0];
                param = arguments[1];
                panel = arguments[2];
                callback = arguments[3]
            }

            if (typeof panel == "string") {
                if (!apollo.util.startsWith(panel, "#"))
                    panel = "#" + panel;
            }
            var div = $(panel);
            url = apollo.Lib.forceNoCache(url);
            $.post(url, param, function (html, status) {
                if (status == "success") {
                    html = apollo.convertpath(html);


                    div.empty();
                    div.append(html);
                    if (callback != null)
                        callback();
                }
                else
                    showNotice(html);
            });
        },
        appendpost: function () {
            //参数只能为三个或四个
            var url = "", param = {}, panel = null, callback = null;
            if (arguments.length == 1) {
                url = arguments[0];
                panel = $("body");
                param = {};
                callback = null;
            }
            if (arguments.length == 2) {
                url = arguments[0];
                panel = arguments[1];
                param = {};
                callback = null;
            }
            else if (arguments.length == 3) {//如果为三个，则各变量向前移一位
                if (jQuery.isFunction(arguments[2]))
                    callback = arguments[2];

                url = arguments[0];
                panel = arguments[1];
                param = {};
            }
            else if (arguments.length >= 4) {
                url = arguments[0];
                param = arguments[1];
                panel = arguments[2];
                callback = arguments[3]
            }

            if (typeof panel == "string") {
                if (!apollo.util.startsWith(panel, "#"))
                    panel = "#" + panel;
            }
            var div = $(panel);
            if (url.length > 0) url = apollo.Lib.forceNoCache(url);
            $.post(url, param, function (html, status) {
                if (status == "success") {
                    html = apollo.convertpath(html);

                    div.append(html);
                    if (callback != null)
                        callback();
                }
                else
                    showNotice(html);
            });
        },
        load: function (p) {
            //参数只能为三个或四个
            var url = "", param = {}, panel = null, callback = null;
            if (arguments.length == 1) {
                url = arguments[0];
                panel = $("body");
                param = {};
                callback = null;
            }
            if (arguments.length == 2) {
                url = arguments[0];
                panel = arguments[1];
                param = {};
                callback = null;
            }
            else if (arguments.length == 3) {//如果为三个，则各变量向前移一位
                if (jQuery.isFunction(arguments[2]))
                    callback = arguments[2];

                url = arguments[0];
                panel = arguments[1];
                param = {};
            }
            else if (arguments.length >= 4) {
                url = arguments[0];
                param = arguments[1];
                panel = arguments[2];
                callback = arguments[3]
            }

            if (typeof panel == "string") {
                if (!apollo.util.startsWith(panel, "#"))
                    panel = "#" + panel;
            }
            var div = $(panel);
            url = apollo.Lib.forceNoCache(url);
            $.get(url, param, function (html, status) {
                if (status == "success") {
                    html = apollo.convertpath(html);


                    div.empty();
                    div.append(html);
                    if (callback != null)
                        callback();
                }
                else
                    showNotice(html);
            });
        },
        append: function (p) {
            //参数只能为三个或四个
            var url = "", param = {}, panel = null, callback = null;
            if (arguments.length == 1) {
                url = arguments[0];
                panel = $("body");
                param = {};
                callback = null;
            }
            if (arguments.length == 2) {
                url = arguments[0];
                panel = arguments[1];
                param = {};
                callback = null;
            }
            else if (arguments.length == 3) {//如果为三个，则各变量向前移一位
                if (jQuery.isFunction(arguments[2]))
                    callback = arguments[2];

                url = arguments[0];
                panel = arguments[1];
                param = {};
            }
            else if (arguments.length >= 4) {
                url = arguments[0];
                param = arguments[1];
                panel = arguments[2];
                callback = arguments[3]
            }

            if (typeof panel == "string") {
                if (!apollo.util.startsWith(panel, "#"))
                    panel = "#" + panel;
            }
            var div = $(panel);
            if (url.length > 0) url = apollo.Lib.forceNoCache(url);
            $.get(url, param, function (html, status) {
                if (status == "success") {
                    html = apollo.convertpath(html);

                    div.append(html);
                    if (callback != null)
                        callback();
                }
                else
                    showNotice(html);
            });
        },
        ajax: function (url, param, onSuccess, onError, onComplete) {
            var isnomask = apollo.nomask;
            apollo.nomask = false;//再次复原，以便保持默认显示执行进度

            if (typeof param == "string")
                param = JSON.parse(param);


            //如果方法是不需要传参数，则可以不传param这个值 ，这样，successFun和errorFun实际上位置向前移一位，类似于C#中的多态方法
            //ajax(controllerName, actionName, successFun, errorFun)
            //为实现上面这情现象，所以对参数要做判断
            var _param = param, _onSuccess = onSuccess, _onError = onError, _onComplete = onComplete;
            if (typeof param == "function") {
                //则表示没传参数,则参数都向前移一位
                param = {};
                onSuccess = _param;

                if (typeof _onError != "function")
                    onComplete = null;
                else
                    onComplete = _onError;


                if (typeof _onSuccess != "function")
                    errorFun = null;
                else
                    errorFun = _onSuccess;
            }

            var json;

            var sucFun = function (data, status, xhr) {
                //取会话信息
                if (apollo.onAjax != null)
                    apollo.onAjax(xhr);

                var result = data;
                try {
                    if (onSuccess != null && onSuccess != undefined) {
                        if (result == null)
                            onSuccess(result);
                        else if (result.d != undefined && result.d != null) { //这种一般是aspx中的web服务方法
                            onSuccess(result.d);
                        }
                        else
                            onSuccess(result);
                    }
                }
                catch (e) {
                    if (onError != null && onError != undefined) {
                        onError("exec successFun Error:" + e.message);
                        return;
                    }
                }
                apollo.ajaxProcess.closeMask();
            }
            var errFun = function (a, x, e) {
                try {
                    if (a.responseText != "") {
                        try {
                            var jobj = JSON.parse(a.responseText);
                            if (jobj != null) {

                                //这里要检测是否是因无权限而导致的错误，如果是，则先提示后，再转入到登录页
                                if (jobj.ReturnValue != null) {
                                    var rtn = jobj.ReturnValue;
                                    if (rtn.gotoLoginPage == true) {
                                        if (apollo.noLoginGotoFun != null) {
                                            apollo.noLoginGotoFun();
                                            return;
                                        }
                                        else {
                                            alert(jobj.Message);
                                            return;
                                        }
                                    }
                                    else if (rtn.isNoPower == true) {//没有权限
                                        showNotice(rtn.Message);
                                        return;
                                    }
                                }


                                if (onError != null && onError != undefined) {
                                    onError(jobj.Message + (apollo.Lib.isNotEmpty(jobj.Error) ? ":" + jobj.Error : ""));
                                    return;
                                }
                            }
                        }
                        catch (e) {

                        }
                    }

                    if (a != null && a.responseJSON != null && a.responseJSON != undefined && typeof (a.responseJSON) == "object") {
                        try {
                            var err = a.responseJSON;

                            //这里要检测是否是因无权限而导致的错误，如果是，则先提示后，再转入到登录页
                            if (err.ReturnValue != null) {
                                var rtn = err.ReturnValue;
                                if (rtn.gotoLoginPage == true) {
                                    if (rtn.gotoLoginPage == true) {
                                        if (apollo.noLoginGotoFun != null) {
                                            apollo.noLoginGotoFun();
                                            return;
                                        }
                                        else
                                            alert(jobj.Message);
                                    }
                                }
                            }


                            if (err.Message != null) {
                                if (onError != null && onError != undefined) {
                                    onError(err.Message);
                                    return;
                                }
                            }
                            else {
                                errview(a, e, onError);
                                return;
                            }
                        }
                        catch (ex) { errview(a, e, onError); }
                    }
                    else {
                        if (apollo.Lib.isNotEmpty(a.responseText)) {
                            if (onError != null && onError != undefined) {
                                onError(a.responseText);
                                return;
                            }
                        }
                        else {
                            errview(a, e, onError);
                            return;
                        }
                    }
                } catch (e1) { }

                apollo.ajaxProcess.closeMask();
            }

            var errview = function (a, e, onError) {
                try {
                    var msg = "";
                    if (a.readyState != null) {
                        if (a.readyState == "0" || a.readyState == 0) {
                            msg = "请求出现异常：网络无法链接";
                        }
                        else if (a.readyState == "1" || a.readyState == 1) {
                            msg = "网络请求中止";
                        }
                        else if (a.readyState == "2" || a.readyState == 2) {
                            msg = "解析出现异常";
                        }
                        else if (a.readyState == "3" || a.readyState == 3) {
                            msg = "接口数据出现异常";
                        }
                        else if (a.readyState == "0" || a.readyState == 0) {
                            msg = "未知异常";
                        }
                    }
                    if (msg == "" && (e != null && e != ""))
                        msg = e;
                    else if (msg == "")
                        msg = "请求时出现未知异常";

                    if (onError != null && onError != undefined) onError(msg);
                }
                catch (er) { }
            }
            var complete = function (x) {
                try {
                    if (onComplete != null && onComplete != undefined) onComplete(x);
                }
                catch (e) { }
                apollo.ajaxProcess.closeMask();
            };

            ///每次ajax时固定要传的参数

            var defaults;
            if (apollo.defaultAjaxParams == null)
                defaults = {};
            else if (typeof apollo.defaultAjaxParams != "object")
                defaults = {};
            else
                defaults = apollo.defaultAjaxParams

            defaults.System_Session_UserToken = apollo.userToken;

            var configdata = {};
            if (window.APOLLOUI_SYSTEM_GLOBAL_VOL != null && jQuery.isPlainObject(window.APOLLOUI_SYSTEM_GLOBAL_VOL.defaultParam)) {
                configdata = window.APOLLOUI_SYSTEM_GLOBAL_VOL.defaultParam;
                defaults = $.extend(defaults, configdata);
            }
            var data = $.extend(defaults, param);

            //处理POST的参数，因为
            var poststrfun = null;
            poststrfun = function (postdata) {
                if (jQuery.isPlainObject(postdata)) {
                    for (var k in postdata) {
                        var postStr = postdata[k];
                        if (postStr == null) continue;
                        if (typeof postStr === 'string') {
                            postStr = postStr.replace(/%/g, "%25");
                            postStr = postStr.replace(/\&/g, "%26");
                            postStr = postStr.replace(/\+/g, "%2B");
                            postdata[k] = postStr;
                        }
                        else if (jQuery.isPlainObject(postStr))
                            poststrfun(postStr);
                    }
                }
            };
            poststrfun(data);

            json = {
                type: "POST",
                url: url,
                dataType: "json",
                data: data,
                async: true,
                cache: false,
                success: sucFun,
                error: errFun,
                complete: complete
            };

            if (isnomask != true) {
                apollo.ajaxProcess.showMask();
            }
            $.ajax(json);
        },
        openUrl: function (url) {
            if (apollo.aLink == null) {
                apollo.aLink = $("<a href='' target='_blank'></a>");
                apollo.aLink.attr("href", url);
                $("body").append(apollo.aLink);
                apollo.aLink.get(0).click();
            }
            else {
                apollo.aLink.attr("href", url);
                apollo.aLink.get(0).click();
            }
        },
        getApiUrl: function (controller, action) {
            var url = this.pageInfo.webapipath;
            if (!apollo.util.endsWith(url, "/")) url += "/";
            url += "api/" + controller + "/" + action;
            return url;
        },
        getMvcUrl: function (controller, action) {
            var url = this.pageInfo.webapipath;
            if (!apollo.util.endsWith(url, "/")) url += "/";
            url += controller + "/" + action;
            return url;
        },
        api: function (controllerName, actionName, param, successFun, errorFun) {
            if (this.ajax == null) return;
            //如果方法是不需要传参数，则可以不传param这个值 ，这样，successFun和errorFun实际上位置向前移一位，类似于C#中的多态方法
            //ajax(controllerName, actionName, successFun, errorFun)
            //为实现上面这情现象，所以对参数要做判断
            var _param = param, _successFun = successFun, _errorFun = errorFun;
            if (typeof param == "function") {
                //则表示没传参数,则参数都向前移一位
                param = {};
                successFun = _param;
                if (typeof _successFun != "function")
                    errorFun = null;
                else
                    errorFun = _successFun;
            }

            var url = this.getApiUrl(controllerName, actionName)

            if (errorFun == null || errorFun == undefined) errorFun = apollo.onError;
            this.ajax(url, param, successFun, errorFun);
        },
        pageInfo: {
            base: "apolloui/",//当前前端框架所在目录
            rootvpath: "/",//当前访问页面根访问路径
            webapipath: window.APOLLOUI_SYSTEM_GLOBAL_VOL == null ? "" : window.APOLLOUI_SYSTEM_GLOBAL_VOL.systemWebApiSiteUrl //api接口访问目录,默认是本地，取本地配置文件，
        },
        onError: function (errMsg) {
            showNotice(errMsg);
        },
        form: {},
        onAjax: null, //在执行ajax前要处理的方法，如果没设，则不处理,处理参数xhr,如：function(xhr){}
        defaultAjaxParams: null,
        noLoginGotoFun: null,//当前没有登录时要跳转的方法
        Enum: {},
        Guid: {
            empty: "00000000-0000-0000-0000-000000000000",
            isEmpty: function (id) {
                if (id == apollo.Guid.empty)
                    return true;
                else
                    return false;
            }
        },
        bindSelect: function (cbs, data, hasEmpty, tf, vf) {
            $(cbs).each(function (i, item) {
                var cb = $(item);
                cb.get(0).options.length = 0;//empty the option
                var jsondata = data; // convert json data
                if (hasEmpty)
                    cb.append('<option value=\'\'></option>');
                $.each(jsondata, function (index, optiondata) {
                    var v = optiondata[vf];
                    var n = optiondata[tf];
                    var op = $("<option value=" + v + ">" + n + "</option>");
                    op.data("dataItem", optiondata);
                    cb.append(op);
                });
                cb.data("dataSource", jsondata);
            });
        },
        getvpath: function (path, isnocatch) {
            var url = "";
            if (apollo.Lib.isEmpty(path)) return url;


            var vp = path.toLowerCase();
            if (vp.indexOf("file://") == 0 ||
                vp.indexOf("ftp://") == 0 ||
                vp.indexOf("gopher://") == 0 ||
                vp.indexOf("http://") == 0 ||
                vp.indexOf("https://") == 0 ||
                vp.indexOf("mailto://") == 0 ||
                vp.indexOf("net.pipe://") == 0 ||
                vp.indexOf("net.tcp://") == 0 ||
                vp.indexOf("news://") == 0 ||
                vp.indexOf("nntp://") == 0 ||
                vp.indexOf("/") == 0) {
                url = path;
            }
            else {
                url = apollo.pageInfo.rootvpath + path;
            }

            if (isnocatch == true) {
                if (url.indexOf("?") >= 0)
                    url += "&timecatch=" + Math.random();
                else
                    url += "?timecatch=" + Math.random();
            }
            return url;
        },
        getwebpath: function (path, isnocatch) {
            if (apollo.Lib.isEmpty(path)) return url;


            var vp = path.toLowerCase();
            if (vp.indexOf("file://") == 0 ||
                vp.indexOf("ftp://") == 0 ||
                vp.indexOf("gopher://") == 0 ||
                vp.indexOf("http://") == 0 ||
                vp.indexOf("https://") == 0 ||
                vp.indexOf("mailto://") == 0 ||
                vp.indexOf("net.pipe://") == 0 ||
                vp.indexOf("net.tcp://") == 0 ||
                vp.indexOf("news://") == 0 ||
                vp.indexOf("nntp://") == 0 ||
                vp.indexOf("/") == 0) {
                url = path;
            }
            else {
                var url = this.pageInfo.webapipath;
                if (!apollo.util.endsWith(url, "/")) url += "/";

                url = apollo.pageInfo.webapipath + path;
            }

            if (isnocatch == true) {
                if (url.indexOf("?") >= 0)
                    url += "&timecatch=" + Math.random();
                else
                    url += "?timecatch=" + Math.random();
            }
            return url;
        },
        request: function (paras) {
            var url = location.href;
            var paraString = url.substring(url.indexOf("?") + 1, url.length).split("&");
            var paraObj = {}
            for (i = 0; j = paraString[i]; i++) {
                paraObj[j.substring(0, j.indexOf("=")).toLowerCase()] = j.substring(j.indexOf("=") + 1, j.length);
            }
            var returnValue = paraObj[paras.toLowerCase()];
            if (typeof (returnValue) == "undefined") {
                return "";
            } else {
                return returnValue;
            }
        },
        getCaseWhen: function (v, casewhenlist, elsevalue) {
            if (v == null) return "";
            if (apollo.Lib.isEmpty(casewhenlist)) return v;
            var lists = casewhenlist.split(',');
            if (lists.length == 0) return "";
            for (var i = 0; i < lists.length; i++) {
                var items = lists[i].split(':');
                if (items.length <= 1) return;
                if (apollo.Lib.isEquals(items[0], v))
                    return items[1];
            }

            if (apollo.Lib.isNotEmpty(elsevalue))
                return elsevalue;
            else
                return "";
        },
        isPCComputer: function () {
            if (window.APOLLOUI_SYSTEM_GLOBAL_VOL != null && jQuery.isFunction(window.APOLLOUI_SYSTEM_GLOBAL_VOL.isPCComputer))
                return window.APOLLOUI_SYSTEM_GLOBAL_VOL.isPCComputer();
            else
                return true;
        },
        isapph5: function () {
            if (window.APOLLOUI_SYSTEM_GLOBAL_VOL != null && jQuery.isFunction(window.APOLLOUI_SYSTEM_GLOBAL_VOL.isPCComputer))
                return window.APOLLOUI_SYSTEM_GLOBAL_VOL.isapph5();
            else
                return false;
        },
        getappurl: function (url) {
            if (apollo.isapph5() == true) {
                try {
                    var index = url.indexOf("?");
                    if (index > 0) {
                        var purl = url.substring(0, index);
                        var nurl = url.substring(index, url.length);
                        if (!apollo.Lib.endsWith(purl, ".html") && !apollo.Lib.endsWith(purl, ".htm") && !apollo.Lib.endsWith(purl, ".aspx") && !apollo.Lib.endsWith(purl, ".asp"))
                            purl += ".html";
                        url = purl + nurl;
                    }
                    else if (index < 0) {
                        if (!apollo.Lib.endsWith(url, ".html") && !apollo.Lib.endsWith(url, ".htm") && !apollo.Lib.endsWith(url, ".aspx") && !apollo.Lib.endsWith(url, ".asp"))
                            url += ".html";
                    }
                }
                catch (e) {
                    showNotice("gotoPage:" + e.message);
                }
            }
            return url;
        },
        isInBody: function (el) {
            var body = $(el).closest("body");
            return body.length > 0;
        },
        getpageparam: function () { //获取页面所传参数，常用于apollo.openWin()
            var param = window.parentParams;
            if (param == null) param = {};
            return param;
        },
        convertpath: function (html) {
            try {
                //解析html
                var root = apollo.pageInfo.rootvpath;

                var str = html;
                var regex = /src(\s?)=(\s?)"(\s?)~(\s?)\/(\s?)(.*?)/g;
                str = str.replace(regex,
                    function (m, name) {
                        return "src=\"" + root;
                    });

                regex = /src(\s?)=(\s?)'(\s?)~(\s?)\/(\s?)(.*?)/g;
                str = str.replace(regex,
                    function (m, name) {
                        return "src='" + root;
                    });

                regex = /href(\s?)=(\s?)"(\s?)~(\s?)\/(\s?)(.*?)/g;
                str = str.replace(regex,
                    function (m, name) {
                        return "href=\"" + root;
                    });

                regex = /href(\s?)=(\s?)'(\s?)~(\s?)\/(\s?)(.*?)/g;
                str = str.replace(regex,
                    function (m, name) {
                        return "href='" + root;
                    });

                html = str;
            }
            catch (e) { }
            return html;
        }
    };
    //如果加载了配置项，则取配置项配置的信息

    if (window.APOLLOUI_SYSTEM_GLOBAL_VOL != null && window.APOLLOUI_SYSTEM_GLOBAL_VOL.autoinit != true) {
        //这里目前主要是设置路径
        //原apollo.init将改为初始页面，则apollo.page.init代替
        var rootvpath = window.APOLLOUI_SYSTEM_GLOBAL_VOL.rootvpath;
        var apipath = window.APOLLOUI_SYSTEM_GLOBAL_VOL.systemWebApiSiteUrl
        rtnObj.pageInfo.rootvpath = rootvpath;
        if (apipath != null && apipath != "")
            rtnObj.pageInfo.webapipath = apipath;
        else
            rtnObj.pageInfo.webapipath = rootvpath;
    }
    rtnObj.getapi = rtnObj.getApiUrl;
    rtnObj.exec = rtnObj.ajax;
    return rtnObj;
})();
/**
apollo框架库
*/
//apollo.util apollo.lib
(function (apollo) {
    apollo.array = apollo.prototype = {
        add: function (arr, item) {
            if (item == null) return arr;
            if (jQuery.isArray(item)) {
                $(item).each(function (i, l) {
                    arr.push(l);
                });
            }
            else
                arr.push(item);
        },
        clear: function (arr) {
            if (arr != null && jQuery.isArray(arr)) {
                var len = arr.length;
                if (len > 0) arr.splice(0, len);
            }
            return arr;
        },
        find: function (arr, propName, propValue) {//查找指定值的元素
            var el = null;
            if (arr != null && jQuery.isArray(arr)) {
                if (propName != null && typeof propName == "string") {
                    for (var i = 0; i < arr.length; i++) {
                        var v1 = apollo.Lib.getAttr(arr[i], propName);
                        if (apollo.Lib.isEquals(v1, propValue)) {
                            el = arr[i];
                            break;
                        }
                    }
                }
                else if (jQuery.isFunction(propName)) {
                    var fun = propName;
                    for (var i = 0; i < arr.length; i++) {
                        if (fun(arr[i]) == true) {
                            el = arr[i];
                            break;
                        }
                    }
                }
            }
            return el;
        },
        exists: function (arr, el, propName) {
            return apollo.array.indexOf(arr, el, propName) >= 0;
        },
        indexOf: function (arr, el, propName) {
            var index = -1;
            if (arr != null && jQuery.isArray(arr)) {
                if (jQuery.isFunction(el)) {
                    var fun = el;
                    index = -1;
                    for (var i = 0; i < arr.length; i++) {
                        if (fun(arr[i]) == true) {
                            index = i;
                            break;
                        }
                    }
                }
                else {
                    var isProp = false, isfun = false;
                    if (propName != null && el != null && typeof propName == "string" && propName in el) {
                        isProp = true;
                    }
                    else if (jQuery.isFunction(propName))
                        isfun = true;
                    var v1, v2;
                    for (var i = 0; i < arr.length; i++) {
                        if (isProp == true) {
                            v1 = apollo.Lib.getAttr(arr[i], propName);
                            v2 = apollo.Lib.getAttr(el, propName)
                            if (apollo.Lib.isEquals(v1, v2)) {
                                index = i;
                                break;
                            }
                        }
                        else if (isfun == true) {
                            var fun = propName;
                            if (fun(arr[i], el) == true) {
                                index = i;
                                break;
                            }
                        }
                        else if (arr[i] == el) {
                            index = i;
                            break;
                        }
                    }
                }
            }
            return index;
        },
        insert: function (arr, index, el) {
            if (index < 0) index = 0;
            if (arr != null && jQuery.isArray(arr)) {
                arr.splice(index, 0, el);
            }
        },
        moveup: function (arr, el) {//将指定元素向上移一位，该元素必须为数组中的数
            var index = this.indexOf(arr, function (cel) { return cel == el; });
            if (index > 0) {
                //先移除当前元素
                arr.splice(index, 1);
                //再插入
                arr.splice(index - 1, 0, el);
            }
        },
        movedown: function (arr, el) {
            var index = this.indexOf(arr, function (cel) { return cel == el; });
            if (index>=0 && index < arr.length - 1) {
                //先移除当前元素
                arr.splice(index, 1);
                //再插入
                arr.splice(index + 1, 0, el);
            }
        },
        removeAll: function (arr, fun) {//移除所有符合条件的项,fun有一个参数
            if (!jQuery.isFunction(fun)) return arr;
            if (!jQuery.isArray(arr)) return arr;
            var index = 0;
            while (arr.length > 0 && index < arr.length) {
                var el = arr[index];
                if (fun(el) == true) { //符合条件，则要移除
                    arr.splice(index, 1);
                }
                else
                    index++;

            }
            return arr;
        },
        remove: function (arr, el, propName) {
            var index = apollo.array.indexOf(arr, el, propName);
            if (index >= 0)
                arr.splice(index, 1);
            return arr;
        },
        removeAt: function (arr, index) {
            if (index >= 0 && index < arr.length) {
                arr.splice(index, 1);
            }
            return arr;
        }
       },
        apollo.util = apollo.prototype = {
            toInt: function (v) {
                if (v == null || v == undefined)
                    return 0;
                if (typeof v == "number") return v;
                var rtn = parseInt(v);
                if (isNaN(rtn))
                    return 0;
                else
                    return rtn;
            },
            toFloat: function (v) {
                if (v == null || v == undefined)
                    return 0;
                if (typeof v == "number") return v;

                var rtn = parseFloat(v);
                if (isNaN(rtn))
                    return 0;
                else
                    return rtn;
            },
            /**将指定对像转为guid值，注意，这里并不是实际转换*/
            toGuid: function (v) {
                if (v == null || v == undefined)
                    return 0;
                if (typeof v != "string")
                    return apollo.Guid.empty;
                else if (apollo.Lib.isEmpty(v))
                    return apollo.Guid.empty;
                else
                    return v;
            },
            toDateTimeString: function (v) {
                if (apollo.Lib.isEmpty(v))
                    return "00000000-0000-0000-0000-000000000000";
                else if (typeof v == "string") {
                    v = v.replace(/\//g, "-");
                    var date = Date.parse(v);
                    if (isNaN(date))
                        return "00000000-0000-0000-0000-000000000000";
                    else
                        return v;
                }
                else if (v instanceof Date) {
                    return apollo.Lib.dateFormat(v, "yyyy-MM-dd HH:mm:ss");
                }
                else
                    return "00000000-0000-0000-0000-000000000000";
            },
            toBoolean: function (v) {
                if (v == null || v == undefined)
                    return 0;
                if (typeof v == "boolean") return v;
                if (typeof v == "string" || typeof v == "number") {
                    if (v == 1)
                        return true;
                    else if (v == true)
                        return true;
                    else if (v.toString().toLowerCase() == "true")
                        return true;
                    else if (v == "1")
                        return true;
                    else if (v == 0)
                        return false;
                    else if (v == false)
                        return false;
                    else if (v.toString().toLowerCase() == "false")
                        return false;
                    else if (v == "0")
                        return false;
                    else if (v.toString() == "是" || v.toString() == "真")
                        return true;
                    else if (v.toString() == "否" || v.toString() == "假")
                        return false;
                    else
                        return v == true;
                }
                else
                    return false;
            },
            endsWith: function (str1, str2) {
                if (str1 == null || str2 == null) return false;
                if (typeof str1 != "string" || typeof str2 != "string") return false;
                try {
                    if (str1.length < str2.length)
                        return false;
                    else if (str1.toLowerCase().lastIndexOf(str2.toLowerCase()) == str1.length - str2.length)
                        return true;
                    else
                        return false;
                }
                catch (e) {
                    return false;
                }
            },
            startsWith: function (str1, str2) {
                if (str1 == null || str2 == null) return false;
                if (typeof str1 != "string" || typeof str2 != "string") return false;
                try {
                    if (str1.length < str2.length)
                        return false;
                    else if (str1.toLowerCase().indexOf(str2.toLowerCase()) == 0)
                        return true;
                    else
                        return false;
                }
                catch (e) {
                    return false;
                }
            }
        };

    apollo.Lib = apollo.prototype = {
        /**对指定数值进行四舍五入
        * @digit 要进行四舍五入的数值
        * @length 四舍五入的小数位数
        */
        round: function (digit, length) {
            length = length ? parseInt(length) : 0;
            if (length <= 0) return Math.round(digit);
            digit = Math.round(digit * Math.pow(10, length)) / Math.pow(10, length);
            return digit;
        },
        isHtml5: function () {
            if (window.applicationCache) {
                return true;
            } else {
                return false;
            }
        },
        isIn: function (v, arr) {
            if (arr == null) return false;
            if (!arr.length) return false;
            for (var i = 0; i < arr.length; i++) {
                if (this.isEquals(v, arr[i])) {
                    return true;
                }
            }
            return false;
        },
        clone: function (obj) {
            if (obj == null || obj == undefined)
                return null;
            var rtn = {};
            return jQuery.extend(true, {}, obj);
        },
        hasProperty: function (obj, name) {
            if (obj == null)
                return false;
            else if (apollo.Lib.isEmpty(name))
                return false;
            else
                return (name in obj);
        },
        hasAttr: function (el, attr) {
            if (typeof ($(el).attr(attr)) == "undefined")
                return false;
            else
                return true;
        },
        getAttr: function (obj, attr) {
            try {
                if (obj == null || obj == undefined)
                    return null;
                else if (attr == null || attr == "") //未设置主键值
                    return null;
                else if (!apollo.Lib.hasProperty(obj, attr))
                    return null;
                else {
                    var id = obj[attr];
                    if (id == null)
                        return null;
                    else
                        return id;
                }
            }
            catch (e) { return null; }
        },
        setAttr: function (obj, attr, v) {
            try {
                if (obj == null || obj == undefined)
                    return false;
                else if (attr == null || attr == "") //未设置主键值
                    return false;
                else if (!apollo.Lib.hasProperty(obj, attr))
                    return false;
                else {
                    obj[attr] = v;
                    return true;
                }
            }
            catch (e) { return false; }
        },
        isEmpty: function (v) {
            if (v == null || v == undefined || v == "undefined")
                return true;
            else if (typeof v == "string") {
                try {
                    var str = v.replace(/(^\s*)|(\s*$)/g, '')
                    return str == "";
                }
                catch (e) {
                    return false;
                }
            }
            else
                return false;
        },
        isNotEmpty: function (v) {
            return !apollo.Lib.isEmpty(v);
        },
        isEquals: function (str1, str2) {
            if (str1 == str2) return true;
            var isE1 = apollo.Lib.isEmpty(str1);
            var isE2 = apollo.Lib.isEmpty(str2);

            if (isE1 || isE2) {
                if (isE1 && isE2)
                    return true;
                else
                    return false;
            }
            else if (typeof str1 == "string" && typeof str2 == "string") {
                if (str1.toLowerCase() == str2.toLowerCase())
                    return true;
                else
                    return false;
            }
            else if (typeof str1 == "string" || typeof str2 == "string") {
                if (str1.toString().toLowerCase() == str2.toString().toLowerCase())
                    return true;
                else
                    return false;
            }
            else
                return str1 == str2;
        },
        forceNoCache: function (url) {
            if (url == null) {
                return null;
            }
            if (url.indexOf("?") == -1) {
                return url + "?" + "noCacheToken=" + Math.random();
            }
            else {
                return url + "&" + "noCacheToken=" + Math.random();
            }
        },
        parseFun: function (data) //将指定值转成function 对象
        {
            if (data == null || data == "" || data == undefined) return null;
            var methodStr = data;
            if (typeof methodStr == "string") {
                methodStr = jQuery.trim(methodStr);
                if (methodStr.indexOf("function ") == 0 || methodStr.indexOf("function(") == 0 || methodStr.indexOf("(") < 0) {
                    var entity = null;
                    try {
                        entity = eval("({method:" + methodStr + "})");
                    }
                    catch (e) { }
                    if (entity == null || entity == undefined) {
                        return null;
                    }
                    if (typeof entity.method == "function") {
                        return entity.method;
                    }
                    else
                        return null;
                }
                else {
                    script = "function(){ try{ return " + methodStr + ";}catch(e){return null;};}";
                    
                    var entity = null;
                    var cfun = null;
                    try {
                        entity = eval("({method:" + script + "})");
                        if (jQuery.isPlainObject(entity))
                            cfun = entity.method();
                    }
                    catch (e) { }
                    if (jQuery.isFunction(cfun)) {
                        return cfun;
                    }
                    else
                        return new Function(methodStr);
                }
            }
            else if (jQuery.isFunction(methodStr)) {
                return methodStr;
            }
            else
                return null;
        },
        addDay: function (date, day) {
            var sz = date.getDate() + day;
            date.setDate(sz);
            return date;
        },
        addMonth: function (date, month) {
            var sz = date.getMonth() + month;
            date.setMonth(sz);
            return date;
        },
        addYear: function (date, year) {
            var sz = date.getFullYear() + year;
            date.setFullYear(sz);
            return date;
        },
        showDate: function (datastr) {
            if (apollo.Lib.isEmpty(datastr)) return "";
            var date = apollo.Lib.toDate(datastr);
            var y, m, d;
            y = date.getFullYear();
            m = date.getMonth() + 1;
            d = date.getDate();

            var yy, mm, dd;
            yy = y.toString();
            if (m < 10)
                mm = '0' + m;
            else
                mm = m.toString();

            if (d < 10)
                dd = '0' + d;
            else
                dd = d.toString();

            return yy + "-" + mm + "-" + dd;
        },
        showTime: function (datastr, format) {
            if (apollo.Lib.isEmpty(datastr)) return "";
            var date = apollo.Lib.toDate(datastr);
            var hour, minute, second;
            hour = date.getHours();
            minute = date.getMinutes();
            second = date.getSeconds();

            var hh, mm, ss;
            hh = hour < 10 ? '0' + hour.toString() : hour.toString();
            mm = minute < 10 ? '0' + minute.toString() : minute.toString();
            ss = second < 10 ? '0' + second.toString() : second.toString();

            if (format != null && format != "") {
                format = format.replace('HH', hh);
                format = format.replace('hh', hh);
                format = format.replace('mm', mm);
                format = format.replace('ss', ss);

                return format;
            }

            return hh + ':' + mm + ':' + ss;
        },
        dateFormat: function (d, format) {
            var data;
            if (typeof d == "string")
                data = apollo.Lib.toDate(d);
            else
                data = d;

            if (date instanceof Date) {
                var o = {
                    "M+": date.getMonth() + 1, //month 
                    "d+": date.getDate(), //day 
                    "h+": date.getHours(), //hour 
                    "m+": date.getMinutes(), //minute 
                    "s+": date.getSeconds(), //second 
                    "q+": Math.floor((date.getMonth() + 3) / 3), //quarter 
                    "S": date.getMilliseconds() //millisecond 
                }

                if (/(y+)/.test(format)) {
                    format = format.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));
                }

                for (var k in o) {
                    if (new RegExp("(" + k + ")").test(format)) {
                        format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
                    }
                }
            }
            return format;
        },
        toDate: function (str) {
            if (apollo.Lib.isEmpty(str)) return null;
            str = str.toString();
            str = str.replace(/-/g, "/");
            var date = new Date(str);
            return date;
        },
        endsWith: function (str1, str2) {
            if (str1 == null || str2 == null) return false;
            try {
                if (str1.length < str2.length)
                    return false;
                else if (str1.toLowerCase().lastIndexOf(str2.toLowerCase()) == str1.length - str2.length)
                    return true;
                else
                    return false;
            }
            catch (e) {
                return false;
            }
        },
        BASEformatLong: function (objDest) //格式化整数
        {
            if (isNaN(objDest)) return "0";
            return Math.round(parseFloat(objDest)).toString();
        },
        //格式化金额，精确到小数点后两位
        BASEformatNumber: function (objDest) {	//格式化金额，精确到小数点后两位
            if (isNaN(objDest)) return "0.00"
            var strDestObj = (0.01 * Math.round(100 * parseFloat(objDest))).toString()
            var Return_Str = "";
            var strDotRight = "";
            var intDestObjLen = strDestObj.length;
            var intDotIdx = strDestObj.indexOf(".");

            switch (intDestObjLen) {
                case 0:
                    Return_Str = "0.00";
                    break;
                default:
                    switch (intDotIdx) {
                        case -1:
                            Return_Str = strDestObj + ".00"
                            break;
                        case (intDestObjLen - 1):
                            Return_Str = strDestObj + "00"
                            break;
                        case (intDestObjLen - 2):
                            Return_Str = strDestObj + "0"
                            break;
                        case (intDestObjLen - 3):
                            Return_Str = strDestObj
                            break;
                        default:
                            Return_Str = strDestObj.substring(0, intDotIdx + 3)
                            break;
                    }
                    break;
            }
            return Return_Str;
        },
        formatString: function (fc, v) {
            if (fc.length > 4 && fc.indexOf("{0:") == 0 && fc.lastIndexOf("}") == fc.length - 1) {
                var format = fc.substring(3, fc.length - 1);
                if (format == "")
                    return v;
                else if (format == "c" || format == "C")
                    return "¥" + apollo.Lib.BASEformatNumber(v);
                else if (format == "n" || format == "N")
                    return apollo.Lib.BASEformatNumber(v);
                else //日期 
                    return apollo.Lib.dateFormat(v, format);
            }
            else
                return v;
        }
    };
})(apollo);
/**
apollo.catch 相关
*/
(function (apollo) {
    var isSupportLocal = false;
    if (localStorage) {
        isSupportLocal = true;
    } else {
        isSupportLocal = false;
    }

    //缓存相关
    //以下为适配(主要是针对app)
    /**
     * localStorage保存数据
     * @param String key  保存数据的key值
     * @param String value  保存的数据
     */
    apollo.catchutil = {
        setLocVal: function (key, value) {
            try {
                if (isSupportLocal == true) //支持本地化存储
                {
                    localStorage.setItem(key, value);
                }
                else {
                    jQuery.cookie(key, value);
                }
            } catch (e) { }
        },

        /**
         * 根据key取localStorage的值
         * @param Stirng key 保存的key值
         */
        getLocVal: function (key) {
            try {
                if (isSupportLocal == true) //支持本地化存储
                {
                    var v = localStorage.getItem(key);
                    if (v == null)
                        return "";
                    else
                        return v;
                }
                else {
                    var v = jQuery.cookie(key);
                    if (v == null)
                        return "";
                    else
                        return v;
                }
            }
            catch (e) { }
            return "";
        },

        /**
         * 清除缓存
         * @param Striong key  保存数据的key，如果不传清空所有缓存数据
         */
        clearLocVal: function (key) {
            try {
                if (isSupportLocal) {
                    if (key)
                        window.localStorage.removeItem(key);
                    else
                        window.localStorage.clear();
                }
                else {
                    jQuery.cookie(key, null);
                }
            }
            catch (e) {

            }
        },
        clear: function () {
            try {
                if (isSupportLocal) {
                    window.localStorage.clear();
                }
            }
            catch (e) {

            }
            showNotice("已清空完成");
        }
    };
})(apollo);


/**模板解析器*/
(function (apollo) {
    /*约定模板格式：
    {{ }}//为程序代码，里面内容为标标js内容，项中的对象名统一为item,如有其它，则必须确保该页有这个名的对象
    如：<div apollo-item="user">
            <div class='{{item.isstop?"red":"blue"}}'></div>
        </div>

    {field}//对指定对象值,这类常用于全局页（取全局对象属性值）或区域页(formarea)中（取区域赋值对象属性值）
    {#getValue(tableName,"{{IDField}}",""{{TextField}}"")#}
    {#cashwhen("1:","")#}
    */
    apollo.Template = (function () {
        var svrUtil = {
            getSvrValue: function (id, tableName, idfield, textfield) {
                return '服务端';
            }
        };
        var app = null;

        var rtnTemplate = {
            setapp: function (_app) {
                app = _app;
            },
            getdata: function () {
                if (app == null)
                    return {};
                else
                    return app.getdata();
            },
            elementProps: null,
            paserPanel: function (data, html) {
                //先解析com组件，格式为{[]}  注意[]代替<>
                var rtnHtml = html.replace(/&gt;/g,">");
                rtnHtml = rtnHtml.replace(/&lt;/g, "<");

                rtnHtml = parseDomExplain(rtnHtml);
                rtnHtml = parseJsExplain(data, rtnHtml);                
                rtnHtml = parseJsFunExplain(data, rtnHtml);

                return rtnHtml;
            },
            parseRowNo: function (rowIndex, rowHtml) {
                var rowNo = rowIndex + 1;
                //优先处理行号
                var str = rowHtml;
                var regex = /\{{RowNo\}}/g;
                str = str.replace(regex,
                    function (m, name) {
                        return rowNo.toString();
                    });
                regex = /\#RowNo\#/g;
                str = str.replace(regex,
                    function (m, name) {
                        return rowNo.toString();
                    });
                return str;
            },
            getJsPropValue: function (data, propExplate) {
                if (!jQuery.isPlainObject(data)) {
                    if (apollo.Lib.isEquals("item", propExplate))
                        return data.toString();
                    else
                        return null;//不是普通｛｝对象，则返回null
                }

                if (jQuery.isEmptyObject(data) || apollo.Lib.isEmpty(propExplate)) return null;
                var arrProp = propExplate.split(".");
                var entity = data;
                for (var i = 0; i < arrProp.length; i++) {
                    var name = jQuery.trim(arrProp[i]);
                    if (apollo.Lib.isEmpty(name)) return null; //没有该属性，则结束
                    var propValue = apollo.Lib.getAttr(entity, name);
                    if (i == arrProp.length - 1) //为最后一项
                        return convertValue(propValue);
                    else if (!jQuery.isPlainObject(propValue) || jQuery.isEmptyObject(propValue)) //如果为null值 ，则不再继续
                        return null;
                    else
                        entity = propValue;
                }
                return null;
            },
            getJsValue: function (data, jsExplain) {
                return execFun(data, "item", jsExplain);
            },
            isTemplate: function (html) {
                if (apollo.Lib.isEmpty(html)) return false;

                var reg = /\{{(.*?)\}}/g;
                if (reg.test(html) == true) {
                    return true;
                }
                reg = /\{\[(.*?)\]\}/g;
                if (reg.test(html) == true) {
                    return true;
                }

                reg = /\{#(.*?)\#}/g;
                if (reg.test(html) == true) {
                    return true;
                }
                reg = /\{{RowNo\}}/g;
                if (reg.test(html) == true) {
                    return true;
                }
                else
                    return false;
            },
            isEleName: function (exp) {
                if (exp.indexOf(".") > 0 ||
                    exp.indexOf("=") > 0 ||
                    exp.indexOf("!") >= 0 ||
                    exp.indexOf(">") > 0 ||
                    exp.indexOf("&&") > 0 ||
                    exp.indexOf(":") > 0 ||
                    exp.indexOf(";") > 0 ||
                    exp.indexOf("]") > 0 ||
                    exp.indexOf("[") > 0 ||
                    exp.indexOf("}") > 0 ||
                    exp.indexOf("{") > 0 ||
                    exp.indexOf("?") > 0 ||
                    exp.indexOf("(") >= 0 ||
                    exp.indexOf(")") > 0 ||
                    exp.indexOf("||") > 0 ||
                    exp.indexOf("<") > 0) //视为表达式
                {
                    return false;
                }
                else {
                    return true;
                }
            },
            isJsExplain: function (exp) {
                if (exp.indexOf("item.") == 0) {
                    return true;
                } else if (exp.indexOf(".") > 0 ||
                    exp.indexOf("=") > 0 ||
                    exp.indexOf("!") >= 0 ||
                    exp.indexOf(">") > 0 ||
                    exp.indexOf("&&") > 0 ||
                    exp.indexOf(":") > 0 ||
                    exp.indexOf(";") > 0 ||
                    exp.indexOf("]") > 0 ||
                    exp.indexOf("[") > 0 ||
                    exp.indexOf("}") > 0 ||
                    exp.indexOf("{") > 0 ||
                    exp.indexOf("?") > 0 ||
                    exp.indexOf("(") >= 0 ||
                    exp.indexOf(")") > 0 ||
                    exp.indexOf("||") > 0 ||
                    exp.indexOf("<") > 0) //视为表达式
                {
                    return true;
                }
                else {
                    return false;
                }
            },
            parseElement: parseElement,
            parseForElement: parseForElement,
            parsePropElement: parsePropElement,
            parsePager: parsePager,
            parseScrollPager: parseScrollPager,
            parseElementAttrData: parseElementAttrData,
            parseElementAttr: parseElementAttr,
            parseForm: parseForm,
            parseEastuiAttrData: parseEastuiAttrData,
            initEasyuiBox: initEasyuiBox,//初始化渲染apollo.form.formArea  对象
            setvalue: updateauivalue,
            reflashParseElement: reflashParseElement
        };
        
        function execFun(data, paraName, JsExplain, elobj) {
            var script;
            if (apollo.Lib.isEmpty(paraName)) paraName = "item";
            if (!jQuery.isPlainObject(data)) {
                script = "function(data," + paraName + ",el){ try{ return " + JsExplain + "}catch(e){return '';};}";
            }
            else {
                var arr = [];
                for (var n in data) {
                    arr.push("var " + n + " = " + paraName + "." + n + ";");
                };
                // if (arr.length == 0) return "";
                var propscript = arr.join("\r\n");
                script = "function(data," + paraName + ",el){ try{ " + propscript + " return " + JsExplain + "}catch(e){return '';};}";
            }
            var fun = apollo.Lib.parseFun(script);
            if (fun == null)
                return "";
            else {
                return convertValue(fun(rtnTemplate.getdata(), data, elobj));
            }
        }
        function execSetFun(data, paraName, JsExplain, v) {
            var script;
            if (!jQuery.isPlainObject(data)) return "";

            if (apollo.Lib.isEmpty(paraName)) paraName = "item";

            var arr = [];
            for (var n in data) {
                arr.push("var " + n + " = " + paraName + "." + n + ";");
            };
            if (arr.length == 0) return "";
            var propscript = arr.join("\r\n");
            script = "function(data," + paraName + ",v){ try{ " + propscript + " " + JsExplain + "=v;}catch(e){};}";

            var fun = apollo.Lib.parseFun(script);
            if (fun != null)
                fun(rtnTemplate.getdata(), data, v);
        }

        function convertValue(v) {
            if (v == null)
                return "";
            else if (v == "00000000-0000-0000-0000-000000000000") //空Guid
                return "";
            else if (v == "0001-01-01 00:00:00") //空日期
                return "";
            else
                return v;
        }




        //解析js值
        function getJsValue(data, JsExplain, elobj) {
            return execFun(data, "item", JsExplain, elobj);
        }


        function getValueByPropExplain(rowData, exp, elobj) {
            if (rtnTemplate.isJsExplain(exp)) {
                return getJsValue(rowData, exp, elobj);
            } else {
                var v = rtnTemplate.getJsPropValue(rowData, exp);
                if (v == null)
                    return "";
                else
                    return v.toString();
            }
        }

        //解析js表达式
        function parseJsExplain(rowData, html) {
            var str = html;
            var regex = /\{{(.*?)\}}/g;
            str = str.replace(regex,
                function (m, name) {
                    return getValueByPropExplain(rowData, name);
                });
            return str;
        }
        function parseDomExplain(html) {
            var str = html;
            var regex = /\{\[(.*?)\]\}/g;
            str = str.replace(regex,
                function (m, name) {
                    return "<" + name + ">";
                });
            return str;
        }

        function parseJsFunExplain(data, html) {
            var str = html;
            var regex = /\{#(.*?)\#}/g;
            str = str.replace(regex,
                function (m, name) {
                    var funExp = parseJsExplain(data, name);

                    if (funExp != null && funExp.indexOf("getSvrValue") == 0 && !jQuery.isFunction(window.getSvrValue)) {
                        funExp = "svrUtil." + funExp;
                        return execFun(svrUtil, "svrUtil", funExp);
                    }
                    else {
                        return execFun(data, "", funExp);
                    }
                });
            return str;
        }

        function getValue(data, name) {
            var v = apollo.getAttr(data, name);
            if (v == null)
                return "";
            else if (v == "00000000-0000-0000-0000-000000000000") //空Guid
                return "";
            else if (v == "0001-01-01 00:00:00") //空日期
                return "";
            else
                return v;
        }


        /**
         * 渲染处理if语句块
         * @param {object} 数据对象
         * @param {string} 元素下html字符串
         */
        function getIfHtml(data, html) {
            var tmpLi = $("<div></div>");
            tmpLi.html(html);
            var arrif = tmpLi.find("[apollo-if]");//,[apollo-elseif],[apollo-else]");
            if (arrif.length <= 0) { //表示没有if语句块，则视elseif 和 else为无效，全都移除
                tmpLi.remove("[apollo-elseif],[apollo-else]");
                return tmpLi.html(); //没有
            }
            var isstart = false;
            var hasifv = false;
            $(arrif).each(function (j, el) {
                var curel = $(el);
                isstart = true;
                var exp = curel.attr("apollo-if");

                curel.removeAttr("apollo-if");  //处理完后，需要移除相应标识

                var arrnxt = curel.nextAll();

                if (apollo.Lib.isNotEmpty(exp)) {
                    hasifv = false;
                    var v = rtnTemplate.getJsValue(data, exp);
                    if (v == true) //符合条件
                    {
                        hasifv = true;
                    }
                    else { //视为不符合条件，则要移除该项
                        curel.remove();
                    }
                }
                else {//视为一个无效的if语句，本身及其后面的截止到else 全部要移除
                    curel.remove();
                }

                for (var i = 0; i < arrnxt.length; i++) {
                    var nxtel = $(arrnxt.get(i));
                    if (apollo.Lib.hasAttr(nxtel, "apollo-elseif")) {
                        if (isstart != true) //未在if之后，视为无效
                        {
                            nxtel.remove();
                            continue;
                        }
                        if (hasifv == true) //前面的if已符合条件
                        {
                            nxtel.remove();
                            continue;
                        }
                        var exp = $(nxtel).attr("apollo-elseif");
                        $(nxtel).removeAttr("apollo-elseif");  //处理完后，需要移除相应标识
                        if (apollo.Lib.isNotEmpty(exp)) {
                            var v = rtnTemplate.getJsValue(data, exp);
                            if (v == true) //符合条件
                            {
                                hasifv = true;
                            }
                            else { //视为不符合条件，则要移除该项
                                nxtel.remove();
                                continue;
                            }
                        }
                        else { //值为空视为无效
                            nxtel.remove();
                            continue;
                        }
                    }
                    else if (apollo.Lib.hasAttr(nxtel, "apollo-else")) {
                        $(nxtel).removeAttr("apollo-else");  //处理完后，需要移除相应标识
                        if (isstart != true) //未在if之后，视为无效
                        {
                            nxtel.remove();
                            continue;
                        }
                        isstart = false;//表示语句块结束
                        if (hasifv == true) //前面的if已符合条件
                        {
                            nxtel.remove();
                            continue;
                        }
                        //视为符合要求，保留
                    }
                    else if (apollo.Lib.hasAttr(nxtel, "apollo-if")) { //为一个新的语句块，则中止检索
                        isstart = false;
                        break;
                    }
                    else {//视为之前的if是单语句，不是if-else块,则表示结束语句块
                        isend = true;
                        isstart = false;
                    }
                }
            });

            //arrItems中的才是本区域要呈现的内容,将期转为html
            return tmpLi.html();
        }

        /**
         * 渲染处理 switch语句块
         * @param {object} 数据对象
         * @param {string} 元素下的html字符串
         */
        function getSwitchHtml(data, html) {
            var tmpLi = $("<div></div>");
            tmpLi.html(html);
            var arrswitch = tmpLi.find("[apollo-switch]");
            if (arrswitch.length == 0) return html; //没有
            var cashLi = null, defaLi = null;//符合条件的项和默认项

            $(arrswitch).each(function (i, el) {
                var exp = $(el).attr("apollo-switch");
                var curel = $(el);
                curel.removeAttr("apollo-switch");  //处理完后，需要移除相应标识

                if (apollo.Lib.isNotEmpty(exp)) {
                    hasifv = false;
                    var v = rtnTemplate.getJsPropValue(data, exp);

                    var arrCash = curel.find("[apollo-case],[apollo-default]");
                    if (arrCash.length == 0) //并没有内置项，则视为无效，整个移除
                        curel.remove();

                    $(arrCash).each(function (j, elCase) {
                        if (apollo.Lib.hasAttr(elCase, "apollo-case")) {
                            if (cashLi != null) {//已有符合条件的项，则本项自动移除
                                $(elCase).remove();
                                return;
                            }
                            var caseV = $(elCase).attr("apollo-case");
                            $(elCase).removeAttr("apollo-case");  //处理完后，需要移除相应标识
                            if (v == null && caseV == null) {
                                cashLi = elCase;
                                return;
                            }
                            else if (v == null || caseV == null) { //视为不同
                                $(elCase).remove();
                                return;
                            }
                            if ((apollo.Lib.isEmpty(caseV) && apollo.Lib.isEmpty(v))
                                || (caseV.toString() == v.toString())) {
                                cashLi = elCase;
                                return;
                            }
                            else //不符合要求，移除
                            {
                                $(elCase).remove();
                                return;
                            }
                        }
                        if (apollo.Lib.hasAttr(elCase, "apollo-default")) {
                            $(elCase).removeAttr("apollo-default");  //处理完后，需要移除相应标识
                            if (cashLi != null) {//已有符合条件的项，则本项自动移除
                                $(elCase).remove();
                                return;
                            }
                            else {
                                defaLi = elCase;//视为有效
                                return;
                            }
                        }

                        //其它的项，全都视为无效，一并移除，所以在apollo-switch下，不能放其它内容，
                        elCase.remove;
                    });

                    if (cashLi == null && defaLi == null) //如果没有一项符合条件，则视整个swith无效，整体移除
                        $(el).remove();
                }
                else {//未设置具体值，则视为无效，整个移除
                    $(el).remove();
                }
            });

            //arrItems中的才是本区域要呈现的内容,将期转为html
            return tmpLi.html();
        }

        function parseForElement(app, data, ele, propName, elehtml, parseChildFun, cfutil) {
            var html = elehtml;
            try {
                var curel = $(ele);
                destroyEasyuiBox(curel);
                curel.empty();
                var propValue;

                var datas;
                if (apollo.Lib.isNotEmpty(propName)) {
                    propValue = rtnTemplate.getJsPropValue(data, propName);
                }
                else {
                    propValue = data;
                }
                if (propValue == null) //没有取到对应表达式值，则停止执行
                {
                    datas = [];
                }
                else if (jQuery.isArray(propValue)) {
                    datas = propValue;
                }
                else if (jQuery.isPlainObject(propValue)) {
                    datas = [propValue];
                }
                else
                    datas = [];


                $(datas).each(function (i, item) {
                    var htmlStr;
                    //先进行子级项渲染
                    if (jQuery.isFunction(parseChildFun)) {
                        var panel = $("<div></div>");
                        panel.html(html);
                        parseChildFun(app, panel, item, cfutil);
                        htmlStr = panel.html();
                    }
                    else
                        htmlStr = html;

                    //优先处理行号
                    htmlStr = rtnTemplate.parseRowNo(i, htmlStr);

                    //处理if 语句块
                    htmlStr = getIfHtml(item, htmlStr);      //处理完后，需要移除相应标识                
                    //处理switch语句块
                    htmlStr = getSwitchHtml(item, htmlStr);  //处理完后，需要移除相应标识

                    //最后处理模板
                    htmlStr = rtnTemplate.paserPanel(item, htmlStr);



                    var rowElement;
                    try {
                        rowElement = $(htmlStr);
                    }
                    catch (e) {
                        rowElement = $($.parseHTML(htmlStr));
                    }

                    rowElement.data("apolloEleTemplate", html);
                    rowElement.data("apolloEleDatas", datas);

                    
                    parseForm(app, rowElement, item, cfutil, datas);
                    curel.append(rowElement);

                    //对行模板自行进行渲染
                    parseElementAttr(app, rowElement, item, cfutil, rowElement, datas);
                });
            }
            catch (e) { showNotice(e.message); }
        }
        //获取指定对象属性值
        function getPropValueObject(data, propName) {
            var propValue;
            if (apollo.Lib.isNotEmpty(propName)) {
                propValue = rtnTemplate.getJsPropValue(data, propName);
            }
            else {
                propValue = data;
            }

            var item;
            if (propValue == null) //没有取到对应表达式值，则设置一空对象
            {
                item = {};
            }
            else if (jQuery.isArray(propValue)) {
                if (propValue.length > 0)
                    item = propValue[0];//取第一项
                else
                    item = {};
            }
            else if (jQuery.isPlainObject(propValue)) {
                item = propValue;
            }
            else
                item = {};

            return item;
        }

        function parseElement(app, data, ele, propName, elehtml, parseChildFun, cfutil) {
            try {
                var html = elehtml;
                var curel = $(ele);
                destroyEasyuiBox(curel);
                curel.empty();
                var item = getPropValueObject(data, propName);


                var htmlStr;
                //先进行子级项渲染
                if (jQuery.isFunction(parseChildFun)) {
                    var panel = $("<div></div>");
                    panel.html(html);
                    parseChildFun(app, panel, item, cfutil);
                    htmlStr = panel.html();
                }
                else
                    htmlStr = html;


                //处理if 语句块
                htmlStr = getIfHtml(item, htmlStr);      //处理完后，需要移除相应标识                
                //处理switch语句块
                htmlStr = getSwitchHtml(item, htmlStr);  //处理完后，需要移除相应标识

                htmlStr = rtnTemplate.paserPanel(item, htmlStr);

                curel.html(htmlStr);

                parseForm(app, ele, item, cfutil);

                var datas = [item];
                curel.data("apolloEleTemplate", html);
                curel.data("apolloEleDatas", datas);


                //对行模板自行进行渲染
                parseElementAttr(app, ele, item, cfutil, ele, datas);


            }
            catch (e) { showNotice(e.message); }
        }


        function reflashParseElement(app, data, oldele, elehtml, parseChildFun, cfutil, datas) {
            var newel = null;
            try {
                var html = elehtml;
                var item = data;

                var htmlStr;
                //先进行子级项渲染
                if (jQuery.isFunction(parseChildFun)) {
                    var panel = $("<div></div>");
                    panel.html(html);
                    parseChildFun(app, panel, item, cfutil);
                    htmlStr = panel.html();
                }
                else
                    htmlStr = html;


                //处理if 语句块
                htmlStr = getIfHtml(item, htmlStr);      //处理完后，需要移除相应标识                
                //处理switch语句块
                htmlStr = getSwitchHtml(item, htmlStr);  //处理完后，需要移除相应标识

                htmlStr = rtnTemplate.paserPanel(item, htmlStr);


                var rowElement;
                try {
                    rowElement = $(htmlStr);
                }
                catch (e) {
                    rowElement = $($.parseHTML(htmlStr));
                }

                rowElement.data("apolloEleTemplate", html);
                rowElement.data("apolloEleDatas", datas);


                $(oldele).after(rowElement);

                $(oldele).each(function (i, mel) { $(mel).remove(); });

                parseForm(app, rowElement, item, cfutil, datas);

                newel = rowElement;
            }
            catch (e) { showNotice(e.message); }
            return newel;
        }

        function parsePropElement(data, ele, propName) {
            try {
                var curel = $(ele);

                curel.empty();
                var propValue;
                if (apollo.Lib.isNotEmpty(propName)) {
                    propValue = getValueByPropExplain(data, propName);
                }
                else {
                    propValue = "";
                }

                var item;
                if (propValue == null) //没有取到对应表达式值，则设置一空对象
                {
                    item = "";
                }
                else if (jQuery.isArray(propValue) || jQuery.isPlainObject(propValue) || jQuery.isEmptyObject(propValue)) {
                    item = JSON.stringify(propValue)
                }
                else if (jQuery.isFunction(propValue)) {
                    item = "(function)";
                }
                else
                    item = propValue.toString();

                //处理if 语句块
                var htmlStr = item;      //处理完后，需要移除相应标识                
                curel.html(htmlStr);
            }
            catch (e) { }
        }


        /**创建一个空的渲染对象 */
        function createCelParseUtil() {
            return {
                no: 0,
                createID: function () {
                    this.no += 1;//序号增加1位
                    return "apollouiformelement_" + this.no;
                },
                setdata: function (elcsid, data, propName, attrs, rowelement, pdatas) {
                    this.elItems.push({ elcsid: elcsid, data: data, propName: propName, attrs: attrs, rowelement: rowelement, pdatas: pdatas });
                },
                elItems: []  //需要进行渲染的元素{elcsid:"",param:{data:null,propName:"",attrs:[]}}
            };
        }
        /**
         * 对元素进行解析
         * @param {any} cfutil
         */
        function parseCelParseUtil(curel, cfutil) {
            //进行元素实际属性方法渲染
            $(cfutil.elItems).each(function (i, item) {
                var myel = curel.find("." + item.elcsid);
                $(myel).each(function (j, cbel) {
                    $(cbel).removeClass(item.elcsid);
                    apollo.Template.parseElementAttrData(cbel, item.data, item.propName, item.attrs, item.rowelement, item.pdatas);
                });
            });
        }

        function parsePager(app, ele, propName, elehtml, _parseChildFun) {
            try {
                var parseChildFun = _parseChildFun;
                var html = elehtml;
                var curel = $(ele);
                var data = app.getoption();
                curel.empty();
                var propValue = null;
                if (apollo.Lib.isNotEmpty(propName)) {
                    propValue = rtnTemplate.getJsPropValue(data, propName);
                }

                var pageOp;
                if (propValue == null) //没有取到对应表达式值，则设置一空对象
                {
                    pageOp = {};
                }
                else if (jQuery.isArray(propValue)) {
                    if (propValue.length > 0)
                        pageOp = propValue[0];//取第一项
                    else
                        pageOp = {};
                }
                else if (jQuery.isPlainObject(propValue)) {
                    pageOp = propValue;
                }
                else
                    pageOp = {};

                //应用apollo.pager
                if (pageOp.bodyer == null) {
                    var tbody = $("<div></div>");
                    tbody.css("display", "block");
                    curel.append(tbody);
                    pageOp.bodyer = tbody;
                }
                if (pageOp.footer == null) {
                    var tfoot = $("<div></div>");
                    tfoot.css("display", "block");
                    curel.append(tfoot);
                    pageOp.footer = tfoot;
                }




                pageOp.createBody = function (bodyer, rows) {
                    //处理if 语句块
                    bodyer.empty();


                    //无素模板下子区域组件渲染器
                    var cfutil = createCelParseUtil();

                    $(rows).each(function (i, data) {

                        var htmlStr;
                        //先进行子级项渲染
                        if (jQuery.isFunction(parseChildFun)) {
                            var panel = $("<div></div>");
                            panel.html(html);
                            parseChildFun(app, panel, data, cfutil);
                            htmlStr = panel.html();
                        }
                        else
                            htmlStr = html;

                        //优先处理行号
                        var htmlStr = rtnTemplate.parseRowNo(i, htmlStr);

                        htmlStr = getIfHtml(data, htmlStr);      //处理完后，需要移除相应标识                
                        //处理switch语句块
                        htmlStr = getSwitchHtml(data, htmlStr);  //处理完后，需要移除相应标识                       

                        //最后处理模板
                        htmlStr = rtnTemplate.paserPanel(data, htmlStr);


                        var rowElement;
                        try {
                            rowElement = $(htmlStr);
                        }
                        catch (e) {
                            rowElement = $($.parseHTML(htmlStr));
                        }

                        bodyer.append(rowElement);

                        parseForm(app, rowElement, data, cfutil, rows);

                        //对行模板自行进行渲染
                        parseElementAttr(app, rowElement, data, cfutil, rowElement, rows);

                    });

                    parseCelParseUtil(curel, cfutil);


                }
                var pager = curel.apollopager(pageOp);

                if (app != null && app.pager != null && apollo.Lib.isNotEmpty(propName)) {
                    var arr;
                    if (propName in app.pager) {
                        arr = app.pager[propName];
                        if (!$.isArray(arr))
                            app.pager[propName] = [arr, pager]
                        else
                            arr.push(pager);
                    }
                    else {
                        app.pager[propName] = [pager];
                    }
                }
            }
            catch (e) {
                showNotice("parsePager error:" + e.message);
            }
        }

        function parseScrollPager(app, ele, propName, elehtml, _parseChildFun) {
            try {
                var parseChildFun = _parseChildFun;
                var curel = $(ele);
                var data = app.getoption();

                var html = elehtml;

                curel.empty();
                var propValue = null;
                if (apollo.Lib.isNotEmpty(propName)) {
                    propValue = rtnTemplate.getJsPropValue(data, propName);
                }

                var pageOp;
                if (propValue == null) //没有取到对应表达式值，则设置一空对象
                {
                    pageOp = {};
                }
                else if (jQuery.isArray(propValue)) {
                    if (propValue.length > 0)
                        pageOp = propValue[0];//取第一项
                    else
                        pageOp = {};
                }
                else if (jQuery.isPlainObject(propValue)) {
                    pageOp = propValue;
                }
                else
                    pageOp = {};

                if (pageOp.bodyer == null) {
                    pageOp.bodyer = curel;
                }

                pageOp.createBody = function (bodyer, rows) {
                    //处理if 语句块

                    //无素模板下子区域组件渲染器
                    var cfutil = createCelParseUtil();

                    $(rows).each(function (i, data) {
                        var htmlStr;
                        //先进行子级项渲染
                        if (jQuery.isFunction(parseChildFun)) {
                            var panel = $("<div></div>");
                            panel.html(html);
                            parseChildFun(app, panel, data, cfutil);
                            htmlStr = panel.html();
                        }
                        else
                            htmlStr = html;

                        //优先处理行号
                        var htmlStr = rtnTemplate.parseRowNo(i, htmlStr);

                        htmlStr = getIfHtml(data, htmlStr);      //处理完后，需要移除相应标识                
                        //处理switch语句块
                        htmlStr = getSwitchHtml(data, htmlStr);  //处理完后，需要移除相应标识                       

                        //最后处理模板
                        htmlStr = rtnTemplate.paserPanel(data, htmlStr);



                        var rowElement;
                        try {
                            rowElement = $(htmlStr);
                        }
                        catch (e) {
                            rowElement = $($.parseHTML(htmlStr));
                        }

                        bodyer.append(rowElement);
                        parseForm(app, rowElement, data, cfutil, rows);


                        //对行模板自行进行渲染
                        parseElementAttr(app, rowElement, data, cfutil, rowElement, rows);


                    });

                    parseCelParseUtil(curel, cfutil);
                }
                var pager = curel.apollopager(pageOp);

                if (app != null && app.pager != null && apollo.Lib.isNotEmpty(propName)) {
                    var arr;
                    if (propName in app.pager) {
                        arr = app.pager[propName];
                        if (!$.isArray(arr))
                            app.pager[propName] = [arr, pager]
                        else
                            arr.push(pager);
                    }
                    else {
                        app.pager[propName] = [pager];
                    }
                }
            }
            catch (e) {
                showNotice("parseScrollPager error:" + e.message);
            }
        }

        function parseElementAttrData(ele, data, propName, attrs, rowElement, pdatas) {

            var curel = $(ele);//当前元素
            if (rowElement != null) {
                curel.data("apolloEleRowElement", $(rowElement));
            }

            if (pdatas != null)
                curel.data("apolloForItemDatas", pdatas);

            var isimg = curel.is("img");
            var isinput = curel.is("input") || curel.is("select") || curel.is("textarea");
            //开始解析
            var curdata = getPropValueObject(data, propName);
            var eleData = {};
            curel.data("apolloEleAttr", eleData);
            curel.data("apolloEleData", curdata);

            var elInitFun = null;
            $(attrs).each(function (i, attr) {
                var name = attr.name;
                var propName = attr.propName;
                if (name == null) name = "";
                name = name.toLowerCase();
                if (attr.isdata == true) {
                    var v, pn;
                    var auiname = attr.dataname;
                    var auivalue = attr.value;

                    pn = attr.propName;

                    if (attr.isauidata!=true)
                        attr.value = getValueByPropExplain(curdata, pn, curel);

                    if (attr.value == null)
                        v = "";
                    else
                        v = attr.value.toString();

                    if (apollo.Lib.isNotEmpty(auiname)) {
                        if (attr.isauidata == true)
                            eleData[auiname] = auivalue;
                        else
                            eleData[attr.dataname] = attr.value;
                    }
                    
                    if (name == "aui-value") {
                        curel.data("ValuePropName", propName);
                        curel.val(v);
                    }
                    else if (name == "aui-src") {
                        curel.attr("src", v);
                    }
                    else if (name == "aui-checked") {
                        if (curel.is(":checkbox") || curel.is(":radio")) {
                            curel.prop("checked", apollo.util.toBoolean(v));

                            var oldN = curel.data("ValuePropName");
                            if (oldN == null && oldN != propName) {
                                curel.data("ValuePropName", propName);
                            }

                        }
                        else {
                            if (apollo.util.toBoolean(v))
                                curel.attr("checked", "checked");
                            else
                                curel.removeAttr("checked");
                        }
                    }
                    else if (name == "aui-hidden") {
                        if (apollo.util.toBoolean(attr.value))
                            curel.hide();
                        else
                            curel.show();
                    }
                    else if (name == "aui-remove") {
                        if (apollo.util.toBoolean(attr.value))
                            curel.remove();
                    }
                    else if (name == "aui-disabled") {
                        if (apollo.util.toBoolean(attr.value))
                            curel.attr("disabled", "disabled");
                        else
                            curel.removeAttr("disabled");
                    }
                }
                else if (attr.isevent == true && (apollo.Lib.isNotEmpty(attr.propName) || $.isFunction(attr.eventfun))) //事件
                {
                    var fun = null;
                    if (apollo.Lib.isNotEmpty(attr.propName)) {
                        var op = app.getoption();
                        if (apollo.Template.isJsExplain(attr.propName)) {
                            fun=apollo.Template.getJsValue(op, attr.propName);
                        }
                        else {
                            fun = apollo.Lib.getAttr(op, attr.propName);
                        }
                        if (!jQuery.isFunction(fun)) fun = null;
                    }
                    if (fun == null) fun = attr.eventfun;
                    if (fun == null) return;


                    var eventfun = fun;
                    var curfun = function (e) {
                        var myel = $(this);
                        var edata = myel.data("apolloEleAttr");
                        var source = myel.data("apolloEleData");
                        var valueName = myel.data("ValuePropName");
                        var rowEle = myel.data("apolloEleRowElement");//所在区域或行

                        if (source == null) source = {};
                        var pdatas = myel.data("apolloForItemDatas");//当前行数据所在的数组
                        if (edata == null) edata = {};
                        if (valueName == null) valueName = "";



                        var v = myel.val();
                        if (v == null) v = "";


                        var arg = {
                            id: myel.attr("id"),
                            name: myel.attr("name"),
                            aui: edata,
                            source: source,
                            value: v,
                            target: myel,
                            ischeck: myel.is(":checkbox") || myel.is(":radio"),
                            checked: $(this).is(":checked"),
                            propname: valueName,
                            update: function () {
                                var pn, pv;

                                if (arguments.length == 0) {
                                    pn = valueName;

                                    if (arg.ischeck == true)
                                        pv = arg.checked;
                                    else
                                        pv = v;
                                }
                                else if (arguments.length == 1) {
                                    pn = arguments[0];
                                    if (arg.ischeck == true)
                                        pv = arg.checked;
                                    else
                                        pv = v;
                                }
                                else {
                                    pn = arguments[0];
                                    pv = arguments[1];
                                }
                                updateauivalue(source, pn, pv);
                            },
                            updatevalue: function () {
                                var pv;
                                if (arg.ischeck == true)
                                    pv = arg.checked;
                                else
                                    pv = v;



                                updateauivalue(source, valueName, pv);
                            },
                            updatavalue: function () {
                                var pv;
                                if (arg.ischeck == true)
                                    pv = arg.checked;
                                else
                                    pv = v;
                                updateauivalue(source, valueName, pv);
                            },
                            removeRowElement: function () {
                                if (rowEle != null) $(rowEle).remove();
                            },
                            removeRowData: function () {
                                if (pdatas != null && jQuery.isArray(pdatas)) apollo.array.remove(pdatas, source);//从指定的数据源中删除当前行数据
                            },
                            removeRow: function () {
                                if (rowEle != null) {
                                    $(rowEle).each(function (i, mel) {
                                        $(mel).remove();
                                    });
                                }
                                if (pdatas != null && jQuery.isArray(pdatas)) apollo.array.remove(pdatas, source);
                            },
                            dataItems: pdatas,
                            parent: rowEle,
                            reflash: function () {
                                if (rowEle == null) return;
                                var datas = $(rowEle).data("apolloEleDatas");
                                var rowTemplate = $(rowEle).data("apolloEleTemplate");
                                if (rowTemplate == null) return;

                                var newEle = apollo.app.reflashDom(source, rowEle, rowTemplate, datas);
                                if (newEle != null) {
                                    arg.parent = newEle;
                                    rowEle = newEle;
                                }
                            },
                            e: e
                        };
                        if (eventfun != null)
                            eventfun(arg);
                    };

                    if (name == "bindfocus") {
                        curel.off('focus')
                        curel.on("focus", curfun);
                    }
                    else if (name == "bindblur") {
                        curel.off("blur");
                        curel.on("blur", curfun);
                    }
                    else if (name == "bindinput")//主要是改变value属性
                    {
                        curel.off('input propertychange')
                        curel.on('input propertychange', curfun);
                    }
                    else if (name == "bindchange") {//主要是改变value属性
                        curel.off("change");
                        curel.on("change", curfun);
                    }
                    else if (name == "bindclick") {
                        curel.off("click");
                        curel.on("click", curfun);
                    }
                    else if (name == "binddblclick") {
                        curel.off("dblclick");
                        curel.on("dblclick", curfun);
                    }
                    else if (name == "bindinit") {//为该行初始化
                        elInitFun = eventfun;
                    }
                }
            });

            if (elInitFun != null) {
                try {
                    var myel = curel;

                    var isauiinit = $(myel).data("isauiinited");
                    if (isauiinit == true) //之前已初始化过，则不再进行初始化
                    {
                        return;
                    }


                    var edata = eleData;
                    var source = curdata;
                    var valueName = myel.data("ValuePropName");
                    var rowEle = myel.data("apolloEleRowElement");//所在区域或行

                    if (source == null) source = {};
                    var pdatas = pdatas;//当前行数据所在的数组
                    if (edata == null) edata = {};
                    if (valueName == null) valueName = "";
                    var v = myel.val();
                    if (v == null) v = "";

                    var arg = {
                        id: myel.attr("id"),
                        name: myel.attr("name"),
                        aui: edata,
                        source: source,
                        value: v,
                        target: myel,
                        ischeck: myel.is(":checkbox") || myel.is(":radio"),
                        checked: $(this).is(":checked"),
                        propname: valueName,
                        update: function () {
                            var pn, pv;

                            if (arguments.length == 0) {
                                pn = valueName;

                                if (arg.ischeck == true)
                                    pv = arg.checked;
                                else
                                    pv = v;
                            }
                            else if (arguments.length == 1) {
                                pn = arguments[0];
                                if (arg.ischeck == true)
                                    pv = arg.checked;
                                else
                                    pv = v;
                            }
                            else {
                                pn = arguments[0];
                                pv = arguments[1];
                            }
                            updateauivalue(source, pn, pv);
                        },
                        updatevalue: function () {
                            var pv;
                            if (arg.ischeck == true)
                                pv = arg.checked;
                            else
                                pv = v;



                            updateauivalue(source, valueName, pv);
                        },
                        updatavalue: function () {
                            var pv;
                            if (arg.ischeck == true)
                                pv = arg.checked;
                            else
                                pv = v;
                            updateauivalue(source, valueName, pv);
                        },
                        removeRowElement: function () {
                            if (rowEle != null) $(rowEle).remove();
                        },
                        removeRowData: function () {
                            if (pdatas != null && jQuery.isArray(pdatas)) apollo.array.remove(pdatas, source);//从指定的数据源中删除当前行数据
                        },
                        removeRow: function () {
                            if (rowEle != null) $(rowEle).remove();
                            if (pdatas != null && jQuery.isArray(pdatas)) apollo.array.remove(pdatas, source);
                        },
                        dataItems: pdatas,
                        parent: rowEle,
                        reflash: function () {
                            if (rowEle == null) return;
                            var datas = $(rowEle).data("apolloEleDatas");
                            var rowTemplate = $(rowEle).data("apolloEleTemplate");
                            if (rowTemplate == null) return;

                            var newEle = apollo.app.reflashDom(source, rowEle, rowTemplate, datas);
                            if (newEle != null) {
                                arg.parent = newEle;
                                rowEle = newEle;
                            }
                        },
                        e: {}
                    };
                    try {
                        elInitFun(arg);
                    }
                    catch (e) {
                        showNotice("exec bindinit error:" + e.message);
                    }
                    $(myel).data("isauiinited",true);
                }
                catch (e) {
                    showNotice("before exec bindinit error:" + e.message);
                }
            }
        }

        //专为处理easyui样式的form对象
        function parseEastuiAttrData(editor, ele, data, propName, attrs, rowElement, pdatas) {
            var curel = $(ele);//当前元素

            if (rowElement != null) {
                curel.data("apolloEleRowElement", $(rowElement));
            }

            if (pdatas != null)
                curel.data("apolloForItemDatas", pdatas);

            //开始解析
            var curdata = getPropValueObject(data, propName);
            var eleData = {};
            curel.data("apolloEleAttr", eleData);
            curel.data("apolloEleData", curdata);

            $(attrs).each(function (i, attr) {
                var name = attr.name;
                var propName = attr.propName;
                if (name == null) name = "";
                name = name.toLowerCase();
                if (attr.isdata == true) {
                    var v, pn;
                    var auiname = attr.dataname;
                    var auivalue = attr.value;


                    pn = attr.propName;

                    attr.value = getValueByPropExplain(curdata, pn, curel);

                    if (attr.value == null)
                        v = "";
                    else
                        v = attr.value.toString();

                    if (apollo.Lib.isNotEmpty(auiname)) {
                        if (attr.isauidata == true)
                            eleData[auiname] = auivalue;
                        else
                            eleData[attr.dataname] = attr.value;
                    }

                    if (name == "aui-value") {
                        curel.data("ValuePropName", propName);
                        editor.setvalue(v);
                    }
                    else if (name == "aui-data")
                    {
                        curel.data("ValuePropName", propName);
                        curel.data("issetdata", true);
                        if (jQuery.isPlainObject(attr.value) || jQuery.isArray(attr.value))
                            editor.setdata(attr.value);
                    }
                    else if (name == "aui-hidden") {
                        if (apollo.util.toBoolean(attr.value))
                            editor.setvisible(false);
                        else
                            editor.setvisible(true);
                    }
                    else if (name == "aui-remove") {
                        if (apollo.util.toBoolean(attr.value))
                            curel.remove();
                    }
                    else if (name == "aui-disabled") {
                        if (apollo.util.toBoolean(attr.value))
                            editor.setenabled(false);
                        else
                            editor.setenabled(true);
                    }
                }
                else if (attr.isevent == true && (apollo.Lib.isNotEmpty(attr.propName) || $.isFunction(attr.eventfun))) //事件
                {
                    var fun = null;
                    if (apollo.Lib.isNotEmpty(attr.propName)) {
                        var op = app.getoption();
                        if (apollo.Template.isJsExplain(attr.propName)) {
                            fun = apollo.Template.getJsValue(op, attr.propName);
                        }
                        else {
                            fun = apollo.Lib.getAttr(op, attr.propName);
                        }
                        if (!jQuery.isFunction(fun)) fun = null;
                    }
                    if (fun == null) fun = attr.eventfun;
                    if (fun == null) return;


                    var eventfun = fun;
                    var curfun = function (nv) {
                        var myeditor = this;
                        if (myeditor.isEditor != true) return;


                        var myel = $(myeditor.box);
                        var edata = myel.data("apolloEleAttr");
                        var source = myel.data("apolloEleData");
                        var valueName = myel.data("ValuePropName");
                        var rowEle = myel.data("apolloEleRowElement");//所在区域或行
                        var issetdata=myel.data("issetdata");


                        if (source == null) source = {};
                        var pdatas = myel.data("apolloForItemDatas");//当前行数据所在的数组
                        if (edata == null) edata = {};
                        if (valueName == null) valueName = "";

                        var v = "";
                        if (issetdata == true) {
                            v = myeditor.getdata();
                            if (v == null) v = [];
                        }
                        else {
                             v = myeditor.getvalue();
                            if (v == null) v = "";
                        }
                        
                        var arg = {
                            id: myel.attr("id"),
                            name: myel.attr("name"),
                            aui: edata,
                            source: source,
                            value: v,
                            target: myeditor.box,
                            ischeck: false,
                            checked: false,
                            propname: valueName,
                            update: function () {
                                var pn, pv;

                                if (arguments.length == 0) {
                                    pn = valueName;
                                    pv = v;
                                }
                                else if (arguments.length == 1) {
                                    pn = arguments[0];
                                    pv = v;
                                }
                                else {
                                    pn = arguments[0];
                                    pv = arguments[1];
                                }
                                updateauivalue(source, pn, pv);
                            },
                            updatevalue: function () {
                                var pv = v;
                                updateauivalue(source, valueName, pv);
                            },
                            updatavalue: function () {
                                var pv = v;
                                updateauivalue(source, valueName, pv);
                            },
                            removeRowElement: function () {
                                if (rowEle != null) $(rowEle).remove();
                            },
                            removeRowData: function () {
                                if (pdatas != null && jQuery.isArray(pdatas)) apollo.array.remove(pdatas, source);//从指定的数据源中删除当前行数据
                            },
                            removeRow: function () {
                                if (rowEle != null) $(rowEle).each(function (i, mel) { $(mel).remove(); });
                                if (pdatas != null && jQuery.isArray(pdatas)) apollo.array.remove(pdatas, source);
                            },
                            dataItems: pdatas,
                            parent: rowEle,
                            reflash: function () {
                                if (rowEle == null) return;
                                var datas = $(rowEle).data("apolloEleDatas");
                                var rowTemplate = $(rowEle).data("apolloEleTemplate");
                                if (rowTemplate == null) return;

                                var newEle = apollo.app.reflashDom(source, rowEle, rowTemplate, datas);
                                if (newEle != null) {

                                    $(rowEle).before(newEle);
                                    //先移除旧的
                                    $(rowEle).remove();

                                    arg.parent = newEle;
                                    rowEle = newEle;
                                }
                            },
                            e: myeditor
                        };
                        if (eventfun != null)
                            eventfun(arg);
                    };
                    if (name == "bindinput" || name == "bindchange")//主要是改变value属性
                    {
                        editor.onchange = curfun;
                    }
                    else if (name == "bindselect") {
                        editor.onselect = curfun;
                    }
                }
            });
        }
        function parseOption(options, source, optionDef, sourceDef) {
            var op = apollo.Options.parseOptions(options, optionDef.option, optionDef.optionType);

            if (sourceDef != null && apollo.Lib.isNotEmpty(source))
                op.source = apollo.Options.parseOptions(source, sourceDef.option, sourceDef.optionType);
            return op;
        }
        function initEasyuiBox(ele, attrs) {
            var box = $(ele);

            var Editor = null;
            if (box.length == 0) return Editor;
            var cb = box.get(0);
            var type = "";//对象类型 
            var name = "";
            var options = "";
            var source = "";
            $(attrs).each(function (i, attr) {
                var name = attr.name;
                var propName = attr.propName;
                if (name == null) name = "";
                name = name.toLowerCase();
                if (attr.isdata == true) {
                    if (name == "aui-type")
                        type = propName;
                    else if (name == "aui-options")
                        options = propName;
                    else if (name == "aui-source")
                        source = propName;
                }
            });

            if (apollo.Lib.isEmpty(options)) {
                options = "easyui:true";
            }
            else
                options += ",easyui:true";

            if (apollo.Lib.isEquals(type, "checklist")) {
                var edtOptions = parseOption(options, source, apollo.Options.checkList, apollo.Options.source);
                Editor = box.checkList(edtOptions);
            }
            else if (apollo.Lib.isEquals(type, "popupbox")) {
                var edtOptions = parseOption(options, source, apollo.Options.popup, apollo.Options.popupSource);
                Editor = box.popupbox(edtOptions);
            }
            else if (apollo.Lib.isEquals(type, "popuplist")) {
                var edtOptions = parseOption(options, source, apollo.Options.popup, apollo.Options.popupSource);
                Editor = box.popuplist(edtOptions);
            }
            else if (apollo.Lib.isEquals(type, "aeditor")) {
                var edtOptions = parseOption(options, source, apollo.Options.input);
                Editor = box.onlineEditor(edtOptions);
            } else if (apollo.Lib.isEquals(type, "customfile")) {//自定义文件上传框
                var edtOptions = parseOption(options, source, apollo.Options.customfile);
                Editor = box.customfile(edtOptions);
            }
            else if (apollo.Lib.isEquals(type, "switchbox")) {//自定义文件上传框
                var edtOptions = parseOption(options, source, apollo.Options.switchbox);
                Editor = box.switchbox(edtOptions);
            }
            else if (apollo.Lib.isEquals(type, "selecttree")) {
                var edtOptions = parseOption(options, source, apollo.Options.selecttree, apollo.Options.source);
                Editor = box.selecttree(edtOptions);
            }
            else if (box.is("select")) {
                var edtOptions = parseOption(options, source, apollo.Options.select, apollo.Options.source);
                Editor = box.selectbox(edtOptions);
            }
            else if ($(ele).is("input")) {
                var type = box.attr("type");
                if (type == "button" || type == "reset" || type == "submit" || type == "radio") {
                    Editor = null;
                }
                else {
                    var editor = null;
                    var edtOptions;
                    if (type == "checkbox") //普通文本输入框
                    {
                        edtOptions = parseOption(options, source, apollo.Options.input);
                        editor = box.checkbox(edtOptions);
                    }
                    else if (type == "radio") {
                        edtOptions = parseOption(options, source, apollo.Options.input);

                        editor = box.radiobox(edtOptions);
                    }
                    else if (type == "file") {
                        edtOptions = parseOption(options, source, apollo.Options.file);
                        editor = box.filebox(edtOptions);
                    }
                    else {
                        edtOptions = parseOption(options, source, apollo.Options.input);
                        editor = box.input(edtOptions);
                    }
                    Editor = editor;
                }
            }

            if (Editor != null) Editor.box = box;
            return Editor;
        }
        function destroyEasyuiBox(curel) {
            var arr = $(curel).data("EasyuiBox");
            if (jQuery.isArray(arr)) {
                $(arr).each(function (i, el) {
                    try {
                        el.destroy();
                    }
                    catch (e) { }
                });
            }
            $(curel).removeData("EasyuiBox");
        }

        function updateauivalue(source, pn, pv) {
            if (apollo.Lib.isNotEmpty(pn)) {
                if (!rtnTemplate.isJsExplain(pn))
                    source[pn] = pv;
                else {
                    execSetFun(source, "item", pn, pv);
                }
            }
        }
        function parseForm(app, ele, data, cfutil, pdatas) {
            //先解析自已

            if (rtnTemplate.elementProps == null) return;

            //先查看是否有子解
            parseChildForm(app, ele, data, cfutil, pdatas);

            //再解析本层下对象
            var propFilter = [];
            $(rtnTemplate.elementProps).each(function (i, en) {
                propFilter.push("[" + en + "]");
            });
            var arrItems = $(ele).find(propFilter.join(","));
            $(arrItems).each(function (i, el) {
                parseElementAttr(app, el, data, cfutil, ele, pdatas);
            });
        }


        function parseChildForm(app, pel, data, cfutil, pdatas) {
            var arrItems = $(pel).find("[apollo-data]");//只取第一层
            $(arrItems).each(function (i, el) {
                var curel = $(el);
                var propName = curel.attr("apollo-data");
                curel.removeAttr("apollo-data");

                if (apollo.Lib.isEmpty(propName)) {
                    propName = "";
                }
                var item = getPropValueObject(data, propName);

                var p = curel.closest("[apollo-data]");
                if (p.length > 0 && p.closest(pel) > 0) {
                    return;
                }
                //先解析子级
                var cars = curel.find("[apollo-data]");
                if (cars.length > 0) {
                    parseChildForm(app, curel, item, cfutil, pdatas);
                }

                parseElementAttr(app, el, data, cfutil, pel, pdatas);
            });
        }

        function parseElementAttr(app, el, data, cfutil, rowElement, pdatas) {           
            var elementProps = rtnTemplate.elementProps;
            var curel = $(el);//当前元素
            var iseasyui = apollo.util.toBoolean($(el).attr("aui-easyui"));
            var attrs = [];
            //解析并设置处理属性方法
            if (curel.length > 0 && curel.get(0).attributes != null) {
                $(curel.get(0).attributes).each(function (i, atr) {
                    var name = atr.name, value = atr.value;
                    if (apollo.util.startsWith(name, "aui-") && name.length > 4) {
                        curel.removeAttr(name);
                        if (apollo.Lib.isIn(name, elementProps)) {
                            attrs.push({ name: name, dataname: name.substring(4, name.length), propName: value, isevent: false,isauidata:false, eventfun: null, isdata: true, value: null });
                        }
                        else {
                            attrs.push({ name: name, dataname: name.substring(4, name.length), propName: value, isevent: false, isauidata: true, eventfun: null, isdata: true, value: value });
                        }
                    }
                    else if (apollo.Lib.isIn(name, ['bindinit', 'bindfocus', 'bindselect', 'bindblur', 'bindinput', 'bindchange', 'bindclick', 'binddblclick'])) {
                        curel.removeAttr(name);
                        var op = app.getoption();
                        var fun = apollo.Lib.getAttr(op, value);
                        if (!jQuery.isFunction(fun)) fun = null;
                        attrs.push({ name: name, propName: value, isevent: true, value: null, eventfun: fun, isdata: false, dataname: name });
                    }
                });
            }
            //将该元素分别一个唯一ID存放到class中，以便能够找到
            if (cfutil != null)//属于子级
            {
                var elcsid = cfutil.createID();
                curel.addClass(elcsid);
                cfutil.setdata(elcsid, data, "", attrs, rowElement, pdatas, iseasyui);
            }
            else { //否则直接渲染
                if (iseasyui == true) {
                    var eidtor = initEasyuiBox(el, attrs);
                    if (editor != null) {
                        parseEastuiAttrData(editor, el, data, "", attrs, rowElement, pdatas);
                    }
                    else
                        parseElementAttrData(el, data, "", attrs, rowElement, pdatas);
                }
                else
                    parseElementAttrData(el, data, "", attrs, rowElement, pdatas);
            }
        }
        return rtnTemplate;
    })();
    /**
     * 页面呈现渲染器
     * @param {DOM对象或JQuery 页面对象} 页面区域
     * @param {int} 渲染区域类型：0-普通页面区域，1-form.area区域,2-form.arrayarea模板区域
     * @param {object} _app
     */
    apollo.Template.Render = function (layer, layerType) {
        var layerPanel = layer;
        var isform = layerType != 0;//是否属于apollo.form中的area或arrlyarea区域下（旧版form组件，将弃用）
        var isarrayform = layerType == 2;

        var elementProps = ['aui-value', 'aui-data', 'aui-name', 'aui-easyui', "aui-hidden", "aui-disabled", 'aui-options', 'aui-type', 'aui-source', 'aui-src', 'aui-checked', 'aui-remove', 'aui-hidden', 'aui-disabled', 'bindinit', 'bindfocus', 'bindblur', 'bindselect', 'bindinput', 'bindchange', 'bindclick', 'binddblclick'];
        if (apollo.Template.elementProps == null) apollo.Template.elementProps = elementProps;


        var funRtn = {
            parsePartail: function (area, data, app) {
                try {
                    appendparse(area, data, app);
                }
                catch (e) {
                    showNotice("apollo.Template.Rander parsePartail Error:" + e.message);
                }
            },
            parseLayer: function (data, app) {
                try {
                    parseLayer(data, app);
                }
                catch (e) {
                    showNotice("apollo.Template.Rander parseLayer Error:" + e.message);
                }
            },
            setSource: setSource,
            reparseForItem: reparseforitem,
            reparseItem: reparseitem,
            reflashEle: reflashEle,
            reflashPager: reflashPager,
            reflashEleItem: reflashEleItem,
            createCelParseUtil: createCelParseUtil,
            parseCelParseUtil: parseCelParseUtil,
            isvalid: isvalid,
            reflashform: reflashform
        }

        var layerElement = {
            foritems: [],//要进行for渲染的对象集
            items: [], //要进行单项渲染的对象集
            props: [],
            pagers: [],
            scrollpagers: [],
            elements: [],
            easyuis: []  //easyui对象
        };//存储要进行渲染的对象

        function isvalid(form) {
            var isV = true;
            for (var i = 0; i < layerElement.easyuis.length; i++) {
                var elInfo = layerElement.easyuis[i];
                if (elInfo.form == form && elInfo.Editor != null) {
                    var cv = elInfo.Editor.isvalid();
                    if (cv != true) {
                        isV = false;
                        return isV;
                    }
                }
            }
            return isV;
        }
        //用指定模板重新刷新指定区域
        function reflashEleItem(app, data, ele, templateHtml, datas) {
            var cfutils = createCelParseUtil();
            var newel = apollo.Template.reflashParseElement(app, data, ele, templateHtml, parseChild, cfutils, datas);
            if (newel != null) parseCelParseUtil($(newel), cfutils);
            return newel;
        }

        function reflashEle(app, data, propName) {
            if (isarrayform) {//如果是属于arrayarea,本身渲染的对象是属于模板中，所以可能并不在body下,故要单独处理
                $(layerElement.foritems).each(function (i, elInfo) {
                    if (elInfo.propName == propName || elInfo.elName == propName) {
                        var cfutils = createCelParseUtil();

                        apollo.Template.parseForElement(app, data, elInfo.el, elInfo.propName, elInfo.html, parseChild, cfutils);

                        parseCelParseUtil($(elInfo.el), cfutils);

                    }
                });

                $(layerElement.items).each(function (i, elInfo) {
                    if (elInfo.propName == propName || elInfo.elName == propName) {
                        var cfutils = createCelParseUtil();

                        apollo.Template.parseElement(app, data, elInfo.el, elInfo.propName, elInfo.html, parseChild, cfutils);

                        parseCelParseUtil($(elInfo.el), cfutils);
                    }
                });

                $(layerElement.props).each(function (i, elInfo) {
                    if (elInfo.propName == propName || elInfo.elName == propName) {
                        apollo.Template.parsePropElement(data, elInfo.el, elInfo.propName);
                    }
                });

                $(layerElement.elements).each(function (i, elInfo) {
                    if (elInfo.elName == propName) {
                        apollo.Template.parseElementAttrData(elInfo.el, data, elInfo.propName, elInfo.attrs, null);
                    }
                });

                $(layerElement.easyuis).each(function (i, elInfo) {
                    if (elInfo.elName == propName) {
                        if (elInfo.Editor != null)
                            apollo.Template.parseEastuiAttrData(elInfo.Editor, elInfo.el, data, elInfo.propName, elInfo.attrs, null);
                        else
                            apollo.Template.parseElementAttrData(elInfo.el, data, elInfo.propName, elInfo.attrs, null);
                    }
                });
            }
            else {
                var arr = [];
                $(layerElement.foritems).each(function (i, elInfo) {
                    if (elInfo.propName == propName || elInfo.elName == propName) {
                        if (apollo.isInBody(elInfo.el)) {
                            arr.push(elInfo);
                            var cfutils = createCelParseUtil();
                            apollo.Template.parseForElement(app, data, elInfo.el, elInfo.propName, elInfo.html, parseChild, cfutils);
                            parseCelParseUtil($(elInfo.el), cfutils);
                        }
                    }
                    else
                        arr.push(elInfo);
                });
                layerElement.foritems = arr;

                arr = [];

                $(layerElement.items).each(function (i, elInfo) {
                    if (elInfo.propName == propName || elInfo.elName == propName) {
                        if (apollo.isInBody(elInfo.el)) {
                            arr.push(elInfo);
                            var cfutils = createCelParseUtil();
                            apollo.Template.parseElement(app, data, elInfo.el, elInfo.propName, elInfo.html, parseChild, cfutils);
                            parseCelParseUtil($(elInfo.el), cfutils);
                        }
                    }
                    else
                        arr.push(elInfo);
                });
                layerElement.items = arr;

                arr = [];
                $(layerElement.props).each(function (i, elInfo) {
                    if (elInfo.propName == propName || elInfo.elName == propName) {
                        if (apollo.isInBody(elInfo.el)) {
                            arr.push(elInfo);
                            apollo.Template.parsePropElement(data, elInfo.el, elInfo.propName);
                        }
                    }
                    else
                        arr.push(elInfo);
                });
                layerElement.props = arr;

                arr = [];
                $(layerElement.elements).each(function (i, elInfo) {
                    if (elInfo.elName == propName) {
                        if (apollo.isInBody(elInfo.el)) {
                            arr.push(elInfo);
                            apollo.Template.parseElementAttrData(elInfo.el, data, elInfo.propName, elInfo.attrs, null);
                        }
                    }
                    else
                        arr.push(elInfo);
                });
                layerElement.elements = arr;

                arr = [];
                $(layerElement.easyuis).each(function (i, elInfo) {
                    if (elInfo.elName == propName) {
                        if (apollo.isInBody(elInfo.el)) {
                            arr.push(elInfo);
                            if (elInfo.Editor != null) {
                                apollo.Template.parseEastuiAttrData(elInfo.Editor, elInfo.el, data, elInfo.propName, elInfo.attrs, null);
                            }
                            else
                                apollo.Template.parseElementAttrData(elInfo.el, data, elInfo.propName, elInfo.attrs, null);
                        }
                    }
                    else
                        arr.push(elInfo);
                });
                layerElement.easyuis = arr;
            }
        }
        function reflashPager(data, propName, app) {
            var arr = [];
            $(layerElement.pagers).each(function (i, elInfo) {
                if (elInfo.propName == propName) {
                    if (apollo.isInBody(elInfo.el)) {
                        arr.push(elInfo);
                        apollo.Template.parsePager(app, elInfo.el, propName, elInfo.html, parseChild);
                    }
                }
                else
                    arr.push(elInfo);
            });
            layerElement.pagers = arr;


            var arr = [];
            $(layerElement.scrollpagers).each(function (i, elInfo) {
                if (elInfo.propName == propName) {
                    if (apollo.isInBody(elInfo.el)) {
                        arr.push(elInfo);
                        apollo.Template.parseScrollPager(app, elInfo.el, propName, elInfo.html, parseChild);
                    }
                }
                else
                    arr.push(elInfo);
            });
            layerElement.scrollpagers = arr;
        }
        function reflashform(app, data, form) {
            if (isarrayform) {//如果是属于arrayarea,本身渲染的对象是属于模板中，所以可能并不在body下,故要单独处理
                $(layerElement.foritems).each(function (i, elInfo) {
                    if (elInfo.form == form) {
                        var cfutils = createCelParseUtil();

                        apollo.Template.parseForElement(app, data, elInfo.el, elInfo.propName, elInfo.html, parseChild, cfutils);

                        parseCelParseUtil($(elInfo.el), cfutils);

                    }
                });

                $(layerElement.items).each(function (i, elInfo) {
                    if (elInfo.form == form) {
                        var cfutils = createCelParseUtil();

                        apollo.Template.parseElement(app, data, elInfo.el, elInfo.propName, elInfo.html, parseChild, cfutils);

                        parseCelParseUtil($(elInfo.el), cfutils);
                    }
                });

                $(layerElement.props).each(function (i, elInfo) {
                    if (elInfo.form == form) {
                        apollo.Template.parsePropElement(data, elInfo.el, elInfo.propName);
                    }
                });

                $(layerElement.elements).each(function (i, elInfo) {
                    if (elInfo.form == form) {
                        apollo.Template.parseElementAttrData(elInfo.el, data, elInfo.propName, elInfo.attrs, null);
                    }
                });

                $(layerElement.easyuis).each(function (i, elInfo) {
                    if (elInfo.form == form) {
                        if (elInfo.Editor != null)
                            apollo.Template.parseEastuiAttrData(elInfo.Editor, elInfo.el, data, elInfo.propName, elInfo.attrs, null);
                        else
                            apollo.Template.parseElementAttrData(elInfo.el, data, elInfo.propName, elInfo.attrs, null);
                    }
                });
            }
            else {
                var arr = [];
                $(layerElement.foritems).each(function (i, elInfo) {
                    if (elInfo.form == form) {
                        if (apollo.isInBody(elInfo.el)) {
                            arr.push(elInfo);
                            var cfutils = createCelParseUtil();
                            apollo.Template.parseForElement(app, data, elInfo.el, elInfo.propName, elInfo.html, parseChild, cfutils);
                            parseCelParseUtil($(elInfo.el), cfutils);
                        }
                    }
                    else
                        arr.push(elInfo);
                });
                layerElement.foritems = arr;

                arr = [];

                $(layerElement.items).each(function (i, elInfo) {
                    if (elInfo.form == form) {
                        if (apollo.isInBody(elInfo.el)) {
                            arr.push(elInfo);
                            var cfutils = createCelParseUtil();
                            apollo.Template.parseElement(app, data, elInfo.el, elInfo.propName, elInfo.html, parseChild, cfutils);
                            parseCelParseUtil($(elInfo.el), cfutils);
                        }
                    }
                    else
                        arr.push(elInfo);
                });
                layerElement.items = arr;

                arr = [];
                $(layerElement.props).each(function (i, elInfo) {
                    if (elInfo.form == form) {
                        if (apollo.isInBody(elInfo.el)) {
                            arr.push(elInfo);
                            apollo.Template.parsePropElement(data, elInfo.el, elInfo.propName);
                        }
                    }
                    else
                        arr.push(elInfo);
                });
                layerElement.props = arr;

                arr = [];
                $(layerElement.elements).each(function (i, elInfo) {
                    if (elInfo.form == form) {
                        if (apollo.isInBody(elInfo.el)) {
                            arr.push(elInfo);
                            apollo.Template.parseElementAttrData(elInfo.el, data, elInfo.propName, elInfo.attrs, null);
                        }
                    }
                    else
                        arr.push(elInfo);
                });
                layerElement.elements = arr;

                arr = [];
                $(layerElement.easyuis).each(function (i, elInfo) {
                    if (elInfo.form == form) {
                        if (apollo.isInBody(elInfo.el)) {
                            arr.push(elInfo);
                            if (elInfo.Editor != null) {
                                apollo.Template.parseEastuiAttrData(elInfo.Editor, elInfo.el, data, elInfo.propName, elInfo.attrs, null);
                            }
                            else
                                apollo.Template.parseElementAttrData(elInfo.el, data, elInfo.propName, elInfo.attrs, null);
                        }
                    }
                    else
                        arr.push(elInfo);
                });
                layerElement.easyuis = arr;
            }
        }

        function setSource(app,data, elname, param) {
            if (isarrayform) {//如果是属于arrayarea,本身渲染的对象是属于模板中，所以可能并不在body下,故要单独处理
                $(layerElement.easyuis).each(function (i, elInfo) {
                    if (elInfo.elName == elname) {
                        if (elInfo.Editor != null) {
                            elInfo.Editor.loadsource(param);
                            apollo.Template.parseEastuiAttrData(elInfo.Editor, elInfo.el, data, elInfo.propName, elInfo.attrs, null);
                        }
                    }
                });
            }
            else {
                $(layerElement.easyuis).each(function (i, elInfo) {
                    if (elInfo.elName == elname) {
                        if (apollo.isInBody(elInfo.el)) {
                            if (elInfo.Editor != null) {
                                elInfo.Editor.loadsource(param);
                                apollo.Template.parseEastuiAttrData(elInfo.Editor, elInfo.el, data, elInfo.propName, elInfo.attrs, null);
                            }
                        }
                    }
                });
            }
        }

        /**创建一个空的渲染对象 */
        function createCelParseUtil() {
            return {
                no: 0,
                createID: function () {
                    this.no += 1;//序号增加1位
                    return "apollouiformelement_" + this.no;
                },
                setdata: function (elcsid, data, propName, attrs, rowelement, pdatas, iseasyui) {
                    this.elItems.push({ elcsid: elcsid, iseasyui: iseasyui, data: data, propName: propName, attrs: attrs, rowelement: rowelement, pdatas: pdatas });
                },
                elItems: []  //需要进行渲染的元素{elcsid:"",param:{data:null,propName:"",attrs:[]}}
            };
        }
        /**
         * 对元素进行解析
         * @param {any} cfutil
         */
        function parseCelParseUtil(curel, cfutil) {
            //进行元素实际属性方法渲染
            $(cfutil.elItems).each(function (i, item) {
                var arr = [];

                if (item.rowelement != null) {
                    var a = $(item.rowelement).data("EasyuiBox");
                    if (a != null && jQuery.isArray(a))
                        arr = a;
                    else
                        $(item.rowelement).data("EasyuiBox", arr);
                }
                var myel = curel.find("." + item.elcsid);
                $(myel).each(function (j, cbel) {
                    var iseasyui = item.iseasyui;
                    $(cbel).removeClass(item.elcsid);

                    if (iseasyui == true) {
                        var editor = apollo.Template.initEasyuiBox(cbel, item.attrs);
                        if (editor != null) {
                            arr.push(editor);
                            apollo.Template.parseEastuiAttrData(editor, cbel, item.data, item.propName, item.attrs, item.rowelement, item.pdatas);
                        }
                        else
                            apollo.Template.parseElementAttrData(cbel, item.data, item.propName, item.attrs, item.rowelement, item.pdatas);
                    }
                    else
                        apollo.Template.parseElementAttrData(cbel, item.data, item.propName, item.attrs, item.rowelement, item.pdatas);
                });
            });
        }


        /**
         * 将指定模板加到内存中，以重可由JS重新刷新该区域
         * @param {any} key
         * @param {any} eltype
         * @param {any} el
         */
        function addToEles(el, propName, attrs, eltype, elName) {
            var ele = $(el);

            var elN = propName;
            if ((eltype == 5 || eltype == 6) && apollo.Lib.isNotEmpty(elName)) {
                elN = elName;
            }
            else if (apollo.Template.isJsExplain(elN) && apollo.Lib.isNotEmpty(elName)) {
                elN = elName;
            }
            var elInfo = { el: ele, attrs: attrs, html: getelehtml(ele), propName: propName, elName: elN, Editor: null,form:"" };      //{ Template: el.html(), eltype: eltype, el: $(el) };//需要存储的对象

            var form = $(ele).closest("[aui-form]");
            if (form != null && form.length > 0) {
                var fn = $($(form).get(0)).attr("aui-form");
                if (apollo.Lib.isNotEmpty(fn))
                    elInfo.form = fn;
            }

            if (eltype == 0) //form
                layerElement.foritems.push(elInfo);
            else if (eltype == 1)
                layerElement.items.push(elInfo);
            else if (eltype == 2)
                layerElement.props.push(elInfo);
            else if (eltype == 3)
                layerElement.pagers.push(elInfo);
            else if (eltype == 4)
                layerElement.scrollpagers.push(elInfo);
            else if (eltype == 6) {
                elInfo.Editor = apollo.Template.initEasyuiBox(ele, attrs);
                layerElement.easyuis.push(elInfo);
            }
            else
                layerElement.elements.push(elInfo);

            return elInfo;
        }
        /**
         * 是否在区域内，如是则不进行页面渲染
         * @param {DOM} 元素
         */
        function isInFormArea(ele) {
            var curArea = $(ele).closest(".apolloui-arrayarea,.apolloui-area");
            if (curArea != null && curArea.length > 0)
                return true;

            return false;//否则视为不在，即只是页面内容，则页面初始渲染
        }

        /**
         * 检查是否可以指定区域内进行渲染
         * @param {any} ele
         * @param {any} pel
         */
        function isInPage(ele) {
            if (apollo.util.toBoolean($(ele).attr("apollo-isframe")) == true) //内置frame
                return false;


            var selecter = "[apollo-foritem],[apollo-item],[apollo-prop],[apollo-pager],[apollo-scrollpager],[apollo-data]";
            var curArea = $(ele).parents(selecter);
            if (curArea != null && curArea.length > 0) {
                return true;
            }

            curArea = $(ele).closest("template");

            if (curArea != null && curArea.length > 0) {
                return true;
            }

            curArea = $(ele).closest("[apollo-istemplate]");

            if (curArea != null && curArea.length > 0 && apollo.util.toBoolean($(curArea).attr("apollo-istemplate")) == true) {
                return true;
            }

            return false;//否则视为不在，即只是页面内容，则页面初始渲染
        }

        function getelehtml(ele) {
            var curel = $(ele);
            //检查当前元素有无指定模板，如有，则以模板内容为准
            var tmpid = curel.attr("apollo-template");
            var tmphtml = "";
            if (apollo.Lib.isNotEmpty(tmpid)) {
                var tmp = $("#" + tmpid);
                if (tmp.length > 0)
                    tmphtml = tmp.html();
            }
            if (tmphtml == "")
                tmphtml = curel.html();
            return tmphtml;
        }

        function reparseforitem(app,el, data,propName) {
            var curel = $(el);//当前元素
            
            if (apollo.Lib.isEmpty(propName)) {
                propName = "";
            }
            
            //无素模板下子区域组件渲染器
            var cfParseUtil = createCelParseUtil();

            apollo.Template.parseForElement(app, data, el, propName, getelehtml(curel), parseChild, cfParseUtil);

            parseCelParseUtil(curel, cfParseUtil);
        }

        function reparseitem(app, el, data, propName) {
            var curel = $(el);//当前元素

            if (apollo.Lib.isEmpty(propName)) {
                propName = "";
            }

            //无素模板下子区域组件渲染器
            var cfParseUtil = createCelParseUtil();
            apollo.Template.parseElement(app, data, el, propName, getelehtml(curel), parseChild, cfParseUtil);

            parseCelParseUtil(curel, cfParseUtil);
        }


        /**渲染处理多项页区域*/
        function parseForItem(app, arrEles, data, isIn, cfutil) {
            $(arrEles).each(function (i, el) {
                var curel = $(el);//当前元素

                if (isform != true && isInFormArea(curel)) return;//如果是直属于apollo.form元素下，则不由Page进行渲染
                if (isInPage(curel)) return;//是否在模板下，如果是，则不进行渲染


                //取到属性名
                var propName = curel.attr("apollo-foritem");//获取属性名或属性表达式
                curel.removeAttr("apollo-foritem");  //处理完后，需要移除相应标识
                if (apollo.Lib.isEmpty(propName)) {
                    propName = "";
                }
                var elName = curel.attr("apollo-name");
                curel.removeAttr("apollo-name");
                if (apollo.Lib.isEmpty(elName)) {
                    elName = propName;
                }
                
                //将该项加到页渲染对象集中，以便变化时重新渲染
                if (isIn != true) //不属于嵌套项，则要加到模板集中
                {
                    addToEles(curel, propName, [], 0,elName);
                }
                else {
                    curel.attr("apollo-data", propName);//将数据标标记为data，以便解析器解析(子级解析)
                }


                //无素模板下子区域组件渲染器
                var cfParseUtil;
                if (cfutil == null) {
                    cfParseUtil = createCelParseUtil();
                }
                else
                    cfParseUtil = cfutil;
                
                apollo.Template.parseForElement(app, data, el, propName, getelehtml(curel), parseChild, cfParseUtil);

                if (cfutil == null) {
                    parseCelParseUtil(curel, cfParseUtil);
                }
            });
        }

        /**渲染处理单项页区域*/
        function parseItem(app, el, data, isIn, cfutil) {
            var curel = $(el);//当前元素

            if (isform != true && isInFormArea(curel)) return;//如果是直属于apollo.form元素下，则不由Page进行渲染
            if (isInPage(curel)) return;

            //取到属性名
            var propName = curel.attr("apollo-item");//获取属性名或属性表达式
            curel.removeAttr("apollo-item");

            if (apollo.Lib.isEmpty(propName)) {
                propName = "";
            }

            var elName = curel.attr("apollo-name");
            curel.removeAttr("apollo-name");
            if (apollo.Lib.isEmpty(elName)) {
                elName = propName;
            }

            if (isIn != true) {
                addToEles(el, propName, [], 1, elName);
            } else {
                curel.attr("apollo-data", propName);//将数据标标记为data，以便解析器解析(子级解析)
            }

            //无素模板下子区域组件渲染器
            var cfParseUtil;
            if (cfutil == null) {
                cfParseUtil = createCelParseUtil();
            }
            else
                cfParseUtil = cfutil;



            apollo.Template.parseElement(app, data, el, propName, getelehtml(curel), parseChild, cfParseUtil);

            if (cfutil == null) {
                parseCelParseUtil(curel, cfParseUtil);
            }
        }

        function parseProp(el, data) {
            var curel = $(el);//当前元素

            if (isform != true && isInFormArea(curel)) return;//如果是直属于apollo.form元素下，则不由Page进行渲染
            if (isInPage(curel)) return;

            //取到属性名
            var propName = curel.attr("apollo-prop");//获取属性名或属性表达式
            curel.removeAttr("apollo-prop");

            if (apollo.Lib.isEmpty(propName)) {
                propName = "";
            }

            var elName = curel.attr("apollo-name");
            curel.removeAttr("apollo-name");
            if (apollo.Lib.isEmpty(elName)) {
                elName = propName;
            }

            addToEles(el, propName, [], 2,elName);

            apollo.Template.parsePropElement(data, el, propName);
        }

        function parsePager(el, app) {
            var curel = $(el);//当前元素

            if (isform != true && isInFormArea(curel)) return;//如果是直属于apollo.form元素下，则不由Page进行渲染
            if (isInPage(curel)) return;

            //取到属性名
            var propName = curel.attr("apollo-pager");//获取属性名或属性表达式
            curel.removeAttr("apollo-pager");

            if (apollo.Lib.isEmpty(propName)) {
                propName = "";
            }

            var elName = curel.attr("apollo-name");
            curel.removeAttr("apollo-name");
            if (apollo.Lib.isEmpty(elName)) {
                elName = propName;
            }

            addToEles(el, propName, [], 3, elName);


            apollo.Template.parsePager(app, el, propName, getelehtml(curel), parseChild);
        }

        function parseScrollPager(el, app) {
            var curel = $(el);//当前元素

            if (isform != true && isInFormArea(curel)) return;//如果是直属于apollo.form元素下，则不由Page进行渲染
            if (isInPage(curel)) return;

            //取到属性名
            var propName = curel.attr("apollo-scrollpager");//获取属性名或属性表达式
            curel.removeAttr("apollo-scrollpager");

            if (apollo.Lib.isEmpty(propName)) {
                propName = "";
            }

            var elName = curel.attr("apollo-name");
            curel.removeAttr("apollo-name");
            if (apollo.Lib.isEmpty(elName)) {
                elName = propName;
            }

            addToEles(el, propName, [], 4,elName);


            apollo.Template.parseScrollPager(app, el, propName, getelehtml(curel), parseChild);
        }

        function parseTemplate(panel) {
            //先处理template元素下的
            var temps = panel.find("template");
            var fun = function (p) {
                var arr = p.find("[apollo-template]");
                $(arr).each(function (i, ele) {
                    //要确认这个是否在模板下，
                    var selecter = "[apollo-foritem],[apollo-item],[apollo-prop],[apollo-pager],[apollo-scrollpager],[apollo-data]";
                    if ($(ele).is(selecter))
                        return true;

                    $(ele).html(getelehtml($(ele)));

                    $(ele).removeAttr("apollo-template");
                });
            }

            $(temps).each(function (i, el) {
                var html = $(el).html();
                var panel = $("<div></div>");
                panel.html(html);

                fun(panel);

                $(el).html(panel.html());
            });


            fun(panel);            
        }

        //追加渲染
        function appendparse(panel, data, app) {
            //先查到所有的apollo-foritem项
            if (typeof panel == "string") {
                if (!apollo.util.startsWith(panel, "#")) panel = "#" + panel;
                panel = $(panel);
            }

            //优先处理模板
            parseTemplate(panel);

            var arrItems = panel.find("not[class*='apolloui'],[apollo-data]");
            $(arrItems).each(function (i, el) {
                parseData(app, el, data);
            });
            //先查所有元素，不处于标准元素下的
            var propFilter = ["not[class*='apolloui-']"];
            $(elementProps).each(function (i, en) {
                propFilter.push("[" + en + "]");
            });
            arrItems = panel.find(propFilter.join(","));
            $(arrItems).each(function (i, el) {
                if (apollo.util.toBoolean($(el).attr("aui-easyui")) == true) {
                    parseEasyui(app, el, data, "");
                }
                else {
                    parseForm(app, el, data, "");
                }
            });

            arrItems = panel.find("not[class*='apolloui-'],[apollo-foritem]");
            //以全局对象进行渲染解析(一次性渲染，无法实现多次渲染)

            parseForItem(app, arrItems, data, false, null);

            //再找所有单项，以全局对象进行渲染解析(一次性渲染，无法实现多次渲染)
            arrItems = panel.find("not[class*='apolloui'],[apollo-item]");
            $(arrItems).each(function (i, el) {
                parseItem(app, el, data, false, null);
            });



            //再找具体属性项
            arrItems = panel.find("not[class*='apolloui'],[apollo-prop]");
            $(arrItems).each(function (i, el) {
                parseProp(el, data);
            });

            //apollo.form arrayarea不实现pager渲染
            if (isarrayform != true) {
                //再处理分页项,会页项只针对options参数
                arrItems = panel.find("not[class*='apolloui'],[apollo-pager]");
                $(arrItems).each(function (i, el) {
                    parsePager(el, app);
                });
                //再处理分页项,会页项只针对options参数
                arrItems = panel.find("not[class*='apolloui'],[apollo-scrollpager]");
                $(arrItems).each(function (i, el) {
                    parseScrollPager(el, app);
                });
            }
        }

       
        /**渲染处理单项页区域*/
        function parseLayer(data, app) {
            appendparse(layerPanel, data, app);
        }

        /**处理嵌套的模板 */
        function parseChild(app, pel, peldata, cfutil) {

            //先查到所有的apollo-foritem项
            var arrItems = $(pel).find("not[class*='apolloui-'],[apollo-foritem]");
            //以全局对象进行渲染解析(一次性渲染，无法实现多次渲染)
            parseForItem(app, arrItems, peldata, true, cfutil);

            //再找所有单项，以全局对象进行渲染解析(一次性渲染，无法实现多次渲染)
            arrItems = $(pel).find("not[class*='apolloui'],[apollo-item]");
            $(arrItems).each(function (i, el) {
                parseItem(app, el, peldata, true, cfutil);
            });
        }

        function parseData(app, el, data) {
            var curel = $(el);//当前元素

            //取到属性名
            var propName = curel.attr("apollo-data");//获取属性名或属性表达式
            curel.removeAttr("apollo-data");
            if (apollo.Lib.isEmpty(propName)) {
                propName = "";
            }


            var propFilter = ["not[class*='apolloui-']"];
            $(elementProps).each(function (i, en) {
                propFilter.push("[" + en + "]");
            });
            arrItems = curel.find(propFilter.join(","));

            $(arrItems).each(function (i, el) {
                if (apollo.util.toBoolean($(el).attr("aui-easyui")) == true) {
                    parseEasyui(app, el, data, propName);
                }
                else {
                    parseForm(app, el, data, propName);
                }
            });
        }
        //以下为渲染form对象或标记为apollo-element的对象
        function parseForm(app, el, data, pn) {
            var curel = $(el);//当前元素

            if (isform != true && isInFormArea(curel)) return;//如果是直属于apollo.form元素下，则不由Page进行渲染
            if (isInPage(curel)) return;

            var elName = curel.attr("aui-name");
            if (apollo.Lib.isEmpty(elName)) {
                elName = curel.attr("aui-value");
                if (apollo.Lib.isEmpty(elName) || !apollo.Template.isEleName(elName))
                    elName = "";
            }

            var attrs = [];
            //解析并设置处理属性方法
            if (curel.length > 0 && curel.get(0).attributes != null) {
                $(curel.get(0).attributes).each(function (i, atr) {
                    var name = atr.name, value = atr.value;
                    if (apollo.util.startsWith(name, "aui-") && name.length > 4) {
                        curel.removeAttr(name);
                        if (apollo.Lib.isIn(name, elementProps)) {
                            attrs.push({ name: name, dataname: name.substring(4, name.length), propName: value, isdata: true,isauidata:false, value: null, isevent: false, eventfun: null });
                        }
                        else {
                            attrs.push({ name: name, dataname: name.substring(4, name.length), propName: value, isdata: true, isauidata: true, value: value, isevent: false, eventfun: null });
                        }
                    }
                    else if (apollo.Lib.isIn(name, ['bindinit', 'bindfocus', 'bindblur', 'bindselect', 'bindinput', 'bindchange', 'bindclick', 'binddblclick'])) {
                        curel.removeAttr(name);
                        var op = app.getoption();
                        var fun = apollo.Lib.getAttr(op, value);
                        if (!jQuery.isFunction(fun)) fun = null;
                        attrs.push({ name: name, propName: value, isevent: true, value: null, eventfun: fun, isdata: null, dataname: name });
                    }
                });
            }

            var propName = curel.attr("apollo-data");//获取属性名或属性表达式
            curel.removeAttr("apollo-data");
            if (apollo.Lib.isEmpty(propName)) {
                if (apollo.Lib.isNotEmpty(pn))
                    propName = pn;
                else
                    propName = "";
            }

            addToEles(el, propName, attrs, 5, elName);

            apollo.Template.parseElementAttrData(el, data, propName, attrs, null);
        }

        //以下为渲染easyui对象   即 aui-easyui=true,且有aui-value,aui-name,bindchange等属性，其它属性不计
        function parseEasyui(app, el, data, pn) {
            var curel = $(el);//当前元素

            if (isform != true && isInFormArea(curel)) return;//如果是直属于apollo.form元素下，则不由Page进行渲染
            if (isInPage(curel)) return;

            var elName = curel.attr("aui-name");
            if (apollo.Lib.isEmpty(elName)) {
                elName = curel.attr("aui-value");
                if (apollo.Lib.isEmpty(elName) || !apollo.Template.isEleName(elName))
                    elName = "";
            }
            if (apollo.Lib.isEmpty(elName)) {
                elName = curel.attr("aui-data");
                if (apollo.Lib.isEmpty(elName) || !apollo.Template.isEleName(elName))
                    elName = "";
            }

            var attrs = [];
            //解析并设置处理属性方法
            if (curel.length > 0 && curel.get(0).attributes != null) {
                $(curel.get(0).attributes).each(function (i, atr) {
                    /*
                     * 这里只处理几个属性
                     * aui-value  取值
                     * aui-name   名称  主要用于刷新
                     * aui-options  类型form中area对象的data-options，移除了Name项
                     * aui-type:
                     * aui-source 数据源  主要用于combox,ckbox等
                     * aui-popupsource  数据源 主要用于popupbox,
                     * bindchange:值改变时激活
                     */
                    var name = atr.name, value = atr.value;

                    if (apollo.util.startsWith(name, "aui-") && name.length > 4) {
                        curel.removeAttr(name);
                        if (apollo.Lib.isIn(name, ["aui-value", "aui-data", "aui-hidden", "aui-disabled", "aui-name", "aui-type", 'aui-options', "aui-source"])) {
                            attrs.push({ name: name, dataname: name.substring(4, name.length), propName: value, isdata: true,isauidata:false, value: null, isevent: false, eventfun: null });
                        }
                        else {
                            attrs.push({ name: name, dataname: name.substring(4, name.length), propName: "", isdata: true, isauidata: true, value: value, isevent: false, eventfun: null });
                        }
                    }
                    else if (apollo.Lib.isIn(name, ['bindinit', 'bindfocus', 'bindblur', 'bindselect', 'bindinput', 'bindchange', 'bindclick', 'binddblclick'])) {
                        curel.removeAttr(name);
                        var op = app.getoption();
                        var fun = apollo.Lib.getAttr(op, value);
                        if (!jQuery.isFunction(fun)) fun = null;
                        attrs.push({ name: name, propName: value, isevent: true, value: null, eventfun: fun, isdata: false,isauidata:false, dataname: name });
                    }
                });
            }

            var propName = curel.attr("apollo-data");//获取属性名或属性表达式
            curel.removeAttr("apollo-data");
            if (apollo.Lib.isEmpty(propName)) {
                if (apollo.Lib.isNotEmpty(pn))
                    propName = pn;
                else
                    propName = "";
            }

            var elInfo = addToEles(el, propName, attrs, 6, elName);

            if (elInfo != null && elInfo.Editor != null) {
                apollo.Template.parseEastuiAttrData(elInfo.Editor, el, data, propName, attrs, null);
            }
            else {
                apollo.Template.parseElementAttrData(el, data, propName, attrs, null);
            }
        }
        return funRtn;
    };
})(apollo);
/**
apollo 前端框架脚本加载器
*/
(function () {
    apollo.pc = {};
    apollo.mobile = {};

    /**
* 获取当前编辑器所在目录,主意，aeditor.js必须是在编辑器目录的根目录下
*/
    function getjsPath() {
        var path = "";
        var scriptNodes = document.getElementsByTagName("script");
        for (var i = 0; i < scriptNodes.length; i++) {
            var src = scriptNodes[i].src;
            if (!src) {
                continue;
            }
            var m = src.match(/apollo\.js(\W|$)/i);
            if (m) {
                path = src.substring(0, m.index);
            }
        }
        return path;
    }

    apollo.mobile.loadScript = function (apollo) {
        apollo.pageInfo.base = getjsPath();
        //如果需要通过自动配置 方式获取路径信息
        if (window.APOLLOUI_SYSTEM_GLOBAL_VOL == null || window.APOLLOUI_SYSTEM_GLOBAL_VOL.autoinit == true) {
            var jsPath = apollo.pageInfo.base;

            //获取基本配置(获取当前站点根路径）
            //首先要加载jquery
            var apisite = apollo.pageInfo.webapipath;

            //如果后台服务不是本地化部署（如APP，html是在APP中，API接口则是放在服务器端，则不取后台配置,直接由本地配置程序路径，这种情况必须要进行配置 
            if (apollo.util.startsWith(apisite, "http://") || apollo.util.startsWith(apisite, "https://")) {
                //只有获取配置成功后才会加载成功
                //原apollo.init将改为初始页面，则apollo.page.init代替
                var rootvpath = window.APOLLOUI_SYSTEM_GLOBAL_VOL.rootvpath;
                apollo.pageInfo.rootvpath = rootvpath;
            }
            else {
                var actionurl = jsPath + "src/ApolloUIHandler.ashx";
                jQuery.ajax({
                    url: actionurl,
                    type: 'post',
                    async: false,//使用同步的方式,true为异步方式
                    dataType: "json",
                    cache: false,
                    data: { action: "config" },
                    success: function (cfg) {
                        //设置当前端站根路径
                        apollo.pageInfo.rootvpath = cfg.RootPath;
                        if (apollo.Lib.isEmpty(apollo.pageInfo.webapipath)) //未设置，则视为本地
                            apollo.pageInfo.webapipath = cfg.RootPath;
                    },
                    fail: function () {
                        throw "加载前端配置失败";
                    }
                });
            }
        }
    };
    apollo.pc.loadScript = function (apollo) {

        //设置提示框或弹出窗口相关方法
        function setWinOrMessageFun(topWin) {
            //弹出窗口，只设两种
            apollo.messageBox = topWin.messageBox;
            apollo.win = topWin.win;
            apollo.showError = topWin.showError;
            apollo.showInfo = topWin.showInfo;
            apollo.showWain = topWin.showWain;
            apollo.showNotice = topWin.showNotice;

            apollo.showProcess = topWin.showProcess;
            apollo.hideProcess = topWin.hideProcess;

            apollo.openWin = function (controller, action, width, height, callback, param) {
                var _controller = controller, _action = action, _width = width, _height = height, _callback = callback, _param = param;
                var url = "";
                if (typeof action == "string") {
                    //则表示没传参数,则参数都向前移一位
                    url = apollo.pageInfo.rootvpath + controller + "/" + action;
                }
                else //只有url，则参数向前移一位相当于 (url, width, height, callback, param)
                {
                    url = apollo.getvpath(controller, true);
                    _width = action;
                    _height = width;
                    _callback = height;
                    _param = callback;
                }

                topWin.openModelDialog(url, _width, _height, _callback, _param);
            }
            apollo.openWinMax = topWin.openModelDialogMax;
            apollo.showInput = topWin.showConfirm;
            apollo.closeWin = function (v) {
                closeWin(v);
            }
        }

        //contentWindow
        function closeWin(params) {
            if (currentWindow != null) {
                currentWindow.ok(params);
            }
        }
        function cancelWin() {
            if (currentWindow != null) {
                currentWindow.cancel();
            }
        }

        apollo.pageInfo.base = getjsPath();


        var jsPath = apollo.pageInfo.base;
        //获取基本配置(获取当前站点根路径）
        //首先要加载jquery

        var actionurl = jsPath + "src/ApolloUIHandler.ashx";
        $.ajax({
            url: actionurl,
            type: 'post',
            async: false,//使用同步的方式,true为异步方式
            dataType: "json",
            cache: false,
            data: { action: "config" },
            success: function (cfg) {
                //设置当前端站根路径
                apollo.pageInfo.rootvpath = cfg.RootPath;
                apollo.pageInfo.formThemes = cfg.FormThemes;
                if (apollo.Lib.isEmpty(apollo.pageInfo.webapipath)) //未设置，则视为本地
                {
                    apollo.pageInfo.webapipath = cfg.RootPath;
                }
                apollo.pageInfo.aeimagevpath = cfg.AEImageVPath;
                //只有获取配置成功后才会加载成功
                scriptload(jsPath);
            },
            fail: function () {
                throw "加载前端配置失败";
            }
        });

        function getThemes() {
            var type = "";
            try {
                var paras = "themes";
                var scripts = document.getElementsByTagName('script');
                var url = scripts[scripts.length - 1].src;
                var paraString = url.substring(url.indexOf("?") + 1, url.length).split("&");
                var paraObj = {}
                for (i = 0; j = paraString[i]; i++) {
                    paraObj[j.substring(0, j.indexOf("=")).toLowerCase()] = j.substring(j.indexOf("=") + 1, j.length);
                }
                var returnValue = paraObj[paras.toLowerCase()];
                if (typeof (returnValue) == "undefined") {
                    type = "";
                } else {
                    type = returnValue;
                }
            }
            catch (e) { }
            return type;
        }
        function scriptload(path) {
            var themes = getThemes();
            if (themes != null && themes != "")
                apollo.pageInfo.formThemes = themes;

            initJavaScript(apollo.pageInfo.rootvpath, apollo.pageInfo.formThemes, "Content");
        }

        apollo.pc.initwinmsg = function (win) {
            setWinOrMessageFun(win);
        };
    };



    if (apollo.isPCComputer()) //PC端
        apollo.pc.loadScript(apollo);
    else
        apollo.mobile.loadScript(apollo);

})();


//单页页面切换
/*
apollo.SPA
*/
(function ($) {
    $.fn.extend({
        PageTransitions: function () {
            var pages = $(".pt-page");//当前窗体主体

            var emptyEle = $("<span style='display:block'>&nbsp;</span>");

            var pageWins = [];//存放当前已打开窗体对象            

            //为防止进行多个切换，这里定义一个方法队列，用于在启动切换期间又有新的切换
            var funInfo = null;

            var isAnimating = false;
            var endCurrPage = false;
            var endNextPage = false;

            var arrPartial = {};//存储各分页对象,刷新为其主对象
            //{name:'',url:'',toback:''}
            function spaReg(options) {
                var defaults = {
                    name: "empspa",
                    load: null,
                    show: null,
                    toback: null
                };
                var op = $.extend(defaults, options);
                if (!jQuery.isFunction(op.show)) {
                    op.show = function (backpage, isback) {
                        op.backpage = backpage;
                        if (jQuery.isFunction(op.load)) {
                            op.load();
                        }
                        if (isback == true) {
                            pageRtn.toBackPage(op.name);
                        }
                        else {
                            pageRtn.toPage(op.name);
                        };
                    }
                }
                if (!jQuery.isFunction(op.toback)) {
                    op.toback = function () {
                        if ($.isFunction(op.backpage))
                            op.backpage.call();
                        else if (apollo.Lib.isNotEmpty(op.backpage)) {
                            pageRtn.toBackPage(op.backpage);
                        }
                        else
                            pageRtn.toBack();
                    }
                }
                arrPartial[op.name] = op;
                return op;
            }

            function openSPA(name, url, toback, _callback, isback) {
                url = apollo.getappurl(url);
                var callback = _callback;
                var fun = function (spaop) {
                    if (spaop != null && jQuery.isFunction(spaop.show)) {
                        var back = toback;
                        if (isback != true && spaop.name == toback && spaop.backpage != null)
                            back = spaop.backpage;


                        spaop.show(back, isback);
                    }
                    else {
                        var back = toback;
                        if (isback != true && spaop.name == toback && spaop.backpage != null)
                            back = spaop.backpage;


                        spaop.backpage = back;
                        if (jQuery.isFunction(spaop.load)) {
                            spaop.load();
                        }
                        if (isback == true)
                            pageRtn.toBackPage(name);
                        else
                            pageRtn.toPage(name);
                    }
                    if (callback != null) callback();
                };

                if (!(name in arrPartial)) //表示之前未加载,则新加载
                {
                    careateNewPage(name, apollo.getvpath(url, true), function () {
                        //检查是否有注册
                        if (name in arrPartial) {
                            var spaop = apollo.Lib.getAttr(arrPartial, name);
                            fun(spaop);
                            if (currentPage != null) currentPage.op = spaop;
                        }
                        else if (apollo.Lib.isNotEmpty(name)) {
                            var spaop = { name: name }
                            var newop = spaReg(spaop);
                            fun(newop);
                            if (currentPage != null) currentPage.op = newop;
                        }
                    });
                }
                else {
                    //这时需要重新调用load方法
                    var spaop = apollo.Lib.getAttr(arrPartial, name);
                    fun(spaop);
                }
            }

            function toback() {
                if (currentPage != null && jQuery.isPlainObject(currentPage.op) && jQuery.isFunction(currentPage.op.toback)) {
                    currentPage.op.toback();
                }
                else if (currentPage != null) {
                    if (currentPage.index > 0) {
                        openPageByIndex(currentPage.index - 1, 2);
                    }
                }
            }

            var animEndEventNames = {
                'WebkitAnimation': 'webkitAnimationEnd',
                'OAnimation': 'oAnimationEnd',
                'msAnimation': 'MSAnimationEnd',
                'animation': 'animationend'
            };
            // animation end event name
            var animEndEventName = animEndEventNames[Modernizr.prefixed('animation')];
            // support css animations
            var support = Modernizr.cssanimations;

            var currentPage = null;//当前对象，下一对象            

            var pageRtn = {
                name: "",
                open: openSPA,
                reg: spaReg,
                getPage: function (name) {
                    if (typeof name == "type")
                        return findWin(name);
                    else
                        return currentPage;
                },
                newPage: newPage,
                toPage: function (name) {
                    if (typeof name == "string")
                        openPageByName(name, 1);
                    else if (typeof name == "object")
                        openPage(name, 1);
                    else if (typeof name == Number)
                        openPageByIndex(name, 1);
                    else
                        openPageByName(name, 1);
                },
                toBackPage: function (name) {
                    if (typeof name == "string")
                        openPageByName(name, 2);
                    else if (typeof name == "object")
                        openPage(name, 2);
                    else if (typeof name == Number)
                        openPageByIndex(name, 2);
                    else
                        openPageByName(name, 2);
                },
                toNext: function () {
                    if (currentPage != null) {
                        if (currentPage.index < pageWins.length - 1) {
                            openPageByIndex(currentPage.index + 1, 1);
                        }
                    }
                    else
                        openPageByIndex(0, 1);
                },
                toBack: toback,
                toback: toback,

            }



            function init() {
                var curPw = null;
                var firstpage = null;
                var prev = null;
                var firstName = "";
                $(pages).each(function (index, page) {
                    var p = $(page);
                    var name = p.attr("id");
                    if (apollo.Lib.isEmpty(name)) {
                        name = "page" + (index + 1);
                    }
                    var pw = createPageEntity(name, p, prev, index);

                    pageWins.push(pw);
                    //默认第一项为当前页
                    if (index == 0) firstpage = pw;
                    if (p.hasClass("pt-page-active")) {
                        curPw = pw;
                        p.removeClass("pt-page-active");
                    }
                    prev = p;
                });
                if (curPw != null) openPage(curPw, 1);
            }
            //创建新的窗体
            function createPageEntity(name, page, prevPage, index) {
                //动画仅限如下，左右切换，上下切换，淡入淡出
                var pageWin = page;
                pageWin.data('originalClassList', pageWin.attr('class'));
                return {
                    name: name,
                    index: index,
                    op: null,
                    win: page,
                    page: page,
                    prevPage: prevPage //打开当前窗口的前一窗口
                };
            }

            //查到已存在的窗体
            function findWin(name) {
                for (var i = 0; i < pageWins.length; i++) {
                    var page = pageWins[i];
                    if (apollo.Lib.isEquals(page.name, name)) {
                        return page;
                    }
                }
                return null;
            }
            function getAnimStyle(animation) {
                switch (animation) {

                    case 1://右入左出
                        outClass = 'pt-page-moveToLeft';
                        inClass = 'pt-page-moveFromRight';
                        break;
                    case 2://
                        outClass = 'pt-page-moveToRight';
                        inClass = 'pt-page-moveFromLeft';
                        break;
                    case 3:
                        outClass = 'pt-page-moveToTop';
                        inClass = 'pt-page-moveFromBottom';
                        break;
                    case 4:
                        outClass = 'pt-page-moveToBottom';
                        inClass = 'pt-page-moveFromTop';
                        break;
                    case 5:
                        outClass = 'pt-page-fade';
                        inClass = 'pt-page-moveFromRight pt-page-ontop';
                        break;
                    case 6:
                        outClass = 'pt-page-fade';
                        inClass = 'pt-page-moveFromLeft pt-page-ontop';
                        break;
                    case 7:
                        outClass = 'pt-page-fade';
                        inClass = 'pt-page-moveFromBottom pt-page-ontop';
                        break;
                    case 8:
                        outClass = 'pt-page-fade';
                        inClass = 'pt-page-moveFromTop pt-page-ontop';
                        break;
                    case 9:
                        outClass = 'pt-page-moveToLeftFade';
                        inClass = 'pt-page-moveFromRightFade';
                        break;
                    case 10:
                        outClass = 'pt-page-moveToRightFade';
                        inClass = 'pt-page-moveFromLeftFade';
                        break;
                    default:
                        outClass = 'pt-page-moveToLeft';
                        inClass = 'pt-page-moveFromRight';
                }
                return { inClass: inClass, outClass: outClass };
            }

            function nextPage(animation) {
                if (currentPage == null) return;
                var index = currentPage.index + 1;
                openPageByIndex(index, animation);
            }

            function openPageByIndex(index, animation) {
                if (index < 0 || index >= pageWins.length) return;

                if (currentPage != null && index == currentPage.index) return;

                var page = pageWins[index];//检测是否已存在，如果已存在，则打开该窗口
                openPage(page, animation);
            }
            function openPageByName(name, animation) {
                var page = findWin(name);//检测是否已存在，如果已存在，则打开该窗口
                if (page == null) return;//否则，则不切换
                openPage(page, animation);
            }

            function newPage(url, callback) {
                url = apollo.getappurl(url);
                return careateNewPage("", url, callback);
            }
            function careateNewPage(id, url, callback) {
                //加载对话框内容
                $.get(url, {}, function (html, status) {
                    if (status != "success") { //加载不成功
                        showNotice(html);
                        return;
                    }

                    html = apollo.convertpath(html);

                    var ele;
                    try {
                        ele = $(html);
                    }
                    catch (e) {
                        ele = $($.parseHTML(html));
                    }
                    var eles = $(ele).find(".pt-page");
                    var divpage
                    if (eles.length == 0) //没有.pt-page
                    {
                        divpage = $("<div class=\"pt-page\"></div>");
                        divpage.append(ele);
                    }
                    else
                        divpage = ele;

                    $(document.body).append(divpage);

                    if (apollo.app != null) {
                        //追加渲染
                        apollo.app.append(divpage);
                    }

                    if (apollo.Lib.isNotEmpty(id)) {
                        var p = $(divpage);
                        var name = id;
                        var index = pageWins.length;
                        var pw = createPageEntity(name, p, prev, index);

                        pageWins.push(pw);
                        if (p.hasClass("pt-page-active")) {
                            curPw = pw;
                            p.removeClass("pt-page-active");
                        }
                        prev = p;
                    }
                    else {
                        var newpages = divpage.find(".pt-page");
                        var prev = currentPage;
                        $(newpages).each(function (index, page) {
                            var p = $(page);
                            var name = p.attr("id");
                            if (apollo.Lib.isEmpty(name)) {
                                name = "page" + pageWins.length;
                            }
                            var pw = createPageEntity(name, p, prev, index);

                            pageWins.push(pw);
                            if (p.hasClass("pt-page-active")) {
                                curPw = pw;
                                p.removeClass("pt-page-active");
                            }
                            prev = p;
                        });
                    }
                    //进入地址加载页
                    if (callback != null)
                        callback();
                });
            }

            var btime = null;
            function openPage(page, animation) {
                if (page == currentPage) return; //如果要打开的页和当前显示的是同一页，则不执行
                //当前还在进行窗口切换，则不操作
                if (isAnimating == true) {
                    var etime = new Date();
                    if (btime != null && etime - btime < 1000) {
                        funInfo = { fun: openPage, page: page, animation: animation };
                        return false;
                    }
                }
                isAnimating = true;
                btime = new Date();

                page.prevPage = currentPage;
                var $currPage = currentPage;//有可能是空值
                var $nextPage = page;//当前要打开的窗口

                var pageAni = getAnimStyle(animation);
                outClass = pageAni.outClass;
                inClass = pageAni.inClass;

                //开始进行动画
                function beginAnim() {
                    $nextPage.win.addClass('pt-page-current');
                    if ($currPage != null) {
                        $currPage.win.addClass(outClass).on(animEndEventName, function () {
                            $currPage.win.off(animEndEventName);
                            endCurrPage = true;
                            if (endNextPage) {
                                onEndAnimation($currPage, $nextPage);
                            }
                        });
                    }

                    $nextPage.win.addClass(inClass).on(animEndEventName, function () {
                        $nextPage.win.off(animEndEventName);
                        endNextPage = true;
                        if ($currPage == null) endCurrPage = true;
                        if (endCurrPage) {
                            onEndAnimation($currPage, $nextPage);
                        }
                    });

                    if (!support) {
                        onEndAnimation($currPage, $nextPage);
                    }
                }
                beginAnim();
                etime = new Date();
                currentPage = page;//当前新开的窗口，便是当前窗口了
                pageRtn.name = currentPage.name;
                if (apollo.app != null) {
                    apollo.app.setdata({ apollospaname: pageRtn.name });
                }
            }

            function onEndAnimation($outpage, $inpage) {
                endCurrPage = false;
                endNextPage = false;
                resetPage($outpage, $inpage);
                isAnimating = false;
                if (funInfo != null) {// funInfo = { fun: openPage, page: page, animation: animation };)
                    funInfo.fun(funInfo.page, funInfo.animation);
                    funInfo = null;
                }

                try {
                    emptyEle.remove();
                    var p = $inpage.win;
                    var header = p.find("header");
                    var article = p.find("article");
                    var footer = p.find("footer");
                    if (footer.length > 0) {
                        var h = footer.height();
                        if (h > 0)
                            emptyEle.height(h);
                    }
                    if (article.length > 0) {
                        article.append(emptyEle);
                    }
                }
                catch (e) {

                }
            }

            function resetPage($outpage, $inpage) {
                if ($outpage != null) $outpage.win.attr('class', $outpage.win.data('originalClassList'));
                if ($inpage != null) $inpage.win.attr('class', $inpage.win.data('originalClassList') + ' pt-page-current');
            }

            init();

            return pageRtn;
        }
    });
    $(function () {
        apollo.SPA = $(document.body).PageTransitions();
    });
})(jQuery);


/*
apollo.mobile.baseform
*/
(function (apollo) {
    //枚举
    (function (apollo) {
        apollo.Enum.textType = {
            /// <summary>
            /// 普通文本
            /// </summary>
            Text: 0,
            /// <summary>
            /// 小数
            /// </summary>
            Float: 1,
            /// <summary>
            /// 正小数
            /// </summary>
            UFloat: 2,
            /// <summary>
            /// 整数
            /// </summary>
            Int: 3,
            /// <summary>
            /// 正整数
            /// </summary>
            UInt: 4,
            Number: 5,

            Guid: 6,
            /// <summary>
            /// 日期:yyyy-MM-dd
            /// </summary>
            Date: 7,
            /// <summary>
            /// 月份，即年+月：yyyy-MM
            /// </summary>
            Month: 8,
            /// <summary>
            /// 年份:yyyy
            /// </summary>
            Year: 9,
            /// <summary>
            /// 日期时间,时间部分可精确到秒级，即yyyy-MM-dd HH:mm:ss
            /// </summary>
            DateTime: 10,
            /// <summary>
            /// 时间:hh:MM:tt，精确到秒级
            /// </summary>
            Time: 11,
            Boolean: 12
        };
        apollo.Enum.dataType = {
            /// <summary>
            /// 字符类数据类型，如：string,char等类型的字段
            /// </summary>
            String: 0,
            /// <summary>
            /// 日期型字段,如:datetime
            /// </summary>
            DateTime: 1,
            /// <summary>
            /// 数值类型，可含小数点
            /// </summary>        
            Numeric: 2,
            /// <summary>
            /// 整型类数据
            /// </summary>
            Int: 3,
            /// <summary>
            /// Guid类数据
            /// </summary>
            Guid: 4,
            /// <summary>
            /// 布尔型数据
            /// </summary>
            Bool: 5,
            /// <summary>
            /// 自定义函数参数类
            /// </summary>
            Parament: 9
        };
        apollo.Enum.compareType = {
            /// <summary>
            /// 等于
            /// </summary>
            Equal: 0,
            /// <summary>
            /// 不等于
            /// </summary>
            NoEqual: 1,
            /// <summary>
            /// 包含,指所有地方
            /// </summary>
            Comprise: 2,
            /// <summary>
            /// 左包含，相当于like 'a%';
            /// </summary>
            LeftComprise: 3,
            /// <summary>
            /// 右包含,相当于like '%a';
            /// </summary>
            RightComprise: 4,
            /// <summary>
            /// 不包含
            /// </summary>
            NoComprise: 5,
            /// <summary>
            /// 左不包含
            /// </summary>
            NoLeftComprise: 6,
            /// <summary>
            /// 右不包含
            /// </summary>
            NoRightComprise: 7,
            /// <summary>
            /// 大于等于
            /// </summary>
            BigOrEqual: 8,
            /// <summary>
            /// 小于等于
            /// </summary>
            LessOrEqual: 9,
            /// <summary>
            /// 大于
            /// </summary>
            BigThen: 10,
            /// <summary>
            /// 小于
            /// </summary>
            LessThen: 11,
            /// <summary>
            /// 在之间
            /// </summary>
            Between: 12,
            /// <summary>
            /// 含下级
            /// </summary>
            Chields: 13,
            /// <summary>
            /// 为空值
            /// </summary>
            DBNull: 14,
            /// <summary>
            /// 不为空值
            /// </summary>
            NotDBNull: 15
        };
        apollo.Enum.dateCompareType =
            {
                /// <summary>
                /// 普通，即不受此项条件影响
                /// </summary>
                Normal: 0,
                /// <summary>
                /// 日比较:精确到日
                /// </summary>
                Date: 1,
                /// <summary>
                /// 日期时间比较，精确到具体时间点
                /// </summary>
                DateTime: 2,
                /// <summary>
                /// 月份比较，精确到月份(对于季度比较，可直接通过月份比较方式实现，这里不单独列出)
                /// </summary>
                Month: 3,
                /// <summary>
                /// 年份比较，精确到年份
                /// </summary>
                Year: 4
            };
        apollo.Enum.totalType = {
            /// <summary>
            /// 普通列，不合计
            /// </summary>
            Normal: 0,
            /// <summary>
            /// 汇总列
            /// </summary>
            Sum: 1,
            /// <summary>
            /// 平均列
            /// </summary>
            Avg: 2,
            /// <summary>
            /// 记录数量
            /// </summary>
            Count: 3
        };
        apollo.Enum.sortingMode =
            {
                ASC: 0,
                DESC: 1
            };
        apollo.Enum.itemtype = {
            label: 0,//普通标签，赋值采用html
            image: 1,//图片，赋值采用src,        
            button: 2 //按钮，不实际赋值，给予对象或键值关联data-itemdata:对象，data-itemvalue:对象值
        };
    })(apollo);

    //options定义
    /*进行各form的option默认属性定义*/
    (function (jQuery, apollo) {
        function getenumvalue(EnumObj, v) {
            var objv = parseInt(v);
            if (isNaN(objv)) {
                if (typeof v == "string") {
                    for (var n in EnumObj) {
                        if (n.toLowerCase() == v.toLowerCase()) {
                            objv = EnumObj[n];
                            break;
                        }
                    }
                }
                if (objv == null)
                    objv = 0;
            }
            return objv;
        }
        apollo.form.baseEditor = function (isempty) {
            var isEmpty = isempty == true;
            return {
                name: "",
                isEditor: true,
                textType: apollo.Enum.textType.Text,
                isempty: isEmpty,
                enabled: true,
                visible: true,
                getvalue: function () { return null; },//取到当前编辑项实际值,不管是多选还是单项，所有的值都是具体类型值，如是多项，则是这些值并以","分隔
                gettext: function () { return "" },//取到这些值的显示文本
                setvalue: function (v, t) { },//设置当前编辑项实际值,注意，有两个参数(v,t)，对于值和显示不同的编辑项，则直接按这个设置，如果只设置一个，则由系统内置去取,t为可选参数
                setdefultvalue: function (v) { },//设置默认值
                getdataitem: function () { return null; },//获取当前选中项对象第一个，只对于下接框，选择项等有效，如是多选，则取第一个
                getdataitems: function () { return []; },//获取当前选中的所有对象
                setdata: function (data) {

                },
                getdata: function (data) {
                    return null;
                },
                onselect: null,
                onchange: null,
                isvalid: function () { return true; },//验证当前编辑项是否符合规则,
                setvisible: function (visible) { },//设置编辑项是否可见
                setenabled: function (enabled) { },//设置编辑项是否可用
                loadsource: function (param) {//重新加载数据源，主要用于下拉输入框

                },
                area: null,//当前编辑项所在编辑区域,该属性在单项是无效的
                data: {},//用于扩展,
                box: null, //当前对象元素
                destroy: function () { }, //销毁当前元素
                isdestroy: false
            };
            return rtn;
        },
            apollo.form.aeditorNumber = 0;

        apollo.Options = {
            parseJsonobj: function (container) {
                var t = jQuery(container);
                if (t.length > 0 && t.context == null) {
                    var obj = t.get(0);
                    if (typeof obj == "object") {
                        var arr = [];

                        for (var n in obj) {
                            arr[n.toLowerCase()] = obj[n];
                        }
                        return {
                            Object: container,
                            arrV: arr,
                            getAttr: function (name) {
                                return this.arrV[name.toLowerCase()];
                            }
                        }
                    }
                }
                return {
                    Object: container,
                    getAttr: function (name) {
                        return jQuery(this.Object).attr(name);
                    }
                }
            },
            getOptions: function (container, defOptions, properties) {
                var t = this.parseJsonobj(container);
                var op = jQuery.extend({}, defOptions);
                if (properties) {
                    var opts = {};
                    for (var i = 0; i < properties.length; i++) {
                        var pp = properties[i];
                        if (typeof pp == 'string') {
                            pp = pp.toString();
                            var pv = t.getAttr(pp);
                            if (pv != "" && pv != "null" && pv != null) {
                                opts[pp] = pv;
                            }
                        } else {
                            for (var name in pp) {
                                var type = pp[name];
                                var pv = t.getAttr(name);

                                if (pv != null) {
                                    if (pv.toString() != "" && pv.toString() != "null") {
                                        if (type == "texttype") {
                                            opts[name] = getenumvalue(apollo.Enum.textType, pv);
                                        }
                                        else if (type == 'datatype') {
                                            opts[name] = getenumvalue(apollo.Enum.dataType, pv);
                                        }
                                        else if (type == 'comparetype') {
                                            opts[name] = getenumvalue(apollo.Enum.compareType, pv);
                                        }
                                        else if (type == 'datecomparetype') {
                                            opts[name] = getenumvalue(apollo.Enum.dateCompareType, pv);
                                        }
                                        else if (type == 'totaltype') {
                                            opts[name] = getenumvalue(apollo.Enum.totalType, pv);
                                        }
                                        else if (type == 'sortingmode') {
                                            opts[name] = getenumvalue(apollo.Enum.sortingMode, pv);
                                        }
                                        else if (type == 'itemtype') {
                                            opts[name] = getenumvalue(apollo.Enum.itemtype, pv);
                                        }
                                        else if (type == 'boolean') {
                                            if (typeof pv == "boolean")
                                                opts[name] = pv;
                                            else
                                                opts[name] = (pv.toString() == 'true');
                                        } else if (type == 'number' || type == 'float') {
                                            if (typeof pv == "number")
                                                opts[name] = pv;
                                            else
                                                opts[name] = pv.toString() == '0' ? 0 : apollo.util.toFloat(pv) || undefined;
                                        } else if (type == 'int') {
                                            if (typeof pv == "number")
                                                opts[name] = pv;
                                            else
                                                opts[name] = pv.toString() == '0' ? 0 : apollo.util.toFloat(pv) || undefined;
                                        }
                                        else if (type == "array") {
                                            if (jQuery.isArray(pv))
                                                opts[name] = pv;
                                            else
                                                opts[name] = [];
                                        }
                                        else
                                            opts[name] = pv;
                                    }
                                }
                            }
                        }
                    }
                    op = jQuery.extend(op, opts);
                }
                return op;
            },
            parseOptions: function (optionString, defOptions, properties) {
                var options = {};
                try {
                    if (apollo.Lib.isNotEmpty(optionString)) {
                        var s = jQuery.trim(optionString);
                        if (s) {
                            if (s.substring(0, 1) != '{') {
                                s = '{' + s + '}';
                            }
                            var script = "function(){return " + s + ";}"
                            var fun = apollo.Lib.parseFun(script);
                            if (fun != null) {
                                options = fun();
                            }
                        }
                    }
                }
                catch (e) { }
                return this.getOptions(options, defOptions, properties);
            },
            getGridOptions: function (id, idfield) {
                var op = apollo.Lib.clone(apollo.Options.grid.option);
                op.id = id;
                op.idfield = idfield;
                op.clientEvent = apollo.Lib.clone(apollo.Options.clientEvent.option);
                return op;
            },
            getFunPanelOptions: function (id,entityid) {
                var op = apollo.Lib.clone(apollo.Options.funpanel.option);
                op.id = id;
                op.entityid = entityid;
                return op;
            },
            getRecordOptions: function (id, idfield) {
                var op = apollo.Lib.clone(apollo.Options.record.option);
                op.id = id;
                op.idfield = idfield;
                return op;
            },
            getFilterPanelOptions: function (id,entityid) {
                var op = apollo.Lib.clone(apollo.Options.filterpanel.option);
                op.id = id;
                op.entityid = entityid;
                return op;
            },
            grid: {
                option: {
                    id: "",
                    url: "",
                    title: "",
                    apicontroller: "",
                    apiaction: "",
                    exportUrl: "",
                    isHasNoCol: true,
                    isMutilSelect: false,
                    isAllowPaging: true,
                    isCanExport: false,
                    treefield: "",
                    istree: false,
                    parentidfield: "",
                    paramfun: "",
                    relagrids:"",
                    clientEvent: {},
                    columns: [],
                    filterDivID: '',
                    filters: [],
                    funDivID: '',
                    funs: [],
                    idfield: '',
                    pageSize: 20,
                    sortItems: [],
                    source: null,//内置数据源，即不需要外部数据源（url)，直接由内置数据源取列表数据
                    SetRelationGrid: function (relagrids) {
                        this.relagrids = relagrids;
                        return this;
                    },
                    //设置表格本身
                    SetSource: function (valuefield, textfield, table, sortfield, curfilter, listfield) {
                        this.source = { valuefield: valuefield, textfield: textfield, table: table, sortfield: sortfield, curfilter: curfilter, listfield: listfield };
                        return this;
                    },
                    SetParamFun: function (paramfun) {
                        this.paramfun = paramfun;
                        return this;
                    },
                    SetDataApi: function (apicontroller, apiaction) {
                        this.apicontroller = apicontroller;
                        this.apiaction = apiaction;
                        return this;
                    },
                    SetDataUrl: function (url) {
                        this.url = url;
                        return this;
                    },
                    SetGridType: function (istree, treefield, parentidfield) {
                        this.istree = istree;
                        this.treefield = treefield;
                        this.parentidfield = parentidfield;
                        return this;
                    },
                    SetGridPage: function (isAllowPaging, pageSize) {
                        this.isAllowPaging = isAllowPaging;
                        this.pageSize = pageSize;
                        return this;
                    },
                    SetSelectType: function (isMutilSelect) {
                        this.isMutilSelect = isMutilSelect;
                        return this;
                    },
                    SetOutTool: function (FilterID, FunID) {
                        this.filterDivID = FilterID;
                        this.funDivID = FunID;
                        return this;
                    },
                    SetGridOther: function (exportUrl, isHasNoCol, isMutilSelect, isCanExport) {
                        this.exportUrl = exportUrl;
                        this.isHasNoCol = isHasNoCol;
                        this.isMutilSelect = isMutilSelect;
                        this.isCanExport = isCanExport;
                        return this;
                    },//设置ClientEvent
                    //设置ClientEvent
                    SetInitEvent: function (initFun, loadSuccessFun, rowStylerFun) {
                        this.clientEvent.initFun = initFun;
                        this.clientEvent.loadSuccessFun = loadSuccessFun;
                        this.clientEvent.rowStylerFun = rowStylerFun;
                        return this;
                    },
                    SetClickOptEvent: function (clickRowFun, dblclickRowFun, clickCellFun, dblclickCellFun) {
                        this.clientEvent.clickRowFun = clickRowFun;
                        this.clientEvent.dblClickRowFun = dblclickRowFun;
                        this.clientEvent.clickCellFun = clickCellFun;
                        this.clientEvent.dblClickCellFun = dblclickCellFun;
                        return this;
                    },
                    SetSelOptEvent: function (selectRowFun, unselectRowFun, selectAllFun, unselectAllFun) {
                        this.clientEvent.selectRowFun = selectRowFun;
                        this.clientEvent.unselectRowFun = unselectRowFun;
                        this.clientEvent.selectAllFun = selectAllFun;
                        this.clientEvent.unselectAllFun = unselectAllFun;
                        return this;
                    },
                    AddColumn: function (field, title, width, align, alias) {
                        var column = apollo.Lib.clone(apollo.Options.column.option);
                        column.owner = this;
                        column.field = field;
                        column.title = title;
                        column.width = width;
                        column.align = align;
                        column.fieldalias = alias;
                        this.columns.push(column);
                        return column;
                    },
                    AddFilter: function (field, title, DataType, compareType, dctype, v1, v2,itemtype) {
                        var filter = apollo.Lib.clone(apollo.Options.filter.option);
                        filter.source = apollo.Lib.clone(apollo.Options.source.option);
                        filter.owner = this;
                        filter.field = field;
                        filter.title = title;
                        filter.itemtype = itemtype;
                        if (DataType != null) filter.dataType = DataType;
                        if (compareType != null) filter.compareType = compareType;
                        if (dctype != null) filter.dateCompareType = dctype;
                        if (v1 != null) filter.value1 = v1;
                        if (v2 != null) filter.value2 = v2;

                        this.filters.push(filter);
                        return filter;
                    },
                    AddFun: function (id, title, iconCls, clickFun) {
                        var fun = apollo.Lib.clone(apollo.Options.fun.option);
                        fun.owner = this;
                        fun.SetFun(id, title, iconCls, clickFun);
                        this.funs.push(fun);
                        return fun;
                    },
                    AddSort: function (field, sortmode) {
                        var sort = apollo.Lib.clone(apollo.Options.sort.option);

                        sort.field = field;
                        sort.sorttype = sortmode;

                        this.sortItems.push(sort);

                        return this;
                    },
                    builder: function () {
                        return $("#" + this.id).gridview(this);
                    }
                },
                optionType: [{
                    isHasNoCol: 'boolean',
                    isMutilSelect: 'boolean',
                    isAllowPaging: 'boolean',
                    isCanExport: 'boolean',
                    pageSize: "int"
                },
                    "id",
                    "url",
                    "title",
                    "apicontroller",
                    "apiaction",
                    "exportUrl",
                    "filterDivID",
                    "funDivID",
                    "idfield"
                ]
            },
            record: {//单记录
                option: {
                    id: "",
                    index:0,
                    idfield: "",
                    columns: [],
                    AddColumn: function (field, title, width, align, alias) {
                        var column = apollo.Lib.clone(apollo.Options.column.option);
                        column.owner = this;
                        column.field = field;
                        column.title = title;
                        column.width = width;
                        column.align = align;
                        column.fieldalias = alias;
                        this.columns.push(column);
                        return column;
                    },
                    builder: function () {
                        return $("#ul" + this.id).recordview(this);
                    }
                },
                optionType:[
                    "idfield","id"
                ]
            },
            funpanel: {
                option: {
                    id: "",
                    entityid:"",
                    funs: [],
                    AddFun: function (id, title, iconCls, clickFun) {
                        var fun = apollo.Lib.clone(apollo.Options.fun.option);
                        fun.owner = this;
                        fun.SetFun(id, title, iconCls, clickFun);
                        this.funs.push(fun);
                        return fun;
                    },
                    builder: function () {
                        return $("#" + this.id).gridfunpanel(this);
                    }
                },
                optionType: [{
                    funs:"object"
                }, "id","entityid"]
            },
            filterpanel: {
                option: {
                    id: "",
                    entityid:"",
                    filters: [],
                    AddFilter: function (field, title, DataType, compareType, dctype, v1, v2) {
                        var filter = apollo.Lib.clone(apollo.Options.filter.option);
                        filter.source = apollo.Lib.clone(apollo.Options.source.option);
                        filter.owner = this;
                        filter.field = field;
                        filter.title = title;
                        if (DataType != null) filter.dataType = DataType;
                        if (compareType != null) filter.compareType = compareType;
                        if (dctype != null) filter.dateCompareType = dctype;
                        if (v1 != null) filter.value1 = v1;
                        if (v2 != null) filter.value2 = v2;

                        this.filters.push(filter);
                        return filter;
                    },
                    builder: function () {
                        return $("#" + this.id).gridfilterpanel(this);
                    }
                },
                optionType: [{
                    filters: "object"
                }, "id","entityid"]
            },
            fun: {
                option: {
                    owner: null,
                    id: '',
                    clickFun: null,
                    field: null,
                    iconCls: '',
                    isNeedRecord: false,
                    title: '',
                    isbutton:false,
                    valueByEnabled: '',
                    valueByHide: '',
                    valueByShow: '',
                    valueByUnEnabled: '',
                    auihide: '',
                    auidisabled: '',
                    ModuleFunID: '',
                    ModuleFunCode: '',
                    FunCode:'',
                    SetPower: function (mfid, mfcode, fcode) {
                        this.ModuleFunID = mfid;
                        this.ModuleFunCode = mfcode;
                        this.FunCode = fcode;
                        return this;
                    },
                    SetIsButton: function (isb) {
                        this.isbutton = isb;
                        return this;
                    },
                    SetAuiHide: function (jsexp) {
                        this.auihide = jsexp;
                        return this;
                    },
                    SetAuiDisabled: function (jsexp) {
                        this.auidisabled = jsexp;
                        return this;
                    },
                    SetShowStatus: function (field, valueByEnabled, valueByHide, valueByShow, valueByUnEnabled) {
                        this.field = field;
                        this.valueByEnabled = valueByEnabled;
                        this.valueByHide = valueByHide;
                        this.valueByShow = valueByShow;
                        this.valueByUnEnabled = valueByUnEnabled;
                        return this;
                    },
                    SetIsNeedRecord: function (isneedrecord) {
                        this.isNeedRecord = isneedrecord;
                        return this;
                    },
                    Grid: function () {
                        return this.owner;
                    },
                    FunPanel: function () {
                        return this.owner;
                    },
                    SetFun: function (id, title, iconCls, clickFun) {
                        this.id = id;
                        this.title = title;
                        this.iconCls = iconCls;
                        this.clickFun = clickFun;
                        return this;
                    }
                },
                optionType: [{
                    isNeedRecord: "boolean"
                },
                    "iconCls",
                    "id",
                    "field",
                    "title",
                    "clickFun",
                    "valueByEnabled",
                    "valueByHide",
                    "valueByShow",
                    "valueByUnEnabled",
                    "auihide",
                    "auidisabled"
                ]
            },
            filter: {
                option: {
                    owner: null,
                    field: "",
                    title: "",
                    dataType: apollo.Enum.dataType.String,
                    dateCompareType: apollo.Enum.dateCompareType.Normal,
                    compareType: apollo.Enum.compareType.Equal,
                    width: 0,
                    itemtype: 0,
                    isshortcut: false,
                    isnormal: true,
                    isadvance: false,
                    hideFilterDefine: null,
                    refFilterSource:null,
                    panelWidth: 0,
                    minYearSpan: -50,
                    maxYearSpan: 3,
                    popupQueryID: "",
                    customwinurl:"",
                    customwinparamfun: "",
                    winwidth: 0,
                    winheight: 0,

                    isBR: false,
                    customGetValueFun: null,
                    allowEmpty: false,
                    filtertype: 0,//0-普通,1-下拉,2-弹出
                    GetTextUrl: "",
                    GetValueUrl: "",
                    InitFun: null,
                    source: null,
                    popupsource: null,
                    customsource:null,//自定义数据源{queryid:'',field:'',title:''}
                    GroupInfo: "",
                    IsHasFilter:false,
                    value1: '',
                    value2: '',
                    LinkageItemName : "",
                    LinkageFilterField : "",
                    IsOnlyForLinkage :false,
                    LinkageFieldValueType: 0,

                    LinkFilterItems:"",


                    SetComboLinkage: function (LinkageItemName, LinkageFilterField, IsOnlyForLinkage, LinkageFieldValueType) {
                        this.LinkageItemName = LinkageItemName;
                        this.LinkageFilterField = LinkageFilterField;
                        this.IsOnlyForLinkage = IsOnlyForLinkage;
                        this.LinkageFieldValueType = LinkageFieldValueType;

                        return this;
                    },
                    SetHideFilterDefine: function (define, LinkFilterItems) {
                        this.hideFilterDefine = define;
                        this.LinkFilterItems = LinkFilterItems;
                        return this;
                    },
                    SetRefFilterSource: function (define) {
                        this.refFilterSource = define;
                        return this;
                    },
                    SetInputHelper: function (queryid, paramfun, width, height) {
                        this.popupQueryID = queryid;
                        this.customwinparamfun = paramfun;
                        this.winwidth = width;
                        this.winheight = height;
                        return this;
                    },
                    SetCustomWinUrl: function (customwinurl, paramfun, width, height) {
                        this.customwinurl = customwinurl;
                        this.customwinparamfun = paramfun;
                        this.winwidth = width;
                        this.winheight = height;
                        return this;
                    },
                    SetGroupInfo: function (groupInfo,ishasfilter) {
                        this.GroupInfo = groupInfo;
                        this.IsHasFilter = ishasfilter;
                        return this;
                    },
                    SetDCType: function (dataType, ctype, dateCType) {
                        this.dataType = dataType;
                        this.compareType = ctype;
                        this.dateCompareType = dateCType;
                        return this;
                    },
                    SetValueInfo: function (value1, value2) {
                        this.value1 = value1;
                        this.value2 = value2;
                        return this;
                    },
                    SetOther: function (width, panelWidth, minYearSpan, maxYearSpan) {
                        this.width = width;
                        this.panelWidth = panelWidth;
                        this.minYearSpan = minYearSpan;
                        this.maxYearSpan = maxYearSpan;
                        return this;
                    },
                    SetFilterType: function (isshortcut,isnormal,isadvance) {
                        this.isshortcut = isshortcut;
                        this.isnormal = isnormal;
                        this.isadvance = isadvance;
                        
                        return this;
                    },
                    SetIsBR: function (isBR) {
                        this.isBR = isBR;
                        return this;
                    },
                    SetIsAllowEmpty: function (allowEmpty) {
                        this.allowEmpty = allowEmpty;
                        return this;
                    },
                    SetCustomSQL:function(queryid) {
                        this.filtertype = 1;
                        this.customsource = {queryid:queryid,field:this.field,title:this.title};
                        return this;
                    },
                    SetDataItems: function (data, ValueField, TextField) {
                        this.filtertype = 1;
                        if (this.source == null) this.source = apollo.Lib.clone(apollo.Options.source.option);
                        this.source.data = data;
                        this.source.valuefield = ValueField;
                        this.source.textfield = TextField;
                        return this;
                    },
                    AddDataItem: function (Value, Text) {
                        this.filtertype = 1;
                        if (this.source == null) {
                            this.source = apollo.Lib.clone(apollo.Options.source.option);
                            this.source.valuefield = "Value";
                            this.source.textfield = "Text";
                        }
                        else if (apollo.Lib.isEmpty(this.source.valuefield) || apollo.Lib.isEmpty(this.source.textfield)) {
                            this.source.valuefield = "Value";
                            this.source.textfield = "Text";
                        }


                        if (this.source.data == null) this.source.data = [];
                        var item = { Value: Value, Text: Text };
                        this.source.data.push(item);
                        return this;
                    },
                    SetWebApi: function (controller, action, ValueField, TextField) {
                        this.source = apollo.Lib.clone(apollo.Options.source.option);
                        this.source.apicontroller = controller;
                        this.source.apiaction = action;
                        this.source.valuefield = ValueField;
                        this.source.textfield = TextField;
                        return this;
                    },
                    SetPopupDefine: function (istree, valuefield, textfield, table, sortfield, curfilter, url, width, height, GetTextUrl, GetValueUrl, InitFun) {
                        this.filtertype = 2;
                        if (this.popupsource == null) {
                            this.popupsource = apollo.Lib.clone(apollo.Options.popupSource.option);
                            this.popupsource.columns = [];
                        }
                        this.GetTextUrl = GetTextUrl;
                        this.GetValueUrl = GetValueUrl;
                        this.InitFun = InitFun;
                        this.popupsource.istree = istree;
                        this.popupsource.valuefield = valuefield;
                        this.popupsource.textfield = textfield;
                        this.popupsource.table = table;
                        this.popupsource.sortfield = sortfield;
                        this.popupsource.curfilter = curfilter;
                        this.popupsource.url = url;
                        this.popupsource.width = width;
                        this.popupsource.height = height;
                        return this;
                    },
                    AddPopupColumns: function (field, caption, width, dataType, isFilter) {
                        if (this.popupsource == null) {
                            this.popupsource = apollo.Lib.clone(apollo.Options.popupSource.option);
                            this.popupsource.columns = [];
                        }
                        this.popupsource.columns.push({
                            DataField: field,
                            Width: width,
                            Caption: caption,
                            DataType: dataType,
                            IsCanFilter: isFilter
                        });
                        return this;
                    },
                    SetSourceUrl: function (url, ValueField, TextField) {
                        this.filtertype = 1;
                        this.source = apollo.Lib.clone(apollo.Options.source.option);
                        this.source.url = url;
                        this.source.valuefield = ValueField;
                        this.source.textfield = TextField;
                        return this;
                    },
                    SetSourceTable: function (table, sortfield, curfilter, ValueField, TextField) {
                        this.filtertype = 1;
                        this.source = apollo.Lib.clone(apollo.Options.source.option);
                        this.source.table = table;
                        this.source.sortfield = sortfield;
                        this.source.curfilter = curfilter;
                        this.source.valuefield = ValueField;
                        this.source.textfield = TextField;
                        return this;
                    },
                    Grid: function () {
                        return this.owner;
                    },
                    FilterPanel: function () {
                        return this.owner;
                    }
                },
                optionType: [{
                    dataType: "datatype",
                    dateCompareType: "datecomparetype",
                    compareType: "comparetype",
                    hideFilterDefine: "object",
                    LinkFilterItems:"",
                    refFilterSource:"object",
                    width: "int",
                    panelWidth: "int",
                    minYearSpan: "int",
                    maxYearSpan: "int",
                    isBR: "boolean",
                    source: "object",
                    allowEmpty: "boolean",
                    isshortcut: "boolean"
                },
                    "field",
                    "title",
                    "customGetValueFun",
                    "value1",
                    "value2",
                    "LinkFilterItems"
                ]
            },
            column: {
                option: {
                    owner: null,
                    parent: null,
                    field: "",
                    fieldalias: "",
                    title: "",
                    hidden:false,
                    align: "center",
                    caseWhenList: "",
                    childs: [],
                    dataFormat: "",
                    elseValue: "",
                    formatterFun: null,
                    isRowMerge: false,
                    issortable: "",
                    sortExpression: "",
                    stylerFun: null,
                    totalType: 0,
                    width: "",
                    displayField: "",
                    relationField: "",
                    relationTable: "",
                    curFilter: "",
                    IsEncryData : false,
                    EncryDataType : 0,
                    SetHidden: function (ishidden) {
                        hidden = ishidden;
                        return this;
                    },
                    SetEncryInfo: function (isencrydata, edatatype) {
                        this.IsEncryData = isencrydata;
                        this.EncryDataType = edatatype;
                        return this;
                    },
                    SetColumn: function (field, title, align, width, alias) {
                        this.field = field;
                        this.title = title;
                        this.align = align;
                        this.width = width;
                        this.fieldalias = alias;
                        return this;
                    },
                    SetShowInfo: function (dataFormat, caseWhenList, elseValue, formatterFun, stylerFun, totalType) {
                        this.dataFormat = dataFormat;
                        this.caseWhenList = caseWhenList;
                        this.elseValue = elseValue;
                        this.formatterFun = formatterFun;
                        this.stylerFun = stylerFun;
                        this.totalType = totalType;
                        return this;
                    },
                    SetRowAndSort: function (isRowMerge, IsSortable, sortExpression) {
                        this.isRowMerge = isRowMerge;
                        this.issortable = IsSortable;
                        this.sortExpression = sortExpression;
                        return this;
                    },
                    SetRelation: function (relationTable, relationField, displayField, curFilter) {
                        this.relationTable = relationTable;
                        this.relationField = relationField;
                        this.displayField = displayField;
                        this.curFilter = curFilter;
                        return this;
                    },
                    AddChildColumn: function (field, title, width, align, alias) {
                        var column = apollo.Lib.clone(apollo.Options.column.option);

                        column.parent = this;
                        column.owner = this.owner;

                        column.field = field;
                        column.title = title;
                        column.width = width;
                        column.align = align;
                        column.fieldalias = alias;

                        this.childs.push(column);
                        return column;
                    },
                    Grid: function () {
                        return this.owner;
                    },
                    Record: function () {
                        return this.owner;
                    },
                    ParentColumn: function () {
                        if (this.parent == null)
                            return this;
                        else
                            return this.parent;
                    }
                },
                optionType: [{
                    totalType: "totaltype",
                    isRowMerge: "boolean",
                    issortable: "boolean",
                    childs: "array"
                },
                    "align",
                    "caseWhenList",
                    "field",
                    "dataFormat",
                    "elseValue",
                    "title",
                    "formatterFun",
                    "stylerFun",
                    "sortExpression",
                    "width",
                    "displayField",
                    "relationField",
                    "relationTable",
                    "curFilter"
                ]
            },
            sort: {
                option: {
                    field: "",
                    sorttype: "asc"
                },
                optionType: [
                    "field",
                    { sorttype: "sortingmode" }]
            },
            clientEvent: {
                option: {
                    execFilterSqlFun: "",
                    clickRowFun: "",
                    dblClickRowFun: "",
                    clickCellFun: "",
                    dblClickCellFun: "",
                    selectRowFun: "",
                    unselectRowFun: "",
                    selectAllFun: "",
                    unselectAllFun: "",
                    initFun: "",
                    loadSuccessFun: "",
                    rowStylerFun: ""
                },
                optionType: [
                    "execFilterSqlFun",
                    "clickRowFun",
                    "dblClickRowFun",
                    "clickCellFun",
                    "dblClickCellFun",
                    "selectRowFun",
                    "unselectRowFun",
                    "selectAllFun",
                    "unselectAllFun",
                    "initFun",
                    "loadSuccessFun",
                    "rowStylerFun"
                ]
            },
            source: {
                option: {
                    valuefield: '',
                    textfield: '',
                    table: '',
                    sortfield: '',
                    curfilter: '',
                    listfield: "",
                    url: '',
                    apicontroller: '',
                    apiaction: '',
                    paramfun: '',//ajax数据源获取参数的方法,主要针对url 和 apicontroller两类
                    data: null
                },
                optionType: [
                    { data: 'array' },
                    "valuefield",
                    "textfield",
                    "table",
                    "sortfield",
                    "curfilter",
                    'listfield',
                    "url",
                    "apicontroller",
                    "apiaction",
                    "paramfun"
                ]
            },
            popupSource: {
                option: {
                    istree: false,
                    valuefield: '',
                    textfield: '',
                    table: '',
                    sortfield: '',
                    curfilter: '',
                    listfield: "",
                    winurl: '',//自定义窗体URL，如果已设置这一项，则由自定义窗口处理
                    paramfun: '',//自定义窗体获取参数的方法
                    url: '',
                    apicontroller: '',
                    apiaction: '',
                    data: null,
                    width: 0,
                    height: 0,
                    columns: [],//{field:'',title:'',width:'',}
                    filters: []//{field:"" title:"" width:"" dataformat:"" align:"center" }
                },
                optionType: [
                    {
                        istree: "boolean",
                        data: 'array',
                        width: 'number',
                        height: 'number',
                        columns: 'array',
                        filters: 'array'
                    },
                    "valuefield",
                    "textfield",
                    "table",
                    "sortfield",
                    "curfilter",
                    'listfield',
                    "winurl",
                    'paramfun',
                    "url",
                    "apicontroller",
                    "apiaction"
                ]
            },
            viewArea: {
                option: {
                    name: "",
                    url: '',//获取到当前区域数据对象的url
                    apicontroller: '',
                    apiaction: '',
                    arrayArea: null,
                    data: null//获取当前区域数据对象
                },
                optionType: [{
                    arrayArea: "object",
                    data: "object"
                },
                    "url", "apicontroller", "apiaction", "name"]

            },
            fromArea: {
                option: {
                    name: "",
                    url: '',//获取到当前区域数据对象的url
                    apicontroller: '',
                    apiaction: '',
                    arrayArea: null,
                    data: null//获取当前区域数据对象
                },
                optionType: [{
                    arrayArea: "object",
                    data: "object"
                },
                    "url", "apicontroller", "apiaction", "name"]
            },
            arrayArea: {
                option: {
                    name: "",
                    rowformatfun: "",//用于格式化行的方法，如已设置，则默认以这个来填充行数据function(rowPanel,rowdata){}
                    data: null//获取当前区域数据对象
                },
                optionType: [{
                    data: "object"
                },
                    "name", "rowformatfun"]
            },
            viewitem: {
                option: {
                    area: null,
                    name: '',
                    field: '',//实际绑定的字段属性，如果值为空，则以name绑定的为准
                    type: 0,
                    format: '',//显示时格式化处理：日期,数字，货币等
                    itempanelid: "",
                    textType: 0,//详见apollo.Enum.textType枚举对象
                    casewhenlist: "",
                    elsevalue: "",
                    clickfun: "",
                    viewfun: "" //自定义呈现方法参数：function(obj,vaule,itemData)
                },
                optionType: [{
                    area: "object",
                    textType: "texttype",
                    type: "itemtype"
                }, "name", "field", "format", "itempanelid", "casewhenlist", "elsevalue", "clickfun", "viewfun"]
            },
            switchbox: {
                option: {
                    area: null,
                    name: '',//绑定的对象，必输项，如不输入，则不计为组件
                    showtext: false,
                    css: '',
                    textType: 12,//详见apollo.Enuy.textType枚举对象
                    defaultValue: "",
                    onchange: ""//值改变时执行的方法名,function(v){}
                }, optionType: [{
                    area: "object",
                    textType: "texttype",
                    showtext: "boolean"
                }, "name", "title", "css", "defaultValue", "onchange"]
            },
            input: {
                option: {
                    area: null,
                    name: '',//绑定的对象，必输项，如不输入，则不计为组件
                    defaultValue: "",
                    validType: "",
                    width: 0,
                    editable: true,
                    easyui: false,
                    allowEmpty: true,
                    showSeconds: true,
                    itempanelid: "",
                    precision: 2,
                    textType: 0,//详见apollo.Enuy.textType枚举对象
                    onchange: "",//值改变时执行的方法名,function(v){}
                    onselect: ""//
                }, optionType: [
                    {
                        area: "object",
                        width: "number",
                        editable: "boolean",
                        easyui: "boolean",
                        allowEmpty: "boolean",
                        textType: "texttype",
                        showSeconds: "boolean",
                        precision: "int"
                    },
                    "itempanelid",
                    "name", "onchange",
                    "defaultValue", "onselect"
                ]
            },
            label: {
                option: {
                    area: null,
                    name: '',//绑定的对象，必输项，如不输入，则不计为组件
                    defaultValue: "",
                    validType: "",
                    width: 0,
                    itempanelid: "",
                    textType: 0,//详见apollo.Enuy.textType枚举对象
                    casewhenlist: "",
                    elsevalue: ""
                }, optionType: [
                    {
                        area: "object",
                        width: "number",
                        textType: "texttype"
                    },
                    "itempanelid",
                    "name", "onchange",
                    "defaultValue", "onselect", "casewhenlist", "elsevalue"
                ]
            },
            file: {
                option: {
                    area: null,
                    name: '',//绑定的对象，必输项，如不输入，则不计为组件
                    width: 0,
                    isimage: false,
                    allowEmpty: true,
                    isonline: false,//是否可以在线进行文件查看管理
                    nochangename: true,//不改变原文件名
                    itempanelid: "",
                    valueType: 0,
                    mutilselect: false,//是否为单文件上传还是多文件上传
                    fpathconfig: '',//上传保存的物理路径配置,如为空，则取系统设置(fpathconfig和vpathconfig必须配对设置)
                    vpathconfig: '',//上传保存后访问的虚拟路径配置，如为空，则取系统默认设置(fpathconfig和vpathconfig必须配对设置)
                    fileMaxSize: 51200000,//上传文件最大路径
                    acceptExtensions: ['*.*'],//上传文件可接收的文件类型
                    onchange: "",//值改变时执行的方法名,function(v){}
                    onselect: ""//
                }, optionType: [
                    {
                        area: "object",
                        isimage: "boolean",
                        width: "number",
                        allowEmpty: "boolean",
                        mutilselect: "boolean",
                        valueType: "int",
                        fileMaxSize: "int"
                    },
                    "itempanelid",
                    "name", "onchange",
                    "fpathconfig", "vpathconfig", "onselect"
                ]
            },
            customfile: {
                option: {
                    area: null,
                    name: '',//绑定的对象，必输项，如不输入，则不计为组件
                    btnid: '',
                    width: 0,
                    isimage: false,
                    allowEmpty: true,
                    isonline: false,//是否可以在线进行文件查看管理
                    nochangename: true,//不改变原文件名
                    itempanelid: "",
                    valueType: 0,
                    mutilselect: false,//是否为单文件上传还是多文件上传
                    fpathconfig: '',//上传保存的物理路径配置,如为空，则取系统设置(fpathconfig和vpathconfig必须配对设置)
                    vpathconfig: '',//上传保存后访问的虚拟路径配置，如为空，则取系统默认设置(fpathconfig和vpathconfig必须配对设置)
                    fileMaxSize: 51200000,//上传文件最大路径
                    onchange: "",//值改变时执行的方法名,function(v){}
                    onselect: "",
                    onupload: ""//
                }, optionType: [
                    {
                        area: "object",
                        isimage: "boolean",
                        width: "number",
                        allowEmpty: "boolean",
                        mutilselect: "boolean",
                        valueType: "int",
                        fileMaxSize: "int"
                    }, "btnid",
                    "itempanelid",
                    "name", "onchange",
                    "fpathconfig", "vpathconfig", "onselect", "onupload"
                ]
            },
            checkbox: {  //其值固定为textType.Boolean,属性textType设置是无效的
                option: {
                    area: null,
                    name: '',//绑定的对象，必输项，如不输入，则不计为组件
                    defaultValue: "",
                    width: 0,
                    allowEmpty: true,
                    textType: 0,
                    onchange: ""//值改变时执行的方法名,function(v){}
                }, optionType: [
                    {
                        area: "object",
                        width: "number",
                        allowEmpty: "boolean",
                        textType: "texttype"
                    },
                    "name", "onchange",
                    "defaultValue"
                ]
            },
            radiobox: {
                option: {
                    area: null,
                    name: '',//绑定的对象，必输项，如不输入，则不计为组件
                    defaultValue: "",
                    width: 0,
                    allowEmpty: true,
                    textType: 0,//详见apollo.Enuy.textType枚举对象
                    onchange: ""//值改变时执行的方法名,function(v){}
                }, optionType: [
                    {
                        area: "object",
                        width: "number",
                        allowEmpty: "boolean",
                        textType: "texttype"
                    },
                    "name", "onchange",
                    "defaultValue"
                ]
            },
            checkList: {
                option: {
                    area: null,
                    name: '',
                    defaultValue: "",
                    width: "",
                    allowEmpty: true,
                    textType: 0,//详见apollo.Enum.textType枚举对象
                    valueType: 0,//0-普通字符串，用,分开,1-数组，如果不设置，则在设置值时，如果对象值为数组，则自动调整为数组，否则为字符连串
                    source: null,
                    onchange: "",//值改变时执行的方法名,function(v){}
                    onselect: ""//选中列项时执行的方法名,function(data){}
                },
                optionType: [
                    {
                        area: "object",
                        allowEmpty: "boolean",
                        width: "number",
                        source: "object",
                        textType: "texttype",
                        valueType:"int"
                    },
                    "name", "onchage", "onselect", "defaultValue"
                ]
            },
            selecttree: {
                option: {
                    editable: false,
                    textField: "",
                    allowEmpty: true,
                    textType: 0,
                    source: null
                },
                optionType: [
                    {
                        editable: "boolean",
                        allowEmpty: "boolean",
                        source: "object",
                        textType:"texttype"
                    }, "textField"
                ]
            },
            select: {
                option: {
                    area: null,
                    name: '',
                    defaultValue: "",
                    width: 0,
                    easyui: false,
                    allowEmpty: true,
                    showItemIcon: false,
                    textType: 0,
                    mutilselect: false,
                    editable: false,
                    source: { valuefield: "value", textfield: "text" },
                    onchange: "",//值改变时执行的方法名,function(v){}
                    onselect: ""//选中列项时执行的方法名,function(data){}
                },
                optionType: [
                    {
                        area: "object",
                        width: "number",
                        allowEmpty: "boolean",
                        textType: "texttype",
                        easyui: "boolean",
                        showItemIcon:"boolean",
                        mutilselect: "boolean",
                        editable: "boolean",
                        source: "object"
                    },
                    "name",
                    "defaultValue",
                    "onchange",//值改变时执行的方法名,function(v){}
                    "onselect"//选中列项时执行的方法名,function(data){}
                ]
            },
            popup: {
                option: {
                    area: null,
                    name: '',
                    width: 200,
                    allowEmpty: true,
                    editable: false,
                    defaultValue: "",
                    textType: 0,
                    valueType: 0,//0-普通字符串，1-对应数组集合
                    showType: 0,//显示方式，0为普通输入框，1，列项输入框
                    mutilselect: false,
                    valueType: 0,//0-普通字符串，1-对应数组集合
                    source: null,
                    onchange: "",//值改变时执行的方法名,function(v){}
                    onselect: ""//选中列项时执行的方法名,function(rowData){}
                },
                optionType: [{
                    object: "object",
                    width: "number",
                    valueType: "int",
                    showType: "int",
                    allowEmpty: "boolean",
                    editable: "boolean",
                    mutilselect: "boolean",
                    textType: "texttype",
                    source: "object"
                }, "name", "onchange", "onselect", "defaultValue"]
            },
            reflashbox: {
                option: {
                    reflashFun: ""
                },
                optionType: ["reflashFun"]
            }
        };
    })(jQuery, apollo);
})(apollo);

/*
apollo form
*/
(function (jQuery, apollo) {
    var frmAreas = {};//用于保存当前页面所有区域对象信息
    var funList = [];//用于保存表单页面初始化时要执行的外部方法
    var areaNumber = 0;//用于表示未设表单名的区域ID
    var isformloaded = false;
    function getDataSource(sourceOption, successFun) {
        //优先url取值
        var url = "";
        var method = function (url,param, success) {
            if (url == null) return;
            apollo.ajax(url,param, success, function (errMsg) {
                apollo.showNotice(errMsg);
            });
        };
        var getparamfun = null;
        var param = {};

        if (apollo.Lib.isNotEmpty(sourceOption.paramfun)) {
            getparamfun = apollo.Lib.parseFun(sourceOption.paramfun);
        }

        if (jQuery.isFunction(getparamfun)) {
            param = getparamfun();
        }
        if (param == null || !jQuery.isPlainObject(param)) param = {};


        if (sourceOption == null) {
            successFun([]);
        }
        else if (apollo.Lib.isNotEmpty(sourceOption.url)) {
            url = sourceOption.url;
            method(url,param ,successFun);
        }
        else if (apollo.Lib.isNotEmpty(sourceOption.apicontroller) && apollo.Lib.isNotEmpty(sourceOption.apiaction)) {
            url = apollo.getApiUrl(sourceOption.apicontroller, sourceOption.apiaction);
            method(url, param, successFun);
        }
        else if (apollo.Lib.isNotEmpty(sourceOption.valuefield) && apollo.Lib.isNotEmpty(sourceOption.textfield) && apollo.Lib.isNotEmpty(sourceOption.table)) {
            url = apollo.pageInfo.base + "src/ApolloUIHandler.ashx?action=GetDataSource&idfield=" + sourceOption.valuefield + "&textfield=" + sourceOption.textfield + "&table=" + sourceOption.table + "&sortfield" + sourceOption.sortfield + "&curfilter=" + sourceOption.curfilter
            method(url, param,successFun);
        }
        else if (jQuery.isArray(sourceOption.data)) {
            successFun(sourceOption.data);
        }
        else
            successFun([]);
    }
    function parseOption(continer, optionDef, sourceDef) {
        var box = jQuery(continer);
        var options = box.attr("data-options");
        var options = apollo.Options.parseOptions(options, optionDef.option, optionDef.optionType);

        var source = box.attr("data-source");
        if (sourceDef != null && apollo.Lib.isNotEmpty(source))
            options.source = apollo.Options.parseOptions(source, sourceDef.option, sourceDef.optionType);
        return options;
    }


    function addItems(items, v) {
        var isadd = false;
        for (var i = 0; i < items.length; i++) {
            if (v == items[i]) {
                isadd = true;
                break;
            }
        }
        if (!isadd) {
            items.push(v);
        }
        return items;
    }
    function removeItem(items, v) {
        var arr = [];
        for (var i = 0; i < items.length; i++) {
            if (v != items[i]) {
                arr.push(items[i]);
            }
        }
        return arr;
    }
    //根据值的类型，取实际值(字符、日期时间、GUID均是以字符串表示
    function getValueTypeV(v, textType) {
        if (apollo.Lib.isEmpty(v)) {
            if (apollo.Lib.isIn(textType, [1, 2, 3, 4, 5])) //数值
                return 0;
            else if (textType == 7 || textType == 10) //日期
                return "0001-01-01 00:00:00";
            else if (textType == 12) //Boolean
                return false;
            else if (textType == 6)//Guid
                return "00000000-0000-0000-0000-000000000000";
            else
                return v;
        }
        else {
            if (apollo.Lib.isIn(textType, [1, 2, 5])) //数值
                return apollo.util.toFloat(v);
            else if (apollo.Lib.isIn(textType, [3, 4]))
                return apollo.util.toInt(v);
            else if (textType == 12) //Boolean
                return apollo.util.toBoolean(v);
            else if (textType == 6)//Guid
                return apollo.util.toGuid(v);
            else if (apollo.Lib.isIn(textType, [7, 10]))//日期
                return apollo.util.toDateTimeString(v);
            else
                return v;
        }
    }
    function getDefaultValue(valueType) {
        if (apollo.Lib.isIn(op.textType, [1, 2, 3, 4, 5])) //数值
            return 0;
        else if (op.TextType == 12) //Boolean
            return false;
        else
            return "";
    }
    function toRSLtextType(textType) {
        if (textType == 0)
            return 0;
        else if (textType == 1)
            return 1;
        else if (textType == 2)
            return 2;
        else if (textType == 3)
            return 3;
        else if (textType == 4)
            return 4;
        else if (textType == 5)
            return 1;
        else if (textType == 6)
            return 22;
        else if (textType == 7)
            return 12;
        else if (textType == 8)
            return 13;
        else if (textType == 9)
            return 14;
        else if (textType == 10)
            return 15;
        else if (textType == 11)
            return 16;
        else if (textType == 12)
            return 21;
        else
            return 0;
    }
    //自动加载form内容
    function autoLoadform(app) {

        //自动加载所有标记了的对象        
        var areas = jQuery(".apolloui-area");
        var areaoptions;
        jQuery(areas).each(function (i, area) {
            areaoptions = parseOption(area, apollo.Options.fromArea);
            var name = areaoptions.name;
            if (apollo.Lib.isEmpty(name)) {
                areaNumber++;
                name = "frmAreaAutoName" + areaNumber;
            }
            frmAreas[name] = jQuery(area).formArea(areaoptions);
        });

        areas = jQuery(".apolloui-arrayarea");
        jQuery(areas).each(function (i, area) {
            areaoptions = parseOption(area, apollo.Options.arrayArea);
            var name = areaoptions.name;
            if (apollo.Lib.isEmpty(name)) {
                areaNumber++;
                name = "frmAreaAutoName" + areaNumber;
            }
            frmAreas[name] = jQuery(area).arrayArea(areaoptions);
        });

        var reflashboxs = jQuery(".apollo-reflashbox");
        if (reflashboxs.length > 0) {
            jQuery(reflashboxs).each(function (i, box) {
                var edtOptions = parseOption(box, apollo.Options.reflashbox);
                jQuery(box).reflashbox(edtOptions);
            });
        }

        //自动加载页面内容
        for (var areaName in frmAreas) {
            try {
                frmAreas[areaName].parseLayer(app.getdata(), app);
            }
            catch (e) { showNotice("apollo.Form.parseLayer " + areaName + " Error：" + e.message); }
        }
        isformloaded = true;
        //加载完之后，调用初始化方法
        jQuery(funList).each(function (i, fun) {
            if (jQuery.isFunction(fun)) {
                fun();
            }
        });
        fun = [];//清空队列        
    }
    function getFileName(f) {
        var fn = f;
        var index = fn.lastIndexOf("/");
        if (index >= 0 && index < fn.length - 1) {
            fn = fn.substring(index + 1, fn.length - 1);
            index = fn.lastIndexOf(".");
            if (index >= 0 && index < fn.length - 1) {
                fn = fn.substring(0, index);
            }
        }
        else
            fn = "";
        return fn;
    }
    function GetCaseWhen(v, casewhenlist, elsevalue) {
        if (v == null) return "";
        if (apollo.Lib.isEmpty(casewhenlist)) return v;
        var lists = casewhenlist.split(',');
        if (lists.length == 0) return "";
        for (var i = 0; i < lists.length; i++) {
            var items = lists[i].split(':');
            if (items.length <= 1) return;
            if (apollo.Lib.isEquals(items[0], v))
                return items[1];
        }

        if (apollo.Lib.isNotEmpty(elsevalue))
            return elsevalue;
        else
            return "";
    }
    var clboxnum = 0;
    jQuery.fn.extend({
        touchutil: function (options) {
            var panel = jQuery(this);
            var defaults = {
                onstart: null,
                ontouching: null,
                onend: null
            };
            var op = jQuery.extend(defaults, options);

            var isend = false;//是否已经停止
            var curisistouch = false;

            var beginX, beginY;
            var beginTop, beginLeft;

            var hastouch = false;//是否有滑动


            beginTop = parseInt(panel.css("top"));
            if (isNaN(beginTop)) beginTop = 0;
            beginLeft = parseInt(panel.css("left"));
            if (isNaN(beginLeft)) beginLeft = 0;


            var curTop, curLeft, curX, curY;

            var rtnObj = {
                body: panel,
                beginTop: function () {
                    return beginTop;
                },
                beginLeft: function () {
                    return beginLeft;
                },
                offset: function () {
                    return {
                        beginX: beginX,
                        beginY: beginY,
                        beginTop: beginTop,
                        beginLeft: beginLeft,
                        x: curX,
                        y: curY,
                        top: curTop,
                        left: curLeft,
                        istotop: curTop < beginTop,// 向上滑动
                        istodown: curTop > beginTop,//向下滑动
                        istoleft: curLeft > beginLeft,//向右滑动
                        istoright: curLeft < beginLeft //向左滑动
                    }
                },
                stop: function () {
                    if (isend == true) return;//如果已经停止了，则不再执行停止
                    endtouch(panel, curisistouch);
                }
            }



            function getY(e, istouch) {
                if (istouch) {
                    var _touch = e.originalEvent.targetTouches[0];
                    var _y = _touch.pageY;
                    return _y;
                }
                else {
                    return e.pageY;
                }
            }
            function getX(e, istouch) {
                if (istouch) {
                    var _touch = e.originalEvent.targetTouches[0];
                    var _x = _touch.pageX;
                    return _x;
                }
                else {
                    return e.pageX;
                }
            }
            function getEndY(e, istouch) {
                if (istouch) {
                    var _touch = e.originalEvent.changedTouches[0];
                    var _y = _touch.pageY;
                    return _y;
                }
                else {
                    return e.pageY;
                }
            }
            function getEndX(e, istouch) {
                if (istouch) {
                    var _touch = e.originalEvent.changedTouches[0];
                    var _x = _touch.pageX;
                    return _x;
                }
                else {
                    return e.pageX;
                }
            }
            function onstart(e, istouch, div) {
                isend = false;
                hastouch = false;
                beginTop = parseInt(div.css("top"));
                if (isNaN(beginTop)) beginTop = 0;
                beginLeft = parseInt(div.css("left"));
                if (isNaN(beginLeft)) beginLeft = 0;

                beginX = getY(e, istouch);
                beginY = getY(e, istouch);

                curTop = beginTop;
                curLeft = beginLeft;
                curX = beginX;
                curY = beginY;

                if (op.onstart != null)
                    op.onstart(rtnObj);

                curisistouch = istouch;

                var movefun = function (es) {
                    hastouch = true;
                    var y = getY(es, istouch);
                    var x = getX(es, istouch);

                    curTop = y - beginY + beginTop;
                    curLeft = x - beginX + beginLeft;

                    if (op.onstart != null)
                        op.onstart(beginX, beginY, beginTop, beginLeft);

                    if (op.ontouching != null) {
                        op.ontouching(rtnObj)
                    }
                };
                if (istouch) {
                    div.bind("touchmove", movefun);
                }
                else {
                    div.bind("mousemove", movefun);
                }
            }
            //停止滑动
            function endtouch(div, istouch) {
                isend = true;
                if (istouch) {
                    div.unbind("touchmove");
                }
                else {
                    div.unbind("mousemove");
                }
                if (hastouch == true) {
                    if (op.onend != null) {
                        op.onend(rtnObj);
                    }
                    hastouch = false;
                }
            }

            function onend(e, istouch, div) {
                if (isend == true) {
                    return;
                }
                endtouch(div, istouch);
            }


            //防止事件冒泡
            function qxmp(e) {
                try {
                    if (window.event) {
                        window.event.cancelBubble = true;
                    } else {
                        e.stopPropagation();
                    }
                }
                catch (e) { }
            }
            function initEvent() {
                panel.on('touchstart', function (e) {
                    qxmp(e);
                    var div = jQuery(this);
                    onstart(e, true, div);
                });
                panel.on('touchend', function (e) {
                    qxmp(e);
                    var div = jQuery(this);
                    onend(e, true, div);
                });

                panel.mousedown(function (e) {
                    //  qxmp(e);
                    var div = jQuery(this);
                    onstart(e, false, div);
                });

                panel.mouseup(function (e) {
                    // qxmp(e);
                    var div = jQuery(this);
                    onend(e, false, div);
                });
            }

            initEvent();


            return rtnObj;
        },
        touchreflash: function (options) {//滑动刷新
            var panel = jQuery(this);
            var defaults = {
                onstart: null,
                ontouching: null,
                onend: null
            };

            var divFlash = jQuery("<div style='width:100%;text-align:center;'></div>");
            divFlash.append("<img src=\"" + apollo.pageInfo.base + "images/imgRef.gif\" style=\"height:100%;width:auto;\" />");
            divFlash.append("<span> 亲，松手后刷新内容...</span>");
            divFlash.css("position", panel.css("position"));
            divFlash.css("z-index", panel.css("z-index"));
            divFlash.hide();
            var baseop = jQuery.extend(defaults, options);
            var h = 0;
            var op = {
                onstart: function (util) {
                    if (baseop.onstart != null)
                        baseop.onstart(util);
                    h = 0;
                    divFlash.height(h);
                    divFlash.css("font-size", h + "px");
                    divFlash.css("top", util.beginTop);
                    panel.before(divFlash);
                    divFlash.show();
                },
                ontouching: function (util) {
                    if (baseop.ontouching != null)
                        baseop.ontouching(util);

                    var os = util.offset();
                    var size = Math.abs(os.beginTop - os.top);
                    if (size < 18) {
                        divFlash.css("font-size", size + "px");
                    }
                    else
                        divFlash.css("font-size", "18px");
                    var top = 0;
                    if (size < 60) {
                        divFlash.css("line-height", size + "px");
                        divFlash.height(size);
                        divFlash.css("top", (os.top - size) + "px");
                    }
                    else {
                        divFlash.css("line-height", "60px");
                        divFlash.height(60);
                        divFlash.css("top", (os.top - 60) + "px");
                    }
                },
                onend: function (util) {
                    if (baseop.onend != null)
                        baseop.onend(util);
                    divFlash.fadeOut("fast", function () {
                        divFlash.remove();
                    });
                }
            }
            var util = panel.touchutil(op);
            return jQuery.extend({}, util);
        },
        formArea: function (options) {
            var defaults = {
                name: '',
                data: null//获取当前区域数据对象
            }
            var op = jQuery.extend(defaults, options);
            var areaData = op.data;//当前区域外部赋加的值

            var areaPanel = jQuery(this);
            //找出当前区域下所有编辑项
            //先找出普通文本输入项:input,select,textarea三项
            var inputs = areaPanel.find("input");

            var selects = areaPanel.find("select");
            var textareas = areaPanel.find("textarea");
            var customfiles = areaPanel.find(".apolloui-customfile");
            var viewitems = areaPanel.find(".apolloui-viewitem");
            var switchboxs = areaPanel.find(".apolloui-switchbox");
            //保存当前区域所有符合标准的编辑项，必须有data-options属性，且至少有一项为 name:'XXX',name不能重复，如重复，则取最后一项
            //注意，只有输入编辑项才有效，非输入编辑项必须要加对应class:apolloui-popupbox;apollo-popuplist;apollo-checklist等，按钮、hidden之类不视为编辑项
            var arrEditors = {};

            var render = apollo.Template.Render(areaPanel, 1);


            var rtnObj = {
                areaname: op.areaName,
                geteditor: function (itemName) {
                    if (itemName in arrEditors)
                        return arrEditors[itemName];
                    else
                        return apollo.form.baseEditor(true);
                },
                geteditors: function () {
                    return arrEditors;
                },
                getvalue: function (itemName) {
                    if (itemName in arrEditors)
                        return arrEditors[itemName].getvalue();
                    else
                        return "";
                },
                setvalue: function (itemName, v, t) {
                    if (itemName in arrEditors)
                        arrEditors[itemName].setvalue(v, t);
                },
                getdata: function () {
                    if (areaData != null) {
                        rtnObj.updata(areaData);
                        return areaData;
                    }
                    else {
                        var datas = {};
                        for (var name in arrEditors) {
                            datas[name] = arrEditors[name].getvalue();
                        }
                        return datas;
                    }
                },
                setdata: function (entity) {
                    if (typeof entity == "object")
                        areaData = jQuery.extend({}, entity);
                    else
                        areaData = null;

                    for (var name in arrEditors) {
                        var editor = arrEditors[name];
                        //首先判断该项是否在该对象中存在
                        if (typeof entity == "object") {
                            if (name in entity) {
                                var v = entity[name];

                                if (v == null) {
                                    editor.setvalue("");//设置默认值
                                }
                                else {
                                    editor.setvalue(v);
                                }
                            }
                        }
                    }
                },
                setenabled: function (itemName, IsEnabled) {
                    if (arguments.length == 1) {
                        for (var name in arrEditors) {
                            arrEditors[name].setenabled(arguments[0]);
                        }
                    }
                    else {
                        if (itemName in arrEditors) {
                            arrEditors[itemName].setenabled(IsEnabled);
                        }
                    }
                },
                setvisible: function (itemName, IsVisible) {
                    if (itemName in arrEditors) {
                        arrEditors[itemName].setvisible(IsVisible);
                    }
                },
                updata: function (entity) {
                    if (entity == null) //如果本身是个空对象，则直接返回当前编辑区
                    {
                        entity = this.getdata();
                        return entity;
                    }
                    for (var name in arrEditors) {
                        var editor = arrEditors[name];
                        if (name in entity)
                            entity[name] = getfactvalue(editor, entity, name);
                    }
                    return entity;
                },
                isvalid: function () {
                    for (var name in arrEditors) {
                        var editor = arrEditors[name];
                        if (typeof editor == "function") return;
                        if (editor == null || editor == undefined) continue;
                        if (!editor.isvalid()) return false;
                    }
                    return true;
                },
                custom: function (name, getvalue, setvalue, isvalid) {
                    if (typeof name == "string") {
                        var editor = apollo.form.baseEditor();
                        editor.name = name;
                        editor.area = rtnObj;
                        if (jQuery.isFunction(getvalue))
                            editor.getvalue = getvalue;
                        if (jQuery.isFunction(setvalue))
                            editor.setvalue = setvalue;
                        if (jQuery.isFunction(isvalid))
                            editor.isvalid = isvalid;
                        arrEditors[name] = editor;
                    }
                },
                parseLayer: function (data, app) {
                    render.parseLayer(data, app);
                },
                reflashEle: function (app, data, propName) {
                    render.reflashEle(app, data, propName);
                }
            };

            //如果要属于编辑区中的具体项,必须要设置field值,如果同一field设置有多个值，则只取第一个

            //进行解析,先解析input

            jQuery(inputs).each(function (i, input) {
                var box = jQuery(input);

                if (!checkIsAreaele(box)) return;


                var type = box.attr("type");

                if (type == "button" || type == "reset" || type == "submit" || type == "radio")
                    return;

                if (box.is(".apolloui-popuplist") || box.is(".apolloui-checklist") || box.is("apolloui-switchbox") || box.is("apolloui-viewitem") || box.is("apolloui-customfile"))
                    return;


                var editor;
                var edtOptions;
                if (box.is(".apolloui-popupbox")) {
                    var edtOptions = parseOption(input, apollo.Options.popup, apollo.Options.popupSource);

                    if (apollo.Lib.isEmpty(edtOptions.name)) return;
                    edtOptions.area = rtnObj;
                    editor = box.popupbox(edtOptions);
                }
                if (type == "checkbox") //普通文本输入框
                {
                    edtOptions = parseOption(input, apollo.Options.input);
                    if (apollo.Lib.isEmpty(edtOptions.name)) return;
                    edtOptions.area = rtnObj;
                    editor = box.checkbox(edtOptions);
                }

                else if (type == "radio") {
                    edtOptions = parseOption(input, apollo.Options.input);
                    if (apollo.Lib.isEmpty(edtOptions.name)) return;
                    edtOptions.area = rtnObj;
                    editor = box.radiobox(edtOptions);
                }
                else if (type == "file") {
                    edtOptions = parseOption(input, apollo.Options.file);
                    if (apollo.Lib.isEmpty(edtOptions.name)) return;
                    edtOptions.area = rtnObj;
                    editor = box.filebox(edtOptions);
                }
                else {
                    edtOptions = parseOption(input, apollo.Options.input);
                    if (apollo.Lib.isEmpty(edtOptions.name)) return;
                    edtOptions.area = rtnObj;
                    editor = box.input(edtOptions);
                }
                var id = box.attr("id");
                if (apollo.Lib.isEmpty(id)) {
                    id = box.attr("name");
                }
                if (apollo.Lib.isNotEmpty(id))
                    window[id] = editor;

                if (apollo.Lib.isNotEmpty(edtOptions.name))
                    arrEditors[edtOptions.name] = editor;
            });

            jQuery(selects).each(function (i, select) {
                var edtOptions = parseOption(select, apollo.Options.select, apollo.Options.source);
                if (apollo.Lib.isEmpty(edtOptions.name)) return;
                edtOptions.area = rtnObj;
                var box = jQuery(select);

                if (!checkIsAreaele(box)) return;

                var editor = box.selectbox(edtOptions);
                var id = box.attr("id");
                if (apollo.Lib.isEmpty(id)) {
                    id = box.attr("name");
                }
                if (apollo.Lib.isNotEmpty(id))
                    window[id] = editor;

                if (apollo.Lib.isNotEmpty(edtOptions.name))
                    arrEditors[edtOptions.name] = editor;
            });

            if (textareas.length > 0) {
                jQuery(textareas).each(function (i, textarea) {
                    var edtOptions = parseOption(textarea, apollo.Options.input);
                    if (apollo.Lib.isEmpty(edtOptions.name)) return;
                    edtOptions.area = rtnObj;
                    var box = jQuery(textarea);

                    if (!checkIsAreaele(box)) return;

                    var editor = box.textarea(edtOptions);

                    var id = box.attr("id");
                    if (apollo.Lib.isEmpty(id)) {
                        id = box.attr("name");
                    }
                    if (apollo.Lib.isNotEmpty(id))
                        window[id] = editor;

                    if (apollo.Lib.isNotEmpty(edtOptions.name))
                        arrEditors[edtOptions.name] = editor;
                });
            }

            if (customfiles.length > 0) {
                jQuery(customfiles).each(function (i, cf) {
                    var edtOptions = parseOption(cf, apollo.Options.customfile);
                    if (apollo.Lib.isEmpty(edtOptions.name)) return;
                    edtOptions.area = rtnObj;
                    var box = jQuery(cf);

                    if (!checkIsAreaele(box)) return;

                    var editor = box.customfile(edtOptions);

                    var id = box.attr("id");
                    if (apollo.Lib.isEmpty(id)) {
                        id = box.attr("name");
                    }
                    if (apollo.Lib.isNotEmpty(id))
                        window[id] = editor;

                    if (apollo.Lib.isNotEmpty(edtOptions.name))
                        arrEditors[edtOptions.name] = editor;
                });
            }

            if (viewitems.length > 0) {
                jQuery(viewitems).each(function (i, cf) {

                    var edtOptions = parseOption(cf, apollo.Options.viewitem);
                    if (apollo.Lib.isEmpty(edtOptions.name)) return;
                    edtOptions.area = rtnObj;
                    var box = jQuery(cf);

                    if (!checkIsAreaele(box)) return;

                    var editor = box.viewitem(edtOptions);

                    var id = box.attr("id");
                    if (apollo.Lib.isEmpty(id)) {
                        id = box.attr("name");
                    }
                    if (apollo.Lib.isNotEmpty(id))
                        window[id] = editor;

                    if (apollo.Lib.isNotEmpty(edtOptions.name))
                        arrEditors[edtOptions.name] = editor;
                });
            }

            if (switchboxs.length > 0) {
                jQuery(switchboxs).each(function (i, cf) {

                    var edtOptions = parseOption(cf, apollo.Options.switchbox);
                    if (apollo.Lib.isEmpty(edtOptions.name)) return;
                    edtOptions.area = rtnObj;
                    var box = jQuery(cf);

                    if (!checkIsAreaele(box)) return;

                    var editor = box.switchbox(edtOptions);

                    var id = box.attr("id");
                    if (apollo.Lib.isEmpty(id)) {
                        id = box.attr("name");
                    }
                    if (apollo.Lib.isNotEmpty(id))
                        window[id] = editor;

                    if (apollo.Lib.isNotEmpty(edtOptions.name))
                        arrEditors[edtOptions.name] = editor;
                });
            }


            //检测指定元素是否为本级区域元素（以区分子级区域的元素)
            function checkIsAreaele(ele) {
                var curArea;
                if (op.arrayArea != null) {
                    curArea = jQuery(ele).closest(".apolloui-arrayarea");

                    if (curArea.length > 0) {
                        if (curArea.get(0) == op.arrayArea.get(0)) return true;
                    }
                }

                curArea = jQuery(ele).closest(".apolloui-area");
                if (curArea.length > 0) {
                    if (curArea.get(0) != areaPanel.get(0)) return false;
                }

                return true;
            }

            function getfactvalue(editor, entity, name) {
                var objoldv = entity[name];
                if (jQuery.isArray) {

                }
                if (typeof objoldv == "string") {

                }
                return editor.getvalue();
            }

            return rtnObj;
        },
        arrayArea: function (options) {
            var defaults = {
                name: '',
                rowformatfun: '',
                data: null//获取当前区域数据对象
            }
            var arrAreas = [];

            var op = jQuery.extend(defaults, options);
            var formatfun = apollo.Lib.parseFun(op.rowformatfun);

            var areaPanel = jQuery(this);



            var rowTemplate = $("<div></div>");//行模板

            if (areaPanel.children().length > 0) {
                var el = areaPanel.children().get(0);
                var rowHtml = jQuery("<panel></panel>").append(jQuery(el)).html();
                rowTemplate.html(rowHtml);
            }
            else {
                var rowHtml = areaPanel.html();
                rowTemplate.html(rowHtml);
            }
            areaPanel.empty();

            //定义当前区域的渲染器
            var render = apollo.Template.Render(rowTemplate, 2);

            var rtnObj = {
                areaname: op.areaName,
                geteditor: function (itemName) {
                    if (arrAreas.length > 0)
                        return arrAreas[0].geteditor(itemName);
                },
                geteditors: function () {
                    if (arrAreas.length > 0)
                        return arrAreas[0].geteditors;
                },
                getvalue: function (itemName) {
                    if (arrAreas.length > 0)
                        return arrAreas[0].getvalue(itemName);
                },
                setvalue: function (itemName, v, t) {
                    if (arrAreas.length > 0)
                        return arrAreas[0].setvalue(itemName, v, t);
                },
                getdata: function () {
                    var datas = [];
                    jQuery(arrAreas).each(function (i, area) {
                        datas.push(area.getdata());
                    });
                },
                setdata: function (data) {
                    var arr = [];
                    if (jQuery.isArray(data)) {
                        arr = data;
                    }
                    else if (typeof data == "object")
                        arr = [data];

                    arrAreas = [];
                    areaPanel.empty();
                    jQuery(arr).each(function (i, item) {
                        var html = rowTemplate.html();
                        var row = jQuery(html);

                        if (formatfun != null) {
                            try {
                                formatfun(row, item);
                            }
                            catch (e) { }
                        }

                        areaPanel.append(row);
                        var area = row.formArea({ name: op.name + i, data: item, arrayArea: areaPanel });
                        row.data("AreaObj", area);

                        area.setdata(item);
                        arrAreas.push(area);
                    });
                },
                appenddata: function (data) {
                    var arr = [];
                    if (jQuery.isArray(data)) {
                        arr = data;
                    }
                    else if (typeof data == "object")
                        arr = [data];

                    jQuery(arr).each(function (i, item) {
                        var html = rowTemplate.html();
                        areaPanel.append(row);


                        if (formatfun != null) {
                            try {
                                formatfun(row, item);
                            }
                            catch (e) { }
                        }



                        var area = row.formArea({ name: op.name + i, data: item, arrayArea: areaPanel });
                        row.data("AreaObj", area);

                        area.setdata(item);
                        arrAreas.push(area);
                    });
                },
                setenabled: function (itemName, IsEnabled) {
                    if (arrAreas.length > 0)
                        return arrAreas[0].setenabled(itemName, IsEnabled);
                },
                setvisible: function (itemName, IsVisible) {
                    if (arrAreas.length > 0)
                        return arrAreas[0].setvisible(itemName, IsVisible);
                },
                updata: function (entity) {

                },
                isvalid: function () {
                    for (var i = 0; i < arrAreas.length; i++) {
                        if (!arrAreas[i].isvalid()) return false;
                    }
                    return true;
                },
                custom: function (name, getvalue, setvalue, isvalid) {

                },
                parseLayer: function (data, app) {
                    render.parseLayer(data, app);
                    for (var i = 0; i < arrAreas.length; i++) {
                        arrAreas[i].parseLayer(data, app);
                    }
                },
                reflashEle: function (app, data, propName) {
                    render.reflashEle(app, data, propName);
                    for (var i = 0; i < arrAreas.length; i++) {
                        arrAreas[i].reflashEle(app, data, propName);
                    }
                }
            };
            return rtnObj;
        },
        viewitem: function (options) {
            var factValue = null;
            var box = jQuery(this);

            var defaults = jQuery({ area: null }, apollo.Options.viewitem.option);
            var op = jQuery.extend(defaults, options);
            var cfn = apollo.Lib.parseFun(op.clickfun);

            if (cfn != null) {
                box.click(function () {
                    cfn(editor.getvalue(), getareadata());
                });
            }
            if (op.type == apollo.Enum.itemtype.button) {
                box.data("AreaObj", op.area);
            }

            var editor = apollo.form.baseEditor();

            function getareadata() {
                if (op.area != null)
                    return op.area.getdata();
                else
                    return {};
            }
            function setitemvalue(v) {
                op.viewfun = apollo.Lib.parseFun(op.viewfun);
                if (op.viewfun != null) return op.viewfun(box, v, getareadata());

                if (op.type == apollo.Enum.itemtype.image) {
                    if (apollo.Lib.isNotEmpty(v))
                        box.attr("src", v);
                    else if (apollo.Lib.isNotEmpty(op.defaultValue))
                        box.attr("src", op.defaultValue);
                    else
                        box.removeAttr("src");
                }
                else if (op.type == apollo.Enum.itemtype.button) {
                    box.data("itemvalue", v);
                    box.data("itemdata", getareadata());
                }
                else {
                    if (apollo.Lib.isNotEmpty(op.format)) {
                        box.html(apollo.Lib.formatString(op.format, v));
                    }
                    else {
                        v = getValueTypeV(v, op.textType);

                        if (toRSLtextType(op.textType) == 12) {
                            if (v == "0001-01-01 00:00:00") {
                                box.html("");
                            }
                            else if (v.indexOf(" ") > 0) {
                                var arr = v.split(" ");
                                box.html(arr[0]);
                            }
                        }
                        else if (toRSLtextType(op.textType) == 15 && v == "0001-01-01 00:00:00")
                            box.html("");
                        else if (apollo.Lib.isNotEmpty(op.casewhenlist)) {
                            box.html(GetCaseWhen(v, op.casewhenlist, op.elsevalue));
                        }
                        else {
                            box.html(v);
                        }
                    }
                }
            }


            editor.getvalue = function () {
                if (factValue == null)
                    return getValueTypeV("", op.textType);
                else
                    return factValue;
            };
            editor.gettext = function () {
                if (op.type == apollo.Enum.type.label) {
                    return box.html();
                }
                else
                    return factValue;
            };
            editor.setvalue = function (v) {
                factValue = v;
                setitemvalue(v);
            };
            editor.isvalid = function () {
                return true;
            };
            editor.setvisible = function (visible) {
                this.visible = visible == true;

                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        jQuery("#" + op.itempanelid).show();
                    else
                        jQuery("#" + op.itempanelid).hide();
                }
                else {
                    if (visible == true)
                        box.show();
                    else
                        box.hide();
                }
            };
            editor.setenabled = function (enabled) {
                this.enabled = enabled == true;
                if (enabled == true) {
                    box.removeAttr("disabled");
                }
                else {
                    box.attr("disabled", "disabled");
                }
            };//设置编辑项是否可用
            editor.name = op.name;
            //editor.field = op.field;
            editor.textType = op.textType;
            editor.isempty = false;
            editor.setdefultvalue = function () {
                editor.setvalue(op.defaultValue);
            };//设置默认值
            editor.getdataitem = function () {
                editor.getvalue();
            };//获取当前选中项对象第一个，只对于下接框，选择项等有效，如是多选，则取第一个
            editor.getdataitems = function () {
                var v = editor.getvalue();
                if (v == null)
                    return [];
                else
                    return [v];//获取当前选中的所有对象
            };
            return editor;
        },
        input: function (options) {
            var box = jQuery(this);
            var type = box.attr("type");

            var defaults = jQuery({ area: null }, apollo.Options.input.option);
            var op = jQuery.extend(defaults, options);

            var editor = apollo.form.baseEditor();


            var divbox = $("<span></span>");

            if (op.easyui == true) {//采用easyui样式

                box.before(divbox);
                box.remove(0);
                divbox.append(box);



                var Width = op.width;
                if (op.textType == apollo.Enum.Month)
                    Width = 123;
                else if (op.textType == apollo.Enum.Year)
                    Width = 73;
                else {
                    Width = 120;
                }
                if (Width <= 0) Width = 120;

                var json = {
                    required: !op.allowEmpty,
                    height: apollo.form.inputHeight,
                    value: op.defaultValue,
                    type: 'text'
                };
                $(box).get(0).type = "text";

                if (type == "date") { //日期
                    if (apollo.Lib.isEmpty(box.css("width")))
                        json.width = Width;

                    json.onSelect = function (date) {
                        var v = date;
                        try {
                            if (editor.onselect != null)
                                editor.onselect(v, editor);
                        }
                        catch (e) { }
                        try {
                            if (editor.onchange != null)
                                editor.onchange(v, editor);
                        }
                        catch (e) { }
                    };



                    box.datebox(json);
                    editor.getvalue = function () {
                        var v = box.datebox("getValue");
                        if (apollo.Lib.isEmpty(v))
                            return getValueTypeV("", op.textType);
                        else
                            return getValueTypeV(v, op.textType);
                    };
                    editor.gettext = function () {
                        var v = box.datebox("getText");
                        if (apollo.Lib.isEmpty(v))
                            return "";
                        else
                            return v;
                    };
                    editor.setvalue = function (v, t) {
                        box.datebox("setValue", v);
                        if (t != null && t != undefined)
                            box.datebox("setText", t);
                    };
                    editor.isvalid = function () {
                        if (editor.enabled && editor.visible) {
                            return box.datebox("isValid");
                        }
                        else
                            return true;
                    };
                    editor.setvisible = function (visible) {
                        this.visible = visible == true;

                        if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                            if (visible == true)
                                $("#" + op.itempanelid).show();
                            else
                                $("#" + op.itempanelid).hide();
                        }
                        else {
                            if (visible == true)
                                divbox.show();
                            else
                                divbox.hide();
                        }
                    };
                    editor.setenabled = function (enabled) {
                        this.enabled = enabled == true;
                        if (enabled == true) {
                            box.datebox("enable");
                        }
                        else {
                            box.datebox("disable");
                        }
                    };//设置编辑项是否可用
                    editor.destroy = function () {
                        box.datebox("destroy");
                    }
                }
                else if (type == "datetime") { //日期时间
                    if (apollo.Lib.isEmpty(box.css("width")) && Width <= 120)
                        json.width = 130;

                    json.onSelect = function (date) {
                        var v = date;
                        try {
                            if (editor.onselect != null)
                                editor.onselect(v, editor);
                        }
                        catch (e) { }
                        try {
                            if (editor.onchange != null)
                                editor.onchange(v, editor);
                        }
                        catch (e) { }
                    };


                    box.datetimebox(json);


                    editor.getvalue = function () {
                        var v = box.datetimebox("getValue");
                        if (apollo.Lib.isEmpty(v))
                            return getValueTypeV("", op.textType);
                        else
                            return getValueTypeV(v, op.textType);
                    };
                    editor.gettext = function () {
                        var v = box.datetimebox("getText");
                        if (apollo.Lib.isEmpty(v))
                            return "";
                        else
                            return v;
                    };
                    editor.setvalue = function (v, t) {
                        box.datetimebox("setValue", v);
                        if (t != null && t != undefined)
                            box.datetimebox("setText", t);
                    };
                    editor.isvalid = function () {
                        if (editor.enabled && editor.visible) {
                            return box.datetimebox("isValid");
                        }
                        else
                            return true;
                    };

                    editor.setvisible = function (visible) {
                        this.visible = visible == true;
                        if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                            if (visible == true)
                                $("#" + op.itempanelid).show();
                            else
                                $("#" + op.itempanelid).hide();
                        }
                        else {
                            if (visible == true)
                                divbox.show();
                            else
                                divbox.hide();
                        }
                    };
                    editor.setenabled = function (enabled) {
                        this.enabled = enabled == true;
                        if (enabled == true) {
                            box.datetimebox("enable");
                        }
                        else {
                            box.datetimebox("disable");
                        }
                    };//设置编辑项是否可用
                    editor.destroy = function () {
                        box.datetimebox("destroy");
                    }
                }
                else if (type == "time") {//时间
                    if (apollo.Lib.isEmpty(box.css("width")))
                        json.width = 100;

                    json.showSeconds = true;

                    json.onChange = function (nv, ov) {
                        var v = nv;
                        try {
                            if (editor.onselect != null)
                                editor.onselect(v, editor);
                        }
                        catch (e) { }
                        try {
                            if (editor.onchange != null)
                                editor.onchange(v, editor);
                        }
                        catch (e) { }
                    };


                    box.timespinner(json);


                    editor.getvalue = function () {
                        var v = box.timespinner("getValue");
                        if (apollo.Lib.isEmpty(v))
                            return "";
                        else
                            return v;
                    };
                    editor.gettext = function () {
                        return editor.getvalue();
                    };
                    editor.setvalue = function (v, t) {
                        box.timespinner("setValue", v);
                    };
                    editor.isvalid = function () {

                        if (editor.enabled && editor.visible) {
                            return box.timespinner("isValid");
                        }
                        else
                            return true;
                    };
                    editor.setvisible = function (visible) {
                        this.visible = visible == true;

                        if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                            if (visible == true)
                                $("#" + op.itempanelid).show();
                            else
                                $("#" + op.itempanelid).hide();
                        }
                        else {
                            if (visible == true)
                                divbox.show();
                            else
                                divbox.hide();
                        }
                    };
                    editor.setenabled = function (enabled) {
                        this.enabled = enabled == true;
                        if (enabled == true) {
                            box.timespinner("enable");
                        }
                        else {
                            box.timespinner("disable");
                        }
                    };//设置编辑项是否可用
                    editor.destroy = function () {
                        box.timespinner("destroy");
                    };
                }
                else if (type == "number") {//数字字符
                    if (apollo.Lib.isEmpty(box.css("width")))
                        json.width = Width;

                    if (apollo.Lib.isIn(op.textType, [apollo.Enum.textType.UFloat, apollo.Enum.textType.UInt])) {//数字整数
                        json.min = 0;
                    }
                    if (apollo.Lib.isIn(op.textType, [apollo.Enum.textType.UFloat, apollo.Enum.textType.Float, apollo.Enum.textType.Number]))//数字小数
                    {
                        json.precision = op.precision;
                    }
                    else //数字字符
                    {
                        json.precision = 0;
                    }

                    json.onChange = function (nv, ov) {
                        var v = nv;
                        try {
                            if (editor.onselect != null)
                                editor.onselect(v, editor);
                        }
                        catch (e) { }
                        try {
                            if (editor.onchange != null)
                                editor.onchange(v, editor);
                        }
                        catch (e) { }
                    };

                    box.numberbox(json);

                    editor.getvalue = function () {
                        var v = box.numberbox("getValue");
                        if (apollo.Lib.isEmpty(v))
                            return getValueTypeV("", op.textType);
                        else
                            return getValueTypeV(v, op.textType);
                    };
                    editor.gettext = function () {
                        var v = box.numberbox("getText");
                        if (apollo.Lib.isEmpty(v))
                            return "";
                        else
                            return v;
                    };
                    editor.setvalue = function (v, t) {
                        box.numberbox("setValue", v);
                        if (t != null && t != undefined)
                            box.numberbox("setText", t);
                    };
                    editor.isvalid = function () {

                        if (editor.enabled && editor.visible) {
                            return box.numberbox("isValid");
                        }
                        else
                            return true;
                    };


                    editor.setvisible = function (visible) {
                        this.visible = visible == true;

                        if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                            if (visible == true)
                                $("#" + op.itempanelid).show();
                            else
                                $("#" + op.itempanelid).hide();
                        }
                        else {
                            if (visible == true)
                                divbox.show();
                            else
                                divbox.hide();
                        }
                    };
                    editor.setenabled = function (enabled) {
                        this.enabled = enabled == true;
                        if (enabled == true) {
                            box.numberbox("enable");
                        }
                        else {
                            box.numberbox("disable");
                        }
                    };//设置编辑项是否可用

                    editor.destroy = function () {
                        box.numberbox("destroy");
                    };
                }
                else if (apollo.Lib.isIn(op.textType, [apollo.Enum.textType.Int, apollo.Enum.textType.UInt]))//整数
                {
                    if (apollo.Lib.isEmpty(box.css("width")))
                        json.width = 60;


                    if (apollo.Lib.isIn(op.textType, [apollo.Enum.textType.UInt])) {
                        json.min = 0;
                    }

                    json.onChange = function (nv, ov) {
                        var v = nv;
                        try {
                            if (editor.onselect != null)
                                editor.onselect(v, editor);
                        }
                        catch (e) { }
                        try {
                            if (editor.onchange != null)
                                editor.onchange(v, editor);
                        }
                        catch (e) { }
                    };


                    box.numberspinner(json);

                    editor.getvalue = function () {
                        var v = box.numberspinner("getValue");
                        if (apollo.Lib.isEmpty(v))
                            return getValueTypeV("", op.textType);
                        else
                            return getValueTypeV(v, op.textType);
                    };
                    editor.gettext = function () {
                        var v = box.numberspinner("getText");
                        if (apollo.Lib.isEmpty(v))
                            return "";
                        else
                            return v;
                    };
                    editor.setvalue = function (v, t) {
                        box.numberspinner("setValue", v);
                        if (t != null && t != undefined)
                            box.numberspinner("setText", t);
                    };
                    editor.isvalid = function () {

                        if (editor.enabled && editor.visible) {
                            return box.numberspinner("isValid");
                        }
                        else
                            return true;
                    };


                    editor.setvisible = function (visible) {
                        this.visible = visible == true;

                        if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                            if (visible == true)
                                $("#" + op.itempanelid).show();
                            else
                                $("#" + op.itempanelid).hide();
                        }
                        else {
                            if (visible == true)
                                divbox.show();
                            else
                                divbox.hide();
                        }
                    };
                    editor.setenabled = function (enabled) {
                        this.enabled = enabled == true;
                        if (enabled == true) {
                            box.numberspinner("enable");
                        }
                        else {
                            box.numberspinner("disable");
                        }
                    };//设置编辑项是否可用

                    editor.destroy = function () {
                        box.numberspinner("destroy");
                    };
                }
                else {//其它文本
                    if (type == "email" || type == "url" || type == "tel") {
                        json.validType = type
                    }

                    if (apollo.Lib.isEmpty(box.css("width")))
                        json.width = Width;

                    json.onChange = function (nv, ov) {
                        var v = nv;
                        try {
                            if (editor.onselect != null)
                                editor.onselect(v, editor);
                        }
                        catch (e) { }
                        try {
                            if (editor.onchange != null)
                                editor.onchange(v, editor);
                        }
                        catch (e) { }
                    };



                    box.textbox(json);

                    editor.getvalue = function () {
                        var v = box.textbox("getValue");
                        if (apollo.Lib.isEmpty(v))
                            return getValueTypeV("", op.textType);
                        else
                            return getValueTypeV(v, op.textType);
                    };
                    editor.gettext = function () {
                        var v = box.textbox("getText");
                        if (apollo.Lib.isEmpty(v))
                            return "";
                        else
                            return v;
                    };
                    editor.setvalue = function (v, t) {
                        box.textbox("setValue", v);
                        if (t != null && t != undefined)
                            box.textbox("setText", t);
                    };
                    editor.isvalid = function () {
                        if (editor.enabled && editor.visible) {
                            if (!op.allowEmpty) {
                                return box.textbox("isValid");
                            }
                            else
                                return true;
                        }
                        else
                            return true;
                    };

                    editor.setvisible = function (visible) {
                        this.visible = visible == true;

                        if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                            if (visible == true)
                                $("#" + op.itempanelid).show();
                            else
                                $("#" + op.itempanelid).hide();
                        }
                        else {
                            if (visible == true)
                                divbox.show();
                            else
                                divbox.hide();
                        }
                    };
                    editor.setenabled = function (enabled) {
                        this.enabled = enabled == true;
                        if (enabled == true) {
                            box.textbox("enable");
                        }
                        else {
                            box.textbox("disable");
                        }
                    };//设置编辑项是否可用

                    editor.destroy = function () {
                        box.textbox("destroy");
                    };
                }

                editor.name = op.name;
                editor.textType = op.textType;
                editor.isempty = false;
                editor.setdefultvalue = function () {
                    editor.setvalue(op.defaultValue);
                };//设置默认值
                editor.getdataitem = function () {
                    editor.getvalue();
                };//获取当前选中项对象第一个，只对于下接框，选择项等有效，如是多选，则取第一个
                editor.getdataitems = function () {
                    var v = editor.getvalue();
                    if (v == null)
                        return [];
                    else
                        return [v];//获取当前选中的所有对象
                };
            }
            else {//普通h5样式
                editor.getvalue = function () {
                    var v = box.val();
                    if (apollo.Lib.isEmpty(v))
                        return getValueTypeV("", op.textType);
                    else
                        return getValueTypeV(v, op.textType);
                };
                editor.gettext = function () {
                    return editor.getvalue();
                };
                editor.setvalue = function (v) {
                    box.val(v);
                };
                editor.isvalid = function () {
                    if (editor.enabled && editor.visible) {
                        if (!op.allowEmpty) {
                            return box.val() != "";
                        }
                        else
                            return true;
                    }
                    else
                        return true;
                };
                editor.setvisible = function (visible) {
                    this.visible = visible == true;

                    if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                        if (visible == true)
                            jQuery("#" + op.itempanelid).show();
                        else
                            jQuery("#" + op.itempanelid).hide();
                    }
                    else {
                        if (visible == true)
                            box.show();
                        else
                            box.hide();
                    }
                };
                editor.setenabled = function (enabled) {
                    this.enabled = enabled == true;
                    if (enabled == true) {
                        box.removeAttr("disabled");
                    }
                    else {
                        box.attr("disabled", "disabled");
                    }
                };//设置编辑项是否可用


                editor.name = op.name;
                editor.textType = op.textType;
                editor.isempty = false;
                editor.setdefultvalue = function () {
                    editor.setvalue(op.defaultValue);
                };//设置默认值
                editor.getdataitem = function () {
                    editor.getvalue();
                };//获取当前选中项对象第一个，只对于下接框，选择项等有效，如是多选，则取第一个
                editor.getdataitems = function () {
                    var v = editor.getvalue();
                    if (v == null)
                        return [];
                    else
                        return [v];//获取当前选中的所有对象
                };
            }
            return editor;
        },
        textarea: function (options) {
            var box = $(this);
            var defaults = $({}, apollo.Options.input.option);
            var op = $.extend(defaults, options);
            if (op.easyui == true) {
                var span = $("<span class='textbox'></span>");
                box.before(span);
                span.width(box.width());
                span.height(box.height());

                box.remove();
                span.append(box);
                box.addClass("textbox-text");
                box.addClass("validatebox-text");
                // box.addClass("textbox-prompt")

                var editor = apollo.form.baseEditor();


                box.focus(function () {
                    span.addClass("textbox-focused");
                });
                box.blur(function () {
                    span.removeClass("textbox-focused");
                })

                box.change(function (e) {
                    var v = box.val();
                    try {
                        if (rtn.onSelChange != null)
                            rtn.onSelChange(v, rtn);
                    }
                    catch (e) { }
                    try {
                        if (rtn.onValueChange != null)
                            rtn.onValueChange(v, rtn);
                    }
                    catch (e) { }
                });


                // box.validatebox({ required: !op.allowEmpty });


                editor.getvalue = function () {
                    var v = box.textbox("getValue");
                    if (apollo.Lib.isEmpty(v))
                        return getValueTypeV("", op.textType);
                    else
                        return getValueTypeV(v, op.textType);
                };
                editor.gettext = function () {
                    var v = box.textbox("getText");
                    if (apollo.Lib.isEmpty(v))
                        return "";
                    else
                        return v;
                };
                editor.setvalue = function (v, t) {
                    box.textbox("setValue", v);
                    if (t != null && t != undefined)
                        box.textbox("setText", t);
                };

                editor.name = op.name;
                editor.textType = op.textType;
                editor.isempty = false;
                editor.getvalue = function () {
                    return box.val();
                };
                editor.gettext = function () {
                    return box.val();
                };
                editor.setvalue = function (v, t) {
                    box.val(v);
                };
                editor.setdefultvalue = function () {
                    editor.setvalue(op.defaultValue);
                };
                editor.getdataitem = function () {
                    return editor.getvalue();
                };
                editor.getdataitems = function () {
                    return [box.val()];
                };
                editor.isvalid = function () {
                    if (editor.enabled && editor.visible) {
                        if (!op.allowEmpty) {
                            return box.validatebox("isValid");
                        }
                        else
                            return true;
                    }
                    else
                        return true;
                };
                editor.setvisible = function (visible) {
                    this.visible = visible == true;

                    if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                        if (visible == true)
                            $("#" + op.itempanelid).show();
                        else
                            $("#" + op.itempanelid).hide();
                    }
                    else {
                        if (isVisible == true)
                            span.show();
                        else
                            span.hide();
                    }
                }
                editor.setenabled = function (enabled) {
                    this.enabled = enabled == true;
                    if (enabled == true) {
                        box.validatebox("enable");
                    }
                    else {
                        box.validatebox("disable");
                    }
                }
                editor.destroy = function () {
                    box.validatebox("destroy");
                };
                return editor;
            }
            else {
                return jQuery(this).input(options);
            }
        },
        label: function (options) {
            var factValue = "";
            var box = jQuery(this);
            var type = box.attr("type");

            var defaults = jQuery({ area: null }, apollo.Options.label.option);
            var op = jQuery.extend(defaults, options);

            var editor = apollo.form.baseEditor();

            editor.getvalue = function () {
                var v = factValue;
                if (apollo.Lib.isEmpty(v))
                    return getValueTypeV("", op.textType);
                else
                    return v;
            };
            editor.gettext = function () {
                return box.html();
            };
            editor.setvalue = function (v) {
                factValue = v;
                v = getValueTypeV(v, op.textType);

                if (toRSLtextType(op.textType) == 12) {
                    if (v == "0001-01-01 00:00:00") {
                        box.html("");
                    }
                    else if (v.indexOf(" ") > 0) {
                        var arr = v.split(" ");
                        box.html(arr[0]);
                    }
                }
                else if (toRSLtextType(op.textType) == 15 && v == "0001-01-01 00:00:00")
                    box.html("");
                else if (apollo.Lib.isNotEmpty(op.casewhenlist)) {
                    box.html(GetCaseWhen(v, op.casewhenlist, op.elsevalue));
                }
                else {
                    box.html(v);
                }
            };
            editor.isvalid = function () {
                return true;
            };
            editor.setvisible = function (visible) {
                this.visible = visible == true;

                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        jQuery("#" + op.itempanelid).show();
                    else
                        jQuery("#" + op.itempanelid).hide();
                }
                else {
                    if (visible == true)
                        box.show();
                    else
                        box.hide();
                }
            };
            editor.setenabled = function (enabled) {
                this.enabled = enabled == true;
                if (enabled == true) {
                    box.removeAttr("disabled");
                }
                else {
                    box.attr("disabled", "disabled");
                }
            };//设置编辑项是否可用


            editor.name = op.name;
            editor.textType = op.textType;
            editor.isempty = false;
            editor.setdefultvalue = function () {
                editor.setvalue(op.defaultValue);
            };//设置默认值
            editor.getdataitem = function () {
                editor.getvalue();
            };//获取当前选中项对象第一个，只对于下接框，选择项等有效，如是多选，则取第一个
            editor.getdataitems = function () {
                var v = editor.getvalue();
                if (v == null)
                    return [];
                else
                    return [v];//获取当前选中的所有对象
            };
            return editor;
        },
        checkbox: function (options) {
            var box = jQuery(this);
            var defaults = jQuery({ area: null }, apollo.Options.input.option);
            var op = jQuery.extend(defaults, options);

            var editor = apollo.form.baseEditor();

            box.click(function (e) {
                var v = jQuery(this).is(":checked");

                try {
                    if (editor.onselect != null)
                        editor.onselect(v);
                }
                catch (e) { }
                try {
                    if (editor.onchange != null)
                        editor.onchange(v)
                }
                catch (e) { }

                try {
                    if (op.onselect != null)
                        op.onselect(v);
                }
                catch (e) { }
                try {
                    if (op.onchange != null)
                        op.onchange(v)
                }
                catch (e) { }
            });

            editor.name = op.name;
            editor.textType = op.textType;
            editor.isempty = false;
            editor.getvalue = function () {
                var v = box.is(":checked");
                if (apollo.Lib.isIn(op.textType, [1, 2, 3, 4, 5]))
                    return (v == true ? 1 : 0);
                else if (op.textType == 0) //字符型：只用0或1代替
                    return v == true ? "1" : "0";
                else
                    return v;
            };
            editor.gettext = function () {
                return editor.getvalue();
            };
            editor.setvalue = function (v, t) {
                var issel = apollo.util.toBoolean(v);
                if (issel == true)
                    box.attr("checked", "checked");
                else
                    box.removeAttr("checked");
            };
            editor.setdefultvalue = function () {
                editor.setvalue(op.defaultValue);
            };
            editor.getdataitem = function () {
                return editor.getvalue();
            };
            editor.getdataitems = function () {
                return [box.val()];
            };
            editor.isvalid = function () {
                return true;
            };
            editor.setvisible = function (visible) {
                this.visible = visible == true;

                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        jQuery("#" + op.itempanelid).show();
                    else
                        jQuery("#" + op.itempanelid).hide();
                }
                else {
                    if (visible == true)
                        box.show();
                    else
                        box.hide();
                }
            }
            editor.setenabled = function (enabled) {
                this.enabled = enabled == true;

                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        jQuery("#" + op.itempanelid).attr("disabled", "disabled");
                    else
                        jQuery("#" + op.itempanelid).removeAttr("disabled");
                }
                if (enabled == true) {
                    box.removeProp("disabled");
                }
                else {
                    box.prop("disabled", "disabled");
                }
            }
            return editor;
        },
        checkList: function (options) {
            var defaults = $({}, apollo.Options.checkList.option);
            var ckLvalue = [];//当前选中项的值
            var ckTexts = [];
            //注意，这里一定要是复本，不能是原引用对象
            var op = $.extend(defaults, options);
            var source = op.source;
            var box = $(this);
            var divbox = $("<div></div>");
            box.before(divbox);
            //box.remove();
            box.hide();
           // divbox.append(box);

            clboxnum++;
            var clboxid = "checkList_ckbox" + clboxnum;

            var editor = apollo.form.baseEditor();

            var isloaded = false;//是否已初始化加载完毕
            var arrBoxs = [];
            var datas = [];

            //暂不考虑模板
            var showList = function (arr) {
                divbox.empty();
                ckTexts = [];
                var arrV = [];
                arrBoxs = [];
                
                datas = [];
                $(arr).each(function (i, data) {
                    var pdiv = $("<div class=\"dis-inl-b mar-r1 mar-b-5\"></div>");
                    divbox.append(pdiv);
                    var v = apollo.Lib.getAttr(data, source.valuefield);
                    var t = apollo.Lib.getAttr(data, source.textfield);
                    var boxid = clboxid+'_'+i;
                    var ckbox = $("<input type=\"checkbox\" id=\""+ boxid +"\" />");
                    

                    ckbox.data("value", v);
                    ckbox.data("text", t);
                    ckbox.data("dataitem", data);
                    var lbl = $("<label for=\""+ boxid +"\"></label>");
                    lbl.html(t);
                    pdiv.append(ckbox);
                    pdiv.append(lbl);
                    ckbox.click(function () {
                        var ck = $(this);
                        var kv = ck.data("value");
                        var kt = ck.data("text");
                        var dataitem = ck.data("dataitem");
                        if (ck.is(":checked")) {
                            addItems(ckLvalue, kv);
                            addItems(ckTexts, kt);
                            addItems(datas, dataitem);
                        }
                        else {
                            ckLvalue = removeItem(ckLvalue, kv);
                            ckTexts = removeItem(ckTexts, kt);
                            datas = removeItem(datas, dataitem);
                        }
                      
                        execchange(editor.getvalue());
                        execselect(datas);
                    });

                    if (apollo.Lib.isIn(v, ckLvalue)) {
                        ckbox.attr("checked", "checked");
                        ckTexts.push(t);
                        arrV.push(v);
                        datas.push(data);
                    }

                    arrBoxs.push(ckbox);
                });
                ckLvalue = arrV;
                isloaded = true;
            };
            
            getDataSource(source, showList);


            function execchange(v) {
                try {
                    if (jQuery.isFunction(op.onchange))
                        op.onchange(v);
                }
                catch (e) { }
                try {
                    if (jQuery.isFunction(editor.onchange))
                        editor.onchange(v);
                }
                catch (e) { }
            }
            function execselect(data) {
                try {
                    if (jQuery.isFunction(op.onselect))
                        op.onselect(data);
                }
                catch (e) { }
                try {
                    if (jQuery.isFunction(editor.onselect))
                        editor.onselect(data);
                }
                catch (e) { }
            }



            editor.name = op.name;
            editor.textType = op.textType;
            editor.isempty = false;
            editor.getvalue = function () {
                //根据数据类型重新取值
                var arr = [];
                $(ckLvalue).each(function (i, v) {
                    arr.push(getValueTypeV(v, op.textType));
                });

                if (op.valueType == 1) {
                    return arr;
                }
                else
                    return arr.join(",");
            };
            editor.gettext = function () {
                return ckText.join(",");
            };
            editor.setvalue = function (v, t) {
                if ($.isArray(v)) {
                    if (op.valueType == 0) op.valueType = 1;

                    ckLvalue = v;
                }
                else if (v == null)
                    ckLvalue = [];
                else
                    ckLvalue = v.toString().split(",");

                if (isloaded == true) { //如果已经加载了
                    var arrV = [];
                    ckText = [];
                    $(arrBoxs).each(function (i, cbbox) {
                        var ck = $(cbbox);
                        var kv = ck.data("value");
                        var kt = ck.data("text");

                        if (apollo.Lib.isIn(kv, ckLvalue)) {
                            ck.attr("checked", "checked");
                            ckTexts.push(kt);
                            arrV.push(kv);
                        }
                        else {
                            ck.removeAttr("checked");
                        }
                    });
                    ckLvalue = arrV;
                }
            };
            editor.setdefultvalue = function () {
                editor.setvalue([]);
            };
            editor.getdataitem = function () {
                if (datas.length > 0)
                    return datas[0];
                else
                    return null;
            };
            editor.getdataitems = function () {
                return datas;
            };
            editor.setdata = function () {

            };
            editor.getdata = function () {
                return datas;
            },
            editor.isvalid = function () {
                if (op.allowEmpty == false) {
                    if (ckLvalue.length <= 0)
                        return false;
                    else
                        return true;
                }
                else
                    return true;
            };
            editor.setvisible = function (visible) {
                this.visible = visible == true;

                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        $("#" + op.itempanelid).show();
                    else
                        $("#" + op.itempanelid).hide();
                }
                if (isVisible == true)
                    divbox.show();
                else
                    divbox.hide();
            }
            editor.setenabled = function (enabled) {
                this.enabled = enabled == true;

                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        $("#" + op.itempanelid).attr("disabled", "disabled");
                    else
                        $("#" + op.itempanelid).removeAttr("disabled");
                }
                if (enabled == true) {
                    $(arrBoxs).each(function (i, ck) {
                        ck.attr("disabled", "disabled");
                    });
                }
                else {
                    $(arrBoxs).each(function (i, ck) {
                        ck.removeAttr("disabled");
                    });
                }
            }
            return editor;
        },
        selectbox: function (options) {
            var cb = jQuery(this);
            var isInitLoad = false;//是否已初始化加载数据（第一次加载数据）
            var initValue = null;//初始化时加载数值
            var defaults = jQuery({ area: null }, apollo.Options.select.option);
            var op = jQuery.extend(defaults, options);

            var divbox = $("<span></span>");
            if (op.easyui == true) {

                cb.before(divbox);
                cb.remove();
                divbox.append(cb);

                var Width = $(cb).width();
                if (op.textType == apollo.Enum.Month)
                    Width = 123;
                else if (op.textType == apollo.Enum.Year)
                    Width = 73;
                else {
                    Width = 120;
                }
                if (Width <= 0) Width = 120;
                if (typeof op.width == "number" && Width < op.width)
                    Width = op.width;
            }

            var editor = apollo.form.baseEditor();

            cb.change(function (e) {
                try {
                    if (op.onchange != null)
                        op.onchange(editor.getvalue());
                }
                catch (e) { }
                try {
                    if (editor.onchange != null)
                        editor.onchange(editor.getvalue());
                }
                catch (e) { }
            });

            var issetvalue = false;
            function setComboboxValue(cb, v) {
                var isSeted = false;
                var ov = cb.combobox("getValue");
                if (ov == v) return; //未实际改变值
                issetvalue = true;

                try {
                    var idfield = "value";
                    var source = op.source;
                    if (source != null) {
                        idfield = source.valuefield;
                    }
                    //先检测有没有值
                    var data = cb.combobox("getData");
                    for (var i = 0; i < data.length; i++) {
                        var item = data[i];
                        if (apollo.Lib.getAttr(item, idfield) == v) //有值
                        {
                            cb.combobox("setValue", v);
                            isSeted = true;
                        }
                    }
                }
                catch (e) { }
                if (!isSeted) //当前列表项没有该项
                {
                    cb.combobox("setValue",v);
                }
                issetvalue = false;
            }


            

            var json = {
                required: !op.allowEmpty,
                multiple: op.mutilselect,
                editable: op.editable,
                showItemIcon: op.showItemIcon,
                height: apollo.form.inputHeight,
                value: op.defaultValue,
                onChange: function (nv, ov) {
                    if (issetvalue == true) return;
                    if (editor.isdestroy == true) return;
                    if (op.editable == true || 1 == 1) {
                        var fun = function () {
                            try {
                                if (jQuery.isFunction(op.onchange))
                                    op.onchange(nv);
                            }
                            catch (e) { }
                            try {
                                if (editor.onchange != null)
                                    editor.onchange(nv);
                            }
                            catch (e) {
                            }
                        };
                        window.setTimeout(function () {
                            fun()
                        }.bind(this), 200);
                    }
                },
                onSelect: function (rec) {
                    try {
                        if (op.onselect != null)
                            op.onselect(rec);
                    }
                    catch (e) { }
                    try {
                        if (editor.onselect != null)
                            editor.onselect(rec);
                    }
                    catch (e) { }
                },
                onLoadSuccess: function () //成功加载数据
                {
                    if (isInitLoad == false && initValue != null) {
                        if (op.mutilselect == true) {
                            issetvalue = true;
                            cb.combobox("setValues", initValue);
                            issetvalue = false;
                        }
                        else
                            setComboboxValue(cb, initValue);
                        initValue = null;
                    }
                    isInitLoad = true;
                }
            };
            var source = op.source;
            var sourceurl = "";
            var getparamfun = null;
            if (source != null) {
                if (apollo.Lib.isNotEmpty(source.url)) {
                    json.url = source.url;
                    json.valueField = source.valuefield;
                    json.textField = source.textfield;
                    if (apollo.Lib.isNotEmpty(source.paramfun)) {
                        getparamfun = apollo.Lib.parseFun(source.paramfun);
                    }
                    sourceurl = json.url;
                }
                else if (apollo.Lib.isNotEmpty(source.apicontroller) && apollo.Lib.isNotEmpty(source.apiaction)) {
                    json.url = apollo.getApiUrl(source.apicontroller, source.apiaction);
                    json.valueField = source.valuefield;
                    json.textField = source.textfield;
                    if (apollo.Lib.isNotEmpty(source.paramfun)) {
                        getparamfun = apollo.Lib.parseFun(source.paramfun);
                    }
                    sourceurl = json.url;
                }
                else if (apollo.Lib.isNotEmpty(source.valuefield) && apollo.Lib.isNotEmpty(source.textfield) && apollo.Lib.isNotEmpty(source.table)) {
                    json.url = apollo.pageInfo.base + "src/ApolloUIHandler.ashx?action=GetDataSource&idfield=" + source.valuefield + "&textfield=" + source.textfield + "&table=" + source.table + "&sortfield" + source.sortfield + "&curfilter=" + source.curfilter
                    json.valueField = source.valuefield;
                    json.textField = source.textfield;
                }
                else if (jQuery.isArray(source.data)) {
                    json.data = source.data;
                    json.valueField = source.valuefield;
                    json.textField = source.textfield;
                    isInitLoad = true;//这类是属于直接加载，所以视为已加载
                }
            }

            var initeditor;
            if (op.easyui == true) {
                if (apollo.Lib.isNotEmpty(json.url)) {
                    var param = {};
                    if (jQuery.isFunction(getparamfun)) {
                        param = getparamfun();
                    }
                    if (param == null) param = {};
                    json.queryParams = param;
                }
                initeditor = function () {
                    cb.combobox(json);
                    editor.name = op.name;
                    editor.textType = op.textType;
                    editor.isempty = false;
                    editor.getvalue = function () {
                        //根据数据类型重新取值
                        var arrv;
                        if (op.mutilselect == true) { //为多选
                            arrv = cb.combobox("getValues");
                        }
                        else {
                            arrv = cb.combobox("getValue");
                        }
                        if ($.isArray(arrv)) {
                            var arr = [];
                            $(arrv).each(function (i, v) {
                                arr.push(getValueTypeV(v, op.textType));
                            });

                            if (op.valueType == 0) {
                                return arr.join(",");
                            }
                            else
                                return arr;
                        }
                        else {
                            return getValueTypeV(arrv, op.textType);
                        }
                    };
                    editor.gettext = function () {
                        return cb.combobox("getText");
                    };
                    editor.setvalue = function (v, t) {
                        if (op.mutilselect == true) //当前是支持多选
                        {
                            var arr = [];
                            if ($.isArray(v)) //设置的值类型为字符串,所赋值为数组,则自动更改为数组
                            {
                                op.valueType = 1;

                                $(v).each(function (i, cv) {
                                    arr = getValueTypeV(cv, op.textType);
                                });
                            }
                            else //非数组
                            {
                                op.valueType = 0;
                                if (typeof (v) == "string") {
                                    var nv = v.split(",");
                                    $(v).each(function (i, cv) {
                                        arr = getValueTypeV(cv, op.textType);
                                    });
                                }
                            }
                            if (isInitLoad == true) {
                                issetvalue = true;
                                cb.combobox("setValues", arr);
                                issetvalue = false;
                            }
                            else {
                                initValue = arr;
                            }
                        }
                        else {
                            var fv = v;
                            if (op.textType == apollo.Enum.textType.Boolean) {
                                if (v == "1" || v == 1 || v == true || v == "true" || v == "True" || v == "TRUE" || v == "是" || v == "真")
                                    fv = "1";
                                else if (v == "0" || v == 0 || v == false || v == "false" || v == "False" || v == "FALSE" || v == "否" || v == "假")
                                    fv = "0"
                            }
                            if (isInitLoad == true)
                                setComboboxValue(cb, fv);
                            else {
                                initValue = fv;
                            }
                        }
                    };
                    editor.setdefultvalue = function () {
                        if (op.mutilselect == true)
                            editor.setvalue([]);
                        else
                            editor.setvalue(getDefaultValue(op.textType));
                    };
                    editor.getdataitem = function () {
                        var v = editor.getvalue();
                        if ($.isArray(v)) {
                            if (v.length > 0)
                                return v[0];
                            else
                                return null;
                        }
                        else
                            return v;
                    };
                    editor.getdataitems = function () {
                        var arr = editor.getvalue();
                        if ($.isArray(arr))
                            return arr;
                        else
                            return [arr];
                    };
                    editor.isvalid = function () {
                        if (editor.enabled && editor.visible) {
                            return cb.combobox("isValid");
                        }
                        else
                            return true;
                    };
                    editor.setvisible = function (visible) {
                        this.visible = visible == true;

                        if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                            if (visible == true)
                                $("#" + op.itempanelid).show();
                            else
                                $("#" + op.itempanelid).hide();
                        }
                        if (visible == true)
                            divbox.show();
                        else
                            divbox.hide();
                    };
                    editor.setenabled = function (enabled) {
                        this.enabled = enabled == true;

                        if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                            if (visible == true)
                                $("#" + op.itempanelid).attr("disabled", "disabled");
                            else
                                $("#" + op.itempanelid).removeAttr("disabled");
                        }
                        if (enabled == true) {
                            cb.combobox("enable");
                        }
                        else {
                            cb.combobox("disable");
                        }
                    };
                    editor.destroy = function () {
                        cb.combobox("destroy");
                        this.isdestroy = true;
                    };
                    editor.loadsource = function (p) {
                        if (apollo.Lib.isNotEmpty(sourceurl)) {
                            var param = p;
                            if (jQuery.isFunction(getparamfun)) {
                                param = getparamfun();
                            }
                            if (param == null) param = {};

                            apollo.ajax(json.url, param, function (data) {
                                //取到原值
                                var v = editor.getvalue();
                                cb.combobox("loadData", data);
                                if (v != null && v != "") {
                                    try {
                                        var item = apollo.array.find(data, source.valuefield, v);
                                        if (item == null) v = null;
                                    }
                                    catch (e) {}
                                }
                                editor.setvalue(v);
                                json.onLoadSuccess();
                            }, function (errMsg) { })
                        }
                    };
                }
            }
            else {
                if (apollo.Lib.isNotEmpty(json.url)) {
                    var param = {};
                    if (jQuery.isFunction(getparamfun)) {
                        param = getparamfun();
                    }
                    if (param == null) param = {};
                    apollo.ajax(json.url, param, function (data) {
                        apollo.bindSelect(cb, data, op.allowEmpty, json.textField, json.valueField);
                        json.onLoadSuccess();

                    }, function (errMsg) { })
                }
                else if (jQuery.isArray(json.data)) {
                    apollo.bindSelect(cb, data, op.allowEmpty, json.textField, json.valueField);
                    json.onLoadSuccess();
                }
                initeditor = function () {
                    editor.name = op.name;
                    editor.textType = op.textType;
                    editor.isempty = false;
                    editor.getvalue = function () {
                        //根据数据类型重新取值
                        var v = cb.val();
                        return getValueTypeV(v, op.textType);
                    };
                    editor.gettext = function () {
                        return cb.val();
                    };
                    editor.setvalue = function (v, t) {
                        cb.val(v);
                    };
                    editor.setdefultvalue = function () {
                        editor.setvalue(getDefaultValue(op.textType));
                    };
                    editor.getdataitem = function () {
                        var v = editor.getvalue();
                        if (jQuery.isArray(v)) {
                            if (v.length > 0)
                                return v[0];
                            else
                                return null;
                        }
                        else
                            return v;
                    };
                    editor.getdataitems = function () {
                        var arr = editor.getvalue();
                        if (jQuery.isArray(arr))
                            return arr;
                        else
                            return [arr];
                    };
                    editor.isvalid = function () {
                        if (editor.enabled && editor.visible) {
                            return cb.val() == "";
                        }
                        else
                            return true;
                    };
                    editor.setvisible = function (visible) {
                        this.visible = visible == true;

                        if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                            if (visible == true)
                                jQuery("#" + op.itempanelid).show();
                            else
                                jQuery("#" + op.itempanelid).hide();
                        }
                        if (visible == true)
                            cb.show();
                        else
                            cb.hide();
                    };
                    editor.setenabled = function (enabled) {
                        this.enabled = enabled == true;

                        if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                            if (visible == true)
                                jQuery("#" + op.itempanelid).attr("disabled", "disabled");
                            else
                                jQuery("#" + op.itempanelid).removeAttr("disabled");
                        }
                        if (enabled == true) {
                            cb.attr("disabled", "disabled");
                        }
                        else {
                            cb.removeAttr("disabled");
                        }
                    };
                    editor.loadsource = function (p) {
                        if (apollo.Lib.isNotEmpty(sourceurl)) {
                            var param = p;
                            if (jQuery.isFunction(getparamfun)) {
                                param = getparamfun();
                            }
                            if (param == null) param = {};

                            apollo.ajax(json.url, param, function (data) {
                                apollo.bindSelect(cb, data, op.allowEmpty, json.textField, json.valueField);
                                json.onLoadSuccess();
                            }, function (errMsg) { })
                        }
                    };
                }
            }

            initeditor();
            return editor;
        },
        selecttree: function (options) {
            var cb = jQuery(this);
            var isInitLoad = false;//是否已初始化加载数据（第一次加载数据）
            var initValue = null;//初始化时加载数值

            var defaults = jQuery({ area: null }, apollo.Options.selecttree.option);
            var op = jQuery.extend(defaults, options);

            var divbox = $("<span></span>");


            var Width = $(cb).width();
            if (op.textType == apollo.Enum.Month)
                Width = 123;
            else if (op.textType == apollo.Enum.Year)
                Width = 73;
            else {
                Width = 120;
            }
            if (Width <= 0) Width = 120;
            if (typeof op.width == "number" && Width < op.width)
                Width = op.width;


            var editor = apollo.form.baseEditor();

            var issetvalue = false;
            function setComboboxValue(cb, v) {
                var isSeted = false;
                var ov = cb.combotree("getValue");
                if (ov == v) return; //未实际改变值
                issetvalue = true;

                try {
                    var idfield = "value";
                    var source = op.source;
                    if (source != null) {
                        idfield = source.valuefield;
                    }
                    cb.combotree("setValue", v);
                    isSeted = true;
                }
                catch (e) { }
                if (!isSeted) //当前列表项没有该项
                {
                    cb.combotree("setValue", "");
                }
                issetvalue = false;
            }


            var json = {
                required: !op.allowEmpty,
                multiple: op.mutilselect,
                editable: op.editable,
                height: apollo.form.inputHeight,
                value: op.defaultValue,
                onChange: function (nv, ov) {
                    if (issetvalue == true) return;
                    if (editor.isdestroy == true) return;
                    if (op.editable == true || 1 == 1) {
                        var fun = function () {
                            try {
                                if (jQuery.isFunction(op.onchange))
                                    op.onchange(nv);
                            }
                            catch (e) { }
                            try {
                                if (editor.onchange != null)
                                    editor.onchange(nv);
                            }
                            catch (e) {
                            }
                        };
                        window.setTimeout(function () {
                            fun()
                        }.bind(this), 200);
                    }
                },
                onSelect: function (rec) {
                    try {
                        if (op.onselect != null)
                            op.onselect(rec);
                    }
                    catch (e) { }
                    try {
                        if (editor.onselect != null)
                            editor.onselect(rec);
                    }
                    catch (e) { }
                },
                onLoadSuccess: function () //成功加载数据
                {
                    if (isInitLoad == false && initValue != null) {
                        if (op.mutilselect == true) {
                            issetvalue = true;
                            cb.combotree("setValues", initValue);
                            issetvalue = false;
                        }
                        else
                            setComboboxValue(cb, initValue);
                        initValue = null;
                    }
                    isInitLoad = true;
                }
            };
            var source = op.source;

            var sourceurl = "";
            var getparamfun = null;

            if (source != null) {
                if (apollo.Lib.isNotEmpty(source.url)) {
                    json.url = source.url;
                    json.valueField = source.valuefield;
                    json.textField = source.textfield;

                    if (apollo.Lib.isNotEmpty(source.paramfun)) {
                        getparamfun = apollo.Lib.parseFun(source.paramfun);
                    }
                    sourceurl = json.url;

                }
                else if (apollo.Lib.isNotEmpty(source.apicontroller) && apollo.Lib.isNotEmpty(source.apiaction)) {
                    json.url = apollo.getApiUrl(source.apicontroller, source.apiaction);
                    json.valueField = source.valuefield;
                    json.textField = source.textfield;

                    if (apollo.Lib.isNotEmpty(source.paramfun)) {
                        getparamfun = apollo.Lib.parseFun(source.paramfun);
                    }
                    sourceurl = json.url;

                }
                else if (apollo.Lib.isNotEmpty(source.valuefield) && apollo.Lib.isNotEmpty(source.textfield) && apollo.Lib.isNotEmpty(source.table)) {
                    json.url = apollo.pageInfo.base + "src/ApolloUIHandler.ashx?action=GetDataSource&idfield=" + source.valuefield + "&textfield=" + source.textfield + "&table=" + source.table + "&sortfield" + source.sortfield + "&curfilter=" + source.curfilter
                    json.valueField = source.valuefield;
                    json.textField = source.textfield;
                }
                else if (jQuery.isArray(source.data)) {
                    json.data = source.data;
                    json.valueField = source.valuefield;
                    json.textField = source.textfield;
                    isInitLoad = true;//这类是属于直接加载，所以视为已加载
                }
            }

                       
            if (apollo.Lib.isNotEmpty(json.url)) {

                var param = {};
                if (jQuery.isFunction(getparamfun)) {
                    param = getparamfun();
                }
                if (param == null) param = {};
                json.queryParams = param;
            }
            cb.combotree(json);

            editor.name = op.name;
            editor.textType = op.textType;
            editor.isempty = false;
            editor.getvalue = function () {
                //根据数据类型重新取值
                var arrv;
                if (op.mutilselect == true) { //为多选
                    arrv = cb.combotree("getValues");
                }
                else {
                    arrv = cb.combotree("getValue");
                }
                if ($.isArray(arrv)) {
                    var arr = [];
                    $(arrv).each(function (i, v) {
                        arr.push(getValueTypeV(v, op.textType));
                    });

                    if (op.valueType == 0) {
                        return arr.join(",");
                    }
                    else
                        return arr;
                }
                else {
                    return getValueTypeV(arrv, op.textType);
                }
            };
            editor.gettext = function () {
                return cb.combotree("getText");
            };
            editor.setvalue = function (v, t) {
                if (op.mutilselect == true) //当前是支持多选
                {
                    var arr = [];
                    if ($.isArray(v)) //设置的值类型为字符串,所赋值为数组,则自动更改为数组
                    {
                        op.valueType = 1;

                        $(v).each(function (i, cv) {
                            arr = getValueTypeV(cv, op.textType);
                        });
                    }
                    else //非数组
                    {
                        op.valueType = 0;
                        if (typeof (v) == "string") {
                            var nv = v.split(",");
                            $(v).each(function (i, cv) {
                                arr = getValueTypeV(cv, op.textType);
                            });
                        }
                    }
                    if (isInitLoad == true) {
                        issetvalue = true;
                        cb.combotree("setValues", arr);
                        issetvalue = false;
                    }
                    else {
                        initValue = arr;
                    }
                }
                else {
                    var fv = v;
                    if (op.textType == apollo.Enum.textType.Boolean) {
                        if (v == "1" || v == 1 || v == true || v == "true" || v == "True" || v == "TRUE" || v == "是" || v == "真")
                            fv = "1";
                        else if (v == "0" || v == 0 || v == false || v == "false" || v == "False" || v == "FALSE" || v == "否" || v == "假")
                            fv = "0"
                    }
                    if (isInitLoad == true)
                        setComboboxValue(cb, fv);
                    else {
                        initValue = fv;
                    }
                }
            };
            editor.setdefultvalue = function () {
                if (op.mutilselect == true)
                    editor.setvalue([]);
                else
                    editor.setvalue(getDefaultValue(op.textType));
            };
            editor.getdataitem = function () {
                var v = editor.getvalue();
                if ($.isArray(v)) {
                    if (v.length > 0)
                        return v[0];
                    else
                        return null;
                }
                else
                    return v;
            };
            editor.getdataitems = function () {
                var arr = editor.getvalue();
                if ($.isArray(arr))
                    return arr;
                else
                    return [arr];
            };
            editor.isvalid = function () {
                if (editor.enabled && editor.visible) {
                    return cb.combotree("isValid");
                }
                else
                    return true;
            };
            editor.setvisible = function (visible) {
                this.visible = visible == true;

                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        $("#" + op.itempanelid).show();
                    else
                        $("#" + op.itempanelid).hide();
                }
                if (visible == true)
                    divbox.show();
                else
                    divbox.hide();
            };
            editor.setenabled = function (enabled) {
                this.enabled = enabled == true;

                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        $("#" + op.itempanelid).attr("disabled", "disabled");
                    else
                        $("#" + op.itempanelid).removeAttr("disabled");
                }
                if (enabled == true) {
                    cb.combotree("enable");
                }
                else {
                    cb.combotree("disable");
                }
            };
            editor.destroy = function () {
                cb.combotree("destroy");
                this.isdestroy = true;
            };

            editor.loadsource = function (p) {
                if (apollo.Lib.isNotEmpty(sourceurl)) {
                    var param = p;
                    if (jQuery.isFunction(getparamfun)) {
                        param = getparamfun();
                    }
                    if (param == null) param = {};

                    apollo.ajax(json.url, param, function (data) {
                        cb.combotree("loadData", data);
                        json.onLoadSuccess();
                    }, function (errMsg) { })
                }
            }
            return editor;
        },
        popupbox: function (options) {
            var cb = $(this);
            var defaults = $({}, apollo.Options.popup.option);
            var op = $.extend(defaults, options);

            if (op.showType == 1 && op.mutilselect == true) {
                return cb.popuplist(options);//转为列表显示
            }

            //增加选择按钮
            var curData = {
                value: "",
                text: "",
                dataItem: null,
                dataItems: []
            };

            var divbox = $("<span></span>");
            cb.before(divbox);
            cb.remove();
            divbox.append(cb);



            var Width = $(cb).width();
            if (op.textType == apollo.Enum.Month)
                Width = 123;
            else if (op.textType == apollo.Enum.Year)
                Width = 73;
            else {
                Width = 120;
            }
            if (Width <= 0) Width = 120;

            if (typeof op.width == "number" && Width < op.width)
                Width = op.width;

            var gridjson = $.extend({}, apollo.Options.grid.option);

            var json = {
                required: !op.allowEmpty,
                height: apollo.form.inputHeight,
                value: op.defaultValue,
                editable: op.editable,
                type: 'text',
                buttonText: '...',
                onClickButton: function () {
                    if (op.source == null) {
                        showNotice("未定义弹出选项数据源!");
                        return;
                    }
                    if (apollo.Lib.isNotEmpty(op.source.winurl)) {
                        popupcustom(op.source.winurl, gridviewOp);
                    }
                    else {
                        popupWindow(cb, { gridJson: gridjson, ValueField: op.source.valuefield, TextField: op.source.textfield, MutilValues: op.mutilselect }, gridviewOp);
                    }
                }
            };

            if (apollo.Lib.isEmpty(cb.css("width")))
                json.width = Width;

            var winW = 0, winH = 0;

            var source = op.source;
            if (source != null) {
                gridjson.idfield = source.valuefield;

                var listFs = [];
                var arr = [];
                $(source.columns).each(function (i, c) {
                    arr.push(apollo.Options.getOptions(c, apollo.Options.column.option, apollo.Options.column.optionType));
                    listFs.push(c.field);
                });
                gridjson.columns = arr;

                arr = [];
                $(source.filters).each(function (i, f) {
                    arr.push(apollo.Options.getOptions(f, apollo.Options.filter.option, apollo.Options.filter.optionType));
                });
                gridjson.filters = arr;

                var funs = [];

                funs.push(
                    {
                        id: "btnOK",
                        title: "确认",
                        iconCls: "icon-ok",
                        clickFun: "SelectOK"
                    });
                if (op.allowEmpty) {
                    funs.push({
                        id: "btnEmpty",
                        title: "空行",
                        iconCls: "icon-tip",
                        clickFun: "SelectEmpty"
                    });
                }
                funs.push({
                    id: "btnCancel",
                    title: "取消",
                    iconCls: "icon-no",
                    clickFun: "SelectCancel"
                });
                gridjson.clientEvent.dblClickRowFun = "SelectOK";
                arr = [];
                $(funs).each(function (i, f) {
                    arr.push(apollo.Options.getOptions(f, apollo.Options.fun.option, apollo.Options.fun.optionType));
                });
                gridjson.funs = arr;

                gridjson.isMutilSelect = op.mutilselect;
                winW = source.width;
                winH = source.height;

                if (apollo.Lib.isNotEmpty(source.url)) {
                    gridjson.url = source.url;
                }
                else if (apollo.Lib.isNotEmpty(source.apicontroller) && apollo.Lib.isNotEmpty(source.apiaction)) {
                    gridjson.url = apollo.getApiUrl(source.apicontroller, source.apiaction);
                }
                else if (apollo.Lib.isNotEmpty(source.valuefield) && apollo.Lib.isNotEmpty(source.textfield) && apollo.Lib.isNotEmpty(source.table)) {
                    gridjson.url = apollo.pageInfo.base + "src/ApolloUIHandler.ashx?action=GetPopupSource&idfield=" + source.valuefield + "&textfield=" + source.textfield + "&table=" + source.table + "&sortfield" + source.sortfield + "&curfilter=" + source.curfilter + "&listfs=" + listFs.join(",");
                }
                else if (jQuery.isArray(source.data)) {
                    gridjson.data = source.data;
                }
            }
            var gridviewOp = {
                width: winW,
                height: winH,
                options: gridjson
            };
            function execchange(v) {
                try {
                    if (jQuery.isFunction(op.onchange))
                        op.onchange(v);
                }
                catch (e) { }
                try {
                    if (jQuery.isFunction(editor.onchange))
                        editor.onchange(v);
                }
                catch (e) { }
            }
            function execselect(data) {
                try {
                    if (jQuery.isFunction(op.onselect))
                        op.onselect(data);
                }
                catch (e) { }
                try {
                    if (jQuery.isFunction(editor.onselect))
                        editor.onselect(data);
                }
                catch (e) { }
            }
            function popupcustom(pageurl, gridviewOp) {
                var w = 900, h = 450;

                if (gridviewOp != null) {
                    if (gridviewOp.width > 100)
                        w = gridviewOp.width;
                    if (gridviewOp.height > 100)
                        h = gridviewOp.height;
                }

                var param = {};
                var fun = apollo.Lib.parseFun(op.source.paramfun);
                if (jQuery.isFunction(fun)) {
                    param = $(param, fun());
                }
                apollo.openWin(pageurl, w, h, selectData, param);
            }

            function popupWindow(box, jsonBoj, gridviewOp) {
                var v = editor.getvalue();
                var values;
                if ($.isArray(v))
                    values = v;
                else if (typeof v == "string")
                    values = v.split(",");

                values = [];

                var w = 700, h = 450;

                if (gridviewOp != null) {
                    if (gridviewOp.width > 100)
                        w = gridviewOp.width;
                    if (gridviewOp.height > 100)
                        h = gridviewOp.height;
                }

                var html = apollo.pageInfo.base + "page/SelectGridWin.html";
                if (op.mutilselect) { //复杂选择
                    html = apollo.pageInfo.base + "page/MutilSelectWin.html";
                    if (w < 1000) w = 1000;
                }

                apollo.openWin(html, w, h, selectData, { options: jsonBoj, viewOptions: gridviewOp.options, values: values });
            }

            function selectData(data) {
                if (data != null && (jQuery.isPlainObject(data) || jQuery.isArray(data))) {//选中有效记录
                    var fv = "";
                    if (op.mutilselect == true) //多选
                    {
                        if (jQuery.isPlainObject(data)) {
                            curData.dataItem = data;
                            curData.dataItems = [data];
                            curData.value = data.value;
                            curData.text = data.text;
                            cb.textbox("setValue", data.value);
                            cb.textbox("setText", data.text);
                            fv = data.value;
                        }
                        else if (jQuery.isArray(data) && data.length > 0) {
                            curData.dataItem = data[0];
                            curData.dataItems = data;
                            var v = [], t = [];
                            $(data).each(function (i, d) {
                                v.push(d.value);
                                t.push(t.value);
                            });
                            cb.textbox("setValue", v.json(","));
                            cb.textbox("setText", t.json(","));
                            fv = v.json(",");
                        }
                    }
                    else {
                        curData.dataItem = data;
                        curData.dataItems = [data];
                        curData.value = data.value;
                        curData.text = data.text;
                        cb.textbox("setValue", data.value);
                        cb.textbox("setText", data.text);
                        fv = data.value;
                    }
                    //确定是否要激发onchange和onselect事件
                    execchange(fv);
                    execselect(data);
                }
            }

            cb.textbox(json);
            var editor = apollo.form.baseEditor();

            editor.name = op.name;
            editor.textType = op.textType;
            editor.isempty = false;
            editor.getvalue = function () {
                //根据数据类型重新取值
                var arrv;
                var v = cb.textbox("getValue");
                if (op.mutilselect == true) { //为多选
                    if (typeof v == "string" && apollo.Lib.isNotEmpty(v))
                        arrv = v.split(",");
                    else
                        arrv = [v];
                }
                else {
                    arrv = v;
                }
                if ($.isArray(arrv)) {
                    var arr = [];
                    $(arrv).each(function (i, v) {
                        arr.push(getValueTypeV(v, op.textType));
                    });

                    if (op.valueType == 0) {
                        return arr.join(",");
                    }
                    else
                        return arr;
                }
                else {
                    return getValueTypeV(arrv, op.testType);
                }
            };
            editor.gettext = function () {
                return cb.textbox("getText");
            };
            editor.setvalue = function (value, t) {
                var v;
                if ($.isArray(value)) {
                    op.valueType = 1;
                    v = value.join(",");
                }
                else {
                    op.valueType = 0;
                    v = value.toString();
                }
                if (apollo.Lib.isNotEmpty(source.valuefield) && apollo.Lib.isNotEmpty(source.textfield) && apollo.Lib.isNotEmpty(source.table)) {
                    var arr = [];
                    if (apollo.Lib.isNotEmpty(v)) {
                        var varr = v.split(",");
                        $(varr).each(function (i, a) {
                            if (apollo.Lib.isNotEmpty(a))
                                arr.push(a);
                        });
                    }
                    if (arr.length > 0) {
                        var url = apollo.pageInfo.base + "src/ApolloUIHandler.ashx?action=GetPopupSource";
                        var param = {
                            idfield: source.valuefield,
                            textfield: source.textfield,
                            table: source.table,
                            sortfield: source.sortfield,
                            curfilter: source.curfilter,
                            listfs: listFs.join(","),
                            isSetValue: true,
                            values: JSON.stringify(arr)
                        }
                        apollo.ajax(url, param, function (rows) {
                            var myarrT = [];
                            var myarrV = [];
                            var myarr = [];
                            $(rows).each(function (i, row) {
                                var fv = "", ft = "";
                                if (source.valuefield in row)
                                    fv = row[source.valuefield];
                                if (source.textfield in row)
                                    ft = row[source.textfield];

                                if (fv != "" && ft != "") {
                                    myarrT.push(ft);
                                    myarrV.push(fv);
                                    myarr.push(row);
                                }
                            });

                            var datas = {
                                value: myarrV.join(","),
                                text: myarrT.join(","),
                                dataItem: myarr.length > 0 ? myarr[0] : null,
                                dataItems: myarr
                            }
                            selectData(datas);
                        }, function (err) {
                            var datas = {
                                value: "",
                                text: "",
                                dataItem: null,
                                dataItems: []
                            };
                            selectData(datas);
                        });
                    }
                }
                else {
                    curData = {
                        value: "",
                        text: "",
                        dataItem: null,
                        dataItems: []
                    };
                    if ($.isArray(value)) {
                        var dataitems = [];
                        $(value).each(function (i, a) {
                            var item = {};
                            if (apollo.Lib.isNotEmpty(source.textfield) && apollo.Lib.isNotEmpty(source.valuefield)) {
                                item[source.textfield] = a;
                                item[source.valuefield] = a;
                                dataitems.push(item);
                            }
                        });

                        curData.dataItems = dataitems;
                        curData.dataItem = dataitems.length > 0 ? dataitems[0] : null;
                        curData.value = value.join(",");
                        curData.text = curData.value;
                    }
                    else if (apollo.Lib.isNotEmpty(value)) {
                        curData.value = value;
                        curData.text = value;
                        var item = {};
                        if (apollo.Lib.isNotEmpty(source.textfield) && apollo.Lib.isNotEmpty(source.valuefield)) {
                            item[source.textfield] = value;
                            item[source.valuefield] = value;
                        }
                        curData.dataItem = item;
                        curData.dataItems.push(item);
                    }
                    selectData(curData);
                }
            };
            editor.setdefultvalue = function () {
                editor.setvalue(getDefaultValue(op.textType));
            };
            editor.getdataitem = function () {
                return curData.dataItem;
            };
            editor.getdataitems = function () {
                return curData.dataItems;
            };
            editor.isvalid = function () {
                if (editor.enabled && editor.visible) {
                    return cb.textbox("isValid");
                }
                else
                    return true;
            }
            editor.setvisible = function (visible) {
                editor.visible = visible;
                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        $("#" + op.itempanelid).show();
                    else
                        $("#" + op.itempanelid).hide();
                }
                if (visible == true)
                    divbox.show();
                else
                    divbox.hide();
            }
            editor.setenabled = function (enabled) {
                editor.enabled = enabled == true;
                if (enabled == true)
                    cb.textbox("enable");
                else
                    cb.textbox("disable");
            }
            editor.destroy = function () {
                cb.validatebox("destroy");
            };
            return editor;
        },
        popuplist: function (options) {
            var cb = $(this);
            var defaults = $({}, apollo.Options.popup.option);
            var op = $.extend(defaults, options);
            if (op.mutilselect != true) {
                return cb.popupbox(options);//转为列表显示
            }
            var arrLi = [];//存储显示列项
            var addLi = $("<li></li>");
            var alink = $("<a style=\"font-weight:bold\">添加选项...</a>");
            addLi.append(alink);

            var ul = $("<ul class='pupuplist-ul'></ul>");
            ul.append(addLi);
            cb.before(ul);
            cb.hide();

            alink.linkbutton({
                plain: true,
                iconCls: "icon-add"
            });

            //增加选择按钮
            var arrV = [];//保存当前选中的值
            var arrT = [];//保存当前选中的显示文本


            var gridjson = $.extend({}, apollo.Options.grid.option);
            var winW = 0, winH = 0;

            var source = op.source;
            if (source != null) {
                gridjson.idfield = source.valuefield;

                gridjson.istree = source.istree;
                gridjson.treefield = source.textfield;

                var listFs = [];
                var arr = [];
                $(source.columns).each(function (i, c) {
                    arr.push(apollo.Options.getOptions(c, apollo.Options.column.option, apollo.Options.column.optionType));
                    listFs.push(c.field);
                });
                gridjson.columns = arr;

                arr = [];
                $(source.filters).each(function (i, f) {
                    arr.push(apollo.Options.getOptions(f, apollo.Options.filter.option, apollo.Options.filter.optionType));
                });
                gridjson.filters = arr;

                var funs = [];

                funs.push(
                    {
                        id: "btnOK",
                        title: "确认",
                        iconCls: "icon-ok",
                        clickFun: "SelectOK"
                    });
                if (op.allowEmpty) {
                    funs.push({
                        id: "btnEmpty",
                        title: "空行",
                        iconCls: "icon-tip",
                        clickFun: "SelectEmpty"
                    });
                }
                funs.push({
                    id: "btnCancel",
                    title: "取消",
                    iconCls: "icon-no",
                    clickFun: "SelectCancel"
                });
                gridjson.clientEvent.dblClickRowFun = "SelectOK";
                arr = [];
                $(funs).each(function (i, f) {
                    arr.push(apollo.Options.getOptions(f, apollo.Options.fun.option, apollo.Options.fun.optionType));
                });
                gridjson.funs = arr;

                gridjson.isMutilSelect = op.mutilselect;
                winW = source.width;
                winH = source.height;

                if (apollo.Lib.isNotEmpty(source.url)) {
                    gridjson.url = source.url;
                }
                else if (apollo.Lib.isNotEmpty(source.apicontroller) && apollo.Lib.isNotEmpty(source.apiaction)) {
                    gridjson.url = apollo.getApiUrl(source.apicontroller, source.apiaction);
                }
                else if (apollo.Lib.isNotEmpty(source.valuefield) && apollo.Lib.isNotEmpty(source.textfield) && apollo.Lib.isNotEmpty(source.table)) {
                    gridjson.url = apollo.pageInfo.base + "src/ApolloUIHandler.ashx?action=GetPopupSource&idfield=" + source.valuefield + "&textfield=" + source.textfield + "&table=" + source.table + "&sortfield" + source.sortfield + "&curfilter=" + source.curfilter + "&listfs=" + listFs.join(",");
                }
                else if (jQuery.isArray(source.data)) {                   
                    gridjson.data = source.data;
                }
            }
            var gridviewOp = {
                width: winW,
                height: winH,
                options: gridjson
            };


            alink.click(function (e) {

                if (op.source == null) {
                    showNotice("未定义弹出选项数据源!");
                    return;
                }
                if (apollo.Lib.isNotEmpty(op.source.winurl)) {
                    popupcustom(op.source.winurl, gridviewOp);
                }
                else {
                    popupWindow(cb, { gridJson: {}, ValueField: op.source.valuefield, TextField: op.source.textfield, MutilValues: op.mutilselect }, gridviewOp);
                }
            });

            function popupcustom(pageurl, gridviewOp) {
                var w = 900, h = 450;

                if (gridviewOp != null) {
                    if (gridviewOp.width > 100)
                        w = gridviewOp.width;
                    if (gridviewOp.height > 100)
                        h = gridviewOp.height;
                }

                var param = {};
                var fun = apollo.Lib.parseFun(op.source.paramfun);
                if (jQuery.isFunction(fun)) {
                    param = $(param, fun());
                }
                apollo.openWin(pageurl, w, h, selectData, param);
            }
            function popupWindow(box, jsonBoj, gridviewOp) {
                var v = editor.getvalue();
                var values;
                if ($.isArray(v))
                    values = v;
                else if (typeof v == "string")
                    values = v.split(",");
                else
                    values = [];

                var w = 700, h = 450;

                if (gridviewOp != null) {
                    if (gridviewOp.width > 100)
                        w = gridviewOp.width;
                    if (gridviewOp.height > 100)
                        h = gridviewOp.height;
                }

                var html = apollo.pageInfo.base + "page/SelectGridWin.html";
                if (op.mutilselect) { //复杂选择
                    html = apollo.pageInfo.base + "page/MutilSelectWin.html";
                    if (w < 1000) w = 1000;
                }
                apollo.openWin(html, w, h, selectData, { options: jsonBoj, viewOptions: gridviewOp.options, values: values });
            }

            function selectData(data,noevent) {
                if (data != null && data != undefined) {
                    var items = data.dataItems;

                    $(items).each(function (i, item) {
                        var v = $(item).attr(op.source.valuefield);
                        var t = $(item).attr(op.source.textfield);
                        if (v != null) {
                            if (apollo.Lib.isIn(v, arrV)) return;

                            arrV.push(v);
                            arrT.push(t);
                            var li = $("<li></li>");
                            li.append(t);
                            li.data("curData", { data: item, value: v, text: t });
                            arrLi.push(li);

                            var btndel = $("<span class=\"pupuplist-icon icon-remove\"></span>");
                            btndel.css("color", "red");
                            btndel.data("myLi", li);
                            btndel.click(function () {
                                var myli = $(this).data("myLi");
                                var data = myli.data("curData");
                                arrV = removeItem(arrV, data.value);
                                arrT = removeItem(arrT, data.text);
                                myli.remove();

                                arrLi = removeItem(arrLi, myli);


                                execchange(arrV.join(","));
                                
                                execselect(editor.getdata());


                            });
                            li.append(btndel);

                            addLi.before(li);
                            addLi.before(" ");
                        }
                    });
                    if (noevent == true) return;
                    execchange(arrV.join(","));
                    execselect(items);
                }
            }
            function execchange(v) {
                try {
                    if (jQuery.isFunction(op.onchange))
                        op.onchange(v);
                }
                catch (e) { showNotice("popuplist=>execchange:" + e.message)  }
                try {
                    if (jQuery.isFunction(editor.onchange))
                        editor.onchange(v);
                }
                catch (e) { showNotice("popuplist=>execchange:" + e.message)  }
            }
            function execselect(data) {
                try {
                    if (jQuery.isFunction(op.onselect))
                        op.onselect(data);
                }
                catch (e) { showNotice("popuplist=>execselect:" + e.message)  }
                try {
                    if (jQuery.isFunction(editor.onselect))
                        editor.onselect(data);
                }
                catch (e) { showNotice("popuplist=>execselect:" + e.message); }
            }

            var editor = apollo.form.baseEditor();

            editor.name = op.name;
            editor.textType = op.textType;
            editor.isempty = false;
            editor.getvalue = function () {
                //根据数据类型重新取值
                if (op.valueType == 1)
                    return arrV;
                else
                    return arrV.join(",");
            };
            editor.gettext = function () {
                return arrT.join(",");
            };
            editor.setvalue = function (value, t) {
                var v;
                var v;
                if ($.isArray(value)) {
                    op.valueType = 1;
                    v = value.join(",");
                }
                else {
                    op.valueType = 0;
                    v = value.toString();
                }
                if (apollo.Lib.isNotEmpty(source.valuefield) && apollo.Lib.isNotEmpty(source.textfield) && apollo.Lib.isNotEmpty(source.table)) {
                    var arr = [];
                    if (apollo.Lib.isNotEmpty(v)) {
                        var varr = v.split(",");
                        $(varr).each(function (i, a) {
                            if (apollo.Lib.isNotEmpty(a))
                                arr.push(a);
                        });
                    }
                    if (arr.length > 0) {
                        var url = apollo.pageInfo.base + "src/ApolloUIHandler.ashx?action=GetPopupSource";
                        var param = {
                            idfield: source.valuefield,
                            textfield: source.textfield,
                            table: source.table,
                            sortfield: source.sortfield,
                            curfilter: source.curfilter,
                            listfs: listFs.join(","),
                            isSetValue: true,
                            values: JSON.stringify(arr)
                        }
                        apollo.ajax(url, param, function (rows) {
                            var myarrT = [];
                            var myarrV = [];
                            var myarr = [];
                            $(rows).each(function (i, row) {
                                var fv = "", ft = "";
                                if (source.valuefield in row)
                                    fv = row[source.valuefield];
                                if (source.textfield in row)
                                    ft = row[source.textfield];

                                if (fv != "" && ft != "") {
                                    myarrT.push(ft);
                                    myarrV.push(fv);
                                    myarr.push(row);
                                }
                            });

                            var datas = {
                                value: myarrV.join(","),
                                text: myarrT.join(","),
                                dataItem: myarr.length > 0 ? myarr[0] : null,
                                dataItems: myarr
                            }
                            selectData(datas);
                        }, function (err) {
                            var datas = {
                                value: "",
                                text: "",
                                dataItem: null,
                                dataItems: []
                            };
                            selectData(datas);
                        });
                    }
                }
                else {
                    var curData = {
                        value: "",
                        text: "",
                        dataItem: null,
                        dataItems: []
                    };
                    if ($.isArray(value)) {
                        var dataitems = [];
                        $(value).each(function (i, a) {
                            var item = {};
                            if (apollo.Lib.isNotEmpty(source.textfield) && apollo.Lib.isNotEmpty(source.valuefield)) {
                                item[source.textfield] = a;
                                item[source.valuefield] = a;
                                dataitems.push(item);
                            }
                        });

                        curData.dataItems = dataitems;
                        curData.dataItem = dataitems.length > 0 ? dataitems[0] : null;
                        curData.value = value.join(",");
                        curData.text = curData.value;
                    }
                    else if (apollo.Lib.isNotEmpty(value)) {
                        curData.value = value;
                        curData.text = value;
                        var item = {};
                        if (apollo.Lib.isNotEmpty(source.textfield) && apollo.Lib.isNotEmpty(source.valuefield)) {
                            item[source.textfield] = value;
                            item[source.valuefield] = value;
                        }
                        curData.dataItem = item;
                        curData.dataItems.push(item);
                    }
                    selectData(curData);
                }
            };
            editor.setdefultvalue = function () {
                editor.setvalue([]);
            };
            editor.getdataitem = function () {
                return arrV.length > 0 ? arrV[0] : null;
            };
            editor.getdataitems = function () {
                return arrV;
            };
            editor.setdata = function (data) {
                $(arrLi).each(function (i, li) {
                    $(li).remove();
                });
                apollo.array.clear(arrLi);
                apollo.array.clear(arrV);
                apollo.array.clear(arrT);
                selectData({ dataItems: data },true);
            };
            editor.getdata = function () {
                var arr = [];
                $(arrLi).each(function (i, li) {
                    var data = $(li).data("curData");
                    if (jQuery.isPlainObject(data)) {
                        arr.push(data.data);
                    }
                });
                return arr;
            };

            editor.isvalid = function () {
                if (editor.enabled && editor.visible) {
                    if (!op.allowEmpty) {
                        return arrV.length > 0;
                    }
                    else
                        return true;
                }
                else
                    return true;
            };
            editor.setvisible = function (visible) {
                editor.visible = visible;
                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        $("#" + op.itempanelid).show();
                    else
                        $("#" + op.itempanelid).hide();
                }
                if (visible == true)
                    ul.show();
                else
                    ul.hide();
            };
            editor.setenabled = function (enabled) {
                editor.enabled = enabled == true;
                if (enabled == true) {
                    addLi.removeAttr("disabled");
                    ul.removeAttr("disabled");
                }
                else {
                    addLi.attr("disabled", "disabled");
                    ul.find(".l-btn-icon").attr("disabled", "disabled");
                }
            };
            return editor;
        },
        filebox: function (options) {
            var cb = jQuery(this);
            var defaults = jQuery({ area: null }, apollo.Options.file.option);
            var op = jQuery.extend(defaults, options);

            var arrT = [], arrV = [];

            var arrLi = [];//存储显示列项
            var addLi = jQuery("<li></li>");
            var alink = jQuery("<a style=\"font-weight:bold\">添加文件...</a>");
            addLi.append(alink);

            var ul = jQuery("<ul class='pupuplist-ul'></ul>");
            ul.append(addLi);
            cb.before(ul);
            cb.remove();

            alink.linkbutton({
                plain: true,
                iconCls: "icon-add"
            });
            alink.click(function (e) {
                popupWindow();
            });

            function popupWindow() {
                var w = 700, h = 450;


                var html = apollo.pageInfo.base + "aupload/upload.html";
                var param = {
                    isonline: op.isonline,//是否可以在线进行文件查看管理
                    nochangename: op.nochangename,//不改变原文件名
                    mutilselect: op.mutilselect,//是否为单文件上传还是多文件上传
                    fpathconfig: op.fpathconfig,//上传保存的物理路径配置,如为空，则取系统设置(fpathconfig和vpathconfig必须配对设置)
                    vpathconfig: op.vpathconfig,//上传保存后访问的虚拟路径配置，如为空，则取系统默认设置(fpathconfig和vpathconfig必须配对设置)
                    fileMaxSize: 1024 * 1024 * 1024,//上传文件最大路径
                    acceptExtensions: ['*.*']//上传文件可接收的文件类型
                };


                apollo.openWin(html, w, h, selectData, param);
            }

            function selectData(data) {
                if (data != null && data != undefined) {
                    var items = data;
                    //先移除之前
                    jQuery(items).each(function (i, item) {
                        var fn = item.title;
                        if (fn == "") return;
                        var v = item.url;
                        var t = fn;
                        if (v != null) {
                            //这里要过滤重复的
                            if (apollo.Lib.isIn(v, arrV)) return;

                            arrV.push(v);
                            arrT.push(t);
                            var li = jQuery("<li></li>");
                            li.append(t);
                            li.data("curData", { value: v, text: t });

                            var btndel = jQuery("<span class=\"pupuplist-icon icon-remove\"></span>");
                            btndel.css("color", "red");
                            btndel.data("myLi", li);
                            btndel.click(function () {
                                var myli = jQuery(this).data("myLi");
                                var data = myli.data("curData");
                                arrV = removeItem(arrV, data.value);
                                arrT = removeItem(arrT, data.text);
                                myli.remove();
                            });
                            li.append(btndel);

                            addLi.before(li);
                            addLi.before(" ");
                        }
                    });
                }
            }


            var editor = apollo.form.baseEditor();

            editor.name = op.name;
            editor.textType = 0;
            editor.isempty = false;
            editor.getvalue = function () {
                //根据数据类型重新取值
                if (op.valueType == 1)
                    return arrV;
                else
                    return arrV.join(",");
            };
            editor.gettext = function () {
                return arrT.join(",");
            };
            editor.setvalue = function (value, t) {
                var v;
                if (jQuery.isArray(value)) {
                    op.valueType = 1;
                    v = value;
                }
                else {
                    op.valueType = 0;
                    if (apollo.Lib.isNotEmpty(value))
                        v = value.split(",");
                    else
                        v = [];
                }
                var data = [];
                jQuery(v).each(function (i, f) {
                    if (apollo.Lib.isNotEmpty(f)) {
                        var t = getFileName(f);
                        data.push({ title: t, url: f });
                    }
                });

                //进行初始化
                arrT = [];
                arrV = [];

                jQuery(arrLi).each(function (i, li) { li.remove(); });
                arrLi = [];

                selectData(data);
            };
            editor.setdefultvalue = function () {
                editor.setvalue([]);
            };
            editor.getdataitem = function () {
                return arrV.length > 0 ? arrV[0] : null;
            };
            editor.getdataitems = function () {
                return arrV;
            };
            editor.isvalid = function () {
                if (editor.enabled && editor.visible) {
                    if (!op.allowEmpty) {
                        return arrV.length > 0;
                    }
                    else
                        return true;
                }
                else
                    return true;
            };
            editor.setvisible = function (visible) {
                editor.visible = visible;
                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        jQuery("#" + op.itempanelid).show();
                    else
                        jQuery("#" + op.itempanelid).hide();
                }
                if (visible == true)
                    ul.show();
                else
                    ul.hide();
            };
            editor.setenabled = function (enabled) {
                editor.enabled = enabled == true;
                if (enabled == true) {
                    addLi.removeAttr("disabled");
                    ul.removeAttr("disabled");
                }
                else {
                    addLi.attr("disabled", "disabled");
                    ul.find(".l-btn-icon").attr("disabled", "disabled");
                }
            };
            return editor;
        },
        customfile: function (options) {
            var cb = jQuery(this);
            var defaults = jQuery({ area: null }, apollo.Options.customfile.option);
            var op = jQuery.extend(defaults, options);
            if (apollo.Lib.isEmpty(op.btnid) || op.btnid == "#")
                return cb.filebox();

            var alink;
            if (apollo.util.startsWith(op.btnid, "#")) {
                alink = jQuery(op.btnid);
            }
            else
                alink = jQuery("#" + op.btnid);
            if (alink.length == 0)
                return cb.filebox();

            var arrT = [], arrV = [], curDatas = [];

            alink.click(function (e) {
                popupWindow();
            });

            function popupWindow() {
                var w = 700, h = 450;
                var html = apollo.pageInfo.base + "aupload/upload.html";
                var param = {
                    isimage: op.isimage,
                    isonline: op.isonline,//是否可以在线进行文件查看管理
                    nochangename: op.nochangename,//不改变原文件名
                    mutilselect: op.mutilselect,//是否为单文件上传还是多文件上传
                    fpathconfig: op.fpathconfig,//上传保存的物理路径配置,如为空，则取系统设置(fpathconfig和vpathconfig必须配对设置)
                    vpathconfig: op.vpathconfig,//上传保存后访问的虚拟路径配置，如为空，则取系统默认设置(fpathconfig和vpathconfig必须配对设置)
                    fileMaxSize: op.fileMaxSize//上传文件最大长度
                };
                apollo.openWin(html, w, h, selectData, param);
            }
            function selectData(data) {

                if (data != null && data != undefined) {
                    var items = data;
                    //先移除之前
                    jQuery(items).each(function (i, item) {
                        var fn = item.title;
                        var v = item.url;
                        var t = fn;
                        if (v != null) {
                            //这里要过滤重复的
                            if (apollo.Lib.isIn(v, arrV)) return;

                            arrV.push(v);
                            arrT.push(t);
                            curDatas.push({ value: v, text: t });
                        }
                    });

                    var fun = apollo.Lib.parseFun(op.onupload);
                    if (fun != null) {
                        fun(curDatas);
                    }
                }
            }

            var editor = apollo.form.baseEditor();

            editor.name = op.name;
            editor.textType = 0;
            editor.isempty = false;
            editor.getvalue = function () {
                //根据数据类型重新取值
                if (op.valueType == 1)
                    return arrV;
                else
                    return arrV.join(",");
            };
            editor.gettext = function () {
                return arrT.join(",");
            };
            editor.setvalue = function (value, t) {
                var v;
                if (jQuery.isArray(value)) {
                    op.valueType = 1;
                    v = value;
                }
                else if (typeof value == "string") {
                    op.valueType = 0;
                    if (apollo.Lib.isNotEmpty(value))
                        v = value.split(",");
                    else
                        v = [];
                }
                var data = [];
                jQuery(v).each(function (i, f) {
                    if (apollo.Lib.isNotEmpty(f)) {
                        var t = getFileName(jQuery.trim(f));
                        data.push({ title: t, url: f });
                    }
                });

                //进行初始化
                arrT = [];
                arrV = [];
                selectData(data);
            };
            editor.setdefultvalue = function () {
                editor.setvalue([]);
            };
            editor.getdataitem = function () {
                return arrV.length > 0 ? arrV[0] : null;
            };
            editor.getdataitems = function () {
                return arrV;
            };
            editor.isvalid = function () {
                if (editor.enabled && editor.visible) {
                    if (!op.allowEmpty) {
                        return arrV.length > 0;
                    }
                    else
                        return true;
                }
                else
                    return true;
            };
            editor.setvisible = function (visible) {
                editor.visible = visible;
                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        jQuery("#" + op.itempanelid).show();
                    else
                        jQuery("#" + op.itempanelid).hide();
                }
                if (visible == true)
                    ul.show();
                else
                    ul.hide();
            };
            editor.setenabled = function (enabled) {
                editor.enabled = enabled == true;
                if (enabled == true) {
                    addLi.removeAttr("disabled");
                    ul.removeAttr("disabled");
                }
                else {
                    addLi.attr("disabled", "disabled");
                    ul.find(".l-btn-icon").attr("disabled", "disabled");
                }
            };
            return editor;
        },
        reflashbox: function (options) {
            var defaults = {
                reflashFun: null
            }

            var op = jQuery.extend(defaults, options);

            var reffun = apollo.Lib.parseFun(op.reflashFun);
            var Panel = jQuery(this);

            var json = {
                ontouching: function (util) {
                    var of = util.offset();
                    if (of.istotop == true) //不是向下滑动，则中止
                    {
                        util.stop();
                    }
                    else
                        util.body.css("top", of.top + "px");
                },
                onend: function (util) {
                    util.body.animate({
                        top: util.beginTop() + "0px"
                    });
                    if (reffun != null) {

                        reffun();
                    }
                }
            }

            return Panel.touchreflash(json);
        },
        switchbox: function (options) {
            var factValue = "";
            var active = false;
            var box = jQuery(this);
            var defaults = jQuery({ area: null }, apollo.Options.input.option);
            var op = jQuery.extend(defaults, options);


            //不显示实际对象，插入switchbox
            var sbox = jQuery("<div class=\"mui-switch\"></div>");
            sbox.append("<div class=\"mui-switch-handle\"></div>");
            if (op.showtext != true) //显示开关
                sbox.addClass("mui-switch-mini");
            else
                sbox.removeClass("mui-switch-mini");

            box.before(sbox);
            box.remove();

            var cngFun = apollo.Lib.parseFun(op.onchange);


            function setvalue(fv) {
                if (typeof factValue == "string") { //是否为字符
                    if (apollo.Lib.isIn(factValue, ["0", "1"]))
                        factValue = fv == true ? "1" : "0";
                    else if (apollo.Lib.isIn(factValue, ["true", "false"]))
                        factValue = fv == true ? "true" : "false";
                    else
                        factValue = fv == true ? "true" : "false";
                }
                else if (typeof factValue == "number")
                    factValue = fv == true ? 1 : 0;
                else
                    factValue = fv;
            }

            sbox.on("tap", function () {
                var nv = false;
                if (sbox.is(".mui-active")) {
                    nv = false;
                    sbox.removeClass("mui-active");
                }
                else {
                    nv = true;
                    sbox.addClass("mui-active");
                }
                var fv = nv
                active = fv;

                try {
                    if (cngFun != null)
                        cngFun(fv);
                }
                catch (e) { }
                try {
                    if (editor.onchange != null)
                        editor.onchange(fv);
                }
                catch (e) { }

                setvalue(fv);
            });

            var editor = apollo.form.baseEditor();


            editor.name = op.name;
            editor.textType = op.textType;
            editor.isempty = false;
            editor.getvalue = function () {
                var fv = false;
                if (sbox.is('.mui-active')) {
                    fv = true;
                }
                setvalue(fv);
                return factValue;
            };
            editor.gettext = function () {
                return editor.getvalue();
            };
            editor.setvalue = function (v, t) {
                var issel = apollo.util.toBoolean(v);
                if (issel == true)
                    sbox.addClass("mui-active");
                else
                    sbox.removeClass("mui-active");

                active = issel;
                factValue = v;
            };
            editor.setdefultvalue = function () {
                editor.setvalue(op.defaultValue);
            };
            editor.getdataitem = function () {
                return editor.getvalue();
            };
            editor.getdataitems = function () {
                return [editor.getvalue()];
            };
            editor.isvalid = function () {
                return true;
            };
            editor.setvisible = function (visible) {
                this.visible = visible == true;

                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        jQuery("#" + op.itempanelid).show();
                    else
                        jQuery("#" + op.itempanelid).hide();
                }
                else {
                    if (visible == true)
                        box.show();
                    else
                        box.hide();
                }
            }
            editor.setenabled = function (enabled) {
                this.enabled = enabled == true;

                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        jQuery("#" + op.itempanelid).attr("disabled", "disabled");
                    else
                        jQuery("#" + op.itempanelid).removeAttr("disabled");
                }
                if (enabled == true) {
                    box.attr("disabled", "disabled");
                }
                else {
                    box.removeAttr("disabled");
                }
            }
            return editor;
        },
        onlineEditor: function (options) {
            var box = $(this);
            var defaults = $({}, apollo.Options.input.option);
            var op = $.extend(defaults, options);

            var rtn = apollo.form.baseEditor();

            var myeditor = box.aeditor({});


            var editor = apollo.form.baseEditor();

            editor.name = op.name;
            editor.textType = op.textType;
            editor.isempty = false;
            editor.getvalue = function () {
                return myeditor.getHtml();
            };
            editor.gettext = function () {
                return myeditor.getText();
            };
            editor.setvalue = function (value, t) {
                myeditor.setHtml(value);
            };
            editor.setdefultvalue = function () {
                myeditor.setHtml("");
            };
            editor.getdataitem = function () {
                return null;
            };
            editor.getdataitems = function () {
                return [];
            };
            editor.isvalid = function () {
                if (editor.enabled && editor.visible) {
                    if (!op.allowEmpty) {
                        return myeditor.hasContents();
                    }
                    else
                        return true;
                }
                else
                    return true;
            };
            editor.setvisible = function (visible) {
                editor.visible = visible;
                if (apollo.Lib.isNotEmpty(op.itempanelid)) {
                    if (visible == true)
                        $("#" + op.itempanelid).show();
                    else
                        $("#" + op.itempanelid).hide();
                }
                if (visible == true)
                    box.show();
                else
                    box.hide();
            };
            editor.setenabled = function (enabled) {
                editor.enabled = enabled == true;
                if (enabled == true) {
                    box.removeAttr("disabled");
                }
                else {
                    box.attr("disabled", "disabled");
                }
            };
            return editor;
        }
    });

    //取到上级窗口传递过来的参数对象
    apollo.form.parentparams = window.parentParams || {};//如果上级未选参数，则设置一个空对象参数
    apollo.form.ready = function (fun) {
        if (jQuery.isFunction(fun)) {
            funList.push(fun);
        }
    }

    apollo.form.init = autoLoadform;

    apollo.form.reflashArea = function (app, data, propName) {
        if (isformloaded == true) {
            for (var areaName in frmAreas) {
                try {
                    frmAreas[areaName].reflashEle(app, data, propName);
                }
                catch (e) { }
            }
        }
    }

    jQuery.extend(apollo.form, {
        ajax: function (url, param, onSuccess, onError) {
            apollo.ajax(url, param, onSuccess, onError);
        },
        api: function (controllerName, actionName, param, successFun, errorFun) {
            apollo.api(controllerName, actionName, param, successFun, errorFun);
        },

        getarea: function (areaName) {
            if (areaName in frmAreas) {
                return frmAreas[areaName];
            }
            else {
                return null;
            }
        },
        geteditor: function (areaName, itemName) {
            if (areaName in frmAreas) {
                return frmAreas[areaName].geteditor(itemName);
            }
            else {
                return null;
            }
        },
        /**将指定对象的属性值更新到区域中，如不设区域，则是更新到表单所有区域，如设置，则只更新到指定区域，指定区域最多只能支持20个区域*/
        updata: function (dataOrName) {
            var areas = [];
            var entity = null;
            if (arguments.length < 2)
                return;//到少需要两个参数
            else if (arguments.length == 2) {
                var p1 = arguments[0];
                var p2 = arguments[1];
                if (typeof p1 == "string" && typeof p2 == "object") {
                    entity = p2;
                    var area = this.getarea(p1);
                    if (area != null) areas.push(area);
                }
                else if (typeof p2 == "string" && typeof p1 == "object") {
                    entity = p1;
                    var area = this.getarea(p2);
                    if (area != null) areas.push(area);
                }
            }
            else if (typeof dataOrName != "object") //其它多个参数，则第一个必须为要赋值的对象
                return;
            else {
                entity = arguments[0];
                for (var i = 1; i < arguments.length; i++) {
                    var area = this.getarea(arguments[i]);
                    if (area != null) areas.push(area);
                }
            }

            if (areas.length == 0) //示设置，
            {
                for (var n in frmAreas) {
                    areas.push(frmAreas[n]);
                }
            }

            jQuery(areas).each(function (i, area) {
                area.updata(entity)
            });
        },
        getdata: function (areaName) {
            if (areaName in frmAreas) {
                return frmAreas[areaName].getdata();
            }
            else {
                return null;
            }
        },
        setdata: function (dataOrName) {
            var areas = [];
            var entity = null;

            if (arguments.length < 1)
                return;//到少需要两个参数
            else if (arguments.length == 1) {
                var p1 = arguments[0];
                if (typeof p1 == "object") //参数必须为object 对象
                {
                    entity = p1;
                    for (var areaName in frmAreas) {
                        areas.push(frmAreas[areaName]);
                    }
                }
                else {
                    return;
                }
            }
            else if (arguments.length == 2) {
                var p1 = arguments[0];
                var p2 = arguments[1];
                if (typeof p1 == "string" && typeof p2 == "object") {
                    entity = p2;
                    var area = this.getarea(p1);
                    if (area != null) areas.push(area);
                }
                else if (typeof p2 == "string" && typeof p1 == "object") {
                    entity = p1;
                    var area = this.getarea(p2);
                    if (area != null) areas.push(area);
                }
            }
            else if (typeof dataOrName != "object") //其它多个参数，则第一个必须为要赋值的对象
                return;
            else if (arguments.length > 2) {
                entity = arguments[0];
                for (var i = 1; i < arguments.length; i++) {
                    var area = this.getarea(arguments[i]);
                    if (area != null) areas.push(area);
                }
            }

            if (areas.length == 0) //示设置，
            {
                return;
            }

            jQuery(areas).each(function (i, area) {
                area.setdata(entity)
            });
        },
        getAreaData: function (btn) {
            var area = jQuery(btn).data("AreaObj");
            if (area != null)
                return area.getdata();
            else
                return null;
        },
        //获取指定区域编辑项的值，对于表格区域,则需要获取其索引
        setvalue: function (areaName, itemName, value) {
            var area = this.getarea(areaName);
            if (area == null) return;
            area.setvalue(itemName, value);
        },
        getvalue: function (areaName, itemName) {
            var area = this.getarea(areaName);
            if (area == null) return "";
            return area.getvalue(itemName);
        },
        setenabled: function (areaName, itemName, IsEnabled) {
            if (arguments.length == 2) //只有两个参数，则视为对指定区域
            {
                var area = this.getarea(arguments[0]);
                if (area != null) {
                    area.setenabled(arguments[1]);
                }
            }
            else {
                var area = this.getarea(areaName);
                if (area != null) {
                    area.setenabled(itemName, IsEnabled);
                }
            }
        },
        setvisible: function (areaName, itemName, IsVisible) {
            var area = this.getarea(areaName);
            if (area != null) {
                area.setvisible(itemName, IsVisible);
            }
        },
        isvalid: function () {
            for (var name in frmAreas) {
                var area = frmAreas[name];
                if (!area.isvalid())
                    return false;
            }
            return true;
        },
        append: function (panel) {
            var box = jQuery(panel);
            var areas = box.find(".apolloui-area");
            var areaoptions;
            jQuery(areas).each(function (i, area) {
                areaoptions = parseOption(area, apollo.Options.fromArea);
                var name = areaoptions.name;
                if (apollo.Lib.isEmpty(name)) {
                    areaNumber++;
                    name = "frmAreaAutoName" + areaNumber;
                }
                frmAreas[name] = jQuery(area).formArea(areaoptions);
            });

            areas = box.find(".apolloui-arrayarea");
            jQuery(areas).each(function (i, area) {
                areaoptions = parseOption(area, apollo.Options.arrayArea);
                var name = areaoptions.name;
                if (apollo.Lib.isEmpty(name)) {
                    areaNumber++;
                    name = "frmAreaAutoName" + areaNumber;
                }
                frmAreas[name] = jQuery(area).arrayArea(areaoptions);
            });

            var reflashboxs = box.find(".apollo-reflashbox");
            if (reflashboxs.length > 0) {
                jQuery(reflashboxs).each(function (i, cbox) {
                    var edtOptions = parseOption(cbox, apollo.Options.reflashbox);
                    cbox.reflashbox(edtOptions);
                });
            }

            if (box.hasClass("apolloui-area")) {
                areaoptions = parseOption(box, apollo.Options.fromArea);
                var name = areaoptions.name;
                if (apollo.Lib.isEmpty(name)) {
                    areaNumber++;
                    name = "frmAreaAutoName" + areaNumber;
                }
                frmAreas[name] = jQuery(panel).formArea(areaoptions);
            }
            else if (box.hasClass("apolloui-arrayarea")) {
                areaoptions = parseOption(box, apollo.Options.arrayArea);
                var name = areaoptions.name;
                if (apollo.Lib.isEmpty(name)) {
                    areaNumber++;
                    name = "frmAreaAutoName" + areaNumber;
                }
                frmAreas[name] = jQuery(panel).arrayArea(areaoptions);
            }

            if (box.hasClass("apollo-reflashbox")) {
                var edtOptions = parseOption(box, apollo.Options.reflashbox);
                box.reflashbox(edtOptions);
            }
        },
        appendarea: function (areaname, area) {
            frmAreas[areaname] = area;
        },
        custom: function (areaName, itemName, getvalue, setvalue, isvalid) {
            var area = this.getarea(areaName);
            if (area != null) {
                area.custom(itemName, getvalue, setvalue, isvalid);
            }
        }
    });
})(jQuery, apollo);




/**
apollo Page
*/
(function ($, apollo) {
    //为部分页对象，注意，这里基本上是属于页面已加载完毕
    apollo.Partial = function (options) {
        var defaults = {
            data: null,
            oninit: null,
            url: "",//远程请求加载数据
            success: null,//加载完后,注意，这里是加载完并渲染完才执行
            fail: null,//加载失败时
            error: null,//加载异常时激活的事件
            postdata: null,//如果是url，则url需要传递的参数，这些参数只能是固定值            
            onload: null//在Page和Form都已初始化完毕后才会执行，如果已设置了url，则按回调执行初始化，再执行onLoad,默认参数为当前页面对象
        };


        var op = $.extend(defaults, options);
        if (op.init != null) {
            op.init();
        }
        apollo.app.appendOptions(op);//将其追加到页面配置中

        if (op.onload != null && apollo.app.isloaded) {
            op.onload(apollo.app);
        }

        if (apollo.Lib.isNotEmpty(op.url)) {
            apollo.app.RemoteData(op);
        }

        return {
            getoption: function () {
                return op;
            }
        };
    };
    apollo.SPAPartial = function (options) {
        var spaPageOp = {};
        var partialop = {};
        for (var name in options) {
            if (name == "spa")
                spaPageOp = options[name];
            else
                partialop[name] = options[name];
        }
        var partial = apollo.Partial(partialop);
        if (apollo.SPA != null) {
            apollo.SPA.reg(spaPageOp);
        }
        else {
            $(function () { apollo.SPA.reg(spaPageOp); });
        }
        return partial;
    };

    apollo.Page = function (options) {
        if (apollo.app != null && apollo.app.isloaded == true) {
            showNotice("页面已进行了apollo.Page初始化，不能在加载后再次调用！");
            return apollo.app;
        }
        else if (apollo.app != null) {//则将页面数据配置进行合并，如属性有重复，原则上是以最近执行的Options为准

            var op = $.extend(defaults, options);
            if (options.oninit != null && jQuery.isFunction(options.oninit)) {
                op.oninit(apollo.app);
            }
            apollo.app.appendOptions(options);
            return apollo.app;
        }

        var defaults = {
            data: null,//页面静态数据，与url不能同时设置 ，如果有url，则优先url
            url: "",//远程请求加载数据
            success: null,//加载完后,注意，这里是加载完并渲染完才执行
            fail: null,//加载失败时
            error: null,//加载异常时激活的事件
            postdata: null,//如果是url，则url需要传递的参数，这些参数只能是固定值            
            oninit: null,//页面初始化
            onload: null//在Page和Form都已初始化完毕后才会执行，如果已设置了url，则按回调执行初始化，再执行onLoad,默认参数为当前页面对象
        }
        var optionTemp = $.extend({}, defaults);//这个是数据配置标准模板，主要用于合并多配置

        var loadFun = [];//要进行初始化的方法,如果有多次调用apollo.Page({});

        var op = $.extend(defaults, options);

        var render = null;
        var isinited = false;//是否进行了初始化，如未初始化，则用parseLayer,否则就用setdata

        var pageRtn = {
            pager: {},//用于存储页面中列表对象
            getOptions: function () {
                return op;
            },
            getoption: function () {
                return op;
            },
            getoptions: function () {
                return op;
            },
            init: init,
            reflashDom: function (data, ele, templateHtml, datas) {
                return render.reflashEleItem(pageRtn, data, ele, templateHtml, datas);
            },
            getdata: function () { return op.data }, //页面初始化对象
            appendOptions: appendOptions,
            setvalue: function (n, v) {
                if (typeof n == "string") {
                    apollo.Template.setvalue(op.data, n, v);
                    setdata(n,false);
                    if (n.indexOf(".") >= 0) {
                        var arrProp = n.split(".");
                        reflashLayer(arrProp[0],false);
                    }
                }
            },
            setdata: function (data) {
                if (arguments.length == 0) //没传参数，则表示刷新整个区域
                {
                    reflashEle(op.data, "");
                    reflashFormEle(op.data, "");
                }
                setdataforarr(arguments);
            },
            setsource: function (name, param) {
                setSource(op.data, name, param);
            },
            loadpager: function (propName) {
                if (propName in pageRtn.pager) {
                    try {
                        var arr = pageRtn.pager[propName];
                        if ($.isArray(arr)) {
                            $(arr).each(function (i, pager) {
                                pager.load();
                            });
                        }
                        else {
                            arr.load();
                        }
                    }
                    catch (e) { }
                }
            },
            reflashpager: function (propName) {
                if (propName in pageRtn.pager) {
                    try {
                        var arr = pageRtn.pager[propName];
                        if ($.isArray(arr)) {
                            $(arr).each(function (i, pager) {
                                pager.load();
                            });
                        }
                        else {
                            arr.load();
                        }
                    }
                    catch (e) { }
                }
            },
            getpager: function (propName) {
                if (propName in pageRtn.pager) {
                    var arr = pageRtn.pager[propName];
                    if ($.isArray(arr) && arr.length > 0) {
                        return arr[arr.length - 1];
                    }
                    else {
                        return arr;
                    }
                }
                else
                    return null;
            },
            removepager: function (propName) {
                pageRtn.pager[propName] = [];
            },
            isloaded: false,
            reparseForItem: function (el, data,propName) {
                try {
                    render.reparseForItem(pageRtn, el, data,propName);
                }
                catch (e) {
                    showNotice("apollo.Page.reparseForItem error:" + e.message);
                }
            },
            reparseItem: function (el,data,propName) {
                try {
                    render.reparseItem(pageRtn, el, data,propName);
                }
                catch (e) {
                    showNotice("apollo.Page.reparseItem error:" + e.message);
                }
            },
            append: append,
            RemoteData: RemoteData,
            reflash: function () {
                if (arguments.length == 0) //没传参数，则表示刷新整个区域
                {
                    this.setdata();
                }
                else {
                    $(arguments).each(function (i, arg) {
                        if (typeof arg == "string") {
                            reflashLayer(arg,true);
                        }
                        else if (jQuery.isPlainObject(arg))
                            setdata(arg,true);
                        else if (jQuery.isArray(arg))
                            setdataforarr(arg,true);
                    });
                }
            },
            isvalid: function (form) {
                return render.isvalid(form);
            },
            reflashform: function (form) {
                return render.reflashform(form);
            },
            parsedata: function (ele, data) {
                render.parsedata(ele,data);
            }
        };

        function setdataforarr(arr,isref) {
            $(arr).each(function (i, arg) {
                if (typeof arg == "string") {
                    reflashLayer(arg,isref);
                }
                else if (jQuery.isPlainObject(arg))
                    setdata(arg,isref);
                else if (jQuery.isArray(arg))
                    setdataforarr(arg,isref);
            });
        }
        function reflashLayer(arg,isref) {
            if (jQuery.isArray(arg)) {
                $(arg).each(function (i, propName) {
                    reflashEle(op.data, propName)
                    reflashFormEle(op.data, propName);
                });
            }
            else {
                var propName = arg;
                if (apollo.Lib.isNotEmpty(propName)) {
                    reflashEle(op.data, propName)
                    reflashFormEle(op.data, propName);
                }
            }
            if (isref == true) return;//如果只是刷新该名称的，则不对所有空的刷新

            reflashEle(op.data, "");
            reflashFormEle(op.data, "");
        }



        //追加局部页
        function append(partailPanel, partail) {
            if (partail == null) {//没定义初步对象
                //再进行追加渲染
                render.parsePartail(partailPanel, op.data, pageRtn);
            }
            else {

                var partailOp = partail.getoption();
                //再进行追加渲染
                render.parsePartail(partailPanel, op.data, pageRtn);

                if (pageRtn.isloaded == true) {
                    if (partailOp.onload != null) {
                        partailOp.onload(pageRtn);
                    }
                }
            }
        }


        function setdata(data,isref) {
            if (!jQuery.isPlainObject(data)) return;//只有设置为{}这类json对象才会生效
            var oldData = op.data;
            if (oldData == null) oldData = {};
            op.data = jQuery.extend(oldData, data);
            //如果已进行初始渲染，则进行react
            if (isinited == true) {
                //只更新已设置的部分
                for (var propName in data) {
                    reflashEle(data, propName)
                    reflashFormEle(data, propName);
                }
                if (isref == true) return;//如果只是刷新该名称的，则不对所有空的刷新
                //再对整个对象的进行刷新
                reflashEle(op.data, "");
                reflashFormEle(op.data, "");
            }
        }
        function updata(data, newobj) {
            if (!jQuery.isPlainObject(newobj)) return;//只有设置为{}这类json对象才会生效
            var oldData = data;
            if (oldData == null) return;
            data = jQuery.extend(oldData, newobj);
            //如果已进行初始渲染，则进行react
            if (isinited == true) {

                //获取更新的对象所属顶层属性名，以便进行更新
                if (op.data == data) //更新的为顶层对数
                {
                    //只更新已设置的部分
                    for (var propName in newobj) {
                        reflashEle(newobj, propName)
                        reflashFormEle(newobj, propName);
                    }
                    //再对整个对象的进行刷新
                    reflashEle(op.data, "");
                    reflashFormEle(op.data, "");
                }
                else {
                    var propName = getTopPropName(op.data, data);
                    if (propName != "") {
                        reflashEle(op.data, propName)
                        reflashFormEle(op.data, propName);
                    }
                    //再对整个对象的进行刷新
                    reflashEle(op.data, "");
                    reflashFormEle(op.data, "");
                }
            }
        }






        function getTopPropName(tdata, data) {
            if (!jQuery.isPlainObject(tdata) || !jQuery.isPlainObject(data)) return "";
            var arrc = [];
            for (var pn in tdata) {
                var d = tdata[pn];
                if (jQuery.isPlainObject(d)) {
                    if (d == data) {
                        return pn;
                    }
                    else
                        arrc.push(d);
                }
            }
            for (var i = 0; i < arrc.length; i++) {
                var pn = getTopPropName(arrc[i], data);
                if (pn != "") {
                    return pn;
                }
            }
            return "";
        }



        function appendOptions(options) {
            var defOp = $.extend({}, optionTemp);
            //注意，这里合并options并不是直接将两个options简单合并，而是options合并和data合并
            //先进行data合并
            var nop = $.extend(defOp, options);

            var data = null;
            var oldData = op.data;
            var newData = nop.data;
            if (oldData != null && newData != null) { //则要进行合并
                data = $.extend(true, oldData, newData);
            }
            else if (oldData != null)
                data = oldData;
            else if (newData != null)
                data = newData;
            else
                data = {};

            //再进行onload方法合并,实际上是执行多个
            var ofun = op.onload;
            var nfun = nop.onload;
            var loadfuns = [];
            if (ofun != null && $.isFunction(ofun)) loadfuns.push(ofun);
            if (nfun != null && $.isFunction(nfun)) loadfuns.push(nfun);

            op = $.extend(op, options);
            op.data = data;
            op.onload = function (app) {
                $(loadfuns).each(function (i, fun) {
                    try {
                        fun(app);
                    }
                    catch (e) {
                        showNotice("apollo.Page.Options onLoad error:" + e.message);
                    }
                })
            }
            //再处理url
            RemoteData(nop);
        }

        function setSource(data, name, param) {
            try {
                render.setSource(pageRtn, data, name, param);
            }
            catch (e) {
                showNotice("apollo.Page.setSource error:" + e.message);
            }
        }

        function reflashEle(data, propName) {
            try {
                render.reflashEle(pageRtn, data, propName);
            }
            catch (e) {
                showNotice("apollo.Page.reflashEle error:" + e.message);
            }
        }

        function reflashFormEle(data, propName) {
            try {
                apollo.form.reflashArea(pageRtn, data, propName);
            }
            catch (e) { showNotice("apollo.Page.reflashFormEle error:" + e.message); }
        }

        function reflashPartial(data, propName) {
            try {

            }
            catch (e) {

            }
        }

        function reflashPager(data, propName) {
            try {
                render.reflashPager(data, propName, pageRtn);
            }
            catch (e) {
                showNotice("apollo.Page.reflashEle error:" + e.message);
            }
        }

        function init(callback) {
            render = apollo.Template.Render($("body"), 0);


            var initCallback = callback;//必须要用内部变量转存，以防在多次重调时丢失

            function loadData(data) {
                //按页面初始数据对整个面进行渲染
                try {
                    render.parseLayer(data, pageRtn);
                }
                catch (e) {
                    showNotice("apollo.Page.loadData error:" + e.message);//如果有异常，则提示
                }
            };

            if (op.data == null && !$.isPlainObject(op.data)) op.data = {};

            //进行初始渲染
            loadData(op.data);

            //执行回调,以便继续进行form渲染
            if (initCallback != null)
                initCallback(pageRtn);

            isinited = true;

            if (pageRtn.isloaded != true) onLoad();
        }

        function onLoad() {
            //先标记正在进行启动
            pageRtn.isloaded = true;
            //自动进行处理页面            
            if (op.onload != null && $.isFunction(op.onload)) {
                try {
                    op.onload(pageRtn);
                }
                catch (e) {
                    showNotice("apollo.Page onLoad error:" + e.message);
                }
            }
        }

        function RemoteData(pageOp) {
            if (apollo.Lib.isNotEmpty(pageOp.url)) //已设置了url,则获取url数据，并合并到op.data中
            {
                apollo.nomask = true;//初始化是不显示执行状态
                apollo.ajax(pageOp.url, pageOp.postdata == null ? {} : pageOp.postdata, function (result) {
                    if (typeof result.IsSuccess != typeof undefined && result.IsSuccess != null
                        && typeof result.Message != typeof undefined && result.Message != null
                        && typeof result.ReturnValue != typeof undefined) {
                        if (result.IsSuccess == true) {
                            var factresult = result.ReturnValue;
                            pageRtn.setdata(factresult);
                            if (pageOp.success != null) pageOp.success(result);
                        }
                        else {
                            if (pageOp.fail != null) pageOp.fail(result);
                        }
                    }
                    else {
                        pageRtn.setdata(result);
                        if (pageOp.success != null) pageOp.success(result);
                    }
                }, function (errMsg) {

                    showNotice("RemoteData error：" + errMsg);
                    if (pageOp.error != null) pageOp.error(errMsg);
                });
            }
            else
                isremoted = true;
        }

        //如果是全局页
        if (apollo.app == null) {
            apollo.app = pageRtn;
            apollo.Template.setapp(pageRtn);
        }

        //立刻启动远程获取数据，如果未设置url，则不会启动
        RemoteData(op);

        if (op.oninit != null && jQuery.isFunction(op.oninit)) {
            op.oninit(pageRtn);
        }

        return pageRtn;
    }

    apollo.app = apollo.Page({});//初始化，为页面全局对象


    //页面初始化
    //将其加载到jquery.ready中，以便dom构建完后马上执行
    $(function () {
        try {

            apollo.app.init(function (app) {
                apollo.form.init(app)
            });
        }
        catch (e) {
            showNotice(e.message);
        }
    });
})(jQuery, apollo);

/*
apollo.gridtable
*/
(function ($) {
    apollo.gridtable = {
        idNumbor: 0,
        getAttr: function (row, name) {
            if (row == null)
                return "";
            else if (name == null || name == "")
                return "";
            else if ("dataItemEntity" in row) {
                var obj = row["dataItemEntity"];
                if (typeof obj == "object") {
                    if (name in obj)
                        return obj[name];
                    else
                        return "";
                }
                else if (name in row)
                    return row[name];
                else
                    return "";
            }
            else if (name in row)
                return row[name];
            else
                return "";
        },
        showlist: function (options) {
            var defaults = {
                width: 700,
                height: 450,
                apicontroller: "",
                apiaction: "",
                url: "",
                idfield: "",
                columns: [],
                filters: [],
                funs: []
            };

            var op = $.extend(defaults, options);
            var gridjson = $.extend({}, apollo.Options.grid.option);
            gridjson.id = "DGrid";
            if (apollo.Lib.isNotEmpty(op.url)) {
                gridjson.url = op.url;
            }
            else if (apollo.Lib.isNotEmpty(op.apicontroller) && apollo.Lib.isNotEmpty(op.apiaction)) {
                gridjson.url = apollo.getApiUrl(op.apicontroller, op.apiaction);
            }
            op.funs.push({
                id: "btnRef",
                title: "刷新",
                iconCls: "icon-reload",
                clickFun: "reflash"
            });
            op.funs.push({
                id: "btnClose",
                title: "关闭",
                iconCls: "icon-no",
                clickFun: "closeList"
            });
            var arr = [];
            $(op.columns).each(function (i, c) {
                arr.push(apollo.Options.getOptions(c, apollo.Options.column.option, apollo.Options.column.optionType));
            });
            gridjson.columns = arr;

            arr = [];
            $(op.filters).each(function (i, f) {
                arr.push(apollo.Options.getOptions(f, apollo.Options.filter.option, apollo.Options.filter.optionType));
            });
            gridjson.filters = arr;

            arr = [];
            $(op.funs).each(function (i, f) {
                arr.push(apollo.Options.getOptions(f, apollo.Options.fun.option, apollo.Options.fun.optionType));
            });
            gridjson.funs = arr;

            gridjson.idfield;

            var gridviewOp = {
                width: op.width,
                height: op.height,
                options: gridjson
            };

            function popupWindow(gridviewOp) {
                var w = 700, h = 450;

                if (gridviewOp != null) {
                    if (gridviewOp.width > 100)
                        w = gridviewOp.width;
                    if (gridviewOp.height > 100)
                        h = gridviewOp.height;
                }

                var html = apollo.pageInfo.base + "page/ShowGridlist.html";
                apollo.openWin(html, w, h, null, { viewOptions: gridviewOp.options });
            }

            popupWindow(gridviewOp);
        }
    };

    function GetRowSpan(cols, rowspan) {
        var curlevel = rowspan + 1;
        for (var i = 0; i < cols.length; i++) {
            var col = cols[i];
            if (col.childs.length > 0) {
                var c = GetRowSpan(col.childs, rowspan + 1);
                if (c > curlevel)
                    curlevel = c;
            }
        }
        return curlevel;
    }
    function GetColSpan(col) {
        var colspan = 0;
        for (var i = 0; i < col.childs.length; i++) {
            colspan += GetColSpan(col.childs[i]);
        }
        return colspan == 0 ? 1 : colspan;
    }

    function toColumnOp(columns, isMutilSelect) {
        var tojson = function (cs, isM) {
            var items = [];
            var curRowSpan = GetRowSpan(cs, 0);
            if (isM == true) {
                items.push({ field: "ck", checkbox: true, rowspan: curRowSpan });
            }

            for (var i = 0; i < cs.length; i++) {
                var col = cs[i];
                var colSpan = GetColSpan(col);

                var field = col.field;
                if (apollo.Lib.isNotEmpty(col.fieldalias))
                    field = col.fieldalias;
                var item =
                {
                    isRowMerge: col.isRowMerge,
                    title: col.title,
                    field: field,
                    width: col.width,
                    rowspan: col.childs.length > 0 ? 1 : curRowSpan,
                    colspan: colSpan > 1 && col.childs.length > 1 ? colSpan : 1,
                    align: col.align,
                    sortable: col.issortable,
                    resizable: true,
                    hidden: false,
                    formatter: apollo.Lib.parseFun(col.formatterFun),
                    styler: apollo.Lib.parseFun(col.stylerFun),
                    IsEncryData: col.IsEncryData,
                    EncryDataType: col.EncryDataType,
                };
                items.push(item);
            }
            return items;
        };


        var items = [];

        var arr = GetAllGridRowColumn(columns, null, 0, null);
        for (var i = 0; i < arr.length; i++) {
            if (arr[i].length > 0)
                items.push(tojson(arr[i], isMutilSelect));
        }
        return items;
    }

    function GetAllGridRowColumn(curarr, col, rowIndex, arr) {
        if (arr == null) {
            arr = [];
            for (var i = 0; i < 10; i++)
                arr[i] = []
        }
        var curRow = rowIndex;
        if (curRow >= 10) return arr;

        if (col == null) {
            for (var i = 0; i < curarr.length; i++) {
                arr[curRow].push(curarr[i]);
            }
            for (var i = 0; i < curarr.length; i++) {
                GetAllGridRowColumn(curarr, curarr[i], curRow + 1, arr);
            }
        }
        else {
            for (var i = 0; i < col.childs.length; i++) {
                arr[curRow].push(col.childs[i]);
            }
            for (var i = 0; i < col.childs.length; i++) {
                GetAllGridRowColumn(curarr, col.childs[i], curRow + 1, arr);
            }
        }
        return arr;
    }

    function toFunJson(funs) {
        var arr = [];
        $(funs).each(function (i, fun) {
            arr.push({
                hasCheck: false,
                isbutton: fun.isbutton,                
                id: fun.id,
                text: fun.title,
                iconCls: fun.iconCls,
                clickFun: fun.clickFun,
                fieldName: fun.field,
                isNeedRecord: fun.isNeedRecord,
                noValidStatus: 1,
                valueByShow: fun.valueByShow,
                valueByHide: fun.valueByHide,
                valueByEnabled: fun.valueByEnabled,
                valueByUnEnabled: fun.valueByUnEnabled,
                auihide: fun.auihide,
                auidisabled: fun.auidisabled,
                moduleFunID: fun.ModuleFunID,
                moduleFunCode: fun.ModuleFunCode,
                funCode: fun.FunCode
            });
        });
        return arr;
    }
    function GetDefaultCompareType(dataType) {
        switch (dataType) {
            case apollo.Enum.dataType.DateTime:
                return apollo.Enum.compareType.Between;
            case apollo.Enum.dataType.String:
                return apollo.Enum.compareType.Comprise;
            case apollo.Enum.dataType.XPath:
                return apollo.Enum.compareType.LeftComprise;
            default:
                return apollo.Enum.compareType.Equal;
        }
    }
    function toFilterOp(filters) {
        var normalitems = [];
        var shortcutItems = [];
        var pendingItems = [];

        $(filters).each(function (i, item) {
            var v1 = item.value1;
            var v2 = item.value2;
            if (apollo.Lib.isEmpty(v1) && apollo.Lib.isEmpty(v2)) {
                if ((item.dataType == apollo.Enum.dataType.DateTime || item.dataType == apollo.Enum.dataType.String) && (item.dateCompareType == apollo.Enum.dateCompareType.Date || item.dateCompareType == apollo.Enum.dateCompareType.DateTime)) {
                    v1 = "addmonth(getdate(),-6)";
                    v2 = "getdate()";
                }
                else if ((item.dataType == apollo.Enum.dataType.DateTime || item.dataType == apollo.Enum.dataType.String) && item.dateCompareType == apollo.Enum.dateCompareType.Month) {
                    v1 = "addyear(getdate(),-1)";
                    v2 = "addmonth(getdate(),1)";
                }
                else if ((item.dataType == apollo.Enum.dataType.DateTime || item.dataType == apollo.Enum.dataType.String) && item.dateCompareType == apollo.Enum.dateCompareType.Year) {
                    v1 = "addyear(getdate(),-10)";
                    v2 = "addyear(getdate(),1)";
                }
            }
            var obj =
            {
                SqlPrefix: 0,
                FieldName: item.field,
                Title: item.title,
                DataType: item.dataType,
                DateCompareType: item.dateCompareType,
                CompareType: item.compareType > 0 ? item.compareType : GetDefaultCompareType(item.dataType),
                Width: item.width,
                PanelWidth: item.panelWidth,
                minYearSpan: item.minYearSpan,
                maxYearSpan: item.maxYearSpan,
                hideFilterDefine: item.hideFilterDefine,
                LinkFilterItems:item.LinkFilterItems,
                refFilterSource: item.refFilterSource,
                isBR: item.isBR,
                CustomGetValueFun: item.customGetValueFun,
                AllowEmpty: item.allowEmpty,
                ItemType: item.itemtype,
                GroupInfo: item.GroupInfo,
                IsHasFilter: item.IsHasFilter,


                LinkageItemName: item.LinkageItemName,
                LinkageFilterField: item.LinkageFilterField,
                IsOnlyForLinkage: item.IsOnlyForLinkage,
                LinkageFieldValueType: item.LinkageFieldValueType,

                Value1: v1,
                Value2: v2
            };

            if (item.filtertype == 1) {
                if (item.source.data != null) {
                    var items = [];
                    $(item.source.data).each(function (i, d) {
                        var v = apollo.Lib.getAttr(d, item.source.valuefield);
                        var t = apollo.Lib.getAttr(d, item.source.textfield);

                        items.push({ Value: v, Text: t });
                    });
                    obj.DataSource = { items: items };
                }
                else {
                    var combojson = getSourceDefine(item, item.source);
                    if (combojson != null)
                        obj.SourceDefine = combojson;
                }
            }
            else if (item.filtertype == 2) {
                var combojson = getpopupSourceDefine(item, item.popupsource);
                if (combojson != null)
                    obj.SourceDefine = combojson;
            }

            if (item.isshortcut == true) {
                shortcutItems.push(obj);
            }
            if (item.isnormal == true) {
                normalitems.push(obj);
            }
            if (item.isadvance == true)
                pendingItems.push(obj);
        });
        if (normalitems.length > 0 || pendingItems.length > 0 || shortcutItems.length > 0) {
            var obj =
            {
                normalItems: normalitems,
                pendingItems: pendingItems,
                shortcutItems: shortcutItems
            };
            return obj;
        }
        else
            return null;
    }
    function GetColumnOptions(idfield, columns) {
        var cops = [];
        var method = null;
        method = function (cs) {
            $(cs).each(function (i, c) {
                if (apollo.Lib.isNotEmpty(c.field)) {
                    var format = c.dataFormat;

                    if (apollo.Lib.isNotEmpty(format) && format.indexOf("{") == -1)
                        format = "{0:" + format + "}";

                    cops.push({
                        headerText: c.title,
                        CaseWhenList: c.caseWhenList,
                        DataField: c.field,
                        FieldAlias: c.fieldalias,
                        DataFormatString: format,
                        DisplayField: c.displayField,
                        RelationField: c.relationField,
                        RelationTable: c.relationTable,
                        ElseValue: c.elseValue,
                        MainTableField: c.field,
                        CurFilter: c.curFilter,
                        TotalFormatString: format,
                        TotalType: c.totalType,
                        Text: c.title,
                        IsEncryData: c.IsEncryData,
                        EncryDataType: c.EncryDataType,
                    });
                }
                else if (c.childs != null && c.childs.length > 0) {
                    method(c.childs);
                }
            });
        };

        method(columns);


        if (apollo.Lib.isNotEmpty(idfield)) {
            var isexists = false;
            for (var i = 0; i < columns.length; i++) {
                if (apollo.Lib.isEquals(idfield, columns[i].field)) {
                    isexists = true;
                    break;
                }
            }
            if (!isexists)
                cops.push({ DataField: idfield });
        }
        return JSON.stringify(cops);
    }

    function GetSortItems(sorts, columns) {
        var arr = [];
        $(sorts).each(function (i, s) {
            arr.push({ FieldName: s.field, SortingMode: s.sorttype });
        });

        if (arr.length == 0 && columns.length > 0) {
            arr.push({ FieldName: columns[0].field, SortingMode: apollo.Enum.ASC });
        }
        return JSON.stringify(arr);
    }

    function toGridTableOptions(gridOp) {
        var isfooter = false;
        $(gridOp.columns).each(function (i, c) {
            if (c.totalType > 0) {
                isfooter = true;
            }
        });
        var gridFilter = toFilterOp(gridOp.filters);
        if (apollo.Lib.isNotEmpty(gridOp.apicontroller) && apollo.Lib.isNotEmpty(gridOp.apiaction) && apollo.Lib.isEmpty(gridOp.url))
            gridOp.url = apollo.getApiUrl(gridOp.apicontroller, gridOp.apiaction);

        if (apollo.Lib.isEmpty(gridOp.url) && gridOp.source != null && apollo.Lib.isNotEmpty(gridOp.source.table)) {
            var source = gridOp.source;
            gridOp.url = apollo.pageInfo.base + "src/ApolloUIHandler.ashx?action=GetPopupSource&idfield=" + source.valuefield + "&textfield=" + source.textfield + "&table=" + source.table + "&sortfield" + source.sortfield + "&curfilter=" + source.curfilter + "&listfs=" + source.listfield
        }

        var op =
        {
            canExport: gridOp.isCanExport,
            id: gridOp.id,
            url: gridOp.url,
            paramfun: gridOp.paramfun,
            exportUrl: gridOp.exportUrl,
            columns: toColumnOp(gridOp.columns, gridOp.isMutilSelect),//数据列
            gridFilter: gridFilter,//过滤项
            queryParams:
            {
                CurrentPageIndex: 0,
                ItemsPerPage: 20,
                TotalRecordCount: "",
                Data: "",
                AllowPaging: gridOp.isAllowPaging,
                ColumnOptions: GetColumnOptions(gridOp.idfield, gridOp.columns),
                GridViewType: 0,
                IDField: gridOp.idfield,
                ParentIDField: gridOp.parentidfield,
                XPathField: "",
                XPathLength: 0,
                SortItems: GetSortItems(gridOp.sortItems, gridOp.columns),
                IsSuccess: "",
                ErrorMessage: "",
                Filter: "", //客户端产生的过滤值
                CustomObj: "",//客户端转过来的额外对象，用于对外部进行处理
                IsExpandAll: false
            },
            isTreeGrid: gridOp.istree,
            title: gridOp.title,
            hasFun: gridOp.funs.length > 0,
            hasFilter: gridFilter != null,
            operateFuns: toFunJson(gridOp.funs),
            funCheckUrl: "",
            checkParamFun: "",
            setFunBtnMethod: "",
            striped: "",
            treeField: gridOp.treefield,
            nowrap: false,
            idfield: gridOp.idfield,
            pagination: gridOp.isAllowPaging,
            rownumbers: gridOp.isHasNoCol,//是否要显示数字行列
            singleSelect: gridOp.isMutilSelect != true,// true,//是否支持单选
            autoRowHeight: false,//行高是否自动
            pageSize: gridOp.pageSize,//每页的大小
            remoteSort: true,//是否支持远程数据加载
            showFooter: isfooter,//是否显示页脚,

            relagrids: gridOp.relagrids,

            filterPanel: gridOp.filterDivID,
            funPanel: gridOp.funDivID
        };

        if (gridOp.clientEvent != null) {
            op.ClickRowFun = gridOp.clientEvent.clickRowFun,
                op.DblClickRowFun = gridOp.clientEvent.dblClickRowFun,
                op.ClickCellFun = gridOp.clientEvent.clickCellFun,
                op.DblClickCellFun = gridOp.clientEvent.dblClickCellFun,

                op.ExecFilterSqlFun = gridOp.clientEvent.execFilterSqlFun,
                op.SelectRowFun = gridOp.clientEvent.selectRowFun,
                op.UnselectRowFun = gridOp.clientEvent.unselectRowFun,
                op.SelectAllFun = gridOp.clientEvent.selectAllFun,
                op.UnselectAllFun = gridOp.clientEvent.unselectAllFun,
                op.InitFun = gridOp.clientEvent.initFun,
                op.RowStylerFun = gridOp.clientEvent.rowStylerFun,
                op.LoadSuccessFun = gridOp.clientEvent.loadSuccessFun
        }
        return op;
    }

    function getFilterOp(divgrid, dfilterOp, dfilterOpType) {
        var arr = [];
        var filters = $(divgrid).find("filters");
        if (filters.length) {
            var filteritems = $(filters.get(0)).find("filter");
            $(filteritems).each(function (i, filter) {
                var sourceStr = $(filter).attr("data-source");
                var sourceDef = apollo.Options.source;
                var source = $.extend({}, sourceDef);
                if (sourceDef != null && apollo.Lib.isNotEmpty(sourceStr))
                    source = apollo.Options.parseOptions(sourceStr, sourceDef.option, sourceDef.optionType);


                var items = $(filter).find("item");

                if ($(items).length > 0) {
                    var datas = [];
                    $(items).each(function (i, item) {
                        datas.push({ value: $(item).attr("value"), text: $(item).attr("text") });
                    });
                    source.data = datas;
                }
                var op = apollo.Options.getOptions(filter, dfilterOp, dfilterOpType);

                op.source = source;
                arr.push(op);
            });
        }
        return arr;
    }

    function getpopupSourceDefine(item, source) {
        var ListFS = [];
        $(source).each(function (i, c) {
            ListFS.push(c.DataField);
        });
        var gridjson = tofiltergridOp(source);

        var json =
        {
            AllowEmpty: item.allowEmpty,
            DefaultValue: "",
            popup:
            {
                IsPopupEdit: true,
                isTree: source.istree,
                WindowMode: 0,

                //主要来源于指定数据表
                popupGrid: gridjson,

                AllowVerify: false,
                ValueField: source.valuefield,
                ValueFieldType: 0,
                TextField: source.textfield,

                FilterFs: "",
                ListFs: ListFS.join(","),
                LinkageChange: null,

                Editable: false,//是否可直接编辑输入
                MutilValues: false,//是否为多个值

                TableName: source.table,
                ClassName: "",
                MethodName: "",

                QueryID: item.popupQueryID,//辅助输入检索查询
                CustomUrl: item.customwinurl,//自定义弹窗
                ParamFun: item.customwinparamfun,//弹窗数据源取参数方法
                WinHeight: item.winheight,
                WinWidth: item.winwidth,


                ItemSourceUrl: gridjson.url,
                GetTextUrl: item.GetTextUrl,
                GetValueUrl: item.GetValueUrl,
                InitFun: item.InitFun
            }
        };
        return json;
    }

    function tofiltergridOp(source) {

        var gridjson = {
            Columns: source.columns,
            Url: ""
        };
        var listFs = [];
        $(source.columns).each(function (i, c) {
            listFs.push(c.DataField);
        });
        if (apollo.Lib.isNotEmpty(source.url)) {
            gridjson.Url = source.url;
        }
        else if (apollo.Lib.isNotEmpty(source.apicontroller) && apollo.Lib.isNotEmpty(source.apiaction)) {
            gridjson.Url = apollo.getApiUrl(source.apicontroller, source.apiaction);
        }
        else if (apollo.Lib.isNotEmpty(source.valuefield) && apollo.Lib.isNotEmpty(source.textfield) && apollo.Lib.isNotEmpty(source.table)) {
            gridjson.Url = apollo.pageInfo.base + "src/ApolloUIHandler.ashx?action=GetPopupSource&idfield=" + source.valuefield + "&textfield=" + source.textfield + "&table=" + source.table + "&sortfield" + source.sortfield + "&curfilter=" + source.curfilter + "&listfs=" + listFs.join(",");
        }
        return gridjson;
    }

    function getSourceDefine(item, source) {
        var json = {
            AllowEmpty: item.allowEmpty,
            DefaultValue: "",
            combo:
            {
                IsCombo: true,
                Data: null,
                Url: "",
                LinkageFilterField: item.LinkageFilterField,//联动过滤字段
                GetLinkageValueFun: null,//获取联动值的方法名
                LinkageFieldValueType: item.LinkageFieldValueType,
                ValueField: source.valuefield,
                TextField: source.textfield,
                Editable: false,//是否可直接编辑输入
                MutilValues: false,//是否为多个值
                DataSource:
                {
                    Table: source.table,
                    OrderField: source.sortfield,
                    CusFilter: source.curfilter
                }
            }
        };

        var url = "";
        var jstype = 0;
        if (apollo.Lib.isNotEmpty(source.url)) {
            json.combo.Url = apollo.getvpath( source.url);
        }
        else if (apollo.Lib.isNotEmpty(source.apicontroller) && apollo.Lib.isNotEmpty(source.apiaction)) {
            json.combo.Url = apollo.getApiUrl(source.apicontroller, source.apiaction);
        }
        else if (apollo.Lib.isNotEmpty(source.valuefield) && apollo.Lib.isNotEmpty(source.textfield) && apollo.Lib.isNotEmpty(source.table)) {
            json.combo.Url = "";// apollo.pageInfo.base + "src/ApolloUIHandler.ashx?action=GetDataSource&idfield=" + source.valuefield + "&textfield=" + source.textfield + "&table=" + source.table + "&sortfield" + source.sortfield + "&curfilter=" + source.curfilter
        }
        else if (item.customsource != null )
        {
            json.combo.Url = apollo.getApiUrl("ReportApi","GetCustomSql");
            json.combo.QueryParams = { QueryID: item.customsource.queryid, Title: item.customsource.title, Field: item.customsource.field };
            json.combo.TextField = "Text";
            json.combo.ValueField = "Value";
        }
        else
            return null;
        return json;
    }


    function getSortOp(divgrid, dsortOp, dsortOpType) {
        var arr = [];

        var sorts = $(divgrid).find("sorts");
        if (sorts.length) {
            var items = $(sorts.get(0)).find("sort");
            $(items).each(function (i, sort) {
                var op = apollo.Options.getOptions(sort, dsortOp, dsortOpType);
                arr.push(op);
            });
        }
        return arr;
    }
    function getFunOp(divgrid, dfunOp, dfunOpType) {
        var arr = [];

        var funs = $(divgrid).find("funs");
        if (funs.length) {
            var funitems = $(funs.get(0)).find("fun");
            $(funitems).each(function (i, fun) {
                var op = apollo.Options.getOptions(fun, dfunOp, dfunOpType);
                arr.push(op);
            });
        }
        return arr;
    }
    function getColumnOp(divgrid, dcolumnOp, dcolumnOpType) {
        var method = null;
        var defFieldNum = 0;
        method = function (pcolumn) {
            var arr = [];
            var colitems = $(pcolumn).find("column");
            $(colitems).each(function (i, col) {

                var op = apollo.Options.getOptions(col, dcolumnOp, dcolumnOpType);
                var hasChilds = ($(col).find("column").length > 0);

                if (apollo.Lib.isEmpty(op.field)) //未设置字段，则应该是自定义列，如果子级有非column元素，则取模板
                {
                    defFieldNum++;
                    var def = "gridTableDefaultF" + defFieldNum;
                    op.field = def;
                    if (apollo.Lib.isEmpty(op.formatterFun)) {

                        var cEles = $(col).children();
                        if ($(cEles).length > 0) {

                            if (!hasChilds) {
                                var html = JSON.stringify($(col).html());
                                var script = "function(value,rowData,rowIndex) {" +
                                    "var str=" + html + ";" +
                                    "var regex=/\{{(.*?)\}}/g;" +
                                    "str=str.replace(regex,function(m,name){return apollo.gridtable.getAttr(rowData,name);});" +
                                    "return str; }";
                                op.formatterFun = script;
                            }
                        }
                    }
                }
                op.childs = method(col);
                arr.push(op);
            });
            return arr;
        }

        var cols = $(divgrid).find("columns");
        if (cols.length > 0) {
            return method(cols.get(0));
        }
        else
            return [];
    }
    function getenumvalue(EnumObj, v) {
        var objv = parseInt(v);
        if (isNaN(objv)) {
            var n = $(EnumObj).attr(v);
            if (n == null)
                objv = 0;
            else
                objv = n;
        }
        return objv;
    }

    function autoParseGrid(divgrid) {
        //先获取grid属性
        var gridOp = apollo.Options.getOptions(divgrid, apollo.Options.grid.option, apollo.Options.grid.optionType);

        //设置gridOp取值
        if (apollo.Lib.isEmpty(gridOp.url) && apollo.Lib.isNotEmpty(gridOp.apicontroller) && apollo.Lib.isNotEmpty(gridOp.apiaction)) {
            gridOp.url = apollo.getApiUrl(gridOp.apicontroller, gridOp.apiaction);
        }

        //再取过滤器
        gridOp.filters = getFilterOp(divgrid, apollo.Options.filter.option, apollo.Options.filter.optionType);
        gridOp.columns = getColumnOp(divgrid, apollo.Options.column.option, apollo.Options.column.optionType);
        gridOp.funs = getFunOp(divgrid, apollo.Options.fun.option, apollo.Options.fun.optionType);
        gridOp.sortItems = getSortOp(divgrid, apollo.Options.sort.option, apollo.Options.sort.optionType);
        gridOp.clientEvent = apollo.Options.getOptions(divgrid.find("clientevent"), apollo.Options.clientEvent.option, apollo.Options.clientEvent.optionType);

        var grid = $("<div id=\"" + gridOp.id + "\"></div>");
        $(divgrid).before(grid)
        $(divgrid).remove();

        window[gridOp.id] = grid.gridview(gridOp);
    }


    $.fn.extend({
        gridview: function (options) {
            var panel = $(this);

            var defaults = $({}, apollo.Options.grid.option);
            var op = $.extend(defaults, options);

            if (apollo.Lib.isEmpty(op.id)) {
                apollo.gridtable.idNumbor++;

                var id = panel.attr("id");
                if (apollo.Lib.isNotEmpty(id))
                    op.id = id;
                else
                    op.id = "DGrid" + apollo.gridtable.idNumbor;
            }

            var json = toGridTableOptions(op);

            if (json.hasFun || json.hasFilter) {
                var divTool = $("<div id=\"" + op.id + "Tool\" class=\"gridtable-toolbar\"></div>");
                panel.before(divTool);
                if (json.hasFun) {
                    var funPanel = $("<div id=\"" + op.id + "Fun\" class=\"gridtable-fun\"></div>");

                    divTool.append(funPanel);
                }
                if (json.hasFilter) {
                    var divFilter = $("<div id=\"" + op.id + "Filter\" ></div>");
                    divTool.append(divFilter);
                }
            }

            return panel.gridTable(json);
        },
        gridfunpanel: function (options) {
            var div = $(this);

            var defaults = $({}, apollo.Options.funpanel.option);
            var op = $.extend(defaults, options);


            //进行功能按钮区初始化
            var btnJson = {
                id: op.id + "Fun",
                operateFuns: toFunJson(op.funs),
                buttonStyle: 1
            };
            var isfun = false;
            for (var i = 0; i < btnJson.operateFuns.length; i++) {
                if (btnJson.operateFuns[i].isbutton == true) {
                    isfun = true;
                    break;
                }
            }
            if (isfun != true) {
                div.addClass("gridtable-fun");
                //div.css("border-bottom", "1px solid #cfcfcf");
                //div.css("line-height", "25px");
                //div.height(28);
                div.css("font-weight", "bold");
                div.css("font-size", "14px");
            }

            for (var i = 0; i < btnJson.operateFuns.length; i++) {
                var fun = btnJson.operateFuns[i];
                var ae = $("<a href=\"javascript:;\" id=\"" + fun.id + "\">" + fun.text + "</a>");
                div.append(ae);
                if (fun.isbutton==true) div.append("&nbsp;");
            }
            return div.funPanel(btnJson);
        },
        gridfilterpanel: function (options) {
            var panel = $(this);

            var defaults = $({}, apollo.Options.filterpanel.option);
            var op = $.extend(defaults, options);

            var gridFilter = toFilterOp(op.filters);

            return panel.filterPanel({ gridFilter: gridFilter });       
        },
        recordview: function (options) {
            var panel = $(this);

            var defaults = $({index:0}, apollo.Options.record.option);
            var op = $.extend(defaults, options);

            var recordOp = {
                queryParams:
                {
                    CurrentPageIndex: 0,
                    ItemsPerPage: 1,
                    TotalRecordCount: 0,
                    AllowPaging: false,
                    ColumnOptions: GetColumnOptions("", op.columns),
                    SortItems: "",
                    Filter: "", //客户端产生的过滤值
                    CustomObj: ""//客户端转过来的额外对象，用于对外部进行处理                    
                }
            }

            //将当前项追加到页项中           

            return {
                value: "",
                rowdata: {},//呈现行值，其中dataItemEntnty为实际行值
                selectedItem: {},//实际行值
                record: {},//待同实际行值
                getdataItem: function () { return this.record; },
                getQueryParams: function () {
                    return recordOp.queryParams;
                },
                getitemvalue: function (name) {
                   return apollo.Lib.getAttr(this.record,name)
                },
                load: function (data) {
                    this.rowdata = data;                    
                    if (data.dataItemEntity != null) {
                        this.selectedItem = data.dataItemEntity;
                        this.record = this.selectedItem;
                    }
                    else {
                        this.selectedItem = data;
                        this.record = data;
                    }
                    this.value = apollo.Lib.getAttr(this.record, op.idfield);
                }
            }
        }
    });

    //自动解析当前内容
    $(function () {
        var grids = $("gridtable");
        $(grids).each(function (i, grid) {
            autoParseGrid($(grid));
        });
    });
})($);

/*
apollo pager
*/
(function (jQuery, apollo) {
    jQuery.fn.extend({
        apollopager: function (options) {
            var isScrollLoad = false;//是否采用滚加载
            var defaults = {
                scrollbody: null,
                allowPager: true,//是否进行分页
                isDefaultLoad: true,//是否一初始化就加载
                pageSize: 20,//每页数量
                data: null,
                header: null,
                bodyer: null,
                footer: null,
                getDataFun: null,//获取数据的方法,通过这个方法，获取到指定数据，需传递如下参数,pageIndex,pageSize,和成功取到数据后的委托方法
                createBody: null,//创建grid数据区方法
                createHeader: null,//创建表头区方法
                createPager: null //创建分页区的方法，如果有分页的话
            };
            var isLoadFin = false, isLoading = false;
            var isWinScroll = false;
            var op = jQuery.extend(defaults, options);
            var pager = {
                pageIndex: 0,//当前页数，从0开始,
                pageSize: op.allowPager == true ? op.pageSize : 0,//每页显示的记录数
                totalRecord: 0,//记录总数,
                totalPage: 0
            };

            if (op.scrollbody == null) op.scrollbody = window;

            if (op.scrollbody == window || op.scrollbody == document || op.scrollbody == document.body)
                isWinScroll = true;

            var grid = jQuery(this);

            var thead, tbody, tfoot;

            if (typeof op.header == "string") {
                thead = grid.find(op.header);
                if (thead.length == 0) thead = jQuery.find(op.header);
            }
            else if (op.header != null)
                thead = jQuery(op.header);
            else
                thead = null;

            if (typeof op.bodyer == "string") {
                tbody = grid.find(op.bodyer);
                if (tbody.length == 0) tbody = jQuery.find(op.bodyer);
            }
            else if (op.bodyer != null)
                tbody = jQuery(op.bodyer);
            else
                tbody = null;

            if (typeof op.footer == "string") {
                tfoot = grid.find(op.footer);
                if (tfoot.length == 0) tfoot = jQuery.find(op.footer);
            }
            else if (op.footer != null)
                tfoot = jQuery(op.footer);
            else
                tfoot = null;


            init();


            function init() {
                //创建列头(因为列头可能是固定，所以这里不进行清除）
                createHeader();
                initList();
                //清空分区
                if (tbody != null) tbody.empty();

                //默认加载第一页
                if (op.isDefaultLoad == true) {
                    if (op.data != null) {
                        op.allowPager = false;
                        createBody(op.data);
                    }
                    else {
                        gotoPage(0);
                    }
                }
            }


            function initList() {
                if (tfoot != null) return; //指定了分页底部分页栏，不进行滚动加载
                if (op.allowPager != true) return;
                isScrollLoad = true;
                jQuery(op.scrollbody).scroll(function () {
                    if (isLoadFin == true || isLoading == true) return;
                    var canLoad = false;
                    if (isWinScroll) {
                        canLoad = isScrollWinBottom();
                    }
                    else {
                        canLoad = isScrollDivBottom();
                    }
                    if (canLoad) {
                        pager.pageIndex++;
                        gotoPage(pager.pageIndex);
                    }
                });
            }

            function isScrollWinBottom() {
                if (apollo.isPCComputer()) {
                    if (jQuery(document).scrollTop() >= jQuery(document).height() - jQuery(window).height()) {
                        return true;
                    }
                    else
                        return false;
                }
                else
                    return false;
            }

            function isScrollDivBottom() {
                var mypager = jQuery(op.scrollbody);

                var srollPos = mypager.scrollTop();    //滚动条距顶部距离(页面超出窗口的高度)
                var totalheight = parseFloat(mypager.get(0).offsetHeight) + parseFloat(srollPos);
                var paddingBottom = parseInt(jQuery(op.scrollbody).css('padding-bottom')), paddingTop = parseInt(jQuery(op.scrollbody).css('padding-top'));
                var range = paddingBottom + paddingTop;

                var nScrollHight = mypager[0].scrollHeight;
                var nScrollTop = mypager[0].scrollTop;


                if (totalheight >= nScrollHight - range) {
                    return true;
                }
                else
                    return false;
            }



            function reflashPager() {
                if (op.createPager != null) op.createPager(pager);

                //创建分页区
                if (tfoot != null) {
                    if (op.allowPager == true) { //需要分页
                        createPager();
                    }
                    else
                        tfoot.hide();
                }
            }

            //创建列头，组件不创建，由使用方自已创建
            function createHeader() {
                if (op.createHeader != null) {
                    op.createHeader(thead);
                    return;
                }
                else if (thead != null) {
                    thead.empty();
                    if (op.hasNo == true)//有序号
                    {
                        var panel = jQuery("<div class=\"font-b fl\">序号</div>");
                        thead.append(panel);
                    }

                    jQuery(op.columns).each(function (i, column) {
                        var panel = jQuery("<div class=\"font-b fl\"></div>");
                        panel.html(column.text);
                        thead.append(panel);
                    });
                }
            }
            //创建数据列表
            function createBody(rows) {
                if (op.createBody != null) {
                    op.createBody(tbody, rows);
                    return;
                }
            }
            //判断是否为空，以便确认是否显示
            function isEmptyValue(v) {
                if (v == "0001-01-01 00:00:00")
                    return true;
                else if (v == null)
                    return true;
                else if (v == "null")
                    return true;
                else if (v == "00000000-0000-0000-0000-000000000000")
                    return true;
                else
                    return false;
            }
            ///创建分页条
            function createPager() {
                if (op.allowPager != true) return;
                if (jQuery.isFunction(op.createPager)) {
                    op.createPager(pager);
                    return;
                }
                if (tfoot == null) return;
                var btnPrev, btnNext;
                var footerPanel = $(tfoot);
                footerPanel.empty();

                var fp = jQuery("<div class=\"mar-t2 pad-t1 pad-b1 ovh tx-c \"></div>");
                footerPanel.append(fp);

                var ftPanel = jQuery("<div class=\"dis-inl-b\"></div>");
                fp.append(ftPanel);

                //前端按钮区
                var plBtn = jQuery("<ul class=\"per-page fl ovh tx-c\"></ul>");

                var plMore = jQuery("<div class=\"per-page-skip fr c-light-gra\"></div>");

                ftPanel.append(plBtn).append(plMore);

                btnPrev = jQuery("<a href=\"javascript:;\" class=\"page-pre\"></a>");
                btnNext = jQuery("<a href=\"javascript:;\" class=\"page-next\"></a>");

                btnPrev.click(function () {
                    if (pager.pageIndex > 0)
                        gotoPage(pager.pageIndex - 1);
                });
                btnNext.click(function () {
                    if (pager.pageIndex < pager.totalPage - 1)
                        gotoPage(pager.pageIndex + 1);
                });


                if (pager.pageIndex <= 0) //已是第一页
                {
                    btnPrev.addClass("disabled");
                    btnPrev.attr("disabled", "disabled");
                    btnPrev.hide();
                    btnPrev.html("<span class='font1-2 c-gra'>&lt;</span>");//"<i class=\"icon iconfont font1-2 c-gra\">&#xe612;</i>");
                }
                else {
                    btnPrev.removeClass("disabled");
                    btnPrev.removeAttr("disabled");
                    btnPrev.html("<span class='font1-2'>&lt;</span>上一页");
                    btnPrev.show();

                    // btnPrev.html("<i class=\"icon iconfont font1-2\">&#xe612;</i>上一页");
                }

                if (pager.pageIndex >= pager.totalPage - 1) //已是第一页
                {
                    btnNext.addClass("disabled");
                    btnNext.attr("disabled", "disabled");
                    btnNext.hide();
                    btnNext.html("<span class=' font1-2 c-gra'>&gt;</span>");//<i class=\"icon iconfont font1-2 c-gra\">&#xe615;</i>");
                }
                else {
                    btnNext.removeClass("disabled");
                    btnNext.removeAttr("disabled");
                    btnNext.show();
                    btnNext.html("下一页<span class='font1-2'>&gt;</span>");//<i class=\"icon iconfont font1-2\">&#xe615;</i>");
                }

                //创建按钮区域
                var li = jQuery("<li class=\"fl mar-l-5 mar-r-5\"></li>");
                li.append(btnPrev);
                plBtn.append(li);
                createNumBtn(plBtn, pager.pageIndex + 1, pager.totalPage);

                li = jQuery("<li class=\"fl mar-l-5 mar-r-5\"></li>");
                li.append(btnNext);
                plBtn.append(li);

                var boxPageSign = jQuery("<input type=\"text\" value=\"10\" class=\"c-gra bor-s1 bor-gra tx-c mar-r-2\" />");
                boxPageSign.val(pager.pageSize);
                var divPB = jQuery("<div class=\"dis-inl-b mar-r1\"></div>");
                divPB.append(boxPageSign);
                divPB.append("条/页 | 共" + pager.totalPage + "页" + pager.totalRecord + "条记录");


                plMore.append(divPB);

                var boxToPage = jQuery("<input type=\"text\" value=\"2\" class=\"bor-s1 bor-light-gra mar-l-5 mar-r-5 tx-c\" />");
                boxToPage.val(pager.pageIndex + 1);

                plMore.append("跳至").append(boxToPage).append("页");

                var btnTo = jQuery("<input type=\"button\" value=\"跳转\" class=\"mar-l1 bg-wh bor-s1 bor-gra bor-rads5 btn\" />");

                btnTo.click(function () {
                    var toPageSize = parseInt(boxPageSign.val());
                    var toIndex = parseInt(boxToPage.val());

                    if (isNaN(toPageSize)) toPageSize = 0;
                    if (isNaN(toIndex)) toIndex = 0;

                    if (toPageSize <= 0) {
                        alert("每页记录数必须大于0");
                        return;
                    }
                    if (toIndex <= 0) {
                        alert("跳转页数必须大于0");
                    }

                    pager.pageSize = toPageSize;
                    op.pageSize = toPageSize;
                    gotoPage(toIndex - 1);
                });


                plMore.append(btnTo).append(""); //页
            }
            //创建数字按钮
            function createNumBtn(pageNumber, curPage, totalPage) {
                if (totalPage <= 0)//少于
                    return;

                var arrNum = [];
                var spanIndex = -1;
                if (totalPage < 7) //当总的页数在6页之内时
                {
                    for (var i = 1; i <= totalPage; i++) {
                        arrNum.push(i);
                    }
                }
                else if (curPage < 4) //当前页少于4，则当前页是在前部
                {
                    arrNum = [1, 2, 3, 4, totalPage - 1, totalPage];
                    spanIndex = 3;
                }
                else if (totalPage - curPage < 2) {
                    arrNum = [1, 2, 3, totalPage - 2, totalPage - 1, totalPage];
                    spanIndex = 2;
                }
                else if (totalPage - curPage < 3) {
                    arrNum = [1, 2, totalPage - 3, totalPage - 2, totalPage - 1, totalPage];
                    spanIndex = 1;
                }
                else if (totalPage - curPage < 4) {
                    arrNum = [1, totalPage - 4, totalPage - 3, totalPage - 2, totalPage - 1, totalPage];
                    spanIndex = 0;
                }
                else {
                    arrNum = [curPage - 2, curPage - 1, curPage, curPage + 1, totalPage - 1, totalPage];
                    spanIndex = 3;
                }

                for (var i = 0; i < arrNum.length; i++) {
                    var curNo = arrNum[i] - 1;
                    var li = jQuery("<li class=\"fl mar-l-5 mar-r-5\"></li>");
                    var btn = jQuery("<a href='javascript:;'></a>");
                    li.append(btn);

                    if (curPage == arrNum[i])
                        btn.attr("class", "page-on");
                    else {
                        btn.data("pageIndex", curNo);
                        btn.click(function () {
                            var index = jQuery(this).data("pageIndex");
                            gotoPage(index);
                        });
                    }

                    btn.html(arrNum[i]);

                    pageNumber.append(li);

                    if (i == spanIndex) {
                        li = jQuery("<li class=\"fl mar-l-5 mar-r-5\"></li>");
                        li.append("<a href=\"javascript:;\" class=\"dots\">……</a>");
                        pageNumber.append(li);
                    }
                }
            }

            //取到数据后执行的方法
            function loadedData(items) {
                var rows = [];
                if (((items.total != null && items.total != undefined) && items.total <= 0) || items.rows == null || items.rows.length <= 0) {//没有数据
                    pager.totalPage = 0;
                    pager.pageIndex = 0;
                    pager.totalRecord = 0;

                    //这里要重新刷新页脚 
                    reflashPager();
                }
                else {
                    if (items.total != null && items.rows != null)//标准格式返回的值
                    {
                        //算出总页数
                        pager.totalRecord = items.total;//总记录数
                        if (isNaN(pager.totalRecord)) pager.totalRecord = items.rows.length;
                        if (isNaN(pager.totalRecord)) pager.totalRecord = 0;

                        pager.totalPage = Math.ceil(pager.totalRecord / pager.pageSize);



                        if (pager.pageIndex > pager.totalPage - 1) //比最后一页还大，则视为最后一页
                            pager.pageIndex = pager.totalPage - 1;

                        if (pager.pageIndex < 0) pager.pageIndex = 0;

                        reflashPager();

                        rows = items.rows;
                    }
                    else {
                        pager.totalRecord = items.length;
                        pager.totalPage = 1;
                        pager.pageIndex = 0;
                        pager.pageSize = items.length;
                        reflashPager();
                        rows = items;
                    }
                }

                if (pager.pageIndex >= pager.totalPage - 1) //表示无记录可加载，已加载完
                {
                    isLoadFin = true;
                }

                createBody(rows);
            }
            //转到第几页并显示指定页数据
            function gotoPage(index) {
                if (isLoading == true) return;
                isLoading = true;


                var successFun = function (rtn) {
                    if (rtn == null) return;
                    if (index == 0 && tbody != null) {
                        tbody.empty();

                        if (isScrollLoad == true) {
                            $(op.scrollbody).animate({ scrollTop: 0 });
                        }
                    }

                    pager.pageIndex = index;
                    loadedData(rtn);
                    isLoading = false;
                };

                pager.pageIndex = index;//设置当前页索引为该页

                if (op.getDataFun != null)
                    op.getDataFun(pager.pageIndex, pager.pageSize, successFun);
            }



            if (op.isDefaultLoad)
                gotoPage(0);

            return {
                load: function () {
                    pager.pageIndex = 0;//默认为第一页
                    isLoadFin = false;
                    gotoPage(0);
                },
                reflash: function () {
                    gotoPage(pager.pageIndex);
                },
                prev: function () {
                    if (pager.pageIndex > 0)
                        pager.pageIndex--;

                    gotoPage(pager.pageIndex);
                },
                next: function () {
                    if (pager.pageIndex < pager.totalPage - 1) //已是最后一页
                        pager.pageIndex++;

                    gotoPage(pager.pageIndex);
                },
                goto: gotoPage
            }
        }
    });
})(jQuery, apollo);




/*
apollo.touchrow
*/
(function ($) {
    $.fn.extend({
        touchrow: function () {

            var ul = $(this);

            var isright = false;
            var preDiv = null;
            function getX(e, istouch) {
                if (istouch) {
                    var _touch = e.originalEvent.targetTouches[0];
                    var _x = _touch.pageX;
                    return _x;
                }
                else {
                    return e.pageX;
                }
            }
            function getEndX(e, istouch) {
                if (istouch) {
                    var _touch = e.originalEvent.changedTouches[0];
                    var _x = _touch.pageX;
                    return _x;
                }
                else {
                    return e.pageX;
                }
            }

            function onstart(e, istouch, div) {
                isright = false;
                stopPrev(div.get(0));
                preDiv = div.get(0);
                var endx = 0;
                var left = parseInt(div.css("left"));
                var downx = getX(e, istouch);

                var movefun = function (es) {
                    var x = getX(es, istouch);
                    var endx = x - downx + left;   //计算div的最终位置
                    div.css("left", endx + "px");

                    if (endx > left) //是往右滑,，则结束
                    {
                        isright = true;
                        if (istouch) {
                            div.unbind("touchmove");
                        }
                        else {
                            div.unbind("mousemove");
                        }
                        div.animate({ left: "0px" });
                    }
                };
                if (istouch) {
                    div.bind("touchmove", movefun);
                }
                else {
                    div.bind("mousemove", movefun);
                }
            }
            function onend(e, istouch, div) {
                if (isright) {
                    isright = false;
                    return;
                }
                if (istouch) {
                    div.unbind("touchmove");
                }
                else {
                    div.unbind("mousemove");
                }

                var left = parseInt(div.css("left"));
                var divbtnW = div.next(".touchitem_btn").width();
                var w = divbtnW * 1 / 3;
                if (left > 0 - w) {
                    div.animate({ left: "0px" });
                }
                else {
                    div.animate({ left: (0 - divbtnW) + "px" });
                }
            }

            function stopPrev(div) {
                if (preDiv != null && preDiv != div) {
                    isright = false;
                    $(preDiv).animate({ left: "0px" });
                }
            }


            function initEvent(row) {
                row.find('.touchitem').on('touchstart', function (e) {
                    var div = $(this);
                    onstart(e, true, div);
                });

                row.find('.touchitem').on('touchend', function (e) {
                    var div = $(this);
                    onend(e, true, div);
                });


                row.find(".touchitem").mousedown(function (e) {
                    var div = $(this);
                    onstart(e, false, div);
                })


                row.find(".touchitem").mouseup(function (e) {
                    var div = $(this);
                    onend(e, false, div);
                });
            }

            function init() {
                var rows = ul.find(".touchrow");
                $(rows).each(function (i, row) {
                    initEvent($(row));
                    resizeB($(row));
                    $(row).resize(function () {
                        resizeB($(this));
                    });
                });
            }

            function resizeB(row) {
                var wh = $(row).width();
                var aw = $(row).find(".touchitem_btn").width();
                $(row).find(".touchitem").data("itembtnW", aw);


                $(row).find(".touchitem").width(wh);
                $(row).find(".touchitem_btn").css("left", (wh - aw) + "px");

                var h = $(row).find(".touchitem").height();
                $(row).find(".touchitem_btn").height(h);
            }

            init();
            return {
                endtouch: function () {
                    if (preDiv != null) {
                        isright = false;
                        $(preDiv).animate({ left: "0px" });
                        preDiv = null;
                    }
                }
            };
        }
    });
})(jQuery);


/*spinner组件，用于输入*/
(function ($) {
    $.fn.Spinner = function (opts) {
        var defaults = { value: 1, min: 1, len: 5, max: 999999, numTimes: 1 };
        var options = $.extend(defaults, opts);
        if (options.numTimes <= 0) options.numTimes = 1;
        var keyCodes = { up: 38, down: 40 };
        var cvfun = null;
        var boxNum = null, a = null, c = null;
        var isEnabled = true;
        var prevNum = options.value;
        var rtnBox = {
            add: null,
            onAdd: null,//增加后激活的事件
            onDecrease: null,//减少后激活的事件
            getValue: function () {
                var nv = boxNum.val();
                var v = parseInt(nv);
                if (isNaN(v))
                    return 0;
                else
                    return v;
            },
            setValue: function (v) {
                boxNum.val(v);
                prevNum = v;
                try {
                    if (cvfun != null) {
                        f(boxNum, 1, "Amount"); cvfun(0);	//值
                    }
                }
                catch (e) { }
            },
            setEnabled: function (isE) {
                isEnabled = isE;
                if (isEnabled) { f(a, 2, "DisDe", "Decrease"); } else { f(a, 2, "Decrease", "DisDe"); }
                if (isEnabled) { f(c, 2, "DisIn", "Increase"); } else { f(c, 2, "Increase", "DisIn"); }
                if (isE)
                    boxNum.removeAttr("disabled");
                else
                    boxNum.attr("disabled", "disabled");
            },
            change: null
        };


        this.each(function () {
            a = $('<span></span>');
            a.css("display", "inline-block");
            f(a, 0, "Decrease", "－");	//减

            c = $('<span></span>');
            c.css("display", "inline-block");
            f(c, 0, "Increase", "＋");	//加

            boxNum = $("<input type='numer'/>");
            boxNum.val(0);
            f(boxNum, 1, "Amount"); cv(0);	//值

            $(this).append(a).append(boxNum).append(c);
            a.click(function () {
                var nv = rtnBox.getValue();

                cv(-1, true);

                if (nv > options.min && rtnBox.onDecrease != null)
                    rtnBox.onDecrease(rtnBox.getValue());
            });
            boxNum.focus(function () {
               // $(this).select();
            });
            boxNum.keyup(function () { cv(0) });
            boxNum.change(function () {
                cv(0);
            });
            c.click(function () {
                var nv = rtnBox.getValue();
                cv(+1, true);
                if (nv < options.max && rtnBox.onAdd != null)
                    rtnBox.onAdd(rtnBox.getValue());
            });

            boxNum.bind('input propertychange keyup paste change', function (e) {
                if (e.keyCode == keyCodes.up)
                    cv(+1, false);
                else if (e.keyCode == keyCodes.down)
                    cv(-1, false);
                else {
                    cv(0);
                }
            });

            function cv(n, isBtn) {
                if (!isEnabled) return;
                n = n * options.numTimes;
                boxNum.val(boxNum.val().replace(/[^\d]/g, ''));
                bv = parseInt(boxNum.val() || options.min) + n;
                if (options.numTimes > 0) {
                    var ys = bv % options.numTimes;
                    if (ys > 0) bv -= ys;
                }
                if (bv >= options.min && bv <= options.max) {
                    boxNum.val(bv);
                }


                if (bv <= options.min) { boxNum.val(options.min); f(a, 2, "DisDe", "Decrease"); } else { f(a, 2, "Decrease", "DisDe"); }
                if (bv >= options.max) { boxNum.val(options.max); f(c, 2, "DisIn", "Increase"); } else { f(c, 2, "Increase", "DisIn"); }

                if (prevNum != bv && rtnBox.change != null) rtnBox.change(rtnBox, isBtn == true, prevNum < bv);
                prevNum = bv;
            }

            cvfun = cv;
            rtnBox.add = function (n) {
                cv(n, true);
            }
        });

        function f(o, t, c, s) {
            t == 0 && o.addClass(c).attr("href", "javascript:;").append(s);
            t == 1 && o.addClass(c).attr({ "value": options.value, "autocomplete": "off", "maxlength": options.len });
            t == 2 && o.addClass(c).removeClass(s);
        }

        rtnBox.setValue(options.value);
        return rtnBox;
    }
})(jQuery);

/** 
× JQUERY 模拟淘宝控件银行帐号输入 
* 
**/
(function ($) {
    // 输入框格式化 
    $.fn.bankInput = function (options) {
        var defaults = {
            min: 10, // 最少输入字数 
            max: 25, // 最多输入字数 
            deimiter: ' ', // 账号分隔符 
            onlyNumber: true, // 只能输入数字 
            copy: true // 允许复制 
        };
        var opts = $.extend({}, defaults, options);
        var obj = $(this);
        obj.css({ imeMode: 'Disabled', borderWidth: '1px', color: '#000', fontFamly: 'Times New Roman' }).attr('maxlength', opts.max);
        if (obj.val() != '') obj.val(obj.val().replace(/\s/g, '').replace(/(\d{4})(?=\d)/g, "$1" + opts.deimiter));
        obj.bind('keyup', function (event) {
            if (opts.onlyNumber) {
                if (!(event.keyCode >= 48 && event.keyCode <= 57)) {
                    this.value = this.value.replace(/\D/g, '');
                }
            }
            this.value = this.value.replace(/\s/g, '').replace(/(\d{4})(?=\d)/g, "$1" + opts.deimiter);
        }).bind('dragenter', function () {
            return false;
        }).bind('onpaste', function () {
            return !clipboardData.getData('text').match(/\D/);
        }).bind('blur', function () {
            this.value = this.value.replace(/\s/g, '').replace(/(\d{4})(?=\d)/g, "$1" + opts.deimiter);
        })
    }
    // 列表显示格式化 
    $.fn.bankList = function (options) {
        var defaults = {
            deimiter: ' ' // 分隔符 
        };
        var opts = $.extend({}, defaults, options);
        return this.each(function () {
            $(this).text($(this).text().replace(/\s/g, '').replace(/(\d{4})(?=\d)/g, "$1" + opts.deimiter));
        })
    }
})(jQuery);


(function ($) {
    $.fn.extend({
        /*  在textarea处插入文本--Start */
        insertContent: function (myValue, t) {
            var $t = $(this)[0];
            if (document.selection) { // ie
                this.focus();
                var sel = document.selection.createRange();
                sel.text = myValue;
                this.focus();
                sel.moveStart('character', -l);
                var wee = sel.text.length;
                if (arguments.length == 2) {
                    var l = $t.value.length;
                    sel.moveEnd("character", wee + t);
                    t <= 0 ? sel.moveStart("character", wee - 2 * t
                        - myValue.length) : sel.moveStart(
                            "character", wee - t - myValue.length);
                    sel.select();
                }
            } else if ($t.selectionStart
                || $t.selectionStart == '0') {
                var startPos = $t.selectionStart;
                var endPos = $t.selectionEnd;
                var scrollTop = $t.scrollTop;
                $t.value = $t.value.substring(0, startPos)
                    + myValue
                    + $t.value.substring(endPos,
                        $t.value.length);
                this.focus();
                $t.selectionStart = startPos + myValue.length;
                $t.selectionEnd = startPos + myValue.length;
                $t.scrollTop = scrollTop;
                if (arguments.length == 2) {
                    $t.setSelectionRange(startPos - t,
                        $t.selectionEnd + t);
                    this.focus();
                }
            } else {
                this.value += myValue;
                this.focus();
            }
        },
        /* 在textarea处插入文本--Ending */
        /*  文字水平滚动--Start */
        roll: function (options) {
            var defaults = {
                speed: 1
            };
            var options = $.extend(defaults, options);
            var speed = (document.all) ? options.speed : Math.max(1, options.speed - 1);
            if ($(this) == null) return;
            var $container = $(this);
            var $content = $container.children();
            var init_left = $container.width();
            $content.css({ left: parseInt(init_left) + "px" });
            var This = this;
            var time = setInterval(function () { This.move($container, $content, speed); }, 20); //setInterval会改变this指向，即使加了This=this，也要用匿名函数封装，这里调试了n久

            $container.bind("mouseover", function () {
                clearInterval(time);
            });
            $container.bind("mouseout", function () {
                time = setInterval(function () { This.move($container, $content, speed); }, 20);
            });

            return this;
        },
        move: function ($container, $content, speed) {
            var container_width = $container.width();
            var content_width = $content.width();
            if (parseInt($content.css("left")) + content_width > 0) {
                $content.css({ left: parseInt($content.css("left")) - speed + "px" });
            }
            else {
                $content.css({ left: parseInt(container_width) + "px" });
            }
        }
        /*  文字水平滚动--Ending */
    })
})(jQuery);




//PC端浏览器版本检测
(function () {
    function showtip() {
        var imgPath = apollo.pageInfo.rootvpath + "Content/Images/ckbwimg/";
        var tip = $("<div style=\"background-color:#f5f09f;height:40px; line-height:40px;font-size:14px;text-align:center;vertical-align:middle;color:#ff6a00\"></div>");
        tip.append("<span style=\"height:40px; line-height:40px;font-size:14px;\">温馨提示：您的浏览器版本过低，可能导致网站不能正常访问！为了您能正常使用网站功能，建议您升级浏览器：</span>");
        var btn = $("<a style='color:#ff6a00;cursor:pointer;'>【关 闭】</a>");
        btn.click(function () {
            tip.slideToggle("slow", function () {
                tip.remove();
            });
        });

        tip.append(btn);
        tip.hide();

        var b = $("body");
        var f = b.children().first();

        if (f.length > 0) {
            tip.insertBefore(f);
        }
        else {
            b.append(tip);
        }
        tip.slideDown();
    }
    function ishtml5() {
        if (window.applicationCache) {
            return true;
        } else {
            return false;
        }
    }
    $(function () {
        if (apollo.isPCComputer()) {
            if (window != top) return;
            if (!ishtml5()) showtip();
            //if (!$.support.leadingWhitespace) {
            //    showtip();
            //}
        }
    });
})();

